#!/usr/local/bin/php
<?php
# This script explodes a valid .po file using English msgid's and UTF-8 msgstr's.
# Its base is the current database.

require_once('../../includes/config.php');

function usage() {
 echo "php i18ntext2gettext.php <language> <file.po>
 
 where
  language can be \"Traditional Chinese\", \"Slovakian\", ...,
  file.po can be gettext/zn_CN.po, gettext/sk.po, ...\n";
 exit(1);
}

if ($_SERVER['argc'] != 3)
 usage();
$language=$_SERVER['argv'][1];
$pofile=$_SERVER['argv'][2];

echo "Language is $language, PO file is $pofile.\n";

if (file_exists($pofile))
 {
  echo "$pofile already exists. Delete it first if you want to continue.\n";
  exit(2);
 }

$f=fopen($pofile,"w");
if ($f=="")
 {
  echo "Unable to open $pofile for writing.\n";
  exit(3);
 }

$link=@pg_connect("dbname=$dbname user=$dbuser password=$dbpasswd port=$dbport");
if ($link=="")
 {
  echo "Unable to open database connection.\n";
  exit(4);
 }

$result=pg_query("select * from _language where langnameen='$language'");
$language_id=pg_fetch_result($result,0,'id');
if ($language_id=="")
 {
  echo "No such language defined yet in the _language table.\n";
  echo "Create it first.\n";
  exit(5);
 }

echo "Language id: $language_id\n";

fwrite($f,"msgid \"\"
msgstr \"\"
\"Project-Id-Version: \\n\"
\"POT-Creation-Date: \\n\"
\"PO-Revision-Date: 2008-03-18 11:03+0100\\n\"
\"Last-Translator: WMI2 Translator Team <info@matek.hu>\\n\"
\"Language-Team: \\n\"
\"MIME-Version: 1.0\\n\"
\"Content-Type: text/plain; charset=utf-8\\n\"
\"Content-Transfer-Encoding: 8bit\\n\"

");

$result=pg_query("select h.text as hmsgid, e.text as msgid, o.text as msgstr from i18ntext h,
i18ntext e, i18ntext o where h._language=1 and e.mainid=h.id and o.mainid=h.id and
o._language=$language_id and e._language=2 order by e.id");

while ($row=pg_fetch_row($result))
 {
  $msgid=$row[1];
  $msgstr=$row[2];
  fwrite($f,"msgid \"".$msgid."\"\n");
  fwrite($f,"msgstr \"".$msgstr."\"\n\n");
 } // while

fclose($f);

?>