dnl WMI_CONFIG_START
dnl
AC_DEFUN(WMI_CONFIG_START, [
AC_MSG_RESULT([
This is WMI2's configure script.
])
])

dnl WMI_CONFIG_END
dnl
AC_DEFUN(WMI_CONFIG_END, [
AC_MSG_RESULT([
------------------------------------------------------------------------
Configuration:

  Source code location:       $srcdir
dnl  Host System Type:           $host
  PHP version:                $phpversion
dnl  Webdir path:                $webdir
dnl  Install path:               $prefix
dnl  Install path:               $webdir/wmi
dnl  Locale path:                $localedir
dnl  Httpd user:                 $wwwuser
  Algebra system:             $algebrasystems
  Database name:              $dbname
  Database user:              $dbuser
  Database password:          $dbpasswd
  Database port:              $dbport
  Database hostname:          $dbhost

dnl See defaults.inc for further configuration information.
------------------------------------------------------------------------
])
AC_MSG_RESULT([
Configuration complete!
Your system seems to be ready to install WMI2.
])
])

dnl ---------------------------------------------------------------------

dnl WMI_PROG_WHICH
dnl
AC_DEFUN(WMI_PROG_WHICH,[dnl
AC_CHECK_PROG(WHICH,which,which,no)
if test "$WHICH" = no; then
        AC_MSG_ERROR([
'which' is required to run this configure script properly.
        ])
fi
])

dnl WMI_PROG_TIMEOUT
dnl
AC_DEFUN(WMI_PROG_TIMEOUT,[dnl
AC_CHECK_PROG(TIMEOUT,timeout,timeout,no)
if test "$TIMEOUT" = no; then
        AC_MSG_ERROR([
'timeout' is needed, install it first.
        ])
fi
])


dnl WMI_PROG_GETTEXT
dnl
AC_DEFUN(WMI_PROG_GETTEXT,[dnl
AC_CHECK_PROG(GETTEXT,gettext,gettext,no)
if test "$GETTEXT" = no; then
	AC_MSG_ERROR([
GNU gettext is needed, install it first.])
fi
])

dnl WMI_PROG_EUKLEIDES
dnl
AC_DEFUN(WMI_PROG_EUKLEIDES,[dnl
AC_CHECK_PROG(EUKLEIDES,eukleides,eukleides,no)
if test "$EUKLEIDES" = no; then
	AC_MSG_ERROR([
eukleides is needed for geometric illustrations, install it first.])
else
	eukleidesdir=`which eukleides`
	AC_SUBST(eukleidesdir)
fi
])

dnl WMI_PROG_POSTGRESQL
dnl
AC_DEFUN(WMI_PROG_POSTGRESQL,[dnl
AC_ARG_WITH(psqldir,
	AC_HELP_STRING([--with-psqldir=PATH],
		[the path to postgresql binaries]),
	psqldir=${withval})

if test "$psqldir"x = x; then
	AC_CHECK_PROG(POSTMASTER,postmaster,postmaster,no)
	psqldir=`which postmaster`
else
	AC_CHECK_PROG(POSTMASTER,postmaster,postmaster,no,$psqldir)
	psqldir="${psqldir}/postmaster"
fi

if test "$POSTMASTER" = no; then
	AC_MSG_ERROR([
PostgreSQL is needed, install it first.])
fi
AC_SUBST(psqldir)
])

dnl WMI_PROG_FORMCONV
dnl
AC_DEFUN(WMI_PROG_FORMCONV,[dnl
AC_ARG_WITH(formconvdir,
	AC_HELP_STRING([--with-formconvdir=PATH],
		[the path to formconv executable]),
	formconvdir=${withval})

if test "$formconvdir"x = x; then
	AC_CHECK_PROG(FORMCONV,formconv,formconv,no)
if test "$FORMCONV" = no; then
        AC_MSG_ERROR([
formconv is needed for parsing and converting math formulae, install it first.])
	fi
	formconvdir=`which formconv`
	fi
AC_SUBST(formconvdir)

AC_MSG_CHECKING(formconv's version)
formconvversion=`$formconvdir --version | head -n 1 | $AWK '{print @S|@4}'`
if test "$formconvversion" = ""; then
	formconvversion=`$formconvdir --version | head -2 | tail -1 | $AWK '{print @S|@3}'`
	fi

AC_MSG_RESULT($formconvversion)

formconvmajorver=`echo $formconvversion | $AWK -F . '{print @S|@1}'`
formconvminorver=`echo $formconvversion | $AWK -F . '{print @S|@2}'`
formconvrevver=`echo $formconvversion | $AWK -F . '{print @S|@3}'`

formconvreqmajor=0
formconvreqminor=8

if test $formconvmajorver -lt $formconvreqmajor || test $formconvmajorver -eq $formconvreqmajor -a $formconvminorver -lt $formconvreqminor; then
	AC_MSG_ERROR([
formconv version must be >= $formconvreqmajor.$formconvreqminor])
fi	
])


dnl WMI_BLOCK_AD
dnl
AC_DEFUN(WMI_BLOCK_AD,[
AC_ARG_ENABLE(ad,
        AC_HELP_STRING([--enable-ad],
                [enables advertisement system]),
        [
if test "x$enableval" = "xno"; then
 AD=FALSE
else
 AD=TRUE
fi
],[
 AD=FALSE
])
AC_SUBST(AD)
])

dnl WMI_BLOCK_WEKKER
dnl
AC_DEFUN(WMI_BLOCK_WEKKER,[
AC_ARG_ENABLE(wekker,
        AC_HELP_STRING([--enable-wekker],
                [enables the wekker database engine]),
        [
if test "x$enableval" = "xno"; then
 WEKKER=FALSE
else
 WEKKER=TRUE
fi
],[
 WEKKER=FALSE
])
AC_SUBST(WEKKER)
])

dnl WMI_PROG_PHP
dnl
AC_DEFUN(WMI_PROG_PHP,[dnl
AC_ARG_WITH(phpdir,
	AC_HELP_STRING([--with-phpdir=PATH],
		[the path to php binaries]),
	psqldir=${withval})
if test x$phpdir = x; then
	AC_CHECK_PROGS(PHP,[php php4 php5 php3],no)
	phpdir=`which $PHP`
else
	AC_CHECK_PROGS(PHP,[php php4 php5 php3],no,$phpdir)
	phpdir="${phpdir}/$PHP"
fi
if test "$PHP" = no; then
	AC_MSG_ERROR([
PHP is needed, install it first.])
else
	PHP=$phpdir
	phpversion=`$PHP -v | head -1`
	AC_SUBST(PHP)
	AC_SUBST(phpdir)
	AC_SUBST(phpversion)
fi
])

dnl WMI_PHPCHECK_GETTEXT
dnl
AC_DEFUN(WMI_PHPCHECK_GETTEXT,[
if test x$phpdir = x; then
	WMI_CHECK_PHP
fi
AC_MSG_CHECKING([gettext module for php])
if test `$PHP -m 2>&1 | grep -c gettext` = "0"; then
	AC_MSG_ERROR([
Gettext support for php is needed. Recompile php with --with-gettext.
See also the INSTALL file for more information.])
else
	AC_MSG_RESULT([ok])
fi
])

dnl WMI_PHPCHECK_PGSQL
dnl
AC_DEFUN(WMI_PHPCHECK_PGSQL,[
if test x$phpdir = x; then
	WMI_CHECK_PHP
fi
AC_MSG_CHECKING([pgsql module for php])
if test `$PHP -m 2>&1 | grep -c pgsql` = "0"; then
	AC_MSG_ERROR([
PostgreSQL support for php is needed. Recompile php with --with-pgsql.
See also the INSTALL file for more information.])
else
	AC_MSG_RESULT([ok])
fi
])

dnl WMI_PROG_CONVERT
dnl
AC_DEFUN(WMI_PROG_CONVERT,[
AC_CHECK_PROG(CONVERT,convert,convert,no)
if test "$CONVERT" = no; then
        AC_MSG_ERROR([
ImageMagick convert is needed for file conversions, install it first.])
else
        convertdir=`which convert`
        AC_SUBST(convertdir)
fi

AC_MSG_CHECKING(for ImageMagick's dvi delegate)
dnl @S|@ -> $
convertversion=`$convertdir --version | head -n 1 | $AWK '{print @S|@3}'`
convertmajorver=`echo $convertversion | $AWK -F . '{print @S|@1}'`

if test $convertmajorver -gt 4; then
	delegatecheck="convert -list Delegate"
else
	delegatecheck="convert --version"
fi

dvisupport=`$delegatecheck | grep -c dvi`

if test $dvisupport -gt 0; then
	AC_MSG_RESULT([ok])
else
	AC_MSG_RESULT([no])
	AC_MSG_ERROR([
No delegate for dvi, install e.g. dvips first.])
fi
])

dnl WMI_PROG_LYX
dnl
AC_DEFUN(WMI_PROG_LYX,[
AC_CHECK_PROG(LYX,lyx,lyx,no)
if test "$LYX" = no -a "$DOC" = true ; then
        AC_MSG_ERROR([
LyX is required for generating documentation, install it first.])
else
        lyxdir=`which lyx`
        AC_SUBST(lyxdir)
fi	
])

dnl WMI_PROG_LATEX2HTML
dnl
AC_DEFUN(WMI_PROG_LATEX2HTML,[
AC_CHECK_PROG(LATEX2HTML,latex2html,latex2html,no)
if test "$LATEX2HTML" = no; then
        AC_MSG_ERROR([
'latex2html' is required for generating documentation, install it first.])
else
        latex2htmldir=`which latex2html`
        AC_SUBST(latex2htmldir)
fi
])

dnl WMI_PROG_LATEX
dnl
AC_DEFUN(WMI_PROG_LATEX,[
AC_CHECK_PROG(LATEX,latex,latex,no)
AC_CHECK_PROG(TEX,tex,tex,no)

if test $LATEX = "no" -o $TEX = "no"; then
	AC_MSG_ERROR([
TeX/LaTeX is required for displaying math formulae, install it first.])
fi

latexdir=`which latex`
texdir=`which tex`
AC_SUBST(latexdir)
AC_SUBST(texdir)
])

dnl WMI_PROG_GNUPLOT
dnl
AC_DEFUN(WMI_PROG_GNUPLOT,[
AC_CHECK_PROG(GNUPLOT,gnuplot,gnuplot,no)
if test "$GNUPLOT" = no; then
        AC_MSG_ERROR([
gnuplot is required for graph plotting, install it first.])
else
        gnuplotdir=`which gnuplot`
        AC_SUBST(gnuplotdir)
fi

AC_MSG_CHECKING(gnuplot's version)
gnuplotversion=`$gnuplotdir --version 2>/dev/null | grep gnuplot | $AWK '{print @S|@2}'`

if test "$gnuplotversion" = ""; then
	AC_MSG_ERROR([
gnuplot does not support --version switch, it is too old for WMI; sorry])
fi

AC_MSG_RESULT($gnuplotversion)

gnuplotmajorver=`echo $gnuplotversion | $AWK -F . '{print @S|@1}'`
gnuplotminorver=`echo $gnuplotversion | $AWK -F . '{print substr(@S|@2,1,1)}'`
formconvrevver=`echo $gnuplotversion | $AWK -F . '{print substr(@S|@2,2)}'`

gnuplotreqmajor=3
gnuplotreqminor=8

if test $gnuplotmajorver -lt $gnuplotreqmajor || test $gnuplotmajorver -eq $gnuplotreqmajor -a $gnuplotminorver -lt $gnuplotreqminor; then
	AC_MSG_ERROR([
gnuplot version must be >= $gnuplotreqmajor.$gnuplotreqminor])
fi
])

dnl WMI_CHECK_DIRS(VARNAME, listofdirs (separated by whitespace), value if not found, checkmsg)
dnl
AC_DEFUN(WMI_CHECK_DIRS,[dnl
AC_MSG_CHECKING($4)
$1=$3
for checkdir in $2; do
 	if test -d $checkdir; then
		$1=$checkdir
		break;
	fi
done
AC_MSG_RESULT($$1)
])

dnl WMI_CHECK_DIR(VARNAME, nameofdir, valueifnotfound, checkmsg)
dnl
AC_DEFUN(WMI_CHECK_DIR,[dnl
$1=$3
AC_MSG_CHECKING($4)
if test -d $2; then
	$1=$2
fi
AC_MSG_RESULT($$1)
])

dnl WMI_CHECK_WEBDIR
dnl
AC_DEFUN(WMI_CHECK_WEBDIR,[
AC_ARG_WITH(webdir,
	AC_HELP_STRING([--with-webdir=PATH],
		[main installation directory for PHP scripts]),
	webdir=${withval})

if test "x$webdir" != "x"; then
	WMI_CHECK_DIR(WEBDIR_TMP, $webdir, no, [for web directory])
	if test $WEBDIR_TMP = "no"; then
		AC_MSG_ERROR([
Error looking for webdir ($webdir)... check if it's really an existing directory.])
	fi
else
	# /usr/local/httpd/	- SuSe 7.x and 8.0 Linux
	# /srv/www/htdocs/	- SuSe 8.2 Linux
	# /home/httpd/html	- Red Hat Linux < 9.0
	# /var/www		- Debian/GNU Linux, Red Hat Linux 9.0
	# /usr/local/www	- FreeBSD
	WMI_CHECK_DIRS(webdir,[/usr/local/httpd/htdocs /srv/www/htdocs /home/httpd/html	/var/www /usr/local/www], no, [for web directory])
        if test $webdir = "no"; then
                AC_MSG_ERROR([
no web directory defined, define it with "./configure --with-webdir=/foo/bar/" --- is Apache installed at all?])
        fi
fi
AC_SUBST(webdir)
])

dnl WMI_CHECK_USERS(VARNAME, listofusers (separated by whitespace), value if not found, checkmsg)
dnl
AC_DEFUN(WMI_CHECK_USERS,[
$1=$3
AC_MSG_CHECKING($4)
for checkuser in $2; do
	if test `cat /etc/passwd | grep -c "${checkuser}:"` != "0"; then
		$1=$checkuser
		break
	fi
done
AC_MSG_RESULT($$1)
])

dnl WMI_CHECK_USER(VARNAME, nameofuser, valuifnotfound, checkmsg)
dnl
AC_DEFUN(WMI_CHECK_USER,[
$1=$3
AC_MSG_CHECKING($4)
if test `cat /etc/passwd | grep -c "$2:"` != "0"; then
	$1=$2
fi
AC_MSG_RESULT($$1)
])

dnl WMI_CHECK_DBNAME
dnl
AC_DEFUN(WMI_CHECK_DBNAME,[
AC_ARG_WITH(dbname,
        AC_HELP_STRING([--with-dbname=database_name],
                [the name of the database for querying]),
        dbname=${withval})

if test "x$dbname" = "x"; then
	dbname=wmi
fi
AC_SUBST(dbname)
])

dnl WMI_CHECK_DBUSER
dnl
AC_DEFUN(WMI_CHECK_DBUSER,[
AC_ARG_WITH(dbuser,
        AC_HELP_STRING([--with-dbuser=username],
                [the name of the user who queries the database]),
        dbuser=${withval})

if test "x$dbuser" = "x"; then
	dbuser=wmi
fi
AC_SUBST(dbuser)
])

dnl WMI_CHECK_DBPORT
dnl
AC_DEFUN(WMI_CHECK_DBPORT,[
AC_ARG_WITH(dbport,
        AC_HELP_STRING([--with-dbport=port],
                [the port number of the database]),
        dbport=${withval})

if test "x$dbport" = "x"; then
	dbport=5432
fi
AC_SUBST(dbport)
])

dnl WMI_CHECK_DBHOST
dnl
AC_DEFUN(WMI_CHECK_DBHOST,[
AC_ARG_WITH(dbhost,
        AC_HELP_STRING([--with-dbhost=host],
                [the hostname or IP number of the database server]),
        dbhost=${withval})

if test "x$dbhost" = "x"; then
	dbhost=localhost
fi
AC_SUBST(dbhost)
])

dnl WMI_CHECK_DBPASSWD
dnl
AC_DEFUN(WMI_CHECK_DBPASSWD,[
AC_ARG_WITH(dbpasswd,
        AC_HELP_STRING([--with-dbpasswd=password],
                [password for the user who queries the database]),
        dbpasswd=${withval})

AC_SUBST(dbpasswd)
])

dnl WMI_CHECK_WWWUSER
dnl
AC_DEFUN(WMI_CHECK_WWWUSER,[
AC_ARG_WITH(wwwuser,
        AC_HELP_STRING([--with-wwwuser=USER],
                [the name of the user who runs the httpd]),
        wwwuser=${withval})

if test "x$wwwuser" != "x"; then
	WMI_CHECK_USER(wwwusertmp,[$wwwuser],no,[for www user])
	if test $wwwusertmp = "no"; then
		AC_MSG_ERROR([
Invalid userhandle for www user ($wwwuser)])
	fi
else
	WMI_CHECK_USERS(wwwuser,[www-data wwwrun www apache],no,[for www user])
	if test $wwwuser = "no"; then
		AC_MSG_ERROR([
Error looking for a valid wwwuser... Please specify one with --with-wwwuser.])
	fi
fi
AC_SUBST(wwwuser)
])


dnl WMI_SET_LOCALEDIR
dnl
AC_DEFUN(WMI_SET_LOCALEDIR,[
AC_ARG_WITH(localedir,
        AC_HELP_STRING([--with-localedir=PATH],
                [path to locale's translation files (default: $webdir/wmi/locale/)]),
        localedir=${withval})

if test "x$localedir" = "x"; then
	if test "x$webdir" = "x"; then
		localedir="/usr/local/share/locale"
	else
		localedir="$webdir/wmi/locale"
	fi
fi

AC_SUBST(localedir)
])


dnl WMI_BLOCK_DOC
dnl
AC_DEFUN(WMI_BLOCK_DOC,[
AC_ARG_ENABLE(doc,
        AC_HELP_STRING([--disable-doc=yes],
                [disables autogenerating of the documentation]),
        [
if test "x$enableval" = "xno"; then
 DOC="#"
 echo Disabling creating documentation
else
 DOC=
fi
],[
 DOC=
])
AC_SUBST(DOC)
])
