<TeXmacs|1.0.7.2>

<style|tmdoc>

<\body>
  e<doc-data|<doc-title|WebMathematics Interactive 2>>

  <\abstract>
    This documentation is a concise description of <strong|WebMathematics
    Interactive 2 (WMI2)>.
  </abstract>

  <section|What is WMI2?>

  <strong|WMI2> is a web application primarily designed for mathematics
  education of the age 14--21. Its main authors are the associates of the
  <hlink|Bolyai Institute|http://www.math.u-szeged.hu><hlink||http://www.matematika.u-szeged.hu>
  at the <hlink|University of Szeged|http://www.u-szeged.hu>.

  The most important purpose of this application is to give help in the
  learning of mathematics. The underlying mathematical software provide ones
  of the best mathematical expert knowledge accessible through computational
  methods. These computer based techniques do not give correct or complete
  solution in every occasions, but they answer the most practical questions
  correctly. Because of this, <strong|WMI2>, like any other similar
  application, is primarily for self-assessment, for getting new ideas, and
  for solving many routine exercises quickly.

  One main purpose of <strong|WMI2> is to be a symbolic computer algebra
  system with easy usability: no programming expertise should be needed, only
  minimal mathematical skills. It is clear that this means some compromise at
  the available types of exercises. But our intention is that the types of
  the exercises should come from the widest possible range and from the most
  important practical problems. The users who want to solve more difficult,
  more complex problems, may probably find it useful to proceed with
  professional computer algebra systems. Such a next step can be the free
  <hlink|<em|wxMaxima>|<em|>http://wxmaxima.sf.net> or the commercial
  <em|<hlink|Mathematica|http://www.wolfram.com/products/student/mathforstudents>>,
  which can be programmed in English.

  <section|How can it be used?>

  In order to use <strong|WMI2>, only a (relatively modern) web browser is
  needed. Our suggestion is <hlink|Mozilla Firefox|http://firefox.hu> 2.0,
  but <with|font-shape|slanted|Internet Explorer<with|font-shape|italic|<with|font-shape|slanted|>>>
  6.0 and 7.0 are completely supported as well.

  Basically, the screen of the application is divided into two parts. On the
  left, under the logo of the program, a calculator can be found, and the
  exercise to be solved must be typed in its upper row, but this also can be
  done by merely pressing the buttons of the mouse. The input formula appears
  immediately on the right, in the worksheet. So the right side is that side
  of the screen where the formulas of exercises appear, and the solutions of
  these exercise formulas can be seen here, too. The exercises are displayed
  in red, and the solutions of them in blue.

  The input exercises can be solved by the greenish blue buttons of the
  calculator. By clicking on the solutions of exercises, they are inserted in
  the calculator, and this way further operations can be done on them.
  Copying formulas works on input formulas, too.

  On the left many types of calculators can be chosen, depending on what
  types of exercises are wanted to be solved. The default calculator type is
  the <with|font-shape|slanted|secondary school> one, we can solve equations,
  compute binomial coefficients, determine the greatest common divisor of two
  numbers, factorize or evaluate expressions. Another calculator types can be
  chosen by the upper left button of the calculator.

  Like the upper left button, some other buttons open submenus. These types
  of buttons are called groupbuttons. Moving the mouse over a groupbutton,
  the group of the button appears after a short time, which is a set of some
  buttons similar to the original one, with the capability of similar
  functions to solve. So, for example, when moving the mouse over the
  equation solving button, there is a possibility to plot functions, and
  beside the greatest common divisor, the least common multiple appears in a
  similar way. In the group of factorization, we can reach expansion as well.

  On the bottom of the worksheet on the right there can be found some icons,
  with them new worksheets can be started, or the content of the worksheet
  can be exported to a web document. There is a possibility to print the
  worksheet, too.

  <subsection|6 important tricks>

  We tried to make the web application as user-friendly as possible. However,
  we collected some useful ideas here, if everything would not be totally
  clear for the first sight:

  <\itemize-dot>
    <item>The sign of multiplication (<math|\<times\>>) always has to be
    present, if the formula is inputed by button pressing. If the formula is
    typed with the keyboard, then the ordinary asterisk character of
    multiplication can be omitted in some cases.

    <item>When entering equations, the equality sign can be inserted with the
    mouse by pressing the red-white ``='' button located in the middle of
    most layouts.

    <item>By entering <math|x<rsup|2>> with the mouse, the <math|x> button
    should be pressed first, and then the <math|x<rsup|2>> button should be
    pressed. To type the same formula with the keyboard, <verbatim|x^2>
    should be written.

    <item>To type decimal fractions, period should be used as decimal
    separator. The comma button is for separating the inputs, if we wish to
    enter more numbers or expressions. For example, we use this to enter two
    numbers for calculating the greatest common divisor of them, or to enter
    two or more functions for displaying, or the elements of a vector.

    <item>When solving too slowly-computable exercises, <strong|WMI2> refuses
    the further computation after 10 seconds in order to avoid the overload
    of the system.

    <item>Matrices can be entered using brackets and commas. Example:
    [[1,0,0],[0,1,0],[0,0,1]] <emdash> this will give you the unit matrix. Do
    not forget that for multiplying matrices you should use the ``.''
    (period) character.
  </itemize-dot>

  <section|How does it work?>

  The <hlink|WMI2|http://sf.net/projects/wmi> (WebMathematics Interactive)
  software runs on a <em|GNU Linux> server. The Linux server <emdash> as many
  other similar software <emdash> runs an <em|Apache> webserver and a
  <em|PostgreSQL> database server. The main parts of WMI2 are written in the
  programming language <em|PHP>, which keep constant communication with the
  <hlink|<em|gnuplot>|http://www.gnuplot.info> function plotter and the
  <hlink|<em|Maxima>|http://maxima.sf.net> computer algebra system, and the
  <em|<hlink|<TeX>/<LaTeX>|http://hu.wikipedia.org/wiki/TeX>> mathematical
  typesetting programs and the <hlink|<em|ImageMagick>|http://www.imagemagick.org>
  image manipulation software. The formula conversions are done by the
  <hlink|<em|formconv>|http://formconv.sf.net> and the
  <em|<hlink|<TeXmacs>|http://www.texmacs.org>> softwares. The database of
  WMI2 was developed using the <em|Wekker> web 2.0 application generator. The
  advertisement system is supported by the <em|GeoLiteCity> software of
  <hlink|MaxMind|http://maxmind.com> company.

  We tried to use the most up-to-date web technologies, and we put everything
  we could on open-source base. Enquirer users can read further details about
  this on the webpage <verbatim|<hlink|<verbatim|http://sf.net/projects/wm>i|<verbatim|http://sf.net/projects/wm>i>>.

  <section|Authors and Copyright>

  The history of <strong|WMI2> dates back to 2002. Rbert Vajda and Zoltn
  Kovcs, two young assistant lecturers of the Bolyai Institute at the
  University of Szeged started developing WebMathematics Interactive website
  that year, which was essentially the previous version of WMI2. Many helpers
  and co-workers joined the development of the program. From 2006,
  <hlink|Partci BT.|http://particio.com>, a company in Szeged has taken the
  development; one main speciality of this company is the management of
  mathematical software.

  The website <strong|matek.hu>, which contains an installation of
  <strong|WMI2>, is freely available for everyone. Most of the underlying
  software are free software, <strong|WMI2> itself is so.

  Between WMI2 and WMI1 many similarities are there, but we have rewritten
  the 2nd version from the basics. Most of this work was done by our
  colleague, rpd Fekete, partially under his work for thesis. For the
  graphical works, we thank <hlink|Zsigmond Kovcs|http://kovzsi.szeged.hu>
  and <hlink|Zsuzsa Dek|http://particio.com/zsuzsi>, and the artists of the
  <hlink|Gnome|http://gnome.hu> desktop environment.

  It would be long to enumerate that who assisted to the completion of this
  program in a smaller or bigger portion. But we still try it: we believe
  that a quality software can be made only by cooperation. <strong|WMI2> is
  the result of such a joint work.

  <subsection|Acknowledgement>

  Chu-Ching Huang has the biggest part in the completion of WMI2, because he
  made it possible for <hlink|Zoltn Kovcs to take a vocational travelling
  to Taiwan|http://wmi.math.u-szeged.hu/~kovzol/Tajvan.php> in 2006, and he
  tried to direct us towards the new version with many encouragements and
  hints. We got much help from Gbor Bakos in the fixation of the smaller
  errors of the formconv software written by him, and from Mikls Marti,
  who, with some encouragements, saw us through that moments which was like
  dead points. Kornl Csernai made nice enhancements for version 2.1 of WMI2.

  We thank the translators for their contributions, namely:

  <\itemize>
    <item>Chu-Ching Huang (traditional and simplified Chinese),

    <item>Robert Mak and Dana hova (Czech),

    <item>Pter Csiba (Slovakian),

    <item>Tams Hotorn (Serbian),

    <item>Orsolya Wetterhn and Sergio Zanchetta (Italian),

    <item>Nrcisz Kulcsr and Zoltn Matos (French),

    <item>va Szeredi (German).
  </itemize>

  We considered the suggestions of our colleagues in Szeged, Jnos Karsai,
  Lajos Szilassi, Gza Makay, Zoltn Nmeth and Gbor Nagy many times. They
  are faithful critics and users of our system since WMI1. Furthermore, we
  thank Csaba Srvri and the computer algebra school in Pcs signed by his
  name, which aided us many possibilities for introducement and
  classification.

  We thank the suggestions of Joris van der Hoeven in the area of connection
  with CAS systems. We learned a lot from the technical solutions of the
  <TeXmacs> system written by him, it is the same with the
  <em|<hlink|Axiom|http://wiki.axiom-developer.org/FrontPage>> and
  <hlink|<em|Sage>|http://www.sagemath.org> computer algebra front-end
  systems, too. In these software there is a many-year long work of many
  hundreds of mathematicians and programmers.

  It is too difficult to enumerate those further, primarily linux-user
  technicians, who gave us professional assistance or programming expert
  knowledge during our projekt. We mention only a few of them: Zoltn
  Tasndy-Szecs, Rbert Zana, Gbor Ancsin, Jzsef Bencs, Csaba Nagy, Istvn
  Hudi, Tibor Lszl, Gbor Szcs and Balzs Kerekes. Without them we would
  not come to this point where we are at now.

  At last we thank the company Consol Rendszerhz Kft. for making available
  the web 2.0 based application developer tool, Wekker, for the public use
  with WMI2.

  <subsection|Contacts>

  The matek.hu website is maintained by Partci BT. You can contact us at
  <hlink|<verbatim|http://www.particio.com>|<verbatim|http://www.particio.com>>.
  We are accessible by email at the <verbatim|info@matek.hu> address, by
  mobile phone on +36-706226977.
</body>

<\initial>
  <\collection>
    <associate|language|hungarian>
    <associate|page-screen-height|768000tmpt>
    <associate|page-screen-width|998400tmpt>
    <associate|sfactor|4>
  </collection>
</initial>