<?php
// Functions for the advertisements

require_once '../includes/config.php';
require_once '../includes/session.php';
require_once '../includes/sql.php';

function compareGeoABigger($a,$b)
{
    $distance_a = sqrt(
	pow($a[2] - $_SESSION['geoip_latitude'], 2) +
	pow($a[3] - $_SESSION['geoip_longitude'], 2));
    $distance_b = sqrt(
	pow($b[2] - $_SESSION['geoip_latitude'], 2) +
	pow($b[3] - $_SESSION['geoip_longitude'], 2));
    if ($distance_a == $distance_b)
	return 0;

    return ($distance_a > $distance_b) ? 1 : -1;
}

function getCategories($layout)
{
    $layoutesc = pg_escape_string($layout);
    $lres = db_query("select id from calclayout where name='$layoutesc'");
    if (!hasResult($lres))
	return FALSE;

    $lid = pg_fetch_result($lres, 0, 0);

    $cres = db_query("select short_description from category where calclayout=$lid");
    if (!hasResult($cres))
	return FALSE;

    $cname = pg_fetch_result($cres, 0, 0);

    return $cname;
}

// get teachers based on the layout and geoip coordinates
function getFirstTeachers($layout)
{
    $layoutesc = pg_escape_string($layout);
    $lres = db_query("select id from calclayout where name='$layoutesc'");
    if (!hasResult($lres))
	return FALSE;

    $lid = pg_fetch_result($lres, 0, 0);

    $cres = db_query("select id from category where calclayout=$lid");
    if (!hasResult($cres))
	return FALSE;

    $cid = pg_fetch_result($cres, 0, 0);

    $fres = db_query("select fc.felhasznalo from felhasznalo_category as fc,
     felhasznalo as f where fc.category=$cid and fc.felhasznalo=f.id
     and (f.aktiv isnull or f.aktiv)");
    if (pg_num_rows($fres) == 0)
    {
	return NULL;
    }
    if (!hasResult($fres))
	return FALSE;

//print "Ok 1.";

    $count = 0;
    $teachers; // ???

    while ($row = pg_fetch_row($fres))
    {
	$usres = db_query("select teljes_nev , kis_foto_fajl , " .
			  "geoip_szelesseg , geoip_hosszusag , " .
			  "rovid_leiras from felhasznalo where id=$row[0]");
        if (!hasResult($usres))
	    return FALSE;
	$usdata = pg_fetch_row($usres);
//	$usname = pg_fetch_result($usres, 0, 0);
        $usdata2[0] = iconv("ISO-8859-2", "UTF-8", $usdata[0]);
	$usdata2[1] = $usdata[1];
	$usdata2[2] = $usdata[2];
	$usdata2[3] = $usdata[3];
	$usdata2[4] = iconv("ISO-8859-2", "UTF-8", $usdata[4]);
    // We use these data when logging into showed_ad (main.php, "for"):
	$usdata2[5] = $cid; // category.id
	$usdata2[6] = $row[0]; // user.id (felhasznalo.id)
	$teachers[$count] = $usdata2; //$usname;
	$count++;
    }

    if ($_SESSION['geoip_latitude'] == NULL ||
	$_SESSION['geoip_longitude'] == NULL)
    {
	return $teachers;
    }

    usort($teachers, "compareGeoABigger");

    return $teachers;
}


// Get teachers based on city name
function getTeachersCity($city)
{

    $cityesc = pg_escape_string($city);
    $tres = db_query("SELECT teljes_nev, kis_foto_fajl, rovid_leiras, id\n" .
		     "FROM felhasznalo WHERE varosnev='$cityesc' " .
		     "AND (aktiv isnull OR aktiv) ORDER BY teljes_nev");

    if (pg_num_rows($tres) == 0)
	return NULL;

    if (!hasResult($tres))
	return FALSE;

    $count = 0;
    $teachers = array();
    while ($trow = pg_fetch_row($tres))
    {
	$data = array();
	$data[0] = iconv("ISO-8859-2", "UTF-8", $trow[0]);
	$data[1] = $trow[1];
	$data[2] = iconv("ISO-8859-2", "UTF-8", $trow[2]);
	$data[3] = $trow[3];
	$teachers[$count] = $data;
	$count++;
    }
    
    return $teachers;
}

function teacherinfo($ertek)
{

    $ertek = iconv("UTF-8", "ISO-8859-2", $ertek);
    $ertekesc = pg_escape_string($ertek);
    $teres = db_query("SELECT nagy_foto_fajl, elsodleges_telefon, email, " .
		      "honlap, cim, hosszu_leiras " .
		      "FROM felhasznalo WHERE " .
		      "teljes_nev='$ertekesc'");

    if (!hasResult($teres))
	return FALSE;

    $tedata = pg_fetch_row($teres);

    $ertek = iconv("ISO-8859-2", "UTF-8", $ertek);
    $tedata2[0] = $tedata[0];
    $tedata2[1] = $tedata[1];
    $tedata2[2] = $tedata[2];
    $tedata2[3] = $tedata[3];
    $tedata2[4] = iconv("ISO-8859-2", "UTF-8", $tedata[4]);
    $tedata2[5]	= iconv("ISO-8859-2", "UTF-8", $tedata[5]);
    
    print '<table><tr><td width="120px">'."\n";
    print '<img src="';
    if ($tedata[0] == NULL)
    {
	print './teacher/fej32.png';
    }
    else
    {
    	print $tedata[0];
    }

    print '" alt="">';
    print '</td><td valign="top">'."\n";
    print "<font size='+2'>" . $ertek . "</font><br>\n"; // nev
    if ($tedata2[1] != NULL)
	print $tedata2[1] . "<br>\n"; // telefon
    if ($tedata2[2] != NULL) 
	print "<a href='mailto:" . $tedata2[2] . "'>" . $tedata2[2] . "</a><br>\n"; // email
    if ($tedata2[3] != NULL)
        print "<a href='" . $tedata2[3] . "' target='_blank'>" . $tedata2[3] . "</a><br>\n"; // www
    if ($tedata2[4] != NULL)
	print $tedata2[4] . "<br>\n"; // cim
    print "</td></tr></table>\n";
    print $tedata2[5] . "<br>\n"; // leiras
}

function adclicked($felhasznalo, $visitor_ip, $showed)
{
    $felhasznalo = iconv("UTF-8", "ISO-8859-2", $felhasznalo);
    $felhasznaloesc = pg_escape_string($felhasznalo);
    $fres = db_query("SELECT id FROM felhasznalo WHERE teljes_nev='$felhasznaloesc'");
    if (!hasResult($fres))
	return FALSE;

    $fid = pg_fetch_result($fres, 0, 0);
    
    $visitor_ipesc = pg_escape_string($visitor_ip);
    $showedesc = pg_escape_string($showed);
    db_query("UPDATE showed_ad SET clicked='true' where felhasznalo=$fid and " .
	     "visitor_ip='$visitor_ipesc' and showed='$showedesc'");
    // FIXME: two query -> one query

}

// Prints the cities where at least one teacher is
function teacher_city()
{
    $varosres = db_query("SELECT DISTINCT varosnev FROM felhasznalo " .
			 "WHERE (aktiv isnull OR aktiv) ORDER BY varosnev");

    if (!hasResult($varosres))
	return FALSE;

    while ($varosrow = pg_fetch_row($varosres))
    {
//	print "<a href=\"#\">";
	$varos = iconv("ISO-8859-2", "UTF-8", $varosrow[0]);
	print "<a onclick=\"ajaxAllTeacherCity('" . $varos . "')\"";
	print " style=\"cursor:pointer;text-decoration:underline;color:#0000ff\">";
	print $varos;
//	print iconv("ISO-8859-2","UTF-8",$varosrow[0]); // $varosrow[0];
	print "</a><br>";
    }
}

function one_city_teachers($city)
{
    $city = iconv("UTF-8", "ISO-8859-2", $city);
    $teachers = getTeachersCity($city);

    if ($teachers == NULL)
	return NULL;

    $insert = "";
    print "<table>";
    $geoipcity = pg_escape_string($_SESSION['geoip_city']);
    $geoipcity = iconv("UTF-8", "ISO-8859-2", $geoipcity);
    for ($i = 0; $i < count($teachers);	$i++)
    {

//	FIXME: perhaps it should not be registered as a showed ad?
	$now = date("Y-m-d H:i:s");
	$insert .= "INSERT INTO showed_ad 
	 (felhasznalo, showed, visitor_ip, visitor_geoip_city, clicked) VALUES
	 (".$teachers[$i][3] . ", '" . $now . "', '" .
	 $_SERVER['REMOTE_ADDR'] . "', '" . $geoipcity . "', false); ";
	 
        print "<tr><td>\n";
	print "<a onclick=\"ajaxPopupTeacher('" . $teachers[$i][0] . "', '" . $_SERVER['REMOTE_ADDR'] . "', '" . $now . "')\"";
	print " style=\"cursor:pointer;\">";
	print "<img src=" . $teachers[$i][1] . ">";
	print "</a>";
	print "</td><td>\n";
	print "<a onclick=\"ajaxPopupTeacher('" . $teachers[$i][0] . "', '" . $_SERVER['REMOTE_ADDR'] . "', '" . $now . "')\"";
	print " style=\"cursor:pointer;font-size:smaller;\">";
	print $teachers[$i][0];
	print ", ";
	print $teachers[$i][2];
	print "</a><br>\n";
	print "</td></tr>\n";
    }

    print "</table>\n";

}

?>
