<?php
// Server-side file cache related functions

// Function returning an existing file name or FALSE if it does not exist
function isincache($application, $parameter, $formula)
{
    $applicationesc = pg_escape_string($application);
    $appid0 = db_query("select id from application where idcode='$applicationesc'");

    if ((!$appid0) || (@pg_num_rows($appid0) == 0))
	return FALSE;

    $appid = @pg_fetch_result($appid0, 0, 0);
    $parameteresc = pg_escape_string($parameter);
    $formulaesc = pg_escape_string($formula);
    $filename0 = db_query("select filename from request where " .
			  "application=$appid and parameter='$parameteresc'" .
			  " and formula='$formulaesc'");
//	or return FALSE;
//	or die("Error in select query...");

    if (!$filename0)
    {
	return FALSE;
    }
    else if (@pg_num_rows($filename0) == 0)
    {
	return FALSE;
    }
    else
    {
        $filename = @pg_fetch_result($filename0, 0, 0);
	return $filename;
    }
}

function seqid()
// Gives a unique ID, http://hu2.php.net/manual/hu/function.microtime.php,
// contributed by helenadeus@gmail.com.
// 
{
    list($usec, $sec) = explode(" ", microtime());
    list($int, $dec) = explode(".", $usec);
    return $sec . $dec;
}

// Function returning a non-existing file name + database refresh
function puttocache($application, $parameter, $formula)
{
    $applicationesc = pg_escape_string($application);
    $appid0 = db_query("select id,outputmime from application where " .
		       "idcode='$applicationesc'");

    if ((!$appid0) || (@pg_num_rows($appid0) == 0))
	return FALSE;

    $appid = @pg_fetch_result($appid0, 0, 0);
    $mime = @pg_fetch_result($appid0, 0, 1);
    $parameteresc = pg_escape_string($parameter);
    $formulaesc = pg_escape_string($formula);

    // FIXME: here sent==received is forced which is not exact
    // FIXME: very first formula transaction fails here
    $result = db_query("begin; insert into request (application,
                       parameter, formula, sent, received) values
		       ($appid, " . "'$parameteresc', '$formulaesc', " .
		       "now(), now())");
//	or return FALSE;
//    or die("Error in insert into query...");

    $maxid0 = db_query("select max(id) from request");
    $maxid = @pg_fetch_result($maxid0, 0, 0);
    if(!$maxid)
    {
	return FALSE;
    }

    $filename = 'f' . $maxid . '-' . seqid() . '.' . $mime;

    db_query("update request set filename='$filename' where id=$maxid;
              commit");

    return $filename;
}

// Function for clearing a file from the database and the cache
function clearfromcache($application, $parameter, $formula)
{
    $applicationesc = pg_escape_string($application);
    $appid0 = db_query("select id from application where idcode='$applicationesc'");
    $appid = @pg_fetch_result($appid0, 0, 0);
    $parameteresc = pg_escape_string($parameter);
    $formulaesc = pg_escape_string($formula);

    if($appid == ""){

      write_log("Appid is empty in clearfromcache(), includes/cache.php", LOG_ERROR);

      }

    $filename0 = db_query("delete from request where application=$appid " .
			  "and parameter='$parameteresc' and formula='$formulaesc'");
//	or return FALSE;
//    or die("Error in database delete...");
    /*
    if (!$filename0)
    {
	return FALSE;
    }
    else if (pg_num_rows($filename0) == 0)
    {
	return FALSE;
    }
    else
    {
        $filename = @pg_fetch_result($filename0, 0, 0);
	return $filename;
    }
    */
}

?>
