<?php
// Calculator related functions (database)

require_once '../includes/sql.php';

$calc_cached = FALSE;

function inbody($htmlt)
{
    $htmlt1 = explode("<body>", $htmlt);
    if (isset($htmlt1[1]))
	$htmlt2 = explode("</body>", $htmlt1[1]);
    else
	$htmlt2 = $htmlt1;

    return $htmlt2[0];
}

function buttonsolvetext($button, $lang)
{
    global $sql_cached, $lids;

    $button = pg_escape_string($button);
    $result = db_query("select solve_text from calcbutton where name='$button'");
    if (!hasResult($result))
    {
	return FALSE;
    }

    $solvetextid = pg_fetch_result($result, 0, 0);

    if ($solvetextid == NULL)
    {
	$solvetext = '<br>[co]';
    }
    else
    {
	if(!$sql_cached)
	{
	    $lang = pg_escape_string($lang);
    	    $result2 = db_query("select id from _language where langnameen='$lang'");
	    
	    if (!hasResult($result2))
		return FALSE;
		
	    $langid = pg_fetch_result($result2, 0, 0);
	}
	else
	{
	    $langid = $lids[$lang];
	}

	$resulti18n = db_query("select text from i18ntext where mainid=$solvetextid and _language=$langid");

        if (!$resulti18n || pg_num_rows($resulti18n) == 0)
	{
	    $resulti18n = db_query("select text from i18ntext where mainid=$solvetextid and _language=2");
	}

        if (!$resulti18n || pg_num_rows($resulti18n) == 0)
	{
	    $resulti18n = db_query("select text from i18ntext where id=$solvetextid");
	}

        if (!hasResult($resulti18n))
	    return FALSE;

	$solvetext = pg_fetch_result($resulti18n,0,0);
    }
    if ($langid == 1)
      $solvetext = iconv('ISO-8859-2', 'UTF-8', $solvetext);
    return $solvetext;
}


function returnsolvetext($button, $imagefile, $lang, $title)
{

    global $sql_cached, $lids;

    $button = pg_escape_string($button);
    $result = db_query("select solve_text from calcbutton where name='$button'");
    if (!hasResult($result))
    {
	return FALSE;
    }

    $solvetextid = pg_fetch_result($result, 0, 0);

    if ($solvetextid == NULL)
    {
	$solvetext = '<br>[co]';
    }
    else
    {

	if(!$sql_cached)
	{
	    $lang = pg_escape_string($lang);
    	    $result2 = db_query("select id from _language where langnameen='$lang'");

	    if (!hasResult($result2))
		return FALSE;

	    $langid = pg_fetch_result($result2, 0, 0);
	}
	else
	{

	    $langid = $lids[$lang];

	}

	$resulti18n = db_query("select text from i18ntext where mainid=$solvetextid and _language=$langid");

        if (!$resulti18n)
	{
	    $resulti18n = db_query("select text from i18ntext where id=$solvetextid");
	
	}
	else if (pg_num_rows($resulti18n) == 0)
	{
    	    $resulti18n = db_query("select text from i18ntext where id=$solvetextid");
	}

        if (!hasResult($resulti18n))
	    return FALSE;

	$solvetext = pg_fetch_result($resulti18n,0,0);
    }
    if ($langid == 1)
      $solvetext = iconv('ISO-8859-2', 'UTF-8', $solvetext);
    $solvetext = str_replace('[co]', '<div class="picdiv1"><div class="picdiv"><img name="co" id="co" class="coa" src="' . $imagefile . '" title="' . $title . '" alt="' . $title . '"></div></div>', $solvetext);
    print $solvetext;
    return TRUE;
}

function returnbuttontypes($value)
{
    if ($value == "true")
    {
	print "buttoncolor = {\n";
	$result = db_query("select name, textcolor from buttontype");
	if (!hasResult($result))
	    return FALSE;

	while ($row = pg_fetch_row($result))
	{
	    print " \"$row[0]\" : \"$row[1]\", \n";
	}

	print '"":""};'. "\n";
	print "buttonbackground = {\n";

	$result = db_query("select name, bgcolor from buttontype");

	if (!hasResult($result))
	    return FALSE;

	while ($row = pg_fetch_row($result))
	{
	    print " \"$row[0]\" : \"$row[1]\", \n";
	}

	print "\"\":\"\"};\n";

    }
    else
    {
	print 'buttoncolor = {"":""};' . "\n";
	print 'buttonbackground = {"":""};' . "\n";
    }    

    return TRUE;
}

// This function requests info on button group members
function buttongroup($value, $lang)
{
    global $sql_cached, $lids;

    $hinttext = "HINT TEXT";

    if ($value == NULL)
    {
	print "groupby = 1;\n";
	print "group = [\n";
        print '[\"\",\"\",\"\",\"\",\"\",\"\",\"\"]];\n';
        print "groupcount = 0;\n";
    }
    else
    {
	if(!$sql_cached)
	{
	    $langesc = pg_escape_string($lang);
	    $langresult = db_query("select id from _language where langnameen='$langesc'");

	    if (!hasResult($langresult))
		return FALSE;

	    $langresid = pg_fetch_result($langresult, 0, 0);
	}
	else
	{
	    $langresid = $lids[$lang];
	}

	$valueesc = pg_escape_string($value);
	$result = db_query("select id, buttonrow from buttongroup where name='$valueesc'");

	if (!hasResult($result))
	    return FALSE;

        $resultrow = pg_fetch_row($result);

	print "groupby = " . addslashes($resultrow[1]) . ";\n";
	print "group = [\n";

// FIXME : add to query that if layout is null or layoutid
	$resultgroup = db_query("select button, grouporder from buttonlayout where groupid=" . $resultrow[0] . " order by grouporder");

	if (!hasResult($resultgroup))
	    return FALSE;

	$counter = 0;

	while ($row = pg_fetch_row($resultgroup))
	{
	    if ($row[1] != NULL)
	    {
		$counter++;
		$resultbutton = db_query("select name, changestring, _type, html_text, picture, description, hint_text from calcbutton where id=$row[0]");

		if (!hasResult($resultbutton))
		    return FALSE;

        	$rrow = pg_fetch_row($resultbutton);
    
		if ($rrow[2] == NULL)
		{
		    $btype = "";
		}
		else
		{
		    $result1 = db_query("select name from buttontype where id=$rrow[2]");

		    if (!hasResult($result1))
			return FALSE;

		    $btype = pg_fetch_result($result1, 0, 0);
		}

    		$bdesc = "";
		$langid = $langresid;
	    
		if ($rrow[5] == NULL)
		{
        	    $bdesc = "";
		}
		else
		{
        	    $resultdesc = db_query("select text from i18ntext where mainid=$rrow[5] and _language=$langid");
        	    if (!$resultdesc || pg_num_rows($resultdesc) == 0)
		    {
			$resultdesc = db_query("select text from i18ntext where mainid=$rrow[5] and _language=2");
    		    }
        	    if (!$resultdesc || pg_num_rows($resultdesc) == 0)
		    {
			$resultdesc = db_query("select text from i18ntext where id=$rrow[5]");
		    }

		    if (!hasResult($resultdesc))
			return FALSE;

		    $bdesc = pg_fetch_result($resultdesc, 0, 0);
		    if ($langid == 1)
        	      $bdesc = iconv("ISO-8859-2", "UTF-8", $bdesc);
    		}

		if ($rrow[4] == NULL)
		    {

		    if ($rrow[3] == NULL)
		    {

		    $htmltext = $rrow[0];

    	    	    }
		    else
		    {
			$resulthtml = db_query("select text from i18ntext where id=$rrow[3]");

			if (!hasResult($resulthtml))
			    return FALSE;

			$htmltext = pg_fetch_result($resulthtml, 0, 0);
			$htmltext = inbody($htmltext);
		        if ($langid == 1)			
			  $htmltext = iconv('ISO-8859-2', 'UTF-8', $htmltext);
		    }
		}
		else
		{
            	    $htmltext = '<img src="' . $rrow[4] . '" alt="'.$bdesc.'" title="'.$bdesc.'" class="lang">';
		}

		if ($rrow[6] == NULL)
		{
		    $hinttext = "";
		}
		else
		{
		    $resulthint = db_query("select text from i18ntext where mainid=$rrow[6] and _language=$langid");
		    if (!$resulthint || pg_num_rows($resulthint) == 0)
		    {
	    		$resulthint = db_query("select text from i18ntext where id=$rrow[6] and _language=2");
		    }
		    if (!$resulthint || pg_num_rows($resulthint) == 0)
		    {
			$resulthint = db_query("select text from i18ntext where id=$rrow[6]");
		    }

		    if (!hasResult($resulthint))
			return FALSE;

		    $hinttext = pg_fetch_result($resulthint, 0, 0);
	            if ($langid == 1)			
		      $hinttext = iconv("ISO-8859-2", "UTF-8", $hinttext);
		}
		
//		$bdesc = "";
		$bgroup = $value;
		print "[ '" . addslashes($rrow[0]) . "', '" . addslashes($rrow[1]) . "', '" . addslashes($btype) . "', '" . addslashes($bgroup) .
		      "', '" . addslashes($htmltext) . "', '" . addslashes($bdesc) . "', '" . addslashes($hinttext) . "' ],\n";
	    }
	}
	print "[\"\",\"\",\"\",\"\",\"\",\"\",\"\"]];\n";
	print "groupcount = $counter;\n";
    }
    return TRUE;
}

function returnlayout($value, $lang)
{

    global $sql_cached, $lids;

    $hinttext = 'HINT TEXT';

    $valueesc = pg_escape_string($value);
    $result = db_query("select id, description from calclayout where name='$valueesc'");

    if (!$result || pg_num_rows($result) == 0)
	return returnlayout("normal", $lang);

    $layoutrow = pg_fetch_row($result);

    $layoutid = $layoutrow[0];
    $resultb = db_query("select button, sorrend, groupid from buttonlayout where layout=$layoutid order by sorrend");

    if (!$resultb || pg_num_rows($resultb) == 0)
	return returnlayout("normal", $lang);
    
    if(!$sql_cached)
    {
	$langesc = pg_escape_string($lang);
	$resultlan = db_query("select id from _language where langnameen='$langesc'");
	if (!hasResult($resultlan))
	    return FALSE;
	$langid = pg_fetch_result($resultlan, 0, 0);
    }
    else
    {
	$langid = $lids[$lang];
    }
    $resultlangroup = db_query("select id from buttongroup where name='lang'");

    if (!hasResult($resultlangroup))
	return FALSE;
    $langroupid = pg_fetch_result($resultlangroup, 0, 0);

    $rend = 0;
    print "buttons = [\n";
    while ($row = pg_fetch_row($resultb))
    {
	$rend++;
	while (($row[1] > $rend) && ($rend <= 40))
	{
	    $rend++;
	    print "[\"\",\"\",\"\",\"\",\"\",\"\",\"\"],\n";
	}

	if ($rend <= 40)
	{
    	    $resulta0 = db_query("select name, changestring, _type, html_text, picture, description, hint_text from calcbutton where id=$row[0]");

	    if (!hasResult($resulta0))
		return FALSE;

    	    $rrow0 = pg_fetch_row($resulta0);
	
	    if ($row[2] == $langroupid)
	    {
		$resultprev = db_query("select button from langbutton where lang=$langid");

		if (!hasResult($resultprev))
		    return FALSE;

		$rpbutton = pg_fetch_result($resultprev, 0, 0);
	    
		$resulta = db_query("select name, changestring, _type, html_text, picture, description, hint_text from calcbutton where id=$rpbutton");

		if (!hasResult($resulta))
		    return FALSE;

		$rrow = pg_fetch_row($resulta);
	    }
	    else
	    {
		$resulta = $resulta0;
		$rrow = $rrow0;
	    }

            if ($rrow[2] == NULL)
	    {
		$btype = "";
            }
	    else
	    {
    		$result1 = db_query("select name from buttontype where id=$rrow[2]");

		if (!hasResult($result1))
		    return FALSE;

		$btype = pg_fetch_result($result1, 0, 0);
            }
	
	    $bdescid = $rrow[5];
	
	    if ($row[2] == NULL)
	    {
		$bgroup = "";
	    }
	    else
	    {
        	$result2 = db_query("select name, description from buttongroup where id=$row[2]");

		if (!hasResult($result2))
		    return FALSE;

		$resultgroupdb = pg_fetch_row($result2);
		$bgroup = $resultgroupdb[0];

		if ($resultgroupdb[1] != NULL)
		{
		    $bdescid = $resultgroupdb[1];
		}
	    }

	    if ($bdescid == NULL)
	    {
		$bdesc = "";
	    }
	    else
	    {
		$resultdesc = db_query("select text from i18ntext where mainid=$bdescid and _language=$langid");
		if (!$resultdesc || pg_num_rows($resultdesc) == 0)
		{
	    	    $resultdesc = db_query("select text from i18ntext where mainid=$bdescid and _language=2");
		}
		if (!$resultdesc || pg_num_rows($resultdesc) == 0)
		{
		    $resultdesc = db_query("select text from i18ntext where id=$bdescid");
		}

		if (!hasResult($resultdesc))
		    return FALSE;

		$bdesc = pg_fetch_result($resultdesc, 0, 0);
		if ($langid == 1)
		  $bdesc = iconv("ISO-8859-2", "UTF-8", $bdesc);
	    }

	    if ($rrow[4] == NULL)
	    {
		if ($rrow[3] == NULL)
		{
		    $htmltext = $rrow[0];
		}
		else
		{
		
		    $resulthtml = db_query("select text from i18ntext where id=$rrow[3]");
		    if (!hasResult($resulthtml))
			return FALSE;

		    $htmltext = pg_fetch_result($resulthtml, 0, 0);
		    if ($langid == 1)
		      $htmltext = iconv("ISO-8859-2", "UTF-8", $htmltext);
		}

	    }
	    else
	    {
		$htmltext = '<img src="' . $rrow[4] . '" alt="'.$bdesc.'" title="'.$bdesc.'" class="lang">';
	    }
	    
	    if ($rrow[6] == NULL)
	    {
		$hinttext = "";
	    }
	    else
	    {
		$resulthint = db_query("select text from i18ntext where mainid=$rrow[6] and _language=$langid");
		if (!$resulthint || pg_num_rows($resulthint) == 0)
		{
	    	    $resulthint = db_query("select text from i18ntext where mainid=$rrow[6] and _language=2");
		}
		if (!$resulthint || pg_num_rows($resulthint) == 0)
		{
		    $resulthint = db_query("select text from i18ntext where id=$rrow[6]");
		}

		if (!hasResult($resulthint))
		    return FALSE;

		$hinttext = pg_fetch_result($resulthint, 0, 0);
		if ($langid == 1)
		  $hinttext = iconv("ISO-8859-2", "UTF-8", $hinttext);
	    }

	    print "[ '" . addslashes($rrow[0]) . "', '" . addslashes($rrow[1]) . "', '" . addslashes($btype) . "', '".
	    addslashes($bgroup) . "', '" . addslashes($htmltext) . "', '" . addslashes($bdesc) . "', '" . addslashes($hinttext) . "' ],\n";
        }
    }

    while ($rend <= 40)
    {
	$rend++;
        print "[\"\",\"\",\"\",\"\",\"\",\"\",\"\"],\n";
    }

    print "[\"\",\"\",\"\",\"\",\"\",\"\",\"\"]];";

    return TRUE;
}


function returnintrotext($layout, $lang)
{

    global $sql_cached, $lids;

    $layoutesc = pg_escape_string($layout);
    $result = db_query("select introductory_text from calclayout where name='$layoutesc'");

    if (!hasResult($result))
	return FALSE;

    $introtextid = pg_fetch_result($result, 0, 0);
    if ($introtextid == NULL)
    {
	print "[phperror]Database field not filled.\n[/phperror]";
	return FALSE;
    }

    if(!$sql_cached)
    {
	$langesc = pg_escape_string($lang);
	$result2 = db_query("select id from _language where langnameen='$langesc'");

	if (!hasResult($result2))
	    return FALSE;

	$langid = pg_fetch_result($result2, 0, 0);
    }
    else
    {
	$langid = $lids[$lang];
    }

    $resulti18n = db_query("select text from i18ntext where mainid=$introtextid and _language=$langid");
    if (!resulti18n)
    {
	print "[phperror]PHP database Error.\n[/phperror]";
	return FALSE;
    }
    else if (pg_num_rows($resulti18n) == 0)
    {
	$resulti18n = db_query("select text from i18ntext where id=$introtextid");
    }

    if (!hasResult($resulti18n))
	return FALSE;

    $introtext = pg_fetch_result($resulti18n, 0, 0);
    if ($introtextid == NULL)
    {
	print "[phperror]Database field not filled.\n[/phperror]";
	return FALSE;
    }

    $introtext = inbody($introtext);
    if ($langid == 1)
      $introtext = iconv("ISO-8859-2", "UTF-8", $introtext);
    print $introtext;

    return TRUE;
}

function langavailable($langname)
{

    $langnameesc = pg_escape_string($langname);
    $result = db_query("SELECT available FROM _language WHERE langnameen='$langnameesc'");

    if (!hasResult($result))
	return FALSE;

    $resultbool = pg_fetch_result($result, 0, 0);
    
    return $resultbool == "t";
}

function button2lang($buttonname)
{

    $buttonesc = pg_escape_string($buttonname);
    $result = db_query("select id from calcbutton where name='$buttonesc'");

    if (!hasResult($result))
	return FALSE;

    $buttonid = pg_fetch_result($result, 0, 0);

    $result2 = db_query("select lang from langbutton where button=$buttonid");

    if (!hasResult($result2))
	return FALSE;

    $langid = 2;

    if (pg_num_rows($result2) == 1)
    {
	$langid = pg_fetch_result($result2, 0, 0);
    }

    $result3 = db_query("select langnameen from _language where id=$langid"); // FIXME: $sql_cached
    return pg_fetch_result($result3, 0, 0);

}

function getlayoutmessage($layout, $lang)
{
    global $sql_cached, $lids;

    $layoutesc = pg_escape_string($layout);
    $didr = db_query("select description from calclayout where name='$layoutesc'");

    if (!hasResult($didr))
	return FALSE;

    $did = pg_fetch_result($didr, 0, 0);

    if(!$sql_cached)
    {
	$langesc = pg_escape_string($lang);
	$langidr = db_query("select id from _language where langnameen='$langesc'");

	if (!hasResult($langidr))
	    return FALSE;

        $langid = pg_fetch_result($langidr, 0, 0);
    }
    else
    {
    
	$langid = $lids[$lang];
    
    }

    $di18nr = db_query("select text from i18ntext where mainid=$did and _language=$langid");
    if (!$di18nr || pg_num_rows($di18nr) == 0)
    {
	$di18nr = db_query("select text from i18ntext where mainid=$did and _language=2");
    }
    if (!$di18nr || pg_num_rows($di18nr) == 0)
    {
	$di18nr = db_query("select text from i18ntext where id=$did");
    }

    if (!hasResult($di18nr))
	return FALSE;
    
    $di18n = pg_fetch_result($di18nr, 0, 0);
    if ($langid == 1)
      return iconv("ISO-8859-2", "UTF-8", $di18n);
    else
      return $di18n;
}

function layoutImagePreload($value)
{
    $ret = '';

    $valueesc = pg_escape_string($value);
    $result = db_query("select id from calclayout where name='$valueesc'");

    if (!$result || pg_num_rows($result) == 0)
	return layoutImagePreload("normal");
    
    $layoutrow = pg_fetch_row($result);
    $layoutid = $layoutrow[0];
    $resultb = db_query("select button, groupid, grouporder from buttonlayout where layout=$layoutid and groupid notnull");
    
    if (!$resultb || pg_num_rows($resultb) == 0)
	return layoutImagePreload("normal");
    
    $ret .= "var liarray = [\n";
    while ($row = pg_fetch_row($resultb))
    {
	if ($row[2] != NULL)
	{
            $resulta0 = db_query("select picture from calcbutton where id=" . $row[0]);

	    if (!hasResult($resulta0))
	        return FALSE;

            $rrow0 = pg_fetch_row($resulta0);

	    if ($rrow0[0] != NULL)
	    {
    	        $ret .= "'" .  $rrow0[0] . "', ";
	    }
	}
	    
	if ($row[2] == NULL)
	{
	    $resulta1 = db_query("select button from buttonlayout where groupid=". $row[1] . " and layout isnull");

	    if (!hasResult($resulta1))
		return FALSE;

	    while ($rrow1 = pg_fetch_row($resulta1))
	    {
		$resulta2 = db_query("select picture from calcbutton where id=" . $rrow1[0]);

		if (!hasResult($resulta2))
		    return FALSE;

		$rrow2 = pg_fetch_row($resulta2);
		if ($rrow2[0] != NULL)
		{
		    $ret .= "'" . $rrow2[0] . "', ";
		}
	    }
	}
	
    }
    
    $resultc = db_query("select button from buttonlayout where layout=$layoutid and groupid isnull and sorrend notnull");
    
    if (!(!$resultc || pg_num_rows($resultc) == 0))
    {
	
	while ($rowc = pg_fetch_row($resultc))
	{
	    if ($rowc[0] != NULL)
	    {
        	$resultc0 = db_query("select picture from calcbutton where id=" . $rowc[0]);

		if (!hasResult($resultc0))
	    	    return FALSE;

        	$rrowc = pg_fetch_row($resultc0);
		if ($rrowc[0] != NULL)
		{
    	    	    $ret .= "'" .  $rrowc[0] . "', ";
		}
	    }
	}
    }

    $ret .= "'./image/groupsign.gif'";
    
    $ret .= " ];\n";
    print $ret;
    return TRUE;
}

?>
