<?php
// Computer Algebra System related functions

require_once '../includes/config.php';
require_once '../includes/misc.php';
include '../includes/text.php';

function maxima_texmacs($call)
{
//    $maxima3_texmacs = "TEXMACS_PATH=/usr/share/texmacs/TeXmacs/";
//    $maxima3_installation = "/usr/lib/texmacs/TeXmacs/bin/tm_maxima 5.9.2 gcl";
//    execlog2($maxima3_texmacs . '; echo "' . $call . '$ tex(%);" | ' . $maxima3_installation, $maxima_answer);

    $maxima2_installation = "TEXMACS_PATH=/usr/share/texmacs/TeXmacs/ /usr/lib/texmacs/TeXmacs/bin/tm_maxima 5.9.2 gcl";
    execlog2('echo "' . $call . '$ tex(%);" | ' . $maxima2_installation, $maxima_answer);
//    | sed s/"\(('.$icode.'[0-9]*)\) "/""/g | grep -v "('.$ocode.'"', $maxima_answer);

    $start_line = 1;
    $returntex = '';
    for ($i = $start_line - 1; $i < count($maxima_answer); ++$i)
    {
        $line=$maxima_answer[$i];
//        $line=eliminate_tabs($line,8);
//        $line=str_pad($line,$formatted_length); // FIXME
        $returntex = $returntex . $line;
    }

    return $returntex;
/*    $first = strpos($returntex,'$$');
    $second = strpos($returntex,'$$',$first+1);
    if ($first == FALSE || $second == FALSE) {
	$keplet = "$$\%$$";
    } else {
        $keplet = substr($returntex,$first,$second-$first+2);	
    }
    return $keplet;
*/
}

// Returns the result of a maxima call in a tex format variable with $$
function maxima($call)
{
    global $maxima_installation, $maxima_version, $maxima_leadinglines;

    $start_line = $maxima_leadinglines;
    $icode = "C";

    if ($maxima_version >= 50901)
        $icode = '%i';

    $ocode = "D";

    if ($maxima_version >= 50901)
        $ocode='%o';

/*
    execlog2('echo "'.$call.'$ tex(%);" | '.$maxima_installation.' | sed s/"\(('.$icode.'[0-9]*)\) "/""/g | grep -v "('.$ocode.'"', $maxima_answer);
*/

    write_log("Maxima called with: $call for tex output", LOG_MAXIMA);

    $handlein = popen('echo "linel: 10000$ ERROR$ ' . $call . '$ tex(%);" | ' . $maxima_installation, "r");
    $descriptorspec = array(
	0 => array("pipe", "r"),
	1 => array("pipe", "w"),
	2 => array("file", "/dev/null", "a")
    );
    $maxima_answer = proc_open(
	'sed s/"\(('.$icode.'[0-9]*)\) "/""/g | grep -v "('.$ocode.'"',
	$descriptorspec,
	$pipes
    );

    if (!feof($handlein))
    {
	$linein = fgets($handlein);
	if (strcmp(substr($linein, 0, 13), "ERROR:timeout") == 0)
	{
	    fclose($handlein);
	    fclose($pipes[0]);
	    fclose($pipes[1]);
	    proc_close($maxima_answer);
	    return "ERROR:timeout";
	}
	fwrite($pipes[0], $linein);
    }

    while (!feof($handlein))
    {
	$linein = fgets($handlein);
	fwrite($pipes[0], $linein);
    }

    fclose($handlein);
    fclose($pipes[0]);

    $lineok = $start_line - 1;

    while (!feof($pipes[1]) && $lineok > 0)
    {
	fgets($pipes[1]);
	$lineok--;
    }

    $returntex = '';

    while (!feof($pipes[1]))
    {
        $line = fgets($pipes[1]);
	$line2 = substr($line, 0, strlen($line) - 1);
        $line2 = eliminate_tabs($line2, 8);
        $line2 = str_pad($line2, $formatted_length); // FIXME
        $returntex .= $line2;
    }

    fclose($pipes[1]);
    proc_close($maxima_answer);
    
    write_log("Maxima tex() return: " . preg_quote($returntex), LOG_MAXIMA);
    
    if(strpos($returntex, 'log(0) has been generated.') !== FALSE) // this has to go before the '$$' check
    {
	return "RETURN:log0";
    }

    $first = strpos($returntex, "$$");
    if ($first === FALSE)
    {
	write_log("Maxima returned with NOTHING when trying to make a tex output.", LOG_ERROR);
	return FALSE;
    }

    $second = strpos($returntex, "$$", $first + 1);
    if ($second === FALSE)
    {
	write_log("Maxima returned with NOTHING when trying to make a tex output.", LOG_ERROR);
	return FALSE;
    }

    $keplet = substr($returntex, $first, $second - $first + 2);
    if ($keplet == '$$ERROR$$' || $keplet == '$${ERROR}$$' || $keplet == '$${\it ERROR}$$')
    {
	if (strpos($returntex, 'Division by 0') !== FALSE)
	{
	    return "RETURN:div0";
	}
	write_log("Maxima returned with ERROR when trying to make a tex output.", LOG_ERROR);
        return FALSE;
    }
    else
    {
	write_log("Maxima returned with tex output: " . preg_quote($keplet), LOG_MAXIMA);
	write_log("Maxima returned with tex output: " . $keplet, LOG_ERROR);
	if ($keplet == '$$und$$' || $keplet == '$${und}$$' || $keplet == '$${\it und}$$')
	{
    	    return "RETURN:undefined";
	}
	else if ($keplet == '$$false$$' || $keplet == '$$\mathbf{false}$$')
	{
    	    return "RETURN:false";
	}
	else if ($keplet == '$$true$$' || $keplet == '$$\mathbf{true}$$')
	{
	    return "RETURN:true";
	}
	else if ($keplet == '$$nosolution$$' || $keplet == '$${nosolution}$$' || $keplet == '$${\it nosolution}$$')
	{
	    return "RETURN:nosolution";
	}
	else if ($keplet == '$$ind$$' || $keplet == '$${ind}$$' || $keplet == '$${\it ind}$$')
	{
	    return "RETURN:ind";
	}
        return $keplet;
    }
}


// Returns the result of a maxima call in maxima format
function maxima_string($call)
{
    global $maxima_installation, $maxima_version, $maxima_leadinglines;

    $start_line = $maxima_leadinglines;
    $icode = "C";
    
    if ($maxima_version >= 50901)
        $icode = '%i';

    $ocode = "D";

    if ($maxima_version >= 50901)
        $ocode = '%o';

    $maxima_statement='linel: 100000$ ratprint:false$ solvetrigwarn:false$ ' . $call . '$ string(%);';

    $exec_statement = 'echo "' . $maxima_statement . '" | ' . $maxima_installation;
    exec($exec_statement, $maxima_answer, $retvar);

    $patterns = array();
    if($maxima_version < 51000)
    {
        $patterns[0] = '/\((' . $ocode . '[0-9]*)\)[\t ]*/';
        $reps[0] = '';

        $ret = array();
        for($i = 0; $i < count($maxima_answer); $i++)
	{
            if(strpos($maxima_answer[$i], $icode) === false)
            {
	        $ret[] = $maxima_answer[$i];
	    }
	}
	$maxima_answer = $ret;
    }
    else
    {
        $patterns[0] = '/\(('.$icode.'[0-9]*)\)/';
        $patterns[1] = '/\(('.$ocode .'[0-9]*)\)[\t ]*/';
        $reps[0] = '';
        $reps[1] = '';
    }

    write_log("Maxima called with: $call for string output", LOG_MAXIMA);
    write_log("Full Maxima statement was: $maxima_statement", LOG_MAXIMA);
    write_log("Full exec statement was: $exec_statement", LOG_MAXIMA);

    $returntex = '';
    for ($i = $start_line - 1; $i < count($maxima_answer)-1; ++$i)
    {
	$line = preg_replace($patterns, $reps, $maxima_answer[$i]);
        $line = eliminate_tabs($line, 8);
        $line = str_pad($line, $formatted_length); // FIXME
        $returntex .= $line;
    }

    write_log("Maxima returned with string: $returntex", LOG_MAXIMA);

    $returntex = str_replace("%pi", "pi", $returntex);
    $returntex = str_replace("%e", "e", $returntex);

    return $returntex;
}


// Returns the result of a maple call in a tex format variable TODO(FIXME?)...
function maple($call)
{
    global $maple_installation;
    execlog2('echo "latex(' . $call . ');" | ' . $maple_installation . ' | grep -v "^bytes used" | grep -v "^>"', $maple_answer);
    $returntex = '';
    for ($i = 5; $i < count($maple_answer); ++$i)
    {
	$returntex = $returntex . $maple_answer[$i];
    }
    return $returntex;
}

?>
