<?php
// Formula convert and display related functions

require_once '../includes/config.php';
require_once '../includes/misc.php';
require_once '../includes/log.php';

// This function is for a formconv call without file i/o
function formconv($informula, $informat, $outformat, $params)
{
    global $formconv_installation;

    unset($outformula);
    $ret = NULL;
    execlog_debug_2("echo \"$informula\" | $formconv_installation $params -l simple -I $informat -O $outformat -r 2>&1", $outformula, $ret);
    if ($ret == 139)
    {

      return "ERROR: formconv";

    }
//    execlog_debug("echo \"$informula\" | $formconv_installation $params -I $informat -O $outformat 2>&1", $outformula);
    return $outformula[0];
}

function isFormconvException($formconvreturn)
{
    if (substr($formconvreturn, 0, 9) == "Exception")
    {
	return TRUE;
    }
    else if (substr($formconvreturn, 0, 9) == "terminate")
    {
	return TRUE;
    }

    return FALSE;
}

function invector($formula, $position)
{
    // Not perfect grammar-check
    execlog('cd cache; echo "' . $formula . ';' . $position . '" >> returns.txt');
    if ($position === FALSE)
    {
	return FALSE;
    }

    $formula_php4 = substr($formula, 0, $position);
    $vbegin = substr_count($formula_php4, "[");
    $vend = substr_count($formula_php4, "]");

    if ($vbegin > $vend)
    {
	return TRUE;
    }
    else
    {
        return FALSE;
    }
}


/*
function input2tex($informula, $informat, $outformat, $params)
{

    if (strpos($informula, ",", 0) != NULL)
    {
	$ret = "";
        $fostart = 0;
        $foend = strpos($informula, ",", $fostart);
        while (invector($informula, $foend) == TRUE)
	{
	    $foend = strpos($informula, ",", $foend + 1);
	}
        while (!($foend === FALSE))
	{
	    $formula = substr($informula, $fostart, $foend - $fostart);
	    $formula2 = formconv($formula, $informat, $outformat, $params);
	    
	    if (isFormconvException($formula2))
		$formula2 = $formula;
	    // FIXME: temporary solution because of formconv

            $ret .= $formula2;
    	    $fostart = $foend + 1;
            $foend = strpos($informula, ",", $fostart);
	    while (invector($informula, $foend) == TRUE)
	    {
		$foend = strpos($informula, ",", $foend + 1);
	    }
	    $ret .= ",";
        }
	$foend = strlen($informula);
	$formula = substr($informula, $fostart, $foend - $fostart);
	$formula2 = formconv($formula, $informat, $outformat, $params);
	
	if (isFormconvException($formula2))
	    $formula2 = $formula;
	// FIXME: temporary solution because of formconv
	
	$ret .= $formula2;
	return $ret;
    }
    else
    {
	return formconv($informula, $informat, $outformat, $params);
    }
}

function input2maxima()
{
}
*/

function matrixfilter($informula)
{
    $formula = $informula;
    $mplace = strpos($formula, "matrix(", 0);
    while ($mplace !== FALSE)
    {
	$endsi = strpos($formula, ")", $mplace);
	$startsi = strpos($formula, "(", $mplace + 7);
	if ($endsi === FALSE)
	{
	    return "Error:matrixfilter1";
	}
	else if ($startsi === FALSE)
	{
	    $formula = substr_replace($formula, "]", $endsi, 1);
	    $formula = substr_replace($formula,"[", $mplace, 7);
	    return $formula;
	}
	$innersn = 0;
	if ($startsi < $endsi)
	{
	    $innersn = 1;
	}
	while ($innersn > 0)
	{
	    $endsi = strpos($formula, ")", $endsi + 1);
	    if ($endsi === FALSE)
	    {
		return "Error:matrixfilter";
	    }
	    $innersn--;
	    $startsi = strpos($formula, "(", $startsi + 1);
	    if ($startsi === FALSE)
	    {
	    }
	    else if ($startsi < $endsi)
	    {
		$innersn++;
	    }
	    else
	    {
	    }
	}
	$formula = substr_replace($formula, "]", $endsi, 1);
        $formula = substr_replace($formula, "[", $mplace, 7);
	$mplace = strpos($formula, "matrix(", 0);
    }
    return $formula;
}

function formconvc($informula, $informat, $outformat, $params)
{    
    if (strpos($informula, ",", 0) != NULL)
    {
	$ret = "";
        $fostart = 0;
        $foend = strpos($informula, ",", $fostart);
        while (invector($informula, $foend) == TRUE)
	{
	    $foend = strpos($informula, ",", $foend + 1);
	}
        while (!($foend === FALSE))
	{
	    $formula = substr($informula, $fostart, $foend - $fostart);
	    $formula2 = formconv($formula, $informat, $outformat, $params);
	    
	    if (isFormconvException($formula2))
		$formula2 = $formula;
	    // FIXME: temporary solution because of formconv
	    
            $ret .= $formula2;
    	    $fostart = $foend + 1;
            $foend = strpos($informula, ",", $fostart);
	    while (invector($informula, $foend) == TRUE)
	    {
		$foend = strpos($informula, ",", $foend + 1);
	    }
	    $ret .= ",";
        }
	$foend = strlen($informula);
	$formula = substr($informula, $fostart, $foend - $fostart);
	$formula2 = formconv($formula, $informat, $outformat, $params);
	
	if (isFormconvException($formula2))
	    $formula2 = $formula;
	// FIXME: temporary solution because of formconv
	
	$ret .= $formula2;
	return $ret;
    }
    else
    {
	return formconv($informula, $informat, $outformat, $params);
    }
}

function matrix_remove_lrangle($informula)
{
    $workformula = $informula;
    $workformula = str_replace("\\rangle", "", $workformula);
    $workformula = str_replace("\langle ", "", $workformula);
    return $workformula;
}

function colortex($informula, $color)
{
    $colorentry = "\color{" . $color . "}";
    return str_replace("$$", "$$" . $colorentry, $informula);
}

// This function adds $$ signs to a tex formula and red cursors
function formtex($informula)
{
//    $cosech = "\def\cosech{\mathop{\\rm cosech}\\nolimits}";
//    $sech = "\def\sech{\mathop{\\rm sech}\\nolimits}";
    $cosech = "\def\csch{\mathop{\\rm cosech}\\nolimits}";
    $sech = "\def\sech{\mathop{\\rm sech}\\nolimits}";
    $definecolor = "\definecolor{FDarkRed}{rgb}{0.8,0.3,0.3}";
    $definemacro = "\\newcommand\\rfillsquare{\mathrel{\mathchoice{\hbox{\\vrule width 5 pt height 7.5 pt depth 1 pt}}{\hbox{\\vrule width 4.5 pt height 6.5 pt depth 1 pt}}{\hbox{\\vrule width 3.5 pt height 5 pt depth 1 pt}}{\hbox{\\vrule width 3 pt height 4 pt depth 1 pt}}}}";
    $informula = $definecolor . $definemacro . $cosech . $sech . "\color{red}" . $informula;
    $informula = str_replace("..", "\color{red}{\\rfillsquare}", $informula);
    $informula = str_replace("*$", "$", $informula);
    $informula = str_replace("$", "\color{FDarkRed}{\\rfillsquare}", $informula);
    $informula = str_replace("bb", "\color{FDarkRed}{\\rfillsquare}", $informula);
    return '$$' . $informula . '$$';
}

// This function is for making a tex file from a tex format formula
function maketex($informula, $outfilename)
{
    global $tempdir;

    $texfile = fopen($tempdir . '/' . $outfilename, "w");
    fwrite($texfile, '\\documentclass[english]{article} ');
    fwrite($texfile, '\\usepackage{color} ');
    fwrite($texfile, '\\pagestyle{empty} ');
    fwrite($texfile, '\\usepackage{babel} ');
    fwrite($texfile, '\scrollmode\input ');
    fwrite($texfile, '\\begin{document} ');
    // Here we should find a LaTeX macro to force the output
    // to be more than one row if the input is too long:
    fwrite($texfile, '\\tolerance 10000 ');
    fwrite($texfile, $informula.' ');
    fwrite($texfile, '\\end{document}');
    fclose($texfile);
    //    \hrule width 3 pt height 3 pt depth 3 pt
}

// This function is for making a png picture from a tex file in tempdir
function tex2png($texfilename, $pngfilename, $texdensity)
{
    global $latex_installation, $convert_installation, $tempdir,
	    $max_tex_size, $max_png_width, $max_png_height;
    
    $basename = substr($pngfilename, 0, -4);
    $tex2filename = $basename . '.tex';
    $dvifilename = $basename . '.dvi';
    $epsfilename = $basename . '.eps';
    
    if (filesize($tempdir . '/' . $texfilename) > $max_tex_size)
    {
//	print "maxtexsize:(".$max_tex_size.")";
	return "FALSE";
    }
    
    execlog_debug_1('cd ' . $tempdir . '; cp ' . $texfilename . ' ' . $tex2filename . '; ' . $latex_installation . ' ' . $tex2filename . '; dvips -E -o ' . $epsfilename . ' ' . $dvifilename . ' 1>&2 2>' . $tempdir . '/info0.txt');
//    execlog('cd ' . $tempdir . '; ' . $convert_installation . ' -crop 0x0 -density ' . $texdensity . 'x' . $texdensity . ' ' . $epsfilename . ' png:' . $pngfilename . ' 1>&2 2>' . $tempdir . '/info.txt');
    execlog_debug_1('cd ' . $tempdir . '; ' . $convert_installation . ' -trim -density ' . $texdensity . 'x' . $texdensity . ' ' . $epsfilename . ' png:' . $pngfilename . ' 1>&2 2>' . $tempdir . '/info.txt');
    
    unlinklog($tempdir . '/' . $epsfilename);
    unlinklog($tempdir . '/' . $dvifilename);
    unlinklog($tempdir . '/' . $tex2filename);
    unlinklog($tempdir . '/' . $basename . '.aux');
    unlinklog($tempdir . '/' . $basename . '.log');

    $isize = @GetImageSize($tempdir . '/' . $pngfilename);
    if (0 + $isize[1] > $max_png_height || 0 + $isize[1] <= 1 || 
	0 + $isize[0] > $max_png_width)
    {
//	print "tempdir:(".$tempdir."),pngfilename:(".$pngfilename."),1:(".$isize[1]."),2:(".$isize[0]."),m1:(".$max_png_height.
//	"),m2:(".$max_png_width.")";
	return "FALSE";
    }
    else
    {
        return "TRUE";
    }
}
