<?php
// Logging related functions

require_once '../includes/config.php';

$logfds = array(); // array of loglevel -> file descriptors, 1 fd per loglevel

// Opens logfile $file and names it log level $level
function open_log($file, $level)
{

    global $logfds, $logpath;

    if(isset($logfds[$level]))
    {
    
	return FALSE;
    
    }

    $file = (string) $file;
    $level = (string) $level;

    $fp = @fopen($logpath.$file, "a");
    if(!$fp)
    {
    
	return FALSE;
    
    }
    
    $logfds[$level] = $fp;

    return $fp;

}
// Closes the logfile associated with log level $level
function close_log($level)
{

    global $logfds;

    if(!isset($logfds[$level]) || @get_resource_type($logfds[$level]) != "file")
    {
  
	return FALSE;

    }

    return @fclose($logfds[$level]);

}

// Writes in logfile associated with log level $level
function write_log($txt, $level)
{

    global $logfds, $timestamp_format, $log_files;

    $level = (int) $level;
    $txt = (string) $txt;
    $ret = 0;

    for($i = 0; $i < count($log_files); $i++)
    {

	$log_files[$i][1] & $level && isset($logfds[$log_files[$i][0]]) && // FD in loglevel and loglevel exists
	get_resource_type($logfds[$log_files[$i][0]]) == "stream" && // loglevel is a valid file
	@fwrite($logfds[$log_files[$i][0]], strftime($timestamp_format) . "<" . session_id() . "> $txt\n") && // write successful
	$ret++; // increment the number of written FD's

    }

    return $ret;

}


// Open the logfiles
for($i = 0; $i < count($log_files); $i++)
{

    open_log($log_files[$i][2], $log_files[$i][0]);

}


?>
