<?php
// Formatted output (and SQL) related functions.

require_once '../includes/sql.php';

// Substitutes TAB characters with spaces.
function eliminate_tabs($string, $tabstop)
{
    $answer = '';
    $l = strlen($string);
    $j = 1;
    for ($i = 0; $i < $l; ++$i, ++$j)
    {
	if ($string[$i] == "\t")
	{
	    $answer .= ' ';
	    while ($j % $tabstop != 0)
	    {
		$answer .= ' ';
		++$j;
	    }
	}
	else
	{
	    $answer .= $string[$i];
	}
    }
    
    return $answer;
}

// Functions for copyright information

function s($size)
{
    return '<p style="text-align: center; color: white; font-family: verdana; font-size: '.
    $size . 'px"><span style="left: 20px">';
}

function e()
{
    return "</span></p>\n";
}

function copyinfo($lang, $size)
{
    global $package_version;

    echo s($size) . getmessage("info_copyright", $lang) . e();
    echo s($size);
    echo sprintf(getmessage("info_poweredby", $lang), "$package_version " .
                 strftime("(%Y-%m-%d)", filemtime("../includes/config.php")));
    echo e();
    echo s($size) . getmessage("info_datapower", $lang) . e();
    echo s($size) . getmessage("info_graphpower", $lang) . e();
    echo s($size) . getmessage("info_underlying", $lang) . e();
    echo "<hr>\n";
    echo s($size) . getmessage("info_contact", $lang) . e();
    echo s($size) . getmessage("info_bugs", $lang) . e();
}

function infotitle($lang, $size)
{
    echo s($size + 1) . getmessage("info_title", $lang) .  e();
    echo "<hr>\n";
    copyinfo($lang, $size);
}

// Determine which type of images we are using
if(strpos($_SERVER['HTTP_USER_AGENT'], "Firefox/2") !== false ||
   strpos($_SERVER['HTTP_USER_AGENT'], "Iceweasel/2") !== false)
{
    $imgext = "png";
}
else
{
    $imgext = "gif";
}
?>
