<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html;charset=utf-8">
<link rel="shortcut icon" type="image/x-icon" href="icon/wmi2_shortcut2.png">
<title>matek.hu install test</title>
</head>
<body>
matek.hu install test<br>
<?php

include '../includes/config.php';
$includefrom = 'install.php';
include '../includes/sql.php';

// TODO: more functions
$func = array(array("Math", "sqrt", "pow"),
	      array("PgSQL", "pg_connect", "pg_last_error", "pg_num_rows", "pg_escape_string", "pg_fetch_result",
	    	    "pg_fetch_row", "pg_fetch_array", "pg_close"),
	      array("System", "exec", "unlink"),
	      array("GD", "GetImageSize"),
	      array("File", "fopen", "fclose", "fwrite", "filemtime"),
	      array("Other", "get_resource_type", "is_object", "printf", "strlen", "dirname", "strpos", "str_pad", "addslashes"),
	      array("PCRE", "preg_replace"),
	      array("Date and Time", "strftime"),
	      array("Iconv", "iconv"),
	      array("GeoIP", "shmop_open", "shmop_write", "shmop_close", "shmop_delete", "ip2long", "chr", "ord",
	    	    "ereg", "str_replace", "split", "fseek", "substr")
	      );

function checkfunc()
{

    global $func;
    $ret = "";
    for($i = 0; $i < count($func); $i++)
    {

	for($j = 1; $j < count($func[$i]); $j++)
	{


	    if(!function_exists($func[$i][$j]))
	    {

	    $ret .= "Function \"" . $func[$i][$j] . "\" not found! Please check if all " . $func[$i][0] ." related requirements are met.<br>\n";

	    }

	}

    }

    return $ret;
}

function checkquotes()
{

    if(get_magic_quotes_gpc() != 1)
    {

// FIXME
//    echo "WMI2 is going to add extra slashes(addslashes()) automatically.<br>\n";

    return "Warning! magic_quotes_gpc is set to 0, which is a security risk<br>\n";
    }

    return "";

}

function checkversion()
{
// TODO: determine minimal PHP version
    if(version_compare(PHP_VERSION, "4.1", "<") == 1)
    {
        return "The installed PHP version(" . PHP_VERSION . ") seems to be old. Incompatibilites may occur. Please update to at least PHP4.1.<br>\n";
    }
    return "";
}

function checklogdir()
{

    global $logpath;
    
    if(is_writable($logpath))
    {
    
	return "";
    
    }
    else
    {
    
	return "\"$logpath\" is not writable";
    
    }

}


function checkcachedir()
{

    global $tempdir;
    
    
    if(is_writable($tempdir))
    {
    
	return "";
    
    }
    else
    {
    
	return "\"$tempdir\" is not writable";
    
    }

}

function checkpgsql()
{

    global $link;
    
    
    if($link && is_resource($link))
    {
    
	return "";
    
    }
    else
    {
    
	return "No SQL Connection!";
    
    }

}


function checkexecdir()
{

    if(ini_get(safe_mode_exec_dir) == "")
    {
    
	return "";
    
    }
    else
    {
    
	// TODO: check directories if they contain maxima, etc
	return "safe_mode_exec_dir is set. Many programs used by WMI2 may not be called at all, rendering WMI2 useless.";
    
    }

}

function checkincludedir()
{

    if(ini_get(safe_mode_include_dir) == "")
    {
    
	return "";
    
    }
    else
    {
	$test = FALSE;
	// TODO: check directories if include is possible
	
	if((@include_once '../includes/test.php') && $test === TRUE)
	{
	    return "Restricted, but seems to work.";
	}
	else
	{
	    return "safe_mode_include_dir is set and WMI2 may not work with this restriction.<br>\n".
		   "Please enable the WMI2 directory in safe_mode_include_dir";
	}
    
    }

}


function ok()
{

    echo "OK";

}

function error($x)
{

    echo "Error: $x";

}

// TODO: safe mode --- escapeshellcmd(), disable_functions, open_basedir

$safemode = (ini_get("safe_mode") == "") ? FALSE : TRUE;


?>
<table>
<tr><td>Checking available PHP functions</td><td><?php $x = checkfunc(); if($x == "") ok(); else error($x); ?></td></tr>
<tr><td>Checking magic_quotes_gpc</td><td><?php $x = checkquotes(); if($x == "") ok(); else error($x); ?></td></tr>
<tr><td>Checking PHP version</td><td><?php $x = checkversion(); if($x == "") ok(); else error($x); ?></td></tr>
<tr><td>Checking if logs directory is writable</td><td><?php $x = checklogdir(); if($x == "") ok(); else error($x); ?></td></tr>
<tr><td>Checking if cache directory is writable</td><td><?php $x = checkcachedir(); if($x == "") ok(); else error($x); ?></td></tr>
<tr><td>Checking if PgSQL connection could be made</td><td><?php $x = checkpgsql(); if($x == "") ok(); else error($x); ?></td></tr>
<tr><td>Checking Safe Mode</td><td><?php if($safemode) echo "ON"; else echo "OFF"; ?></td></tr>
<?php
if($safemode)
{
?>
<tr><td>Checking safe_mode_exec_dir</td><td><?php $x = checkexecdir(); if($x == "") ok(); else error($x); ?></td></tr>
<tr><td>Checking safe_mode_include_dir</td><td><?php $x = checkincludedir(); if($x == "") ok(); else error($x); ?></td></tr>
<?php
}
?>
</table>
</body>
</html>
