--
-- PostgreSQL database dump
--

SET client_encoding = 'latin2';
SET check_function_bodies = false;
SET client_min_messages = warning;

--
-- Name: SCHEMA public; Type: COMMENT; Schema: -; Owner: postgres
--

COMMENT ON SCHEMA public IS 'Standard public schema';


--
-- Name: plpgsql; Type: PROCEDURAL LANGUAGE; Schema: -; Owner: 
--

CREATE PROCEDURAL LANGUAGE plpgsql;


SET search_path = public, pg_catalog;

--
-- Name: array_to_list(anyarray); Type: FUNCTION; Schema: public; Owner: postgres
--

SET default_tablespace = '';

SET default_with_oids = true;

--
-- Name: _language; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE _language (
    id serial NOT NULL,
    langnameen text,
    langnameown text,
    flagiconfile text,
    available boolean,
    os integer,
    sorrend double precision
);


ALTER TABLE public._language OWNER TO postgres;

--
-- Name: _language_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('_language', 'id'), 12, true);


--
-- Name: application; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE application (
    id serial NOT NULL,
    handle text,
    outputmime text,
    idcode text,
    maxsize integer,
    description integer,
    os integer,
    sorrend double precision
);


ALTER TABLE public.application OWNER TO postgres;

--
-- Name: application_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('application', 'id'), 10, true);


--
-- Name: buttongroup; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE buttongroup (
    id serial NOT NULL,
    name text,
    buttonrow integer,
    description integer,
    os integer,
    sorrend double precision
);


ALTER TABLE public.buttongroup OWNER TO postgres;

--
-- Name: buttongroup_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('buttongroup', 'id'), 62, true);


--
-- Name: buttonlayout; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE buttonlayout (
    id serial NOT NULL,
    layout integer,
    button integer,
    buttonorder integer,
    groupid integer,
    grouporder integer,
    os integer,
    sorrend double precision
);


ALTER TABLE public.buttonlayout OWNER TO postgres;

--
-- Name: buttonlayout_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('buttonlayout', 'id'), 430, true);


--
-- Name: buttontype; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE buttontype (
    id serial NOT NULL,
    name text,
    description integer,
    textcolor text,
    bgcolor text,
    os integer,
    sorrend double precision
);


ALTER TABLE public.buttontype OWNER TO postgres;

--
-- Name: buttontype_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('buttontype', 'id'), 17, true);


--
-- Name: calcbutton; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE calcbutton (
    id serial NOT NULL,
    name text,
    _type integer,
    changestring text,
    picture text,
    description integer,
    html_text integer,
    solve_text integer,
    hint_text integer,
    os integer,
    sorrend double precision
);


ALTER TABLE public.calcbutton OWNER TO postgres;

--
-- Name: calcbutton_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('calcbutton', 'id'), 320, true);


--
-- Name: calclayout; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE calclayout (
    id serial NOT NULL,
    name text,
    description integer,
    introductory_text integer,
    os integer,
    sorrend double precision
);


ALTER TABLE public.calclayout OWNER TO postgres;

--
-- Name: calclayout_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('calclayout', 'id'), 11, true);


--
-- Name: category; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE category (
    id serial NOT NULL,
    short_description text,
    long_description text,
    calclayout integer,
    parent integer,
    os integer,
    sorrend double precision
);


ALTER TABLE public.category OWNER TO postgres;

--
-- Name: category_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('category', 'id'), 10, true);


--
-- Name: checkcode; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE checkcode (
    id serial NOT NULL,
    mcode text,
    os integer,
    sorrend double precision
);


ALTER TABLE public.checkcode OWNER TO postgres;

--
-- Name: checkcode_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('checkcode', 'id'), 3, true);


--
-- Name: dokumentum; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE entry (
    id serial NOT NULL,
    name character varying NOT NULL,
    parent integer,
    is_leaf boolean DEFAULT false NOT NULL,
    CONSTRAINT entry_name_check CHECK (((name)::text <> ''::text))
);


ALTER TABLE public.entry OWNER TO postgres;

--
-- Name: entry_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('entry', 'id'), 14, true);


--
-- Name: exercise; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE exercise (
    id serial NOT NULL,
    title text,
    extype integer,
    _language integer,
    calclayout integer,
    problemtext integer,
    generatorcode integer,
    solvecode integer,
    checkcode integer,
    source text,
    sourcedef text,
    os integer,
    sorrend double precision
);


ALTER TABLE public.exercise OWNER TO postgres;

--
-- Name: exercise_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('exercise', 'id'), 3, true);


--
-- Name: f_alfolyam_verem; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE felhasznalo (
    id serial NOT NULL,
    vezeteknev text,
    keresztnev text,
    jelszo text,
    jelszo_ervenyes_tol timestamp without time zone DEFAULT now(),
    jelszo_ervenyes_ig timestamp without time zone DEFAULT 'infinity'::timestamp without time zone,
    teljes_nev text,
    azonosito text,
    elsodleges_telefon text,
    email text,
    honlap text,
    cim text,
    kis_foto_fajl text,
    nagy_foto_fajl text,
    geoip_szelesseg double precision,
    geoip_hosszusag double precision,
    rovid_leiras text,
    hosszu_leiras text,
    varosnev text,
    aktiv boolean,
    os integer,
    sorrend double precision,
    elotag text
);


ALTER TABLE public.felhasznalo OWNER TO postgres;

--
-- Name: felhasznalo_category; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE felhasznalo_category (
    id serial NOT NULL,
    felhasznalo integer,
    category integer,
    os integer,
    sorrend double precision
);


ALTER TABLE public.felhasznalo_category OWNER TO postgres;

--
-- Name: felhasznalo_category_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('felhasznalo_category', 'id'), 62, true);


--
-- Name: felhasznalo_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('felhasznalo', 'id'), 12, true);


--
-- Name: forditas; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE gencode (
    id serial NOT NULL,
    mcode text,
    os integer,
    sorrend double precision
);


ALTER TABLE public.gencode OWNER TO postgres;

--
-- Name: gencode_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('gencode', 'id'), 3, true);


--
-- Name: hang; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE i18ntext (
    id serial NOT NULL,
    mainid integer,
    _language integer,
    text text,
    os integer,
    sorrend double precision
);


ALTER TABLE public.i18ntext OWNER TO postgres;

--
-- Name: i18ntext_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('i18ntext', 'id'), 3063, true);


--
-- Name: kep; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE langbutton (
    id serial NOT NULL,
    lang integer,
    button integer
);


ALTER TABLE public.langbutton OWNER TO postgres;

--
-- Name: langbutton_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('langbutton', 'id'), 12, true);


--
-- Name: latogatas; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE mathtext (
    id serial NOT NULL,
    mtext text,
    os integer,
    sorrend double precision
);


ALTER TABLE public.mathtext OWNER TO postgres;

--
-- Name: mathtext_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('mathtext', 'id'), 3, true);


--
-- Name: menu; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE messages (
    id serial NOT NULL,
    handle text,
    textid integer
);


ALTER TABLE public.messages OWNER TO postgres;

--
-- Name: messages_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('messages', 'id'), 62, true);


--
-- Name: mezo; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE request (
    id serial NOT NULL,
    application integer,
    parameter text,
    formula text,
    filename text,
    sent timestamp without time zone,
    received timestamp without time zone,
    os integer,
    sorrend double precision
);


ALTER TABLE public.request OWNER TO postgres;

--
-- Name: request_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('request', 'id'), 9234, true);


--
-- Name: showed_ad; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE showed_ad (
    id serial NOT NULL,
    felhasznalo integer,
    category integer,
    showed timestamp without time zone,
    visitor_ip text,
    visitor_hostname text,
    visitor_geoip_city text,
    visitor_geoip_latitude double precision,
    visitor_geoip_longitude double precision,
    clicked boolean,
    visitor_distance double precision,
    os integer,
    sorrend double precision
);


ALTER TABLE public.showed_ad OWNER TO postgres;

--
-- Name: showed_ad_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('showed_ad', 'id'), 59, true);


--
-- Name: solvecode; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE solvecode (
    id serial NOT NULL,
    mcode text,
    os integer,
    sorrend double precision
);


ALTER TABLE public.solvecode OWNER TO postgres;

--
-- Name: solvecode_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('solvecode', 'id'), 3, true);


--
-- Name: szakag; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

COPY _language (id, langnameen, langnameown, flagiconfile, available, os, sorrend) FROM stdin;
1	Hungarian	Magyar	lang_hungarian.gif	t	\N	\N
2	English	English	lang_english.gif	t	\N	\N
6	Spanish	Espanhol	lang_spanish.gif	f	\N	\N
5	Italian	Italiano	lang_italian.gif	t	\N	\N
4	German	Deutsch	lang_german.gif	t	\N	\N
7	Simplified Chinese	中国		t	\N	\N
8	Traditional Chinese	臺灣		t	\N	\N
9	Slovakian	Slovak		t	\N	\N
10	Czech	Ceska		t	\N	\N
3	French	Francais	lang_french.gif	t	\N	\N
11	Serbian	Srpski		t	\N	\N
\.


--
-- Data for Name: application; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY application (id, handle, outputmime, idcode, maxsize, description, os, sorrend) FROM stdin;
1	maxima	tex	maxima-tex	\N	\N	\N	\N
2	maxima	png	maxima-png	\N	\N	\N	\N
3	maximacall	tex	maximacall-tex	\N	\N	\N	\N
4	maximacall	maxima	maximacall-maxima	\N	\N	\N	\N
5	maximacall	png	maximacall-png	\N	\N	\N	\N
6	intuitive	tex	intuitive-tex	\N	\N	\N	\N
7	intuitive	png	intuitive-png	\N	\N	\N	\N
8	ignuplot	png	ignuplot-png	\N	\N	\N	\N
9	complex	png	complex-png	\N	\N	\N	\N
\.


--
-- Data for Name: buttongroup; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY buttongroup (id, name, buttonrow, description, os, sorrend) FROM stdin;
1	layout	3	456	\N	\N
2	latin	8	460	\N	\N
3	greek	5	460	\N	\N
4	test	2	\N	\N	\N
5	trigm	3	462	\N	\N
6	logar	3	464	\N	\N
7	lang	6	458	\N	\N
8	exps	2	466	\N	\N
9	xad	2	\N	\N	\N
10	conditional	2	\N	\N	\N
11	root	2	468	\N	\N
12	power	2	\N	\N	\N
13	equas	2	\N	\N	\N
14	sina	2	462	\N	\N
15	cosa	2	462	\N	\N
16	tana	2	462	\N	\N
17	division	2	\N	\N	\N
18	factore	2	\N	\N	\N
19	gcdlcm	2	\N	\N	\N
20	evfl	3	\N	\N	\N
21	digitmod	2	\N	\N	\N
22	easycas	3	\N	\N	\N
23	equacomma	2	\N	\N	\N
24	limits	3	474	\N	\N
25	evalsumprod	4	\N	\N	\N
26	difftaylor	3	\N	\N	\N
27	intpartfrac	3	\N	\N	\N
28	calcconst	3	476	\N	\N
29	sinsec	4	462	\N	\N
30	coscsc	4	462	\N	\N
31	tancot	4	462	\N	\N
32	logexp	3	\N	\N	\N
33	absfloor	2	\N	\N	\N
34	sqrtcube	3	468	\N	\N
35	jklmn	5	472	\N	\N
36	vwxyzabcd	3	470	\N	\N
37	powercalculus	2	\N	\N	\N
38	plotequacalc	2	484	\N	\N
39	factore_pol	2	\N	\N	\N
40	gcdlcm_pol	2	\N	\N	\N
41	divide_pol	2	\N	\N	\N
42	trigon_alg	2	462	\N	\N
43	logar_alg	3	464	\N	\N
44	root_alg	2	\N	\N	\N
45	m2m_linalg	3	\N	\N	\N
46	m2n_linalg	2	\N	\N	\N
47	mnewn_linalg	3	482	\N	\N
48	mid_linalg	3	480	\N	\N
49	eig_linalg	3	\N	\N	\N
50	mzer_linalg	3	478	\N	\N
51	rand_linalg	3	\N	\N	\N
52	mnmax_linalg	2	\N	\N	\N
53	eq_linalg	2	\N	\N	\N
54	numth_fac	3	\N	\N	\N
55	numth_npprime	2	\N	\N	\N
56	numth_intop	2	\N	\N	\N
57	numth_gcdlcm	2	\N	\N	\N
58	numth_mod	2	\N	\N	\N
59	numth_div	2	\N	\N	\N
60	numth_floor	2	\N	\N	\N
61	linalg_pow	2	\N	\N	\N
\.


--
-- Data for Name: buttonlayout; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY buttonlayout (id, layout, button, buttonorder, groupid, grouporder, os, sorrend) FROM stdin;
404	1	100	\N	11	3	\N	\N
405	1	101	\N	11	4	\N	\N
406	6	297	\N	54	2	\N	\N
407	6	239	\N	54	3	\N	\N
408	6	296	\N	55	2	\N	\N
409	6	301	\N	56	2	\N	\N
410	6	307	\N	56	3	\N	\N
411	6	308	\N	59	2	\N	\N
412	6	309	\N	58	2	\N	\N
413	6	229	\N	57	2	\N	\N
414	6	242	\N	60	2	\N	\N
415	6	311	\N	56	4	\N	\N
416	6	116	\N	61	2	\N	\N
417	1	2	\N	13	2	\N	\N
418	3	2	\N	38	5	\N	\N
419	3	218	\N	25	5	\N	\N
420	1	209	\N	7	7	\N	\N
421	1	216	\N	7	8	\N	\N
422	1	208	\N	7	9	\N	\N
423	1	207	\N	7	10	\N	\N
424	3	315	\N	25	6	\N	\N
425	3	316	\N	27	3	\N	\N
426	3	317	\N	26	3	\N	\N
427	3	318	\N	25	7	\N	\N
428	3	78	\N	28	3	\N	\N
30	1	6	\N	20	1	\N	30
31	1	91	\N	\N	\N	\N	31
32	1	92	\N	\N	\N	\N	32
33	1	93	\N	\N	\N	\N	33
34	1	110	\N	\N	\N	\N	34
35	1	25	\N	\N	\N	\N	35
36	1	90	\N	\N	\N	\N	36
37	1	22	\N	21	1	\N	37
38	1	23	\N	\N	\N	\N	38
39	1	20	\N	\N	\N	\N	39
40	1	21	\N	\N	\N	\N	40
41	1	237	\N	8	2	\N	\N
42	1	238	\N	8	3	\N	\N
43	1	239	\N	8	4	\N	\N
44	1	240	\N	6	2	\N	\N
45	1	121	\N	6	3	\N	\N
46	1	101	\N	9	2	\N	\N
47	1	241	\N	10	2	\N	\N
48	1	242	\N	10	3	\N	\N
49	1	243	\N	10	4	\N	\N
50	1	244	\N	11	2	\N	\N
51	1	140	\N	12	2	\N	\N
52	1	220	\N	13	4	\N	\N
53	1	133	\N	14	2	\N	\N
54	1	134	\N	15	2	\N	\N
55	1	135	\N	16	2	\N	\N
56	1	245	\N	17	2	\N	\N
57	1	227	\N	18	2	\N	\N
58	1	229	\N	19	2	\N	\N
59	1	226	\N	20	2	\N	\N
60	1	224	\N	21	2	\N	\N
61	\N	10	\N	1	1	\N	\N
62	\N	11	\N	1	2	\N	\N
63	\N	14	\N	1	3	\N	\N
64	\N	12	\N	1	4	\N	\N
65	\N	13	\N	1	5	\N	\N
66	\N	210	\N	7	1	\N	\N
67	\N	211	\N	7	2	\N	\N
68	\N	212	\N	7	3	\N	\N
69	\N	213	\N	7	4	\N	\N
70	\N	214	\N	7	5	\N	\N
71	\N	215	\N	7	6	\N	\N
72	\N	50	\N	2	1	\N	\N
73	\N	51	\N	2	2	\N	\N
74	\N	52	\N	2	3	\N	\N
75	\N	53	\N	2	4	\N	\N
77	\N	55	\N	2	5	\N	\N
78	\N	56	\N	2	6	\N	\N
79	\N	57	\N	2	7	\N	\N
81	\N	59	\N	2	8	\N	\N
82	\N	60	\N	2	9	\N	\N
83	\N	61	\N	2	10	\N	\N
84	\N	62	\N	2	11	\N	\N
85	\N	63	\N	2	12	\N	\N
86	\N	64	\N	2	13	\N	\N
87	\N	65	\N	2	14	\N	\N
88	\N	66	\N	2	15	\N	\N
89	\N	67	\N	2	16	\N	\N
90	\N	68	\N	2	17	\N	\N
91	\N	69	\N	2	18	\N	\N
92	\N	70	\N	2	19	\N	\N
93	\N	71	\N	2	20	\N	\N
94	\N	72	\N	2	21	\N	\N
95	\N	73	\N	2	22	\N	\N
96	\N	74	\N	2	23	\N	\N
97	\N	75	\N	2	24	\N	\N
98	2	11	\N	1	\N	\N	1
99	2	210	\N	7	\N	\N	2
100	2	5	\N	\N	\N	\N	3
101	2	9	\N	\N	\N	\N	4
102	2	3	\N	\N	\N	\N	5
103	2	101	\N	\N	\N	\N	6
104	2	100	\N	\N	\N	\N	7
105	2	243	\N	\N	\N	\N	8
106	2	73	\N	2	\N	\N	9
107	2	314	\N	\N	\N	\N	10
108	2	122	\N	\N	\N	\N	11
109	2	120	\N	\N	\N	\N	12
110	2	221	\N	\N	\N	\N	13
111	2	114	\N	\N	\N	\N	14
112	2	220	\N	\N	\N	\N	15
113	2	225	\N	\N	\N	\N	16
114	2	77	\N	\N	\N	\N	17
115	2	24	\N	\N	\N	\N	18
116	2	113	\N	\N	\N	\N	19
117	2	223	\N	\N	\N	\N	20
118	2	97	\N	\N	\N	\N	21
119	2	98	\N	\N	\N	\N	22
120	2	99	\N	\N	\N	\N	23
121	2	112	\N	\N	\N	\N	24
122	2	226	\N	22	1	\N	25
123	2	94	\N	\N	\N	\N	26
124	2	95	\N	\N	\N	\N	27
125	2	96	\N	\N	\N	\N	28
126	2	111	\N	\N	\N	\N	29
127	2	6	\N	\N	\N	\N	30
128	2	91	\N	\N	\N	\N	31
129	2	92	\N	\N	\N	\N	32
130	2	93	\N	\N	\N	\N	33
131	2	110	\N	\N	\N	\N	34
132	2	25	\N	\N	\N	\N	35
133	2	90	\N	\N	\N	\N	36
134	2	22	\N	\N	\N	\N	37
135	2	23	\N	\N	\N	\N	38
136	2	20	\N	\N	\N	\N	39
137	2	21	\N	\N	\N	\N	40
138	2	218	\N	22	2	\N	\N
139	2	227	\N	22	3	\N	\N
140	2	223	\N	22	4	\N	\N
141	2	228	\N	22	5	\N	\N
142	2	229	\N	22	6	\N	\N
143	\N	24	\N	23	1	\N	\N
144	\N	25	\N	23	2	\N	\N
145	3	14	\N	1	\N	\N	1
146	3	210	\N	7	\N	\N	2
147	3	5	\N	\N	\N	\N	3
148	3	9	\N	\N	\N	\N	4
149	3	3	\N	\N	\N	\N	5
150	3	120	\N	34	1	\N	6
151	3	122	\N	33	1	\N	7
152	3	121	\N	32	1	\N	8
153	3	63	\N	35	5	\N	9
154	3	230	\N	24	1	\N	10
155	3	130	\N	29	1	\N	11
156	3	131	\N	30	1	\N	12
157	3	132	\N	31	1	\N	13
158	3	114	\N	37	1	\N	14
159	3	220	\N	38	1	\N	15
160	3	73	\N	36	8	\N	16
161	3	77	\N	28	1	\N	17
162	3	24	\N	\N	\N	\N	18
163	3	113	\N	\N	\N	\N	19
164	3	231	\N	26	1	\N	20
165	3	97	\N	\N	\N	\N	21
166	3	98	\N	\N	\N	\N	22
167	3	99	\N	\N	\N	\N	23
168	3	112	\N	\N	\N	\N	24
169	3	232	\N	27	1	\N	25
170	3	94	\N	\N	\N	\N	26
171	3	95	\N	\N	\N	\N	27
172	3	96	\N	\N	\N	\N	28
173	3	111	\N	\N	\N	\N	29
174	3	6	\N	25	1	\N	30
175	3	91	\N	\N	\N	\N	31
176	3	92	\N	\N	\N	\N	32
177	3	93	\N	\N	\N	\N	33
178	3	110	\N	\N	\N	\N	34
179	3	25	\N	\N	\N	\N	35
180	3	90	\N	\N	\N	\N	36
181	3	22	\N	\N	\N	\N	37
182	3	23	\N	\N	\N	\N	38
183	3	20	\N	\N	\N	\N	39
184	3	21	\N	\N	\N	\N	40
185	\N	\N	\N	\N	\N	\N	\N
186	3	246	\N	24	2	\N	\N
187	3	248	\N	24	3	\N	\N
188	3	235	\N	24	4	\N	\N
189	3	234	\N	24	5	\N	\N
190	3	249	\N	25	3	\N	\N
191	3	250	\N	25	4	\N	\N
192	3	253	\N	26	2	\N	\N
193	3	233	\N	27	2	\N	\N
194	3	76	\N	28	2	\N	\N
195	3	133	\N	29	2	\N	\N
196	3	136	\N	29	3	\N	\N
197	3	137	\N	29	4	\N	\N
198	3	150	\N	29	5	\N	\N
199	3	151	\N	29	6	\N	\N
200	3	152	\N	29	7	\N	\N
201	3	153	\N	29	8	\N	\N
202	3	134	\N	30	2	\N	\N
203	3	138	\N	30	3	\N	\N
204	3	139	\N	30	4	\N	\N
205	3	154	\N	30	5	\N	\N
206	3	155	\N	30	6	\N	\N
207	3	156	\N	30	7	\N	\N
208	3	157	\N	30	8	\N	\N
209	3	135	\N	31	2	\N	\N
210	3	128	\N	31	3	\N	\N
211	3	129	\N	31	4	\N	\N
212	3	158	\N	31	5	\N	\N
213	3	159	\N	31	6	\N	\N
214	3	160	\N	31	7	\N	\N
215	3	161	\N	31	8	\N	\N
216	3	222	\N	32	2	\N	\N
217	3	240	\N	32	3	\N	\N
218	3	238	\N	32	4	\N	\N
219	3	221	\N	32	5	\N	\N
220	3	237	\N	32	6	\N	\N
221	3	241	\N	33	2	\N	\N
222	3	242	\N	33	3	\N	\N
223	3	243	\N	33	4	\N	\N
224	3	100	\N	34	2	\N	\N
225	3	101	\N	34	3	\N	\N
226	3	239	\N	32	7	\N	\N
228	3	59	\N	35	1	\N	\N
229	3	60	\N	35	2	\N	\N
230	3	61	\N	35	3	\N	\N
231	3	62	\N	35	4	\N	\N
232	3	50	\N	36	1	\N	\N
233	3	51	\N	36	2	\N	\N
234	3	52	\N	36	3	\N	\N
235	3	53	\N	36	4	\N	\N
237	3	71	\N	36	5	\N	\N
238	3	72	\N	36	6	\N	\N
239	3	74	\N	36	8	\N	\N
240	3	75	\N	36	9	\N	\N
241	1	223	\N	20	3	\N	\N
242	3	226	\N	25	2	\N	\N
243	3	140	\N	37	2	\N	\N
244	3	314	\N	38	4	\N	\N
245	5	13	\N	1	\N	\N	1
246	5	210	\N	7	\N	\N	2
247	5	5	\N	\N	\N	\N	3
248	5	9	\N	\N	\N	\N	4
249	5	3	\N	\N	\N	\N	5
250	5	102	\N	\N	\N	\N	6
251	5	101	\N	\N	\N	\N	7
252	5	100	\N	\N	\N	\N	8
253	5	73	\N	2	\N	\N	9
254	5	2	\N	\N	\N	\N	10
255	5	130	\N	42	1	\N	11
256	5	222	\N	43	1	\N	12
257	5	120	\N	44	1	\N	13
258	5	114	\N	\N	\N	\N	14
259	5	236	\N	\N	\N	\N	15
260	5	122	\N	\N	\N	\N	16
261	5	77	\N	\N	\N	\N	17
262	5	24	\N	\N	\N	\N	18
263	5	113	\N	\N	\N	\N	19
264	5	228	\N	40	1	\N	20
265	5	97	\N	\N	\N	\N	21
266	5	98	\N	\N	\N	\N	22
267	5	99	\N	\N	\N	\N	23
268	5	112	\N	\N	\N	\N	24
269	5	218	\N	39	1	\N	25
270	5	94	\N	\N	\N	\N	26
271	5	95	\N	\N	\N	\N	27
272	5	96	\N	\N	\N	\N	28
273	5	111	\N	\N	\N	\N	29
274	5	6	\N	\N	\N	\N	30
275	5	91	\N	\N	\N	\N	31
276	5	92	\N	\N	\N	\N	32
277	5	93	\N	\N	\N	\N	33
278	5	110	\N	\N	\N	\N	34
279	5	25	\N	\N	\N	\N	35
280	5	90	\N	\N	\N	\N	36
281	5	22	\N	\N	\N	\N	37
282	5	23	\N	\N	\N	\N	38
283	5	20	\N	\N	\N	\N	39
284	5	21	\N	\N	\N	\N	40
285	5	227	\N	39	2	\N	\N
286	5	229	\N	40	2	\N	\N
287	\N	255	\N	41	\N	\N	\N
288	4	12	\N	1	\N	\N	1
289	4	210	\N	7	\N	\N	2
290	4	5	\N	\N	\N	\N	3
291	4	9	\N	\N	\N	\N	4
292	4	3	\N	\N	\N	\N	5
293	4	313	\N	\N	\N	\N	6
294	4	271	\N	50	1	\N	12
295	4	267	\N	48	1	\N	11
296	4	115	\N	\N	\N	\N	9
297	4	257	\N	45	1	\N	10
298	4	265	\N	47	1	\N	13
301	4	114	\N	61	1	\N	14
302	4	260	\N	46	1	\N	15
303	4	26	\N	\N	\N	\N	16
304	4	27	\N	\N	\N	\N	17
305	4	24	\N	\N	\N	\N	18
306	4	113	\N	\N	\N	\N	19
307	4	261	\N	49	1	\N	20
308	4	97	\N	\N	\N	\N	21
309	4	98	\N	\N	\N	\N	22
310	4	99	\N	\N	\N	\N	23
311	4	117	\N	\N	\N	\N	24
312	4	279	\N	52	1	\N	25
313	4	94	\N	\N	\N	\N	26
314	4	95	\N	\N	\N	\N	27
315	4	96	\N	\N	\N	\N	28
316	4	111	\N	\N	\N	\N	29
317	4	6	\N	53	1	\N	30
318	4	91	\N	\N	\N	\N	31
319	4	92	\N	\N	\N	\N	32
320	4	93	\N	\N	\N	\N	33
321	4	110	\N	\N	\N	\N	34
322	4	25	\N	\N	\N	\N	35
323	4	90	\N	\N	\N	\N	36
1	1	10	\N	1	\N	\N	1
2	1	210	\N	7	\N	\N	2
3	1	5	\N	\N	\N	\N	3
4	1	9	\N	\N	\N	\N	4
5	1	3	\N	\N	\N	\N	5
6	1	120	\N	11	1	\N	6
7	1	221	\N	8	1	\N	7
8	1	222	\N	6	1	\N	8
9	1	73	\N	2	\N	\N	9
10	1	314	\N	13	1	\N	10
11	1	130	\N	14	1	\N	11
12	1	131	\N	15	1	\N	12
13	1	132	\N	16	1	\N	13
14	1	114	\N	12	1	\N	14
15	1	254	\N	\N	\N	\N	15
16	1	122	\N	10	1	\N	16
17	1	77	\N	\N	\N	\N	17
18	1	24	\N	\N	\N	\N	18
19	1	113	\N	17	1	\N	19
20	1	228	\N	19	1	\N	20
21	1	97	\N	\N	\N	\N	21
22	1	98	\N	\N	\N	\N	22
23	1	99	\N	\N	\N	\N	23
24	1	112	\N	\N	\N	\N	24
25	1	218	\N	18	1	\N	25
26	1	94	\N	\N	\N	\N	26
27	1	95	\N	\N	\N	\N	27
28	1	96	\N	\N	\N	\N	28
29	1	111	\N	\N	\N	\N	29
324	4	22	\N	\N	\N	\N	37
325	4	23	\N	\N	\N	\N	38
326	4	20	\N	\N	\N	\N	39
327	4	21	\N	\N	\N	\N	40
328	5	133	\N	42	2	\N	\N
329	5	131	\N	42	3	\N	\N
330	5	134	\N	42	4	\N	\N
331	5	132	\N	42	5	\N	\N
332	5	135	\N	42	6	\N	\N
333	5	240	\N	43	2	\N	\N
334	5	121	\N	43	3	\N	\N
335	5	221	\N	43	4	\N	\N
336	5	237	\N	43	5	\N	\N
337	5	238	\N	43	6	\N	\N
338	5	239	\N	43	7	\N	\N
339	5	244	\N	44	2	\N	\N
340	4	269	\N	45	2	\N	\N
341	4	263	\N	45	3	\N	\N
342	4	270	\N	46	2	\N	\N
343	4	266	\N	47	2	\N	\N
344	4	268	\N	48	2	\N	\N
345	4	262	\N	49	2	\N	\N
346	4	272	\N	50	2	\N	\N
347	4	273	\N	48	3	\N	\N
348	4	274	\N	50	3	\N	\N
349	4	275	\N	47	3	\N	\N
350	4	2	\N	53	2	\N	\N
351	4	277	\N	51	2	\N	\N
352	4	278	\N	51	3	\N	\N
353	4	281	\N	47	4	\N	\N
354	4	282	\N	47	5	\N	\N
355	4	283	\N	47	6	\N	\N
356	4	259	\N	49	3	\N	\N
357	4	280	\N	52	2	\N	\N
358	4	312	\N	\N	1	\N	7
359	4	73	\N	\N	1	\N	8
360	1	290	\N	13	3	\N	\N
361	3	292	\N	38	2	\N	\N
363	6	15	\N	1	\N	\N	1
364	6	210	\N	7	\N	\N	2
365	6	5	\N	\N	\N	\N	3
366	6	9	\N	\N	\N	\N	4
367	6	3	\N	\N	\N	\N	5
368	6	302	\N	\N	\N	\N	6
369	6	299	\N	\N	\N	\N	7
370	6	218	\N	\N	\N	\N	8
371	6	304	\N	\N	\N	\N	9
372	6	295	\N	55	1	\N	10
373	6	305	\N	54	1	\N	11
374	6	303	\N	\N	\N	\N	12
375	6	254	\N	\N	\N	\N	13
376	6	306	\N	\N	\N	\N	14
377	6	310	\N	\N	\N	\N	15
378	6	243	\N	60	1	\N	16
379	6	114	\N	\N	\N	\N	17
380	6	245	\N	58	1	\N	18
381	6	113	\N	59	1	\N	19
382	6	228	\N	57	1	\N	20
383	6	97	\N	\N	\N	\N	21
384	6	98	\N	\N	\N	\N	22
385	6	99	\N	\N	\N	\N	23
386	6	112	\N	\N	\N	\N	24
387	6	298	\N	56	1	\N	25
388	6	94	\N	\N	\N	\N	26
389	6	95	\N	\N	\N	\N	27
390	6	96	\N	\N	\N	\N	28
391	6	111	\N	\N	\N	\N	29
392	6	6	\N	\N	\N	\N	30
393	6	91	\N	\N	\N	\N	31
394	6	92	\N	\N	\N	\N	32
395	6	93	\N	\N	\N	\N	33
396	6	110	\N	\N	\N	\N	34
397	6	25	\N	\N	\N	\N	35
398	6	90	\N	\N	\N	\N	36
399	6	22	\N	\N	\N	\N	37
400	6	23	\N	\N	\N	\N	38
401	6	20	\N	\N	\N	\N	39
402	6	21	\N	\N	\N	\N	40
403	\N	15	\N	1	6	\N	\N
429	1	319	\N	7	11	\N	\N
\.


--
-- Data for Name: buttontype; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY buttontype (id, name, description, textcolor, bgcolor, os, sorrend) FROM stdin;
1	control	\N	black	#fbfbd9	\N	\N
2	special	\N	white	#632e47	\N	\N
3	const	\N	white	#707024	\N	\N
4	var	\N	black	#ffba00	\N	\N
5	digit	\N	white	#961845	\N	\N
6	op1	\N	black	#f8f7bf	\N	\N
7	op2	\N	white	#ff690f	\N	\N
8	fun1	\N	black	#fffc05	\N	\N
9	fun2	\N	white	#f05009	\N	\N
10	test	\N	white	#b1833b	\N	\N
11	maxima	\N	white	#2b7c8a	\N	\N
12	maple	\N	black	#d04040	\N	\N
13	mupad	\N	black	#d04040	\N	\N
14	gnuplot	\N	#80ffff	#2b7c8a	\N	\N
15	relation	\N	white	#c52424	\N	\N
16	complex	\N	#80ffff	#2b7c8a	\N	\N
\.


--
-- Data for Name: calcbutton; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY calcbutton (id, name, _type, changestring, picture, description, html_text, solve_text, hint_text, os, sorrend) FROM stdin;
1		1	\N	\N	\N	\N	\N	\N	\N	\N
204	test5	10	z^5=2^z	\N	\N	\N	\N	\N	\N	\N
281	2x3	9	[[..#,..#,..#],[..#,..#,..#]]	\N	\N	332	\N	\N	\N	\N
282	3x4	9	[[..#,..#,..#,..#],[..#,..#,..#,..#],[..#,..#,..#,..#]]	\N	\N	333	\N	\N	\N	\N
3	ce	1	\N	\N	54	\N	\N	\N	\N	\N
201	test2	10	x^3=3^x	\N	\N	\N	\N	\N	\N	\N
2	solve	11	solve([#])	\N	115	68	6	\N	\N	\N
4	off	1	\N	\N	\N	\N	\N	\N	\N	\N
5	back	1	\N	\N	120	33	\N	\N	\N	\N
6	ev	11	ev(#)	\N	118	589	8	488	\N	\N
7	cycle	1	\N	\N	\N	\N	\N	\N	\N	\N
9	redo	1	\N	\N	121	57	\N	\N	\N	\N
10	normal	1	\N	./button/secondary.png	122	\N	\N	\N	\N	\N
11	easy	1	\N	./button/elementary.png	123	\N	\N	\N	\N	\N
12	linalg	1	\N	./button/4dcube-small.gif	259	\N	\N	\N	\N	\N
13	polalg	1	\N	./button/algebra.png	258	\N	\N	\N	\N	\N
14	calculus	1	\N	./button/calculus.png	257	\N	\N	\N	\N	\N
15	numtheory	1	\N	./button/lakat2_pici.jpg	497	\N	\N	\N	\N	\N
20	(	2	\N	\N	112	586	\N	\N	\N	\N
21	)	2	\N	\N	113	587	\N	\N	\N	\N
22	.	2	\N	\N	210	588	\N	\N	\N	\N
23	(-)	2	\N	\N	209	28	\N	\N	\N	\N
24	equality	15	\N	\N	119	589	\N	\N	\N	\N
25	,	2	\N	\N	195	590	\N	\N	\N	\N
26	[	2	\N	\N	616	584	\N	\N	\N	\N
27	]	2	\N	\N	618	585	\N	\N	\N	\N
30	test0	10	sqrt(sin(x)^2+cos(x)^2)=1	\N	\N	\N	\N	\N	\N	\N
89	F	5	F|	\N	\N	\N	\N	\N	\N	\N
90	0	5	0|	\N	\N	600	\N	\N	\N	\N
91	1	5	1|	\N	\N	591	\N	\N	\N	\N
92	2	5	2|	\N	\N	592	\N	\N	\N	\N
93	3	5	3|	\N	\N	593	\N	\N	\N	\N
94	4	5	4|	\N	\N	594	\N	\N	\N	\N
95	5	5	5|	\N	\N	595	\N	\N	\N	\N
96	6	5	6|	\N	\N	596	\N	\N	\N	\N
97	7	5	7|	\N	\N	597	\N	\N	\N	\N
98	8	5	8|	\N	\N	598	\N	\N	\N	\N
99	9	5	9|	\N	\N	599	\N	\N	\N	\N
100	sqr	6	^2#	\N	190	25	\N	\N	\N	\N
101	cube	6	^3#	\N	191	26	\N	\N	\N	\N
102	quad	6	^4#	\N	626	266	\N	\N	\N	\N
110	+	7	+..#	\N	\N	583	\N	\N	\N	\N
111	-	7	-..#	\N	\N	32	\N	\N	\N	\N
112	*	7	*..#	\N	\N	30	\N	\N	\N	\N
113	/	7	/(..#)#	\N	\N	516	\N	\N	\N	\N
114	pow	7	^(..#)#	\N	189	23	\N	\N	\N	\N
115	mdot	7	 . ..#	\N	318	282	\N	\N	\N	\N
116	mpow	7	^^(..#)#	\N	320	283	\N	\N	\N	\N
117	times	7	*..#	\N	513	30	\N	\N	\N	\N
219	normal2	1	\N	./button/numtheory.png	\N	\N	\N	\N	\N	\N
50	a	4	a	\N	\N	228	\N	\N	\N	\N
51	b	4	b	\N	\N	229	\N	\N	\N	\N
52	c	4	c	\N	\N	230	\N	\N	\N	\N
53	d	4	d	\N	\N	231	\N	\N	\N	\N
54	e	4	e	\N	\N	232	\N	\N	\N	\N
55	f	4	f	\N	\N	233	\N	\N	\N	\N
56	g	4	g	\N	\N	234	\N	\N	\N	\N
57	h	4	h	\N	\N	235	\N	\N	\N	\N
58	i	4	i	\N	\N	236	\N	\N	\N	\N
59	j	4	j	\N	\N	237	\N	\N	\N	\N
60	k	4	k	\N	\N	238	\N	\N	\N	\N
61	l	4	l	\N	\N	239	\N	\N	\N	\N
62	m	4	m	\N	\N	240	\N	\N	\N	\N
63	n	4	n	\N	\N	241	\N	\N	\N	\N
64	o	4	o	\N	\N	242	\N	\N	\N	\N
65	p	4	p	\N	\N	243	\N	\N	\N	\N
66	q	4	q	\N	\N	244	\N	\N	\N	\N
67	r	4	r	\N	\N	245	\N	\N	\N	\N
68	s	4	s	\N	\N	246	\N	\N	\N	\N
69	t	4	t	\N	\N	247	\N	\N	\N	\N
70	u	4	u	\N	\N	248	\N	\N	\N	\N
71	v	4	v	\N	\N	249	\N	\N	\N	\N
72	w	4	w	\N	\N	250	\N	\N	\N	\N
73	x	4	x	\N	193	251	\N	\N	\N	\N
74	y	4	y	\N	\N	252	\N	\N	\N	\N
75	z	4	z	\N	\N	253	\N	\N	\N	\N
76	e	3	e	\N	453	\N	\N	\N	\N	\N
77	pi	3	pi	\N	188	204	\N	\N	\N	\N
78	i	3	i	\N	\N	\N	\N	\N	\N	\N
84	A	5	A|	\N	\N	\N	\N	\N	\N	\N
85	B	5	B|	\N	\N	\N	\N	\N	\N	\N
86	C	5	C|	\N	\N	\N	\N	\N	\N	\N
87	D	5	D|	\N	\N	\N	\N	\N	\N	\N
88	E	5	E|	\N	\N	\N	\N	\N	\N	\N
220	funpl	14	\N	./button/funpl.png	116	\N	\N	\N	\N	\N
121	ln	8	ln(..#)	\N	196	609	\N	\N	\N	\N
122	abs	8	abs(..#)	\N	107	24	\N	\N	\N	\N
128	ctg	8	ctg(..#)	\N	\N	\N	\N	\N	\N	\N
129	actg	8	actg(..#)	\N	\N	\N	\N	\N	\N	\N
130	sin	8	sin(..#)	\N	108	\N	\N	\N	\N	\N
131	cos	8	cos(..#)	\N	109	\N	\N	\N	\N	\N
132	tan	8	tan(..#)	\N	110	\N	\N	\N	\N	\N
133	asin	8	asin(..#)	\N	\N	\N	\N	\N	\N	\N
134	acos	8	acos(..#)	\N	\N	\N	\N	\N	\N	\N
135	atan	8	atan(..#)	\N	\N	\N	\N	\N	\N	\N
136	sec	8	sec(..#)	\N	\N	\N	\N	\N	\N	\N
137	asec	8	asec(..#)	\N	\N	\N	\N	\N	\N	\N
138	csc	8	csc(..#)	\N	\N	\N	\N	\N	\N	\N
139	acsc	8	acsc(..#)	\N	\N	\N	\N	\N	\N	\N
140	logab	9	log_..(..#)	\N	\N	27	\N	\N	\N	\N
141	sqrtn	9	nthroot(..#,..#)	\N	\N	\N	\N	\N	\N	\N
150	sinh	8	sinh(..#)	\N	\N	\N	\N	\N	\N	\N
151	asinh	8	asinh(..#)	\N	\N	\N	\N	\N	\N	\N
152	sech	8	sech(..#)	\N	\N	\N	\N	\N	\N	\N
153	asech	8	asech(..#)	\N	\N	\N	\N	\N	\N	\N
154	cosh	8	cosh(..#)	\N	\N	\N	\N	\N	\N	\N
155	acosh	8	acosh(..#)	\N	\N	\N	\N	\N	\N	\N
156	csch	8	csch(..#)	\N	\N	\N	\N	\N	\N	\N
157	acsch	8	acsch(..#)	\N	\N	\N	\N	\N	\N	\N
158	tanh	8	tanh(..#)	\N	\N	\N	\N	\N	\N	\N
159	atanh	8	atanh(..#)	\N	\N	\N	\N	\N	\N	\N
160	ctgh	8	ctgh(..#)	\N	\N	\N	\N	\N	\N	\N
161	actgh	8	actgh(..#)	\N	\N	\N	\N	\N	\N	\N
199	test-1	10	sqrt(3+x)=2	\N	\N	\N	\N	\N	\N	\N
200	test1	10	2^x=3^x	\N	\N	\N	\N	\N	\N	\N
202	test3	10	x^3=2^x	\N	\N	\N	\N	\N	\N	\N
203	test4	10	y^2=5^y	\N	\N	\N	\N	\N	\N	\N
205	test6	10	x+y=x*y	\N	\N	\N	\N	\N	\N	\N
206	test	1	\N	./button/normal1.png	\N	\N	\N	\N	\N	\N
207	cz	1	\N	./button/cz.gif	7	7	\N	\N	\N	\N
208	sk	1	\N	./button/sk.gif	5	5	\N	\N	\N	\N
209	cn	1	\N	./button/cn.gif	1	1	\N	\N	\N	\N
210	en	1	\N	./button/en.gif	125	\N	\N	\N	\N	\N
211	de	1	\N	./button/de.gif	12	12	\N	\N	\N	\N
212	fr	1	\N	./button/fr.gif	\N	\N	\N	\N	\N	\N
213	es	1	\N	./button/es.gif	\N	\N	\N	\N	\N	\N
214	it	1	\N	./button/it.gif	\N	\N	\N	\N	\N	\N
215	hu	1	\N	./button/hu.gif	124	\N	\N	\N	\N	\N
216	tw	1	\N	\N	2	2	\N	\N	\N	\N
120	sqrt	8	sqrt(..#)	./button/sqrt.gif	106	213	\N	\N	\N	\N
217	fac2	11	a:#^2$factor(a)	\N	\N	\N	34	\N	\N	\N
218	factor	11	factor(#)	\N	117	127	184	488	\N	\N
221	10^x	8	10^(..#)	\N	\N	203	\N	\N	\N	\N
222	lg	8	log_10(..#)	\N	111	608	\N	\N	\N	\N
223	simp	11	ratprint:false$ ratsimp(#)	./button/ratsimp.png	114	138	173	\N	\N	\N
224	EXP	2	*10^..	\N	211	\N	\N	\N	\N	\N
225	%	2	/100	\N	212	\N	\N	\N	\N	\N
226	float	11	float(#)	\N	174	137	175	488	\N	\N
227	expand	11	expand(#)	\N	186	126	185	488	\N	\N
228	gcd	11	gcd(#,#)	\N	176	128	177	486	\N	\N
229	lcm	11	expra:#$ exprb:#$ expra*exprb/gcd(expra,exprb)	\N	178	129	179	486	\N	\N
230	limit	11	tlimswitch: true$ limit(#,n,inf)	./button/liman.jpg	149	130	147	\N	\N	\N
231	diff	11	diff(#,x)	./button/derive.gif	153	131	157	\N	\N	\N
232	int	11	integrate(#,x)	./button/integr.gif	151	132	155	\N	\N	\N
233	partfrac	11	load(ntrig)$ factor_with_solve_real(expr, n) := block([sol, fac, expr1],sol : solve(expr, n),expr : ratexpand(expr),fac : ratcoef(expr, n, hipow(expr, n)),for i:1 thru length(sol) do (if not(freeof(n, rhs(sol[i]))) then error(),if imagpart(rectform(rhs(sol[i])))=0 then fac : fac * (n - rhs(sol[i]))^multiplicities[i] else (if imagpart(rectform(rhs(sol[i])))>0 then fac: fac*(ratsimp(expand((n-rectform(rhs(sol[i])))*(n-conjugate(rectform(rhs(sol[i])))))))^multiplicities[i])),if not(zeroequiv(expr-fac,x)) then error(),fac)$ my_partfrac(e, x) := partfrac(num(e)/factor_with_solve_real(denom(e), x), x)$ my_partfrac(#,x)	./button/partial.jpg	180	133	181	\N	\N	\N
234	xlimp	11	tlimswitch: true$ limit(#,x,#,plus)	./button/limfxjobb.jpg	441	270	445	\N	\N	\N
235	xlimm	11	tlimswitch: true$ limit(#,x,#,minus)	./button/limfxbal.jpg	443	269	447	\N	\N	\N
236	divide	11	divide(#,#)	\N	223	136	222	\N	\N	\N
237	2^x	8	2^(..#)	\N	\N	201	\N	\N	\N	\N
238	e^x	8	e^(..#)	\N	199	200	\N	\N	\N	\N
239	n!	8	(..#)!	\N	198	262	\N	\N	\N	\N
240	log2	8	log_2(..#)	\N	197	202	\N	\N	\N	\N
241	sgn	8	sgn(..#)	\N	207	\N	\N	\N	\N	\N
242	ceil	8	ceil(..#)	\N	205	214	\N	\N	\N	\N
243	floor	8	floor(..#)	\N	206	215	\N	\N	\N	\N
244	cubroot	8	(..#)^(1/3)	./button/cubroot.gif	208	267	\N	\N	\N	\N
245	mod	7	 mod ..#	\N	187	517	\N	\N	\N	\N
246	limsum	11	tlimswitch: true$ ev(sum(#,n,1,inf),simpsum)	./button/limsan.jpg	449	271	451	\N	\N	\N
247	limitm	11	tlimswitch: true$ limit(#,n,-inf)	\N	\N	\N	\N	\N	\N	\N
248	xlim	11	tlimswitch: true$ limit(#,x,#)	./button/limfx.jpg	159	163	161	\N	\N	\N
249	summa	11	kform: subst(k,n,#)$ ev(sum(kform,k,1,n),simpsum)	\N	141	134	139	\N	\N	\N
250	product	11	kform: subst(k,n,#)$ ev(prod(kform,k,1,n),simpprod)	\N	145	135	143	\N	\N	\N
251	xlim2	11	tlimswitch: true$ expr: (#)$ at: (#)$ nounify(limit)(expr,x,at) = limit(expr,x,at)	\N	159	163	161	\N	\N	\N
252	taylor	11	taylor(#,x,#,#)	\N	166	\N	164	\N	\N	\N
253	simtay	11	taylor(#,x,0,10)	./button/taylor.png	166	\N	164	\N	\N	\N
254	binom	11	binomial(#,#)	./button/binom.gif	410	268	411	486	\N	\N
255	modulus	11	divide(#,#)[2]	\N	225	136	224	\N	\N	\N
256	matrix	11	matrix(#)	\N	\N	\N	\N	\N	\N	\N
257	invert	11	invert(#)	\N	286	275	287	\N	\N	\N
258	invert2	11	(#)^^(-1)	\N	\N	\N	\N	\N	\N	\N
259	charpoly	11	charpoly(#,x)	\N	306	277	307	\N	\N	\N
260	determ	11	determinant(#)	\N	290	274	291	\N	\N	\N
261	eivals	11	load("eigen")$ M: #$ eivals(M)	\N	310	280	311	\N	\N	\N
262	eivects	11	load("eigen")$ M: #$ eivects(M)	\N	314	323	315	\N	\N	\N
263	adjugate	11	adjoint(#)	\N	302	276	303	\N	\N	\N
264	scalarp	11	A:#$ B:#$ ev(A . B)	\N	\N	\N	\N	\N	\N	\N
265	2x2	9	[[..#,..#],[..#,..#]]	\N	418	284	\N	\N	\N	\N
266	3x3	9	[[..#,..#,..#],[..#,..#,..#],[..#,..#,..#]]	\N	\N	285	\N	\N	\N	\N
267	I2	3	[[1,0],[0,1]]	\N	414	278	\N	\N	\N	\N
268	I3	3	[[1,0,0],[0,1,0],[0,0,1]]	\N	\N	279	\N	\N	\N	\N
269	transpose	11	transpose(#)	\N	294	281	295	\N	\N	\N
270	rank	11	rank(#)	\N	298	322	299	\N	\N	\N
271	O2	3	[[0,0],[0,0]]	\N	\N	324	\N	\N	\N	\N
272	O3	3	[[0,0,0],[0,0,0],[0,0,0]]	\N	\N	325	\N	\N	\N	\N
273	I4	3	[[1,0,0,0],[0,1,0,0],[0,0,1,0],[0,0,0,1]]	\N	\N	326	\N	\N	\N	\N
274	O4	3	[[0,0,0,0],[0,0,0,0],[0,0,0,0],[0,0,0,0]]	\N	\N	327	\N	\N	\N	\N
275	4x4	9	[[..#,..#,..#,..#],[..#,..#,..#,..#],[..#,..#,..#,..#],[..#,..#,..#,..#]]	\N	\N	328	\N	\N	\N	\N
276	?2	11	x: #$ s1: make_random_state(true)$ set_random_state(s1)$ v[i,j] := random(2*x)-x$ genmatrix(v,2,2)	\N	\N	329	\N	\N	\N	\N
277	?3	11	x: #$ s1: make_random_state(true)$ set_random_state(s1)$ v[i,j] := random(2*x)-x$ genmatrix(v,3,3)	\N	\N	330	\N	\N	\N	\N
278	?4	11	x: #$ s1: make_random_state(true)$ set_random_state(s1)$ v[i,j] := random(2*x)-x$ genmatrix(v,4,4)	\N	\N	331	\N	\N	\N	\N
279	echelon	11	echelon(#)	./button/echelon.png	336	335	338	\N	\N	\N
280	triang	11	triangularize(#)	./button/triang.png	420	\N	422	\N	\N	\N
283	4x5	9	[[..#,..#,..#,..#,..#],[..#,..#,..#,..#,..#],[..#,..#,..#,..#,..#],[..#,..#,..#,..#,..#]]	\N	\N	334	\N	\N	\N	\N
284	conjugate	11	conjugate(#)	\N	\N	342	\N	\N	\N	\N
285	Htransp	11	transpose(conjugate(#))	\N	\N	341	\N	\N	\N	\N
286	R_2x3	11	x: #$ s1: make_random_state(true)$ set_random_state(s1)$ v[i,j] := random(2*x)-x$ genmatrix(v,2,3)	\N	\N	343	\N	\N	\N	\N
287	R_3x4	11	x: #$ s1: make_random_state(true)$ set_random_state(s1)$ v[i,j] := random(2*x)-x$ genmatrix(v,3,4)	\N	\N	344	\N	\N	\N	\N
288	R_4x5	11	x: #$ s1: make_random_state(true)$ set_random_state(s1)$ v[i,j] := random(2*x)-x$ genmatrix(v,4,5)	\N	\N	345	\N	\N	\N	\N
289	rsolve	11	float(realroots(#))	\N	\N	\N	\N	\N	\N	\N
290	nsolve	11	find_root_error: false$ fr: find_root(#,x,#,#)$ if (numberp(fr)) then fr else nosolution	\N	433	432	435	603	\N	\N
291	nsolve2	11	fr: find_root(#,x,#,#)$ if (numberp(fr)) then fr else VALAMI	\N	\N	\N	\N	\N	\N	\N
292	plot3	14	\N	./button/funpl3d.png	437	\N	\N	\N	\N	\N
293	cplot	16	\N	\N	439	\N	\N	\N	\N	\N
294	pplot	14	\N	./button/funpl.png	\N	\N	\N	\N	\N	\N
295	nprime	11	next_prime(#)	\N	530	506	518	\N	\N	\N
296	pprime	11	prev_prime(#)	\N	532	507	520	\N	\N	\N
297	fib	11	fib(#)	\N	550	510	552	\N	\N	\N
298	isqrt	11	isqrt(#)	./button/isqrt.gif	562	605	568	\N	\N	\N
299	divsum	11	divsum(#)	\N	528	505	524	\N	\N	\N
300	ifactor	11	ifactors(#)	\N	\N	\N	\N	\N	\N	\N
301	inrt	11	inrt(#,#)	./button/inrt.gif	564	606	570	\N	\N	\N
302	totient	11	totient(#)	\N	526	504	522	\N	\N	\N
303	vari	11	x1: #$ x2: #$ x1!/(x1-x2)!	./button/variat.gif	540	490	544	\N	\N	\N
304	primep	11	num: #$ if (num > 0) then primep(num) else false	\N	534	508	500	\N	\N	\N
305	fact	11	factorial(#)	\N	620	515	548	\N	\N	\N
306	nk1k	11	x1: #$ x2: #$ binomial(x1+x2-1,x2)	./button/rcomb.gif	538	502	542	\N	\N	\N
307	ilog2	11	floor(log(#)/log(2))	\N	566	509	572	\N	\N	\N
308	idiv	11	floor(#/#)	\N	554	516	558	\N	\N	\N
309	imod	11	mod(#,#)	\N	556	517	560	\N	\N	\N
310	reperm	11	xlist : [#]$ xsum: lsum(x,x,xlist)$ lv: 1$ fsum: 1$ for lv: 1 thru length(xlist) do fsum : fsum*(xlist[lv]!)$ ev(xsum!/fsum)	./button/rperm.gif	536	503	546	\N	\N	\N
311	ilogab	11	xa: #$ xb: #$ floor(log(xa)/log(xb))	\N	574	578	576	\N	\N	\N
312	msqr	6	^^2#	\N	622	579	\N	\N	\N	\N
313	mcube	6	^^3#	\N	624	580	\N	\N	\N	\N
314	solve2	11	algexact:true$ realonly: true$ syst1: [#]$ vars1: listofvars(syst1)$ sol1: algsys(syst1,vars1)$ algexact: false$ sol2: algsys(syst1,vars1)$ if (member([],sol1)) then sol1 else sol2	\N	610	607	6	\N	\N	\N
315	substx	11	big: #$ small: #$ subst(small,x,big)	./button/subst.png	650	\N	654	\N	\N	\N
316	defintx	11	defint(#,x,#,#)	./button/defint.png	648	\N	652	\N	\N	\N
317	diffu	11	diff(#,#)	./button/parde.png	656	\N	660	\N	\N	\N
318	sbstu	11	big: #$ what2: #$ small: #$ subst(small, what2, big)	./button/sbstu.png	658	\N	662	\N	\N	\N
319	sr	1	\N	./button/sr.gif	11	11	\N	\N	\N	\N
\.


--
-- Data for Name: calclayout; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY calclayout (id, name, description, introductory_text, os, sorrend) FROM stdin;
1	normal	62	4	\N	\N
2	easy	217	10	\N	\N
3	calculus	219	10	\N	\N
4	linalg	38	10	\N	\N
5	polalg	256	10	\N	\N
6	numtheory	455	10	\N	\N
7	complex	37	10	\N	\N
8	test	36	10	\N	\N
9	mytest	3	10	\N	\N
10	normal2	40	10	\N	\N
\.


--
-- Data for Name: category; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY category (id, short_description, long_description, calclayout, parent, os, sorrend) FROM stdin;
1	ltalnos iskola	ltalnos iskols matematika	2	\N	\N	\N
2	Kzpiskola	Kzpiskols matematika	1	\N	\N	\N
3	Felsoktats	Fiskolai-egyetemi matematika	\N	\N	\N	\N
4	Szakkzp	Szakkzpiskolai kpzs	1	2	\N	\N
5	Gimnzium	Gimnziumi matematika	1	2	\N	\N
6	Bevezet analzis	Sorozatok, fggvnyek, derivls, integrls	3	3	\N	\N
7	Lineris algebra	Mtrixok, determinns, egyenletrendszerek, sajtrtk-szmts	4	3	\N	\N
8	Polinomalgebra	Egyenletek, polinomoszts, faktorizci	5	3	\N	\N
9	Szmelmlet	Oszthatsg, prmszmok	6	3	\N	\N
\.


--
-- Data for Name: checkcode; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY checkcode (id, mcode, os, sorrend) FROM stdin;
1	print("check code 1");	\N	\N
2	print("check code 2");	\N	\N
\.


--
-- Data for Name: dokumentum; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY entry (id, name, parent, is_leaf) FROM stdin;
1	Root	\N	f
2	Thematics	1	f
3	Discrete	2	f
4	Analysis	2	f
5	Geometry	2	f
6	Limits	4	f
7	Limitsof	6	f
8	Ages	1	f
9	Students	8	f
10	Pupils	8	f
11	Modules	1	f
12	Tests	11	f
13	Services	11	f
\.


--
-- Data for Name: exercise; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY exercise (id, title, extype, _language, calclayout, problemtext, generatorcode, solvecode, checkcode, source, sourcedef, os, sorrend) FROM stdin;
1	quadratic_equation	3	1	1	1	1	1	1	\N	\N	\N	\N
2	division_remainder	3	1	1	2	2	2	2	\N	\N	\N	\N
\.


--
-- Data for Name: f_alfolyam_verem; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY felhasznalo (id, vezeteknev, keresztnev, jelszo, jelszo_ervenyes_tol, jelszo_ervenyes_ig, teljes_nev, azonosito, elsodleges_telefon, email, honlap, cim, kis_foto_fajl, nagy_foto_fajl, geoip_szelesseg, geoip_hosszusag, rovid_leiras, hosszu_leiras, varosnev, aktiv, os, sorrend, elotag) FROM stdin;
-1	Kovcs	Zoltn	kz	2008-01-12 15:55:31.455824	infinity	Kovcs Zoltn	kovzol	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N
-2	Bencs	Jzsef	bj	2008-01-12 15:55:31.460139	infinity	Bencs Jzsef	bencs	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N
-3	Zana	Rbert	gel	2008-01-12 15:55:31.461296	infinity	Zana Rbert	robi	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N
-4	Tasndy-Szecs	Zoltn	t	2008-01-12 15:55:31.46285	infinity	Tasndy-Szecs Zoltn	tasy	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N
-5	Hivatalnok	felhasznl	demo	2008-01-12 15:55:31.464281	infinity	Hivatalnok felhasznl	demo	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N
-6	Modul adminisztrtor	felhasznl	admin	2008-01-12 15:55:31.465574	infinity	Modul adminisztrtor felhasznl	moduladmin	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N
-7	Knya	Zoltn	kz	2008-01-12 15:55:31.466865	infinity	Knya Zoltn	consol	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N
-8	wmi2	designer	wmi2	2008-01-12 15:55:31.468088	infinity	wmi2 designer	wmi2	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N
-9	wmi2	administrator	...wmi2admin...	2008-01-12 15:55:31.469469	infinity	wmi2 administrator	wmi2admin	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N
1	Lipovszky	Pter	egyenlet3000	2008-01-12 15:55:31.471001	infinity	Lipovszky Pter	lipovszkypeter	70/532-4476	magantanar@lipovszky.hu	http://www.lipovszky.hu	9022 Gyr, rpd t 62. III. em. 14.	./teacher/lippet32.png	./teacher/lippet.png	47.683329999999998	17.633330000000001	fizika-matematika szakos flls magntanr Gyrben	1970-ben szletett Gyrben. Tanulmnyait a Sgvri Endre ltalnos Iskolban s a Rvai Mikls Gimnziumban, majd az ELTE TTK-n vgezte. <br> 2003 ta flls magntanr, tantvnyai kztt az ltalnos iskolstl a kzpiskolsokon keresztl a fiskolsig minden korosztly megtallhat.	Gyr	f	\N	\N	\N
2	Taksony	Gyrgy	primszam101	2008-01-12 15:55:31.473142	infinity	Taksony Gyrgy	taksonygy	1/329-1647	tasku@freemail.hu		1133 Budapest, Pozsonyi t 59.	./teacher/nincsk32.png	./teacher/nincskep.png	47.516669999999998	19.066669999999998	okleveles mrnk-tanr, korrepetlst, rettsgire felksztst vllal	Dr. Taksony Gyrgy Budapesten, a XIII. kerletben tant, f szakterlete az ltalnos iskols korosztly tantsa. <br> Korreptl, rettsgire s ptvizsgra is felkszt.	Budapest	f	\N	\N	\N
3	Bozi	Imre	fuggveny567	2008-01-12 15:55:31.475104	infinity	Bozi Imre	boziimre	30/477-3189	ibozi@externet.hu		1143 Budapest, Ilka u. 26. II. 9.	./teacher/nincsk32.png	./teacher/nincskep.png	47.5	19.08333	doktori disszertcijt r matematikus, 10 ves magntanri tapasztalattal	Budapesti magntanr, aki a BME-n, az Ybl Mikls Mszaki Fiskoln s az ELTE TTK-n is dolgozott mr tanrsegdknt. <br> rettsgire, felvtelire, dolgozatra, vizsgra, szigorlatra felkszts, akr csoportos keretek kztt is.	Budapest	f	\N	\N	\N
4	Hudi	Istvn	titok1963	2008-01-12 15:55:31.476879	infinity	Hudi Istvn	hudiistvan	62/631-851 (de. 8-11, du. 12-13)	hudi1963istvan@freemail.hu		6720 Szeged, Palnk 1.	./teacher/hi32.png	./teacher/hi100.png	46.255000000000003	20.145	okleveles fizikus s mrnk, korrepetlst vllal	1963-ban szletett Szegeden, a Sgvri Gimnziumban rettsgizett kitn eredmnnyel. Szmos versenyen szerepelt sikeresen. Fizikusi diplomt szerzett 1986-ban a JAT-n. ltalnos s kzpiskolsok korrepetlst vllalja.	Szeged	t	\N	\N	\N
5	Kakuk	Nra	_.235._	2008-01-12 15:55:31.478664	infinity	Kakuk Nra	kakuknora	70/205-1383	Kakuk.Nora@stud.u-szeged.hu	http://www.stud.u-szeged.hu/Kakuk.Nora		./teacher/kaknor32.png	./teacher/kaknor.png	46.255000000000003	20.145	V. ves informatika-matematika szakos tanr a Szegedi Tudomnyegyetemen	Az idei tanvben flllsban informatika tanr vagyok Szegeden a Kossuth Zsuzsanna kzpiskolban, ahol minden vfolyamon tantok, illetve 11. vfolyamon n tartom az rettsgi felksztst informatikbl kzpszintre. Az ECDL vizsgt 2000-ben szereztem meg. Szakdolgozatomat kzpiskols trgeometria feladatokbl, s ehhez kapcsold elmletekbl rom, amelynek f tmja a tetrader s analgija a skon s tbb dimenzis trben. Szabad idpontjaim a mostani flvben: szerda 11.00-14.30, november 1-tl cstrtk 10.00-17.00 s pntek 9.00-16.00 is.	Szeged	\N	\N	\N	\N
6	Nyakn dr. Juhsz	Katalin	F4=65537	2008-01-12 15:55:31.480648	infinity	Nyakn dr. Juhsz Katalin	nyakonejk	30/383-8559	nyako@inf.unideb.hu			./teacher/juhkat32.png	./teacher/juhkat.png	47.529000000000003	21.638999999999999	tudomnyos fmunkatrs a Debreceni Egyetem Informatikai Karn	Matematikusknt vgzett 1976-ban. Jelenleg Debreceni Egyetemen Informatikai Karn dolgozik tudomnyos fmunkatrsknt. 1999-ben PhD tudomnyos fokozatot szerzett.<br>Hsz ve folytat oktatsi tevkenysget. Az utbbi idben az Informatikai Karon elssorban nappali s levelez tagozatos informatikatanr szakos hallgatknak tart szakmai s mdszertani eladsokat, gyakorlatokat. A doktori kpzsben oktatknt s tmavezetknt vesz rszt.	Debrecen	\N	\N	\N	\N
7	Horvth	Janina	osleny999	2008-01-12 15:55:31.482473	infinity	Horvth Janina	horvathjanina	30/482-3217	janabagoly@gmail.com			./teacher/horjan32.png	./teacher/horjan.png	46.255000000000003	20.145	szegedi matematika tanr, V. ves fldrajz szakos hallgat	2005-ben szerzett matematika tanri diplomt a Szegedi Tudomnyegyetemen, jelenleg V. ves fldrajz szakos hallgat. Tbb matematikaversenyen rt el kivl eredmnyt. Kztrsasgi sztndjas, 2006-ban <i>Fldtudomnyi s fldrajzi szmtsi feladatok cmmel</i> trsszerzknt feladatgyjtemnye jelent meg a Szegedi Tudomnyegyetemen.<br>Fknt analzist tant szvesen. rdekldsi kre a matematika mellett az slnytan, smaradvnyok gyjtse s a teljestmnytrk.	Szeged	\N	\N	\N	\N
8	rdgh	Erzsbet	betti579	2008-01-12 15:55:31.484356	infinity	rdgh Erzsbet	ordogherzsebet	30/416-2966	erzsii@freemail.hu			./teacher/orderz32.png	./teacher/orderz.png	46.255000000000003	20.145	matematika szakos tanr Szegeden	Matematika-technika szakos tanr vagyok, ltalnos s kzpiskolsok korrepetlst, vizsgra val felksztst vllalom. Sok trelemmel s szakmai tapasztalattal rendelkezem. Szegeden bell hzhoz is megyek.	Szeged	\N	\N	\N	\N
9	Kntor	kos	kos0111	2008-01-12 15:55:31.486062	infinity	Kntor kos	kantorakos	70/315-2273	kantorak@citromail.hu		Budapest XX.	./teacher/kanako32.png	./teacher/kanako.png	47.430971	19.134741999999999	fiatal kzpiskolai tanr matematika, fizika s informatika korrepetlst vllal	Matematika- fizika szakos kzpiskolai tanr, szmtgp rendszerprogramoz segt felzrkzni, vizsgra, szigorlatra felkszlni ltalnos iskoltl az egyetemig. Gyakorlatorientlt, hatkony segtsgnyjts Budapesten dli rgijban.	Budapest	\N	\N	\N	\N
10	Mder	Attila	ma10	2008-01-12 15:55:31.487819	infinity	Mder Attila	maderattila	30/253-7730	madera@math.u-szeged.hu	http://www.math.u-szeged.hu/~madera	6723 Szeged, Ortutay u. 1/A X.27.	./teacher/madatt32.png	./teacher/madatt.png	46.255000000000003	20.145	2004-ben diplomzott, szemlletre ptve szeret matematikt tantani	2004-ben diplomztam a Szegedi Tudomnyegyetemen, hrom vig a Sgvri Endre Gyakorl Gimnziumban tantottam matematikt, t ve tantok az egyetemen. Jelenleg PhD fokozatom megszerzsn fradozom, melynek tmja a matematika j, szemlletre pl hatkony tantsi lehetsgei. Rugalmas idbeosztssal vrom a matematikbl javtani, felzrkzni szndkoz jelentkezst.	Szeged	\N	\N	\N	\N
11	Nygr	Istvn	ny_9999	2008-11-14 10:14:14.777545	infinity	Nygr Istvn	nyogeristvan	30/6077508	istvanny@gmail.com			./teacher/nyoist32.png	./teacher/nyoist.png	46.255000000000003	20.145	az SZTE-TTIK V. ves matematika szakos hallgatja, szmelmlettel foglalkozik szvesen	Nygr Istvn vagyok, V. ves az SZTE-n matematika szakon. Az ltalnos alapokon kvl felsbb szinten fleg szmelmlettel foglalkozom szvesen.	Szeged	\N	\N	\N	\N
\.


--
-- Data for Name: felhasznalo_category; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY felhasznalo_category (id, felhasznalo, category, os, sorrend) FROM stdin;
1	1	1	\N	\N
2	1	2	\N	\N
3	1	3	\N	\N
4	1	4	\N	\N
5	1	5	\N	\N
6	1	6	\N	\N
7	2	1	\N	\N
8	2	2	\N	\N
9	2	3	\N	\N
10	2	4	\N	\N
11	2	5	\N	\N
12	2	6	\N	\N
13	3	1	\N	\N
14	3	2	\N	\N
15	3	3	\N	\N
16	3	4	\N	\N
17	3	5	\N	\N
18	3	6	\N	\N
19	5	1	\N	\N
20	5	2	\N	\N
21	5	3	\N	\N
22	5	4	\N	\N
23	5	5	\N	\N
24	5	7	\N	\N
25	5	8	\N	\N
26	6	1	\N	\N
27	6	2	\N	\N
28	6	3	\N	\N
29	6	4	\N	\N
30	6	5	\N	\N
31	6	6	\N	\N
32	6	7	\N	\N
33	6	8	\N	\N
34	7	1	\N	\N
35	7	2	\N	\N
36	7	3	\N	\N
37	7	4	\N	\N
38	7	5	\N	\N
39	7	6	\N	\N
40	7	7	\N	\N
41	7	8	\N	\N
42	8	1	\N	\N
43	8	2	\N	\N
44	8	4	\N	\N
45	8	5	\N	\N
46	9	1	\N	\N
47	9	2	\N	\N
48	9	6	\N	\N
49	9	7	\N	\N
50	9	8	\N	\N
51	9	9	\N	\N
52	10	2	\N	\N
53	10	6	\N	\N
54	10	7	\N	\N
55	10	8	\N	\N
56	10	9	\N	\N
57	11	2	\N	\N
58	11	6	\N	\N
59	11	7	\N	\N
60	11	8	\N	\N
61	11	9	\N	\N
\.


--
-- Data for Name: forditas; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY gencode (id, mcode, os, sorrend) FROM stdin;
1	$x1=rand(-20,20);$x2=rand(-20,20);$a=rand(-10,10);while($a == 0){$a=rand(-10,10);}$b=$a*(-1)*($x1+$x2);$c=$x1*$x2*$a;$formula="$a*x^2+$b*x+$c=0";$replacer = "<div class='ci'><img src='".calcact($formula,100)."'></div>";$pt=str_replace("<!--ci1-->",$replacer,$pt);$pt=str_replace("<!--uo1-->","<div class='uo'><img name='uo1' id='uo1' class='uoa' src='./image/alap.png'></div>",$pt);$pt=str_replace("<!--uo2-->","<div class='uo'><img name='uo2' id='uo2' class='uo' src='./image/alap.png'></div>",$pt);	\N	\N
2	$num=rand(1000,10000);$div=rand(50,200);$pt=str_replace("<!--ci1-->",$num,$pt);$pt=str_replace("<!--ci2-->",$div,$pt);$pt=str_replace("<!--uo1-->","<div class='uo'><img name='uo1' id='uo1' class='uoa' src='./image/alap.png'></div>",$pt);$pt=str_replace("<!--uo2-->","<div class='uo'><img name='uo2' id='uo2' class='uo' src='./image/alap.png'></div>",$pt);	\N	\N
\.


--
-- Data for Name: hang; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY i18ntext (id, mainid, _language, text, os, sorrend) FROM stdin;
204	204	\N	<font face="Times New Roman, serif" size="+1">&#960;</font>	\N	\N
205	205	1	Fels egszrsz	\N	\N
206	206	1	Als egszrsz	\N	\N
207	207	1	Eljel (szignum) fggvny	\N	\N
208	208	1	Kbgyk	\N	\N
209	209	1	Negls	\N	\N
210	210	1	Tizedespont	\N	\N
211	211	1	Normlalak kitevje	\N	\N
212	212	1	Szzalk	\N	\N
213	213	\N	&#8730;<span style="text-decoration:overline;"><i>x</i></span>	\N	\N
214	214	\N	&#8968;<i>x</i>&#8969;	\N	\N
215	215	\N	&#8970;<i>x</i>&#8971;	\N	\N
216	63	1	Most el lehet menteni a munkalapot.	\N	\N
221	59	1	A <a href="http://matek.hu">matek.hu</a> tmenetileg zemen kvl van.<br>Krjk, ltogasson vissza ksbb!	\N	\N
222	222	1	A kt polinom hnyadosa s a maradk:[co]	\N	\N
223	223	1	Polinomok osztsa	\N	\N
257	257	1	Bevezet analzis	\N	\N
258	258	1	Algebra	\N	\N
259	259	1	Lineris algebra	\N	\N
260	257	2	Calculus	\N	\N
307	307	1	A mtrix karakterisztikus polinomja (<i>x</i>-ben):[co]	\N	\N
308	306	2	Characteristic polynomial	\N	\N
309	307	2	<a href="http://en.wikipedia.org/wiki/Characteristic_polynomial" target="_blank">The characteristic polynomial of the matrix (respect to <i>x</i>)</a>:[co]	\N	\N
310	310	1	Sajtrtkek	\N	\N
311	311	1	<a href="http://hu.wikipedia.org/wiki/Saj%C3%A1tvektor_%C3%A9s_saj%C3%A1t%C3%A9rt%C3%A9k" target="_blank">A mtrix sajtrtkei</a> [[<i>sajtrtkek</i>], [<i>hozzjuk tartoz multiplicitsok</i>] alakban:[co]	\N	\N
312	310	2	Eigenvalues	\N	\N
313	311	2	<a href="http://en.wikipedia.org/wiki/Eigenvalue%2C_eigenvector_and_eigenspace#Eigenvalues_and_eigenvectors_of_matrices" target="_blank">Eigenvalues of the matrix</a> in format [[<i>eigenvalues</i>], [<i>respective multiplicities</i>]]:[co]	\N	\N
314	314	1	Sajtvektorok	\N	\N
315	315	1	<a href="http://hu.wikipedia.org/wiki/Saj%C3%A1tvektor_%C3%A9s_saj%C3%A1t%C3%A9rt%C3%A9k" target="_blank">A mtrix sajtvektorai</a> [[[<i>sajtrtkek</i>],[<i>hozzjuk tartoz multiplicitsok</i>]], <i>1. sajtvektor</i>, <i>2. sajtvektor</i>, ...] alakban:[co]	\N	\N
316	314	2	Eigenvectors	\N	\N
317	315	2	<a href="http://en.wikipedia.org/wiki/Eigenvalue%2C_eigenvector_and_eigenspace#Eigenvalues_and_eigenvectors_of_matrices" target="_blank">Eigenvectors of the matrix</a> in format [[[<i>eigenvalues</i>], [<i>respective multiplicites</i>]], <i>1st eigenvector</i>, <i>2nd eigenvector</i>, ...]:[co]	\N	\N
318	318	1	Mtrix szorzs, skalris szorzat	\N	\N
319	318	2	Matrix multiplication, scalar product	\N	\N
320	320	1	Mtrix hatvnyozs	\N	\N
1262	77	9	súkromný učiteľ.	\N	\N
321	320	2	Matrix power	\N	\N
322	322	\N	<span style="font-size:larger;font-style:italic;font-weight:bold;"><font face="Verdana, Arial, sans-serif">r</font></span>	\N	\N
323	323	\N	<span style="font-weight:bold;font-style:italic;color:#c0c0c0;"><font face="Verdana, Arial, sans-serif">A<span style="color:white;">v</span>=&#955;<span style="color:white;">v</span></font></span>	\N	\N
324	324	\N	<span style="font-size:larger;font-style:italic;font-weight:bold;"><font face="Verdana, Arial, sans-serif">O</font></span><sub>2</sub>	\N	\N
325	325	\N	<span style="font-size:larger;font-style:italic;font-weight:bold;"><font face="Verdana, Arial, sans-serif">O</font></span><sub>3</sub>	\N	\N
326	326	\N	<span style="font-size:larger;font-style:italic;font-weight:bold;"><font face="Verdana, Arial, sans-serif">I</font></span><sub>4</sub>	\N	\N
327	327	\N	<span style="font-size:larger;font-style:italic;font-weight:bold;"><font face="Verdana, Arial, sans-serif">O</font></span><sub>4</sub>	\N	\N
328	328	\N	<span style="font-size:larger;font-style:italic;font-weight:bold;"><font face="Verdana, Arial, sans-serif">M</font></span><sub>4x4</sub>	\N	\N
329	329	\N	<span style="font-size:larger;font-face:Verdana, Arial, sans-serif;font-style:italic;font-weight:bold;">?</span><sub>2</sub>	\N	\N
330	330	\N	<span style="font-size:larger;font-face:Verdana, Arial, sans-serif;font-style:italic;font-weight:bold;">?</span><sub>3</sub>	\N	\N
331	331	\N	<span style="font-size:larger;font-face:Verdana, Arial, sans-serif;font-style:italic;font-weight:bold;">?</span><sub>4</sub>	\N	\N
332	332	\N	<span style="font-size:larger;font-style:italic;font-weight:bold;"><font face="Verdana, Arial, sans-serif">M</font></span><sub>2x3</sub>	\N	\N
333	333	\N	<span style="font-size:larger;font-style:italic;font-weight:bold;"><font face="Verdana, Arial, sans-serif">M</font></span><sub>3x4</sub>	\N	\N
334	334	\N	<span style="font-size:larger;font-style:italic;font-weight:bold;"><font face="Verdana, Arial, sans-serif">M</font></span><sub>4x5</sub>	\N	\N
335	335	1	RLA	\N	\N
336	336	1	Lpcss alak (a ftlban 1-esekkel)	\N	\N
337	336	2	Echelon form (with unit leading coefficients)	\N	\N
381	189	2	Power	\N	\N
382	190	2	Square	\N	\N
383	191	2	Cube	\N	\N
385	193	2	Real variable	\N	\N
387	195	2	Next parameter	\N	\N
388	196	2	Logarithm (natural based)	\N	\N
389	197	2	Logarithm (2 based)	\N	\N
390	198	2	Factorial	\N	\N
391	199	2	Exponential function	\N	\N
392	205	2	Ceiling	\N	\N
393	206	2	Floor	\N	\N
394	207	2	Sign (signum) function	\N	\N
395	208	2	Cube root	\N	\N
396	209	2	Negation	\N	\N
397	210	2	Decimal point	\N	\N
398	211	2	Exponent of normal form	\N	\N
399	212	2	Percent	\N	\N
400	173	2	In simplified form:[co]	\N	\N
401	174	2	Approximately	\N	\N
402	175	2	Approximately:[co]	\N	\N
403	176	2	Greatest common divisor	\N	\N
404	177	2	<a href="http://en.wikipedia.org/wiki/Greatest_common_divisor" target="_blank">Greatest common divisor of the expressions</a>:[co]	\N	\N
405	178	2	Least common multiplier	\N	\N
406	179	2	<a href="http://en.wikipedia.org/wiki/Least_common_multiple", target="_blank">Least common multiplier of the expressions</a>:[co]	\N	\N
407	180	2	Decomposition to partial fractions	\N	\N
408	181	2	Decomposition to <a href="http://en.wikipedia.org/wiki/Partial_fraction" target="_blank">partial fraction</a>:[co]	\N	\N
409	184	2	<a href="http://en.wikipedia.org/wiki/Factorization" target="_blank">Factorized</a>:[co]	\N	\N
410	410	1	Binomilis egytthat	\N	\N
411	411	1	A krdses binomilis egytthat:[co]	\N	\N
412	410	2	Binomial coefficient	\N	\N
413	411	2	<a href="http://en.wikipedia.org/wiki/Binomial_coefficient" target="_blank">The binomial coefficient</a>:[co]	\N	\N
414	414	1	2x2-es egysgmtrix	\N	\N
415	414	2	Identity matrix of size 2x2	\N	\N
416	416	1	2x2-es zrmtrix	\N	\N
417	416	2	Zero matrix of size 2x2	\N	\N
2156	574	5	Parte intera del logaritmo in base b	\N	\N
2193	601	5	<span style="color:blue;">non ci sono soluzioni</span>	\N	\N
2232	94	5	Grafica basata su Gnome<br> Copyright del logo &copy; 2003 Zsigmond Kovacs<br> Scelta colori a cura di Zsuzsa Deak<br> <span style="font-size:smaller;">Animazione del cubo 4D a cura di Oliver Knill, Universitá di Harvard<br> Logo della ragazza punk &copy; www.sykospark.net<br> Immagine della spirale proveniente da Wikipedia &copy; Chris 73<br> Logo della teoria dei numeri &copy; Zoltan Medve</span>	\N	\N
2233	95	5	Software di base:<br> GNU Linux/Apache/PostgreSQL/PHP, gnuplot/Maxima, TeX/LaTeX/ImageMagick, formconv/TeXmacs, GeoLite (http://www.maxmind.com)	\N	\N
2234	96	5	Per contattare gli sviluppatori<br> scrivere a<br> <b><a style="color: #ffffff; text-decoration: none;" href="mailto:info@matek.hu"> info@matek.hu</a></b>	\N	\N
1800	97	5	Segnalare i bug su<br> <b><a style="color: #ffffff; text-decoration: none;" href="http://wmi.sf.net/2/bugs" target="_blank">http://wmi.sf.net/2/bugs</a></b>	\N	\N
3024	125	5	Cambia la lingua in inglese.	\N	\N
2228	88	5	<a href="http://it.wikipedia.org/wiki/Grafico_di_una_funzione" target="_blank">Grafico della funzione</a>:	\N	\N
2163	141	5	Successione di somme parziali	\N	\N
2300	272	5	Database degli insegnanti	\N	\N
463	462	2	Trigonometric functions	\N	\N
464	464	1	Logaritmikus fggvnyek	\N	\N
465	464	2	Logarithmic functions	\N	\N
466	466	1	Exponencilis nagysg fggvnyek	\N	\N
467	466	2	Exponential scale functions	\N	\N
468	468	1	Egyszer gykk s hatvnyok	\N	\N
469	468	2	Simple roots and powers	\N	\N
470	470	1	Vals vltozk	\N	\N
471	470	2	Real variables	\N	\N
472	472	1	Egsz vltozk	\N	\N
473	472	2	Integer variables	\N	\N
474	474	1	Hatrrtkek	\N	\N
475	474	2	Limits	\N	\N
476	476	1	Konstansok	\N	\N
477	476	2	Constants	\N	\N
478	478	1	Nullmtrix	\N	\N
479	478	2	Null matrix	\N	\N
480	480	1	Egysgmtrix	\N	\N
481	480	2	Identity matrix	\N	\N
482	482	1	j mtrix	\N	\N
483	482	2	New matrix	\N	\N
484	484	1	Fggvnyek brzolsa, egyenletmegolds	\N	\N
485	484	2	Functon plotting, solving equations	\N	\N
486	486	1	Ehhez a szmtshoz 2 paramtert kell megadni. A paramtereket egy vessz (",") vlasztja el egymstl.	\N	\N
487	486	2	You should give 2 parameters for this calculation. The parameters must be separated by a comma (",").	\N	\N
488	488	1	Ehhez a szmtshoz csak egy paramtert kell megadni. Teht nem szabad vesszt (",") hasznlni.	\N	\N
489	488	2	You should give only one parameter for this calculation. So you must not use comma (",").	\N	\N
490	490	\N	<table cellpadding="0" cellspacing="0" border="0" align="center" valign="middle"><tr valign="middle"><td style="font-size:x-small;color:white;text-align:center;"><b><i>n</i>!</b></td></tr><tr valign="middle"><td style="color:white;font-size:x-small;border-top:solid 1px;"><b>(<i>n-k</i>)!</b></td></tr></table>	\N	\N
491	491	1	<span style="color:blue;">nincs definilva (nincs rtelmezve, nem ltezik)</span>	\N	\N
492	491	2	<span style="color:blue;">undefined (not exist)</span>	\N	\N
493	493	1	<span style="color:blue;">hamis</span>	\N	\N
494	493	2	<span style="color:blue;">false</span>	\N	\N
495	495	1	<span style="color:blue;">igaz</span>	\N	\N
496	495	2	<span style="color:blue;">true</span>	\N	\N
497	497	1	Szmelmlet	\N	\N
498	497	2	Number theory	\N	\N
499	455	2	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Welcome to the Number Theory section!</h2></center>Just start to type the problem using the keyboard or the mouse and press a cyan button on the left to start the calculation. To select another layout of available calculator buttons please press the button on the top-left.</td><td valign="top" align="right"><img src="./image/lakat2.jpg" alt="Can be used for encryption" title="Can be used for encryption" style="position:relative;top:-10px;right:-10px;"></td></table>	\N	\N
500	500	1	Az, hogy a szm <a href="http://hu.wikipedia.org/wiki/Pr%C3%ADmsz%C3%A1mok" target="_blank">prmszm</a>:[co]	\N	\N
501	500	2	The statement that the number is <a href="http://en.wikipedia.org/wiki/Prime_number" target="_blank">prime</a> is:[co]	\N	\N
502	502	\N	<table align="center" valign="center" cellpadding="0" cellspacing="0" border="0"><tr><td style="color:white;font-size:large;">(</td><td><table cellpadding="0" cellspacing="0" border="0"><tr><td style="font-size:x-small;color:white;"><b><i>n+k-</i>1</b></td></tr><tr><td style="color:white;font-size:x-small;text-align:center;"><b><i>k</i></b></td></tr></table></td><td style="font-size:large;color:white;">)</td></table>	\N	\N
503	503	\N	<table cellpadding="0" cellspacing="0" border="0" align="center"><tr><td style="font-size:x-small;color:white;text-align:center;"><i>n</i>!</td></tr><tr><td style="color:white;font-size:x-small;border-top:solid 1px;font-weight:normal;"><i>k</i><sub><small>1</small></sub>!<i>k</i><sub><small>2</small></sub>!<i>k</i><sub><small>3</small></sub>!</td></tr></table>	\N	\N
504	504	\N	<big><span style="font-weight:normal;"><font face="Times,serif"><i>&#966;</i></font><font face="Verdana, Arial, sans-serif">(<i>n</i>)</font></span></big>	\N	\N
505	505	\N	<big><span style="font-weight:normal;"><font face="Times,serif"><i>&#963;</i></font><font face="Verdana, Arial, sans-serif">(<i>n</i>)</font></span></big>	\N	\N
506	506	\N	<font size="-1"><i>n</i>&#8594;<i>p<sub>k</sub></i></font>	\N	\N
507	507	\N	<font size="-1"><i>p<sub>k</sub></i>&#8592;<i>n</i></font>	\N	\N
509	509	\N	<font size="-1"><span style="font-weight:normal;">&#8970;log<sub><small>2</small></sub><i>x</i>&#8971;</span></font>	\N	\N
510	510	\N	<i>F<sub>n</sub></i>	\N	\N
511	511	1	Krjk, tmogassa a matek.hu-t! Ksznjk!	\N	\N
512	511	2	Please donate to WMI2! Thank you!	\N	\N
855	335	8	RREF	\N	\N
1380	82	10	Zavřít	\N	\N
519	518	2	The smallest <a href="http://en.wikipedia.org/wiki/Prime_number" target="_blank">prime</a> which is bigger than the given number:[co]	\N	\N
520	520	1	A megadott szm eltti <a href="http://hu.wikipedia.org/wiki/Pr%C3%ADmsz%C3%A1mok" target="_blank">prmszm</a>:[co]	\N	\N
521	520	2	The largest <a href="http://en.wikipedia.org/wiki/Prime_number" target="_blank">prime</a> which is smaller than the given number:[co]	\N	\N
522	522	1	Az adott szmnl kisebb <a href="http://hu.wikipedia.org/wiki/Relat%C3%ADv_pr%C3%ADmek" target="_blank"> relatv prmek</a> szma:[co]	\N	\N
523	522	2	The number of <a href="http://en.wikipedia.org/wiki/Coprime" target="_blank">relatively primes</a> less than the given number:[co]	\N	\N
524	524	1	Az adott szm osztinak sszege:[co]	\N	\N
525	524	2	The sum of <a href="http://en.wikipedia.org/wiki/Divisor" target="_blank">divisors</a> of the given number:[co]	\N	\N
526	526	1	Kisebb relatv prmek szma	\N	\N
527	526	2	Number of smaller relative primes	\N	\N
528	528	1	Osztk sszege	\N	\N
529	528	2	Sum of divisors	\N	\N
530	530	1	A kvetkez prmszm	\N	\N
531	530	2	The next prime	\N	\N
532	532	1	Az elz prmszm	\N	\N
533	532	2	The previous prime	\N	\N
534	534	1	A szm prm-e?	\N	\N
535	534	2	Is the number a prime?	\N	\N
536	536	1	Ismtlses permutcik szma	\N	\N
537	536	2	Number of permutations with repetition	\N	\N
538	538	1	Ismtlses kombincik szma	\N	\N
539	538	2	Multiset coefficient	\N	\N
540	540	1	Varicik szma	\N	\N
541	540	2	Number of variations (permutations)	\N	\N
544	544	1	A varicik szma:[co]	\N	\N
2211	69	5	La lingua è impostata su %s. Si consiglia di ricaricare la pagina ora.	\N	\N
1856	219	5	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>L'analisi matematica può essere semplice!</h2></center>Inizia ad inserire il problema utilizzando la tastiera o il mouse e premi il pulsante azzurro sulla sinistra per eseguire il calcolo. Per selezionare un altro tipo di calcolatrice disponibile premi il pulsante in alto a sinistra. È anche disponibile un <a href=doc/calculus.avi>filmato dimostrativo</a>.</td><td valign="top" align="right"><img src="./image/calculus-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt="Spirale logaritmica, simbolo dell'analisi matematica" title="Spirale logaritmica, simbolo dell'analisi matematica"></td></tr></table>	\N	\N
2295	226	5	<b>La formula inserita non può essere elaborata, spiacente.</b>	\N	\N
2297	257	5	Analisi matematica	\N	\N
2299	259	5	Algebra lineare	\N	\N
2301	286	5	Inverso della matrice	\N	\N
1868	287	5	<a href="http://it.wikipedia.org/wiki/Matrice_invertibile" target="_blank">L'inverso della matrice</a>:[co]	\N	\N
2302	290	5	Determinante	\N	\N
1870	291	5	<a href="http://it.wikipedia.org/wiki/Determinante" target="_blank">Il determinante della matrice</a>:[co]	\N	\N
1874	299	5	<a href="http://it.wikipedia.org/wiki/Rango_(algebra_lineare)" target="_blank">Il rango della matrice</a>:[co]	\N	\N
2305	302	5	Trasposta della matrice dei cofattori (matrice aggiunta)	\N	\N
1876	303	5	<a href="http://it.wikipedia.org/wiki/Matrice_dei_cofattori#Trasposta" target="_blank">La trasposta della matrice dei cofattori (matrice aggiunta)</a>:[co]	\N	\N
2306	306	5	Polinomio caratteristico	\N	\N
2307	307	5	<a href="http://it.wikipedia.org/wiki/Polinomio_caratteristico" target="_blank">Il polinomio caratteristico della matrice (rispetto a <i>x</i>)</a>:[co]	\N	\N
2308	310	5	Autovalori	\N	\N
1879	311	5	<a href="http://it.wikipedia.org/wiki/Autovettore_e_autovalore" target="_blank">Gli autovalori della matrice</a> nel formato [[<i>autovalori</i>], [<i>rispettive molteplicità</i>]]:[co]	\N	\N
2309	314	5	Autovettori	\N	\N
2310	315	5	<a href="http://it.wikipedia.org/wiki/Autovettore_e_autovalore" target="_blank">Gli autovettori della matrice</a> nel formato [[[<i>autovalori</i>], [<i>rispettive molteplicità</i>]], <i>1° autovettore</i>, <i>2° autovettore</i>, ...]:[co]	\N	\N
2311	318	5	Moltiplicazione di matrice, prodotto scalare	\N	\N
2312	320	5	Potenza di matrice	\N	\N
2191	336	5	Forma ridotta (con valori unitari nella diagonale principale)	\N	\N
2313	338	5	In forma ridotta (con valori unitari nella diagonale principale):[co]	\N	\N
2173	335	5	RREF	\N	\N
1863	256	5	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Benvenuti al dipartimento di algebra!</h2></center>Inizia a inserire il problema utilizzando la tastiera o il mouse e premi il pulsante azzurro sulla sinistra per eseguire il calcolo. Per selezionare un altro tipo di calcolatrice disponibile premi il pulsante in alto a sinistra.</td><td valign="top" align="right"><img src="./image/algebra-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt="Al Khwarizmi, autore del primo libro di algebra (stampa dall'unione sovietica, 1983)" title="Al Khwarizmi, autore del primo libro di algebra (stampa russa, 1983)"></td></tr></table>	\N	\N
1769	38	5	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Benvenuti negli strumenti di algebra lineare!</h2></center>Inizia a inserire il problema utilizzando la tastiera o il mouse e premi il pulsante azzurro sulla sinistra per eseguire il calcolo. Per selezionare un altro tipo di calcolatrice disponibile premi il pulsante in alto a sinistra. Per capire meglio come inserire un problema, <a href="doc/linalg.avi">guarda questo filmato</a>.</td><td valign="top" align="right"><img src="./image/4dcube.gif" alt="Ruotare un cubo in 4 dimensioni" title="Ruotare un cubo in 4 dimensioni" style="position:relative;top:-10px;right:-10px;"></td></tr></table>	\N	\N
2215	75	5	Il percorso verso la soluzione...	\N	\N
2218	78	5	Aiuto ancora maggiore...	\N	\N
2219	79	5	Bisogno di aiuto?	\N	\N
2220	80	5	Cos'è questo?	\N	\N
2221	81	5	Facendo clic con il tasto sinistro del mouse la formula sarà posizionata nel campo di input	\N	\N
2223	83	5	Sicuro di voler cancellare il foglio di lavoro?	\N	\N
2224	84	5	Nuovo foglio di lavoro	\N	\N
574	574	1	b alap logaritmus egsz rsze	\N	\N
2225	85	5	Salva	\N	\N
2226	86	5	Stampa	\N	\N
2227	87	5	Informazioni su WMI2	\N	\N
2186	106	5	Radice quadrata	\N	\N
2235	107	5	Valore assoluto	\N	\N
2236	108	5	Seno	\N	\N
2237	109	5	Coseno	\N	\N
2238	110	5	Tangente	\N	\N
2239	111	5	Logaritmo (decimale)	\N	\N
2240	112	5	Parentesi (apertura e chiusura, 1 livello interno)	\N	\N
2241	113	5	Chiusura parentesi (1 livello esterno)	\N	\N
2242	114	5	Semplificazione	\N	\N
2243	115	5	Risoluzione dell'equazione (incluse radici complesse)	\N	\N
2244	116	5	Grafico di una funzione	\N	\N
2181	185	5	In forma estesa:[co]	\N	\N
2270	186	5	Espansione	\N	\N
2271	187	5	Resto della divisione	\N	\N
2272	188	5	Pi greco, costante matematica, circa 3,14159	\N	\N
2273	189	5	Potenza	\N	\N
2274	190	5	Quadrato	\N	\N
2275	191	5	Cubo	\N	\N
2276	193	5	Variabile reale	\N	\N
2277	195	5	Parametro seguente	\N	\N
2278	196	5	Logaritmo (naturale)	\N	\N
2279	197	5	Logaritmo (base 2)	\N	\N
2280	198	5	Fattoriale	\N	\N
2281	199	5	Funzione esponenziale	\N	\N
2282	205	5	Parte intera superiore	\N	\N
2283	206	5	Parte intera inferiore	\N	\N
2284	207	5	Funzione segno (signum)	\N	\N
2285	208	5	Radice cubica	\N	\N
2286	209	5	Negazione	\N	\N
2287	210	5	Punto decimale	\N	\N
2288	211	5	Esponente della forma normale	\N	\N
2289	212	5	Percento	\N	\N
2259	173	5	In forma semplificata:[co]	\N	\N
2260	174	5	Circa	\N	\N
2261	175	5	Circa:[co]	\N	\N
2262	176	5	Massimo comun divisore	\N	\N
2263	177	5	<a href="http://it.wikipedia.org/wiki/Massimo_comun_divisore" target="_blank">Il massimo comun divisore delle espressioni</a>:[co]	\N	\N
2264	178	5	Minimo comune multiplo	\N	\N
2265	179	5	<a href="http://it.wikipedia.org/wiki/Minimo_comune_multiplo", target="_blank">Il minimo comune multiplo delle espressioni</a>:[co]	\N	\N
2266	180	5	Decomposizione in frazioni parziali	\N	\N
2267	181	5	Decomposizione in <a href="http://it.wikipedia.org/wiki/Decomposizione_in_frazioni_parziali_sui_reali" target="_blank">frazioni parziali</a>:[co]	\N	\N
2269	184	5	<a href="http://it.wikipedia.org/wiki/Fattorizzazione" target="_blank">Fattorizzato</a>:[co]	\N	\N
2192	410	5	Coefficiente binomiale	\N	\N
2314	411	5	<a href="http://it.wikipedia.org/wiki/Coefficiente_binomiale" target="_blank">Il coefficiente binomiale</a>:[co]	\N	\N
2315	414	5	Matrice identitá 2x2	\N	\N
2316	416	5	Matrice nulla 2x2	\N	\N
2317	418	5	Matrice 2x2 (modello)	\N	\N
2318	420	5	Forma ridotta per righe	\N	\N
2319	422	5	<a href=http://en.wikipedia.org/wiki/Row_echelon_form>Forma ridotta per righe</a>:[co]	\N	\N
2291	222	5	Il quoziente e il resto dopo la divisione:[co]	\N	\N
2292	223	5	Divisione di polinomi	\N	\N
2112	441	5	Limite destro della funzione	\N	\N
2113	443	5	Limite sinistro della funzione	\N	\N
2114	445	5	Il limite destro della funzione:[co]	\N	\N
2115	447	5	Il limite sinistro della funzione:[co]	\N	\N
2116	449	5	Limite della somma	\N	\N
2117	451	5	Il limite della somma all'infinito:[co]	\N	\N
2118	453	5	e, costante matematica, circa 2,71828	\N	\N
2119	456	5	Carica un'altra calcolatrice	\N	\N
2120	458	5	Selettore lingua	\N	\N
2122	462	5	Funzioni trigonometriche	\N	\N
2123	464	5	Funzioni logaritmiche	\N	\N
2124	466	5	Funzioni esponenziali	\N	\N
2125	468	5	Radici e potenze semplici	\N	\N
2126	470	5	Variabili reali	\N	\N
2127	472	5	Variabili intere	\N	\N
2128	474	5	Limiti	\N	\N
2129	476	5	Costanti	\N	\N
2130	478	5	Matrice nulla	\N	\N
2131	480	5	Matrice identità	\N	\N
2132	482	5	Nuova matrice	\N	\N
2133	484	5	Grafico della funzione, risoluzione delle equazioni	\N	\N
2134	486	5	Per questo calcolo sono necessari 2 parametri. I parametri devono essere separati da una virgola (",").	\N	\N
2135	488	5	Per questo calcolo è necessario un solo parametro. Quindi non deve essere utilizzata la virgola (",").	\N	\N
2136	491	5	<span style="color:blue;">indefinito (non esiste)</span>	\N	\N
2137	493	5	<span style="color:blue;">falso</span>	\N	\N
2138	495	5	<span style="color:blue;">vero</span>	\N	\N
2174	497	5	Teoria dei numeri	\N	\N
1680	455	5	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Benvenuto nella sezione di teoria dei numeri!</h2></center>Inizia a inserire il problema utilizzando la tastiera o il mouse e premi il pulsante azzurro sulla sinistra per eseguire il calcolo. Per selezionare un altro tipo di calcolatrice disponibile premi il pulsante in alto a sinistra.</td><td valign="top" align="right"><img src="./image/lakat2.jpg" alt="Può essere usata per la cifratura" title="Può essere usata per la cifratura" style="position:relative;top:-10px;right:-10px;"></td></table>	\N	\N
1697	500	5	L'affermazione che il numero è <a href="http://it.wikipedia.org/wiki/Numero_primo" target="_blank">primo</a> è:[co]	\N	\N
2139	511	5	Fai una donazione a WMI2! Grazie!	\N	\N
2140	513	5	Moltiplicazione (degli elementi delle matrici uno per uno, non moltiplicazione di matrice)	\N	\N
797	10	7	公式：[ui]	\N	\N
1700	518	5	Il più piccolo <a href="http://it.wikipedia.org/wiki/Numero_primo" target="_blank">numero primo</a> maggiore del numero dato:[co]	\N	\N
1701	520	5	Il più grande <a href="http://it.wikipedia.org/wiki/Numero_primo" target="_blank">numero primo</a> minore del numero dato:[co]	\N	\N
1702	522	5	Il numero dei <a href="http://it.wikipedia.org/wiki/Interi_coprimi" target="_blank"> primi relativi</a> minore del numero dato:[co]	\N	\N
2141	524	5	La somma dei <a href="http://it.wikipedia.org/wiki/Divisore" target="_blank">divisori</a> del numero dato:[co]	\N	\N
1209	224	9	Zvyšok delenia polinómov:[co]	\N	\N
1210	225	9	Delenie polynómov, zvyšok	\N	\N
2142	526	5	Numero dei più piccoli primi relativi	\N	\N
2143	528	5	Somma dei divisori	\N	\N
2144	530	5	Numero primo seguente	\N	\N
2145	532	5	Numero primo precedente	\N	\N
2146	534	5	Il numero é primo?	\N	\N
2147	536	5	Numero di permutazioni con ripetizioni	\N	\N
2148	538	5	Numero di combinazioni con ripetizioni	\N	\N
2149	540	5	Numero delle disposizioni (permutazioni)	\N	\N
2150	542	5	Il numero delle combinazioni con ripetizione:[co]	\N	\N
2151	544	5	Numero delle disposizioni (permutazioni):[co]	\N	\N
1130	258	9	Algebra	\N	\N
2152	546	5	Numero delle permutazioni con oggetti identici:[co]	\N	\N
2153	548	5	Fattoriale (numero di permutazioni):[co]	\N	\N
2154	550	5	L'ennesimo elemento della serie di Fibonacci	\N	\N
1660	552	5	L'elemento <i>ennesimo<i> della <a href="http://it.wikipedia.org/wiki/Successione_di_Fibonacci" target="_blank">successione di Fibonacci</a>:[co]	\N	\N
2175	554	5	Divisione intera	\N	\N
2176	556	5	Resto della divisione intera	\N	\N
2177	558	5	La <a href="http://http://it.wikipedia.org/wiki/Intero" target="_blank">parte intera</a> del <a href="http://it.wikipedia.org/wiki/Quoziente" target="_blank">quoziente</a>:[co]	\N	\N
2178	560	5	Il <a href="http://it.wikipedia.org/wiki/Resto" target="_blank">resto</a> della <a href="http://it.wikipedia.org/wiki/Divisione_(matematica)" target="_blank">divisione</a>:[co]	\N	\N
2179	562	5	Radice quadrata intera	\N	\N
2155	564	5	Radice ennesima intera	\N	\N
2180	566	5	Parte intera del logaritmo in base 2	\N	\N
1717	568	5	Parte intera della <a href="http://it.wikipedia.org/wiki/Radice_quadrata" target="_blank">radice quadrata</a>:[co]	\N	\N
1718	570	5	Parte intera della <a href="http://it.wikipedia.org/wiki/Radicale_(matematica)" target="_blank">radice<i>ennesima</i></a>:[co]	\N	\N
1719	572	5	Parte intera del <a href="http://it.wikipedia.org/wiki/Logaritmo" target="_blank">logaritmo</a> in base 2 del numero:[co]	\N	\N
1721	576	5	Parte intera del <a href="http://it.wikipedia.org/wiki/Logaritmo" target="_blank">logaritmo</a> in base <i>b</i> del numero:[co]	\N	\N
2157	581	5	Per questo calcolo il numero dei parametri forniti dovrebbe essere [PAR]. Se sono più di uno, i parametri stessi devono essere separati da virgole.	\N	\N
2194	603	5	Per questo calcolo sono necessari 3 parametri. I parametri devono essere separati da una virgola (","). Il primo parametro contiene l'equazione da risolvere, il secondo e il terzo contengono due valori che determinano gli estremi dell'intervallo entro cui deve essere cercata la soluzione.	\N	\N
2195	610	5	Risoluzione dell'equazione	\N	\N
2196	612	5	<span style="color:blue;">indefinito</span>	\N	\N
2197	614	5	<b>Errore: divisione per zero</b>	\N	\N
2160	628	5	Da lontano	\N	\N
2162	632	5	Ruota a sinistra	\N	\N
2165	634	5	Ruota a destra	\N	\N
2166	636	5	Ruota in alto	\N	\N
2168	640	5	Traslazione x+	\N	\N
2202	648	5	Integrale definito	\N	\N
2169	652	5	L' <a href="http://it.wikipedia.org/wiki/Integrale">integrale definito</a> della funzione:[co]	\N	\N
2204	654	5	Sostituendo la variabile x dell'espressione con qualcosa:[co]	\N	\N
2170	656	5	Derivata parziale	\N	\N
2171	658	5	Sostituzione	\N	\N
2185	660	5	La <a href="http://it.wikipedia.org/wiki/Derivata_parziale">derivata parziale</a> della funzione:[co]	\N	\N
2303	294	5	Trasposta	\N	\N
1872	295	5	<a href="http://it.wikipedia.org/wiki/Trasposta" target="_blank">Trasposta della matrice</a>:[co]	\N	\N
2304	298	5	Rango di matrice	\N	\N
2212	72	5	Chiedi aiuto vicino a %s...	\N	\N
2213	73	5	Soluzione dettagliata...	\N	\N
2214	74	5	Aiuto maggiore...	\N	\N
2222	82	5	Chiudi	\N	\N
2172	662	5	Sostituendo nell'espressione:[co]	\N	\N
3017	664	5	<b>Errore: log(0) è indefinito</b>	\N	\N
2268	182	5	<b>L'immagine verrebbe troppo grande, spiacente.</b>	\N	\N
2182	642	5	Traslazione x-	\N	\N
2183	644	5	Traslazione y+	\N	\N
2184	646	5	Traslazione y-	\N	\N
2203	650	5	Sostituzione (x)	\N	\N
2188	143	5	<a href="http://it.wikipedia.org/wiki/Prodotto_infinito">Successione di prodotti parziali</a>:[co]	\N	\N
2206	10	5	La formula:[ui]	\N	\N
2205	4	5	La formula del problema:[ui]	\N	\N
2207	8	5	Il valore di espressione è di:[co]	\N	\N
1773	6	5	Una soluzione approssimata dell'<a href="http://it.wikipedia.org/wiki/Equazione" target="_blank">equazione</a> nel intervallo dato:[co]	\N	\N
2210	61	5	Chiedi aiuto vicino a %s...	\N	\N
2008	62	5	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Ciao, questo è il matek.hu!</h2></center>Sì! Il matek.hu ha rinnovato, ma non solo nella forma esterna, ma anche nel suo funzionamento! Naturalmente <a href="http://matek.hu/1" target="_blank">la vecchia versione è accessibile</a>. La rubrica della teoria dei numeri di matek.hu ti saluta!</h2></center>Puoi inscrivere i compiti sulla calcolatrice sinistra, sia con mouse sia anche con tastiera. I conti puoi mettere in movimento con i bottoni glauci. Il tipo di calcolatrice puoi cambiare con il bottone di sopra sinistra: che adesso usi, con quello può risolvere <i>i compiti della scuola secondaria</i>. Se hai bisogno di aiuto, <a href="segitseg" target="_blank">fai clic qui</a> (<a href="doc/intro_hu.pdf">PDF</a>) oppure <a href="doc/normal-hu.avi">guarda questo film</a>!<br><br></td><td valign="top" align="right"><img src="./image/normal-pres.png" style="position:relative;top:-10px;right:-10px;" alt=""></td></tr></table>	\N	\N
2209	60	5	Si dispone di un tasto errato, in questo contesto.\nLa formula deve essere inserita come in una moderna calcolatori,\nda sinistra a destra, a portata di mano-scritta Analogamente Formule.\n\nSe non sapete cosa fare adesso, cercare di ripristinare la calcolatrice\ne riavviare il vostro lavoro con il tasto 'ce'.\n\nSe si pensa che avete incontrato un errore utilizzando WMI2,\nprova a ricaricare questa pagina e visitare il nostro sito\ndi monitoraggio http://wmi.sf.net/2/bugs di\nriferire su questo problema, la ringrazio.\n	\N	\N
2290	63	5	Il foglio di lavoro può essere salvato oggi.	\N	\N
2229	90	5	<b>matek.hu <small>BETA</small></b>	\N	\N
2230	91	5	Copyright &copy; 2006-2007 Particio BT.<br> Z. Kovacs, R. Vajda, A. Fekete, G. Bakos, K. Csernai	\N	\N
3023	92	5	E 'alimentato da WMI %s<br> Copyright &copy; 2002-2007 University of Szeged<br>	\N	\N
2231	93	5	Database basato sul motore RAD Wekker<br> Copyright &copy; 2005-2007 Consol Kft.<br>	\N	\N
2384	630	11	Поред	\N	\N
2602	453	4	e, eine mathematische Konstante, ihr nummerischer Wert ist ca. 2.71828	\N	\N
2603	455	4	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Willkommen bei der Sparte "Zahlentheorie" der Seite matek.hu!</h2></center>In den Taschenrechner links kannst du Aufgaben eingeben, entweder per Mausklick oder per Tastatur. Die Rechnungen können mit dem blaugrünen Knopf gestartet werden.  Den Kalkulator kannst du mit dem Knopf links oben wechseln. Wenn du Hilfe brauchst, <a href="segitseg" target="_blank">klicke hier</a>!</td><td valign="top" align="right"><img src="./image/lakat2.jpg" alt="Kódolásra is használható" title="Kódolásra is használható" style="position:relative;top:-10px;right:-10px;"></td></table>	\N	\N
2604	456	4	Einen anderen Kalkulator laden	\N	\N
2605	458	4	Sprache auswählen	\N	\N
2577	460	4	Die Unbekannten	\N	\N
2606	462	4	Trigonometrische Funktionen	\N	\N
2607	464	4	Logarithmische Funktionen	\N	\N
2608	466	4	???	\N	\N
2609	468	4	Einfache Wurzeln und Potenzen	\N	\N
2610	470	4	Reele Variablen	\N	\N
2611	472	4	Ganze Variablen	\N	\N
2612	474	4	Grenzwerte	\N	\N
2578	476	4	Konstanten	\N	\N
2613	478	4	Nullmatrix	\N	\N
2614	480	4	Einheitsmatrix	\N	\N
2615	482	4	Neue Matrix	\N	\N
2616	484	4	Funktionsgrafen, Lösung von Gleichungen	\N	\N
2617	486	4	Für diese Rechnung muss man 2 Parameter angeben. Die Parameter sind durch ein Komma (",") voneinander getrennt.	\N	\N
2618	488	4	Für diese Rechnung muss man nur einen Parameter angeben. Also darf kein Komma (",") benutzt werden.	\N	\N
2619	491	4	<span style="color:blue;">undefiniert  existiert nicht)</span>	\N	\N
2579	493	4	<span style="color:blue;">falsch</span>	\N	\N
2580	495	4	<span style="color:blue;">richtig</span>	\N	\N
2620	500	4	Dass die Zahl <a href="http://de.wikipedia.org/wiki/Primzahl" target="_blank">eine Primzahl ist, ist</a>:[co]	\N	\N
2621	511	4	Unterstützten Sie bitte die Seite matek.hu! Danke!	\N	\N
2622	513	4	Multiplikation (elementenweise, keine Matrixmultiplikation)	\N	\N
2623	518	4	Die <a href="http://de.wikipedia.org/wiki/Primzahl" target="_blank">Primzahl</a> nach der angegebenen Zahl:[co]	\N	\N
2624	520	4	Die <a href="http://de.wikipedia.org/wiki/Primzahl" target="_blank">Primzahl</a> vor der angegebenen Zahl:[co]	\N	\N
2625	522	4	Relative Primzahlen, kleiner als die angegebene Zahl	\N	\N
2626	524	4	Summe der Teiler der angegebenen Zahl:[co]	\N	\N
2627	526	4	Anzahl der kleineren relativen Primzahlen	\N	\N
2628	528	4	Summe aller Teiler	\N	\N
2629	530	4	die nächste Primzahl	\N	\N
2630	532	4	die vorige Primzahl	\N	\N
2631	534	4	Ist diese Zahl eine Primzahl?	\N	\N
2632	536	4	Anzahl der Permutationen mit Wiederholung	\N	\N
2633	538	4	Anzahl der Kombinationen mit Wiederholung 	\N	\N
2634	540	4	Anzahl der Variationen	\N	\N
2635	542	4	Die Anzahl der Kombinationen mit Wiederholung:[co]	\N	\N
2636	544	4	Die Anzahl der Variationen:[co]	\N	\N
2637	546	4	Anzahl der Permutationen mit Wiederholung:[co]	\N	\N
2638	548	4	Fakultät (Anzahl der Permutationen):[co]	\N	\N
2581	550	4	n-tes Glied der Fibonacci-Folge	\N	\N
2639	564	4	Wurzelziehen mit ganzem Wurzelexponenten	\N	\N
2640	568	4	Der Ganzteil <a href="http://de.wikipedia.org/wiki/Wurzel_(Mathematik)"> der Quadratwurzel </a>:[co]	\N	\N
2641	570	4	Ganzteil der n-ten Wurzel	\N	\N
2642	572	4	der Logarithmus zur Basis 2 von der Zahl	\N	\N
2643	574	4	Ganzteil des Logarithmus zur Basis b	\N	\N
2644	576	4	Ganzteil des Logarithmus</a> zur Basis <i>b</i> :[co]	\N	\N
2645	581	4	Für diese Rechnung muss ein Parameter [PAR] angegeben werden, mit Komma getrennt	\N	\N
2646	624	4	dritte Potenz einer Matrix	\N	\N
2647	626	4	vierte Potenz berechnen	\N	\N
2650	632	4	Drehung nach links	\N	\N
2651	141	4	Partialsummenfolge	\N	\N
2652	149	4	Der Grenzwert einer Folge	\N	\N
2653	634	4	Drehung nach rechts	\N	\N
2654	636	4	Drehung nach oben	\N	\N
2655	638	4	Drehung nach unten	\N	\N
2656	640	4	Verschiebung x+	\N	\N
2657	652	4	bestimmtes Integral der Funktion:[co]	\N	\N
2658	656	4	Partielle Ableitung	\N	\N
2659	658	4	Einsetzen	\N	\N
2660	662	4	eingesetzt in den Term:[co]	\N	\N
2661	497	4	Zahlentheorie	\N	\N
2583	552	4	Das n-te Element der <a href="http://de.wikipedia.org/wiki/Fibonacci-Folge" target="_blank">Fibonacci-Folge</a> :[co]	\N	\N
2662	554	4	Dividieren mit ganzen Zahlen	\N	\N
2663	556	4	Das Rest beim Dividieren mit ganzen Zahlen	\N	\N
2664	558	4	Ganzteil des Quotienten:[co]	\N	\N
2665	560	4	Divisionsrest:[co]	\N	\N
2666	562	4	Quadratwurzel einer ganzen Zahl	\N	\N
2667	566	4	Ganzteil des Logarithmus zur Basis 2 	\N	\N
2668	185	4	In Form von  Summe:[co]	\N	\N
2669	642	4	Verschiebung x-	\N	\N
2670	644	4	Verschiebung y+	\N	\N
2672	660	4	 <a href="http://de.wikipedia.org/wiki/Partielle_Ableitung"> Partielle Ableitung der Funktion</a>:[co]	\N	\N
2674	139	4	Folge der Partialsummen:[co]	\N	\N
2675	143	4	Folge der Partialprodukten:[co]	\N	\N
2676	145	4	Partialproduktfolge	\N	\N
2677	59	4	Die Seite <a href="http://matek.hu">matek.hu</a> ist vorübergehend außer Betrieb. <br> Bitte, schauen Sie später noch einmal vorbei!	\N	\N
2678	336	4	Stufenform (mit Einsen in der Hauptdiagonale)	\N	\N
2679	410	4	Binomialkoeffizient	\N	\N
2680	601	4	<span style="color:blue;">Es gibt keine Lösung</span>	\N	\N
2681	603	4	Für diese Rechnung muss man 3 Parameter angeben. Die Parameter sind durch ein Komma (",") voneinander getrennt. Der erste Parameter enthält die zu lösende Gleichung, der zweite und der dritte Parameter sind Werte, die die Endpunkte des Intervalls, wo die Lösungen zu suchen sind, definieren.	\N	\N
2682	610	4	Gleichungslösung	\N	\N
2683	612	4	<span style="color:blue;">nicht definiert</span>	\N	\N
2684	614	4	<b>Fehler: Dividieren durch Null</b>	\N	\N
2685	616	4	Neuer Vektor	\N	\N
2686	618	4	Austritt aus dem Vektor	\N	\N
2687	620	4	Anzahl der Permutationen	\N	\N
2688	622	4	Zweite Potenz einer Matrix	\N	\N
2689	648	4	Bestimmtes Integral	\N	\N
2690	650	4	Einsetzten (x)	\N	\N
2691	654	4	Eingesetzt für die Variable x des Terms:[co]	\N	\N
2692	38	4	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Willkommen in der Sparte "Lineare Algebra" von matek.hu!</h2></center>In dem Taschenrechner links kannst du Aufgaben eingeben, entweder per Mausklick oder mit der Tastatur. Die Rechnungen können mit der blaugrünen Taste gestartet werden.  Den Kalkulatortyp kannst du mit der Taste oben links wechseln. Wenn du Hilfe brauchst, <a href="Hilfe" target="_blank"> klicke hier</a> oder <a href="doc/linalg-hu.avi">schaue dir diesen Film an</a>!</td><td valign="top" align="right"><img src="./image/4dcube.gif" alt="forgó 4 dimenziós kocka" title="Forgó 4 dimenziós kocka" style="position:relative;top:-10px;right:-10px;"></td></tr></table>	\N	\N
2695	8	4	Wert des Terms:[co]	\N	\N
2696	6	4	Die Lösung der <a href="http://de.wikipedia.org/wiki/Gleichung" target="_blank">Gleichung</a> :[co]	\N	\N
2697	54	4	Löschen des Eingabefeldes	\N	\N
2698	60	4	Die gedrückte Taste funktioniert momentan nicht.\nDie Formeln der Seite matek.hu muss man in den Kalkulatoren\nwie gewöhnlich eintragen, von links nach rechts,\nwie beim Handschreiben.\n\nFalls du nicht weiterkommst, benutze die Taste CE, oder\nlade die Seite neu.\n\nDie Seite matek.hu ist zur Zeit im Experimentstadium.\nWenn du bei der Konstruktion mithelfen möchtest,\nbitte suche die Seite http://wmi.sf.net/2/bugs auf.	\N	\N
2699	61	4	Wie kommt man zur Lösung? Bitte um Hilfe in der Nähe von %s!	\N	\N
2700	62	4	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Hallo, das ist die Seite matek.hu!</h2></center>Ja!  matek.hu wurde neu bearbeitet, sowohl im Layout als auch was die Funktionen betrifft! Natürlich ist auch <a href="http://matek.hu/1" target="_blank">die alte Version erreichbar</a>. In den Taschenrechner links kannst du Aufgaben eingeben, entweder per Mausklick oder per Tastatur. Die Rechnungen können mit dem blaugrünen Knopf gestartet werden.  Den Kalkulator kannst du mit dem Knopf links oben wechseln: was du jetzt benutzt, kann für die Lösung von Aufgaben für die <i> Sekundar- bzw. Oberstufe</i> gebraucht werden. Wenn du Hilfe brauchst, <a href="segitseg" target="_blank">klicke hier</a>  (<a href="doc/intro_hu.pdf">PDF</a>) oder <a href="doc/normal-hu.avi">schaue dir diesen Film an</a>!<br><br></td><td valign="top" align="right"><img src="./image/normal-pres.png" style="position:relative;top:-10px;right:-10px;" alt=""></td></tr></table>	\N	\N
2701	69	4	Ab jetzt läuft das Programm auf Deutsch. Es ist ratsam, die Seite neu zu laden.	\N	\N
2693	4	4	Die Formel der Aufgabe:[ui]	\N	\N
2694	10	4	Die Formel der Aufgabe:[ui]	\N	\N
2702	72	4	Bitte um Hilfe in der Nähe von %s!	\N	\N
2703	73	4	Ausführliche Lösung...	\N	\N
2704	74	4	Mehr Hilfe...	\N	\N
2705	75	4	Wie kommt das heraus?	\N	\N
2706	76	4	gibt Nachhilfe	\N	\N
2707	77	4	Privatlehrer	\N	\N
2708	78	4	Noch mehr Hilfe...	\N	\N
2709	79	4	Bitte um Hilfe!	\N	\N
2584	80	4	Was ist das?	\N	\N
2710	81	4	Beim Linksklick kommt die Formel ins Eingabefeld.	\N	\N
2711	82	4	Schließen	\N	\N
2712	83	4	Soll das Arbeitsblatt wirklich gelöscht werden?	\N	\N
2713	84	4	Neues Aufgabenblatt	\N	\N
2714	85	4	Speichern	\N	\N
2715	86	4	Drucken	\N	\N
2716	87	4	Informationen über die Seite	\N	\N
2717	88	4	Graf der Funktion:	\N	\N
2585	90	4	<b>matek.hu <font color=#d0d0d0><small>BETA</small></font></b>	\N	\N
2718	91	4	Copyright &copy; 2006-2007 Partíció BT.<br> Kovács Z., Vajda R., Fekete Á., Bakos G., Csernai K.	\N	\N
2820	92	4	Das Portal basiert auf der Bedienungsoberfläche WMI%s.<br> Copyright &copy; 2002-2007 SZTE	\N	\N
2719	93	4	Datenbasis angetrieben von: Wekker RAD System<br>Copyright &copy; 2005-2007 Consol Rendszerhaz Kft.<br>	\N	\N
2720	94	4	Graphische Unterstützung: Gnome<br> Logo copyright &copy; 2003 Zsigmond Kovács<br> Farbenzusammenstellung: Zsuzsa Deák<br> 4D-Würfel-Animation &copy; Oliver Knill, Universität Harvard, Logo "Punk Girl" &copy; www.sykospark.net<br> Foto der Spirale &copy; Wikipedia, Chris 73<br>  Logo "Zahlentheorie" &copy;  Zoltán Medve	\N	\N
2721	95	4	Weitere Untersysteme:<br> GNU Linux/Apache/PostgreSQL/PHP, gnuplot/Maxima, TeX/LaTeX/ImageMagick, formconv/TeXmacs, GeoLite (http://www.maxmind.com)	\N	\N
2722	96	4	Die Entwickler der Seite sind unter der E-mail-Adresse<br> <b><a style="color: #ffffff; text-decoration: none;" href="mailto:info@matek.hu">info@matek.hu</a></b><br> zu erreichen.	\N	\N
2723	97	4	Fehlermeldungen werden unter <br> <b><a style="color: #ffffff; text-decoration: none;" href="http://wmi.sf.net/2/bugs" target="_blank">http://wmi.sf.net/2/bugs</a></b><br> empfangen, vielen Dank!	\N	\N
2724	107	4	Absolutwert (Betrag)	\N	\N
2587	109	4	Cosinus	\N	\N
2588	110	4	Tangent	\N	\N
2725	111	4	Logatithmus (zur Basis 10)	\N	\N
2726	112	4	öffnende und schließende Klammer (beide)	\N	\N
2727	113	4	Austritt aus dem Term in Klammern	\N	\N
2728	114	4	Kürzen	\N	\N
2729	115	4	Gleichungslösung (auch komplexe Lösungen)	\N	\N
2730	116	4	Funktionengraf	\N	\N
2731	117	4	Primfaktorenzerlegung, Zerlegen in Faktoren	\N	\N
2732	118	4	Auswertung	\N	\N
296	294	2	Transpose	\N	\N
297	295	2	<a href="http://en.wikipedia.org/wiki/Transpose" target="_blank">Transpose of the matrix</a>:[co]	\N	\N
298	298	1	Mtrix rangja	\N	\N
2733	119	4	Gleichungszeichen (in einer Gleichung)	\N	\N
2734	120	4	doch nicht	\N	\N
2736	122	4	Mathematik für die Sekundarstufe II und Oberstufe	\N	\N
2737	123	4	Elementare Mathematik	\N	\N
2738	147	4	<a href="http://de.wikipedia.org/wiki/Grenzwert_(Folge)" target="_blank">Grenzwert der Folge</a>:[co]	\N	\N
299	299	1	<a href="http://hu.wikipedia.org/wiki/M%C3%A1trix_(matematika)#M.C3.A1trix_rangja" target="_blank">A mtrix rangja</a>:[co]	\N	\N
300	298	2	Rank of matrix	\N	\N
2739	151	4	unbestimmtes Integral	\N	\N
2740	153	4	Ableitung	\N	\N
2741	155	4	unbestimmtes Integral der Funktion:[co]	\N	\N
2742	157	4	<a href="<a href="http://hu.wikipedia.org/wiki/Differenci%C3%A1lh%C3%A1nyados" target="_blank">Ableitung der Funktion</a>:[co]	\N	\N
2743	159	4	Grenzwert der Folge	\N	\N
2744	161	4	<a href="http://de.wikipedia.org/wiki/Grenzwert_(Funktion)" target="_blank">Greznwert der Funktion</a>:[co]	\N	\N
2745	164	4	<a href="http://de.wikipedia.org/wiki/Taylorreihe" target="_blank">Taylor-Reihe der Funktion</a>:[co]	\N	\N
2590	166	4	Taylor-Reihe	\N	\N
2746	169	4	<font color="black"><b>Die Aufgabe ist falsch formuliert, wenn es nötig ist, <a href="segitseg" target="_blank">bitte um Hilfe</a>!</b></font>	\N	\N
2747	171	4	<b>Tut mir Leid, die Aufgabe ist zu schwer.</b>	\N	\N
2748	173	4	gekürzt:[co]	\N	\N
2749	174	4	der Wert des Terms ist ungefähr	\N	\N
2750	175	4	der Wert des Terms ist ungefähr:[co]	\N	\N
2751	176	4	größter gemeinsamer Teiler	\N	\N
2752	177	4	größter gemeinsamer Teiler der Terme:[co]	\N	\N
2753	178	4	kleinstes gemeinsames Vielfaches	\N	\N
2754	179	4	kleinstes gemeinsames Vielfaches der Terme:[co]	\N	\N
2755	180	4	Partialbrüche	\N	\N
2756	181	4	zerlegt in Partialbrüche:[co]	\N	\N
2757	182	4	<b>Sorry, das Bild wäre zu groß</b>	\N	\N
2758	184	4	zerlegt in Primfaktoren:[co]	\N	\N
2759	186	4	Ausklammerung	\N	\N
2760	187	4	Rest bei der Division mit Rest	\N	\N
2761	188	4	Pi, mathematischer Konstant, sein Wert ist ungefähr 3,14159	\N	\N
2762	189	4	Potenzieren	\N	\N
2763	190	4	zweite Potenz	\N	\N
2764	191	4	dritte Potenz der Zahl	\N	\N
2765	193	4	Reele Unbekannte	\N	\N
2766	195	4	Der nächste Parameter	\N	\N
2767	196	4	Logarithmus (zur natürlichen Basis)	\N	\N
2768	197	4	Logarithmus (zur Basis 2)	\N	\N
2769	198	4	Fakultät	\N	\N
2770	199	4	Die POtenzfunktion	\N	\N
2771	205	4	Aufrundung	\N	\N
2772	206	4	Abrundung	\N	\N
2773	207	4	Vorzeichenfunktion	\N	\N
2774	208	4	Kubikwurzel	\N	\N
2775	209	4	Negation	\N	\N
2591	210	4	Dezimalpunkt	\N	\N
2776	211	4	Der Exponent von 10 in der normierten Gleitkommadarstellung	\N	\N
2777	212	4	Prozent	\N	\N
2592	63	4	Jetzt kann das Arbeitsblatt gespeichert werden.	\N	\N
2778	217	4	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Willkommen auf der Seite matek.hu!</h2></center>In dem Taschenrechner links kannst du Aufgaben eingeben, entweder per Mausklick oder mit der Tastatur. Die Rechnungen können mit der blaugrünen Taste gestartet werden.  Den Kalkulatortyp kannst du mit der Taste oben links wechseln:  was du jetzt benutzt, kann für die Lösung von Aufgaben für die <i> Elementar- bzw. Sekundarstufe I </i> gebraucht werden.Wenn du Hilfe brauchst,  <a href="segitseg" target="_blank">klicke hier</a>!<br><br></td><td valign="top" align="right"><img src="./image/easy-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt=""></td></tr></table>	\N	\N
2779	219	4	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Willkommen in der Sparte Analysis von matek.hu!</h2></center>In dem Taschenrechner links kannst du Aufgaben eingeben, entweder per Mausklick oder mit der Tastatur. Die Rechnungen können mit der blaugrünen Taste gestartet werden.  Den Kalkulatortyp kannst du mit der Taste oben links wechseln. Wenn du Hilfe brauchst, <a href="Hilfe" target="_blank"> klicke hier</a> oder <a href="doc/linalg-hu.avi">schaue dir diesen Film an</a>!<br><br></td><td valign="top" align="right"><img src="./image/calculus-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt="Logaritmikus spirál, a matematikai analízist szimbolizálja" title="Logaritmikus spirál, a matematikai analízist szimbolizálja" ></td></tr></table>	\N	\N
2780	222	4	Quotient zweier Polinome und das Rest:[co]	\N	\N
2781	223	4	Polinomdivision	\N	\N
2527	223	11	Подјела полиноми	\N	\N
2782	224	4	Rest bei der Poinomdivision:[co]	\N	\N
2783	225	4	Polinomdivision, Rest	\N	\N
2784	226	4	<b>Die eingetragene Formel ist leider nicht zu definieren.</b>	\N	\N
2785	254	4	Für Entwickler	\N	\N
2786	256	4	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Willkommen in der Sparte Algebra von matek.hu!</h2></center>In dem Taschenrechner links kannst du Aufgaben eingeben, entweder per Mausklick oder mit der Tastatur. Die Rechnungen können mit der blaugrünen Taste gestartet werden.  Den Kalkulatortyp kannst du mit der Taste oben links wechseln. Wenn du Hilfe brauchst, <a href="Hilfe" target="_blank"> klicke hier</a>!<br><br></td><td valign="top" align="right"><img src="./image/algebra-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt="Al-Khwarizmi, Autor des ersten Algebrabuches (sowjetische Briefmarke, 1983)" title="Al-Hvárizmi, az elsõ algebra könyv szerzõje (szovjet bélyeg, 1983)"></td></tr></table>	\N	\N
2593	258	4	Algebra	\N	\N
2594	306	4	Charakteristisches Polinom	\N	\N
345	72	2	Ask help near %s...	\N	\N
346	73	2	Detailed solution...	\N	\N
347	74	2	More help...	\N	\N
353	82	2	Close	\N	\N
2326	441	11	Право функцију ограничења вредности	\N	\N
2327	443	11	Лијевих функцију ограничења вредности	\N	\N
2328	445	11	Право ограничење вредности функција	\N	\N
2329	447	11	У лијевих ограничење вредности функција	\N	\N
2330	449	11	Границу вредности од збира	\N	\N
2331	451	11	Границу вредности од збира у један бескрајан	\N	\N
2332	453	11	e, Математичка константа једном, његова вредност је цца. 2.71828	\N	\N
2334	456	11	Пуњење од других калкулатор	\N	\N
2335	458	11	Избор језика	\N	\N
2374	564	11	Цијелу н-едик Екстракција корена	\N	\N
2375	568	11	A <a href="http://hu.wikipedia.org/wiki/Gy%C3%B6kvon%C3%A1s" target="_blank">квадратни корен</a>његов цијели дио:[co]	\N	\N
508	508	\N	<font size="-3">2? 3? 5?</font>	\N	\N
2333	455	11	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Поздравља матек.ху у тарифни број теорија!</h2></center>Можете писати задаће лево калкулатор, ви сте га с мишем биллентыюзетен чак и превише. У прорачунима су стартабле с плаво-зелене тастере. Врста калкулатора лево фелсо̃ вам мај претворити га с дугме. Ако вам треба помоћ, <a href="segitseg" target="_blank">kликните овде</a>!</td><td valign="top" align="right"><img src="./image/lakat2.jpg" alt=На кодирање корисни" title=На кодирање корисни" style="position:relative;top:-10px;right:-10px;"></td></table>	\N	\N
2336	460	11	Ункноунс	\N	\N
2337	462	11	Тригонометријски функције	\N	\N
2338	464	11	Логаритамску функција	\N	\N
2339	466	11	Функције с експоненцијалним величина	\N	\N
2340	468	11	Плаин корене и овлашћења	\N	\N
583	583	\N	<big>+</big>	\N	\N
662	662	1	A kifejezsbe helyettestve:[co]	\N	\N
663	662	2	Substituting into the expression:[co]	\N	\N
664	664	1	<b>Hiba: log(0) nincs rtelmezve</b>	\N	\N
665	664	2	<b>Error: log(0) is undefined</b>	\N	\N
2341	470	11	Реал променљивих	\N	\N
2342	472	11	Цела променљивих	\N	\N
2343	474	11	Граничним вредностима	\N	\N
2344	476	11	Констансок	\N	\N
2345	478	11	Нуллма́трикс	\N	\N
2346	480	11	Јединична матрица	\N	\N
2347	482	11	Нова матрица	\N	\N
2348	484	11	У приказом функције, једначина решење	\N	\N
2349	486	11	Потребно је обезбедити 2 параметри за тај израчунавање. Параметри запета(",")он га одваја од сваке друге.	\N	\N
2350	488	11	Потребно је обезбедити само овај параметар за израчунавање. Па није бесплатно вессзо̃т ( ", ") бити корисне.	\N	\N
2351	491	11	<span style="color:blue;"Он није дефинисана (није тумачити, не постоји)</span>	\N	\N
2352	493	11	<span style="color:blue;">лажно</span>	\N	\N
2353	495	11	<span style="color:blue;">ИСТИНИТА</span>	\N	\N
2354	500	11	То, да је број<a href="http://hu.wikipedia.org/wiki/Pr%C3%ADmsz%C3%A1mok" target="_blank">прим број</a>:[co]	\N	\N
2355	511	11	Молимо га, нека га у корист матек.ху-т! Хвала!	\N	\N
2216	76	5	Assume la ripetizione	\N	\N
2217	77	5	Ripetitrice/ripetitore	\N	\N
2293	224	5	Il resto della divisione dei polinomi:[co]	\N	\N
2294	225	5	La divisione dei polinomi, il resto	\N	\N
2298	258	5	L'algebra	\N	\N
2322	430	5	<b>Non è stato possibile creare il grafico di questa formula.</b>	\N	\N
2323	433	5	Soluzione approssimata dell'equazione	\N	\N
1894	435	5	Una soluzione approssimata dell'<a href="http://it.wikipedia.org/wiki/Equazione" target="_blank">equazione</a> nel intervallo dato:[co]	\N	\N
2324	437	5	Grafico 3D di una funzione	\N	\N
2325	439	5	Grafico di una funzione complessa	\N	\N
2321	427	5		\N	\N
1617	254	7	发展者	\N	\N
2551	314	11	сопствени вектора	\N	\N
2552	315	11	<a href="http://hu.wikipedia.org/wiki/Saj%C3%A1tvektor_%C3%A9s_saj%C3%A1t%C3%A9rt%C3%A9k" target="_blank">У властите вектора од матрице [[[<i>sajátértékek</i>],[<i>hozzájuk tartozó multiplicitások</i>]], <i>1. sajátvektor</i>, <i>2. sajátvektor</i>, ...] у облику:[co]	\N	\N
2553	318	11	Матрица умножавање, скаларни продукт	\N	\N
787	544	7	相异物的排列:[co]	\N	\N
788	546	7	不尽相异物直线排列:[co]	\N	\N
789	548	7	阶乘 ( 排列总数 ):[co]	\N	\N
790	550	7	第 n 个  Fibonacci 级数	\N	\N
1052	552	7	第 <i>n</i> 个 <a href="http://en.wikipedia.org/wiki/Fibonacci_number" target="_blank">Fibonacci 级数</a>:[co]	\N	\N
791	554	7	正着厨房	\N	\N
792	556	7	整数除法的余数	\N	\N
1053	558	7	<a href="http://en.wikipedia.org/wiki/Quotient" target="_blank">商</a>的 <a href="http://en.wikipedia.org/wiki/Integer" target="_blank">整数</a> 部份:[co]	\N	\N
1054	560	7	<a href="http://en.wikipedia.org/wiki/Division_%28mathematics%29" target="_blank">除法</a>的<a href="http://en.wikipedia.org/wiki/Remainder" target="_blank">余数</a>:[co]	\N	\N
793	562	7	整数平方根	\N	\N
794	564	7	整数 n 次方根	\N	\N
1059	581	7	计算中，变数的数目应该是 [PAR]，如果超过1个，变数之间须用逗点隔开。	\N	\N
807	601	7	<span style="color:blue;">无解</span>	\N	\N
1060	603	7	计算中，必须给三个参数，并用 (",") 隔开，第一个参数为求解的方程式，第2个和第三个参数分别为寻找区间的端点。	\N	\N
1603	648	7	定积分	\N	\N
1604	652	7	函数的<a href="http://en.wikipedia.org/wiki/Antiderivative" target="_blank">定积分</a>:[co]	\N	\N
1605	654	7	代入:[co]	\N	\N
1596	656	7	偏导函数	\N	\N
1597	658	7	代替	\N	\N
1598	660	7	函数的<a href="http://en.wikipedia.org/wiki/Derivative" target="_blank">偏导函数</a>:[co]	\N	\N
2554	320	11	Матрица потенцирауу	\N	\N
2560	420	11	Згази облик	\N	\N
1022	217	7	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>数学变容易了！</h2></center>只要用键盘或者滑鼠输入问题，按下左边紫色的按键，就可以开始计算。也可以使用左上角的电脑按键，选择其他的计算机功能选单。</td><td valign="top" align="right"><img src="./image/easy-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt=""></td></tr></table>	\N	\N
856	72	8	向靠近 %s 求助	\N	\N
1023	219	7	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>微积分变简单了!</h2></center>只要用键盘或者滑鼠输入问题，按下左边紫色的按键，就可以开始计算。也可以使用左上角的电脑按键，选择其他的计算机功能选单。  <a href=doc/calculus.avi>示范影片</a> 提供参考，</td><td valign="top" align="right"><img src="./image/calculus-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt="Logarithmic spiral, symbol of calculus" title="Logarithmic spiral, symbol of calculus"></td></tr></table>	\N	\N
1616	226	7	<b>抱歉，输入的公式无法执行。</b>	\N	\N
1618	257	7	微积分	\N	\N
1651	259	7	线性代数	\N	\N
1024	263	7	抱歉，WMI2 尚未支援你使用的语言，所有的信息将使用英文和匈牙利文显示。你可以考虑协助将这些信息内容翻译成你使用的语言，非常欢迎你的协助。	\N	\N
1652	286	7	反矩阵	\N	\N
1025	287	7	<a href="http://en.wikipedia.org/wiki/Invertible_matrix" target="_blank">反矩阵</a>:[co]	\N	\N
1653	290	7	行列式	\N	\N
1026	291	7	<a href="http://en.wikipedia.org/wiki/Determinant" target="_blank">矩阵的行列式</a>:[co]	\N	\N
1028	299	7	矩阵秩	\N	\N
670	302	7	伴随矩阵	\N	\N
1029	303	7	<a href="http://en.wikipedia.org/wiki/Adjugate_matrix" target="_blank">伴随矩阵</a>:[co]	\N	\N
671	306	7	特征多项式	\N	\N
1030	307	7	<a href="http://en.wikipedia.org/wiki/Characteristic_polynomial" target="_blank">矩阵特征多项式</a>:[co]	\N	\N
672	310	7	固有值	\N	\N
1031	311	7	<a href="http://en.wikipedia.org/wiki/Eigenvalue%2C_eigenvector_and_eigenspace#Eigenvalues_and_eigenvectors_of_matrices" target="_blank">矩阵的固有值</a>:[co]	\N	\N
673	314	7	固有向量	\N	\N
1032	315	7	<a href="http://en.wikipedia.org/wiki/Eigenvalue%2C_eigenvector_and_eigenspace#Eigenvalues_and_eigenvectors_of_matrices" target="_blank">矩阵的固有向量</a>:[co]	\N	\N
674	318	7	矩阵乘法，数值乘法	\N	\N
675	320	7	矩阵次方	\N	\N
925	437	8	3D 函數畫圖 	\N	\N
932	449	8	和的極限	\N	\N
183	182	2	<b>It would be a too big image, sorry.</b>	\N	\N
185	185	1	sszeg alakban:[co]	\N	\N
642	642	1	Eltols x-	\N	\N
643	642	2	Offset x-	\N	\N
644	644	1	Eltols y+	\N	\N
645	644	2	Offset y+	\N	\N
646	646	1	Eltols y-	\N	\N
647	646	2	Offset y-	\N	\N
1034	256	7	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>欢迎来到代数园地！</h2></center>只要用键盘或者滑鼠输入问题，按下左边紫色的按键，就可以开始计算。也可以使用左上角的电脑按键，选择其他的计算机功能选单。</td><td valign="top" align="right"><img src="./image/algebra-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt="Al Khwarizmi, author of the first algebra book (stamp from the Soviet Union, 1983)" title="Al Khwarizmi, author of the first algebra book (Russian stamp, 1983)"></td></tr></table>	\N	\N
1035	38	7	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>欢迎使用线性代数工具！</h2></center>只要用键盘或者滑鼠输入问题，按下左边紫色的按键，就可以开始计算。也可以使用左上角的电脑按键，选择其他的计算机功能选单。如果你想弄得更清楚解题技巧， <a href=doc/linalg.avi>请看影片</a>.</td><td valign="top" align="right"><img src="./image/4dcube.gif" alt="Rotating cube in 4 dimensions" title="Rotating cube in 4 dimensions" style="position:relative;top:-10px;right:-10px;"></td></tr></table>	\N	\N
683	79	7	是否需要帮忙？	\N	\N
685	81	7	使用左键点选公式，即可使用	\N	\N
687	83	7	确定清除工作清单?	\N	\N
688	84	7	新的工作清单	\N	\N
689	85	7	储存	\N	\N
690	86	7	列印	\N	\N
691	87	7	关于 WMI2	\N	\N
692	120	7	复原	\N	\N
753	121	7	重覆	\N	\N
694	123	7	小学	\N	\N
696	107	7	绝对值	\N	\N
697	108	7	正弦 sin	\N	\N
698	109	7	余弦 cos	\N	\N
699	110	7	正割 tan	\N	\N
700	111	7	对数 (以10为底)	\N	\N
701	112	7	左括号	\N	\N
702	113	7	右括号	\N	\N
703	114	7	化简	\N	\N
704	115	7	解方程式 (包含负数根)	\N	\N
705	116	7	函数图形画图	\N	\N
706	117	7	因式分解	\N	\N
707	118	7	求值	\N	\N
708	119	7	等号 (在方程式中)	\N	\N
709	185	7	In expanded form:[co]	\N	\N
710	186	7	展开式	\N	\N
711	187	7	余数	\N	\N
721	199	7	指数函数	\N	\N
722	205	7	无条件进位	\N	\N
723	206	7	无条件舍去	\N	\N
724	207	7	正负号函数	\N	\N
725	208	7	3次法根	\N	\N
726	209	7	消去	\N	\N
727	210	7	小数点	\N	\N
728	211	7	Exponent of normal form	\N	\N
729	212	7	百分比	\N	\N
730	173	7	In simplified form:[co]	\N	\N
731	174	7	大约	\N	\N
732	175	7	大约 :[co]	\N	\N
733	176	7	最大公因数	\N	\N
1036	177	7	<a href="http://en.wikipedia.org/wiki/Greatest_common_divisor" target="_blank">最大公因数</a>:[co]	\N	\N
734	178	7	最小公倍数	\N	\N
1037	179	7	<a href="http://en.wikipedia.org/wiki/Least_common_multiple", target="_blank">最小公倍数</a>:[co]	\N	\N
735	180	7	部份因式分解	\N	\N
1038	181	7	分解成 <a href="http://en.wikipedia.org/wiki/Partial_fraction" target="_blank">部份因式</a>:[co]	\N	\N
738	416	7	2x2  零矩阵	\N	\N
739	418	7	2x2 矩阵	\N	\N
740	420	7	Row echelon form	\N	\N
741	422	7	In <a href="http://en.wikipedia.org/wiki/Reduced_row_echelon_form" target="_blank">row echelon form</a>:[co]	\N	\N
742	222	7	除法所得的商和余式[:[co]	\N	\N
743	223	7	多项式分解	\N	\N
744	426	7	错误	\N	\N
1041	427	7	此网站特地为 Mozilla Firefox 2.0 and Internet Explorer 6/7 最佳化设计，你现在所使用的并非具有高支持的浏览器。请自行调整你的使用毛病后，若有所不便，敬请原谅!	\N	\N
745	430	7	<b>公式无法画图</b>	\N	\N
746	433	7	方程式的近似解	\N	\N
1042	435	7	所给条件区间， <a href="http://en.wikipedia.org/wiki/Equation" target="_blank">方程式</a> 的近似解l:[co]	\N	\N
747	437	7	3D 函数画图 	\N	\N
748	439	7	复数函数图形画图	\N	\N
749	441	7	函数的右极限	\N	\N
750	443	7	函数的左极限	\N	\N
751	445	7	函数的右极限:[co]	\N	\N
752	447	7	函数的左极限:[co]	\N	\N
754	449	7	和的极限	\N	\N
755	451	7	在无穷远的极限:[co]	\N	\N
756	453	7	e, Euler 常数，大约 2.71828	\N	\N
757	456	7	使用其他计算程式	\N	\N
758	458	7	选择语系	\N	\N
759	460	7	未知变数	\N	\N
760	462	7	三角函数	\N	\N
761	464	7	对数函数	\N	\N
762	466	7	指数函数	\N	\N
763	468	7	简单的根与次方	\N	\N
764	470	7	实数	\N	\N
765	472	7	整数变数	\N	\N
766	474	7	极限	\N	\N
767	476	7	常数	\N	\N
768	478	7	零矩阵	\N	\N
769	480	7	单位矩阵	\N	\N
770	482	7	新矩阵	\N	\N
771	484	7	函数图形，方程式解	\N	\N
1043	486	7	计算中，必须先给两个变数，变数之间必须用逗点 (",") 隔开。	\N	\N
1044	488	7	在计算中，只给1个变数，不需要使用逗点符号 (",")。	\N	\N
772	491	7	<span style="color:blue;">不存在</span>	\N	\N
773	493	7	<span style="color:blue;">错误</span>	\N	\N
774	495	7	<span style="color:blue;">正确</span>	\N	\N
775	497	7	数论	\N	\N
1217	294	9	Transponovanie	\N	\N
1218	295	9	Transponovaná matica:[co]	\N	\N
2320	426	5	Errore	\N	\N
1039	184	7	<a href="http://en.wikipedia.org/wiki/Factorization" target="_blank">分解</a>:[co]	\N	\N
736	410	7	相异物组合	\N	\N
1040	411	7	<a href="http://en.wikipedia.org/wiki/Binomial_coefficient" target="_blank">相异物组合</a>:[co]	\N	\N
737	414	7	2x2  单位矩阵	\N	\N
1045	455	7	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>欢迎来到数论的世界!</h2></center>只要用键盘或者滑鼠输入问题，按下左边紫色的按键，就可以开始计算。也可以使用左上角的电脑按键，选择其他的计算机功能选单。</td><td valign="top" align="right"><img src="./image/lakat2.jpg" alt="Can be used for encryption" title="Can be used for encryption" style="position:relative;top:-10px;right:-10px;"></td></table>	\N	\N
1046	500	7	式子中的数为 <a href="http://en.wikipedia.org/wiki/Prime_number" target="_blank">质数</a> is:[co]	\N	\N
777	511	7	请资助 WMI2 发展！谢谢！	\N	\N
1047	513	7	乘法 (矩阵的元素相乘，而不是矩阵乘法)	\N	\N
1048	518	7	比所给的数大的最小 <a href="http://en.wikipedia.org/wiki/Prime_number" target="_blank">质数</a> :[co]	\N	\N
1049	520	7	比所给的数小的最大<a href="http://en.wikipedia.org/wiki/Prime_number" target="_blank">质数</a>:[co]	\N	\N
1050	522	7	小于所给数目的 <a href="http://en.wikipedia.org/wiki/Coprime" target="_blank">质数</a> 总数为 :[co]	\N	\N
1051	524	7	<a href="http://en.wikipedia.org/wiki/Divisor" target="_blank">因数</a>总和:[co]	\N	\N
778	526	7	小于本身的质数数目为	\N	\N
779	528	7	因数和	\N	\N
780	530	7	下1个质数	\N	\N
781	532	7	前一个质数	\N	\N
782	534	7	是否为质数？	\N	\N
783	536	7	不尽相异物直线排列	\N	\N
784	538	7	重复组合	\N	\N
785	540	7	相异物的排列	\N	\N
786	542	7	重复组合:[co]	\N	\N
668	294	7	转置矩阵	\N	\N
1027	295	7	<a href="http://en.wikipedia.org/wiki/Transpose" target="_blank">转置矩阵</a>:[co]	\N	\N
669	298	7	矩阵秩	\N	\N
678	72	7	向靠近 %s 求助	\N	\N
679	73	7	详解	\N	\N
680	74	7	更多的帮助	\N	\N
686	82	7	关闭	\N	\N
1599	662	7	代&#25442;后的表示式&#20026;:[co]	\N	\N
2569	664	7	<b>错误：分母为零</b>	\N	\N
1600	182	7	<b>抱歉，图形过大，无法显示</b>	\N	\N
1601	650	7	代值 (x)	\N	\N
1015	143	7	<a href="http://en.wikipedia.org/wiki/Infinite_product">部分乘积数列</a>:[co]	\N	\N
1602	153	7	导函数	\N	\N
799	37	7	<html><head></head><body>是...</body></html>	\N	\N
800	40	7	<html><head></head><body> test2 输出<br /></body></html>	\N	\N
801	3	7	<html><head></head><body><p>	\N	\N
802	4	7	题目的公式：[ui]	\N	\N
803	8	7	表示式的值为:[co]	\N	\N
1062	6	7	方程式的解答为 <a href="http://en.wikipedia.org/wiki/Equation" target="_blank">解答</a> 为:[co]	\N	\N
804	54	7	清空输入栏	\N	\N
805	59	7	WMI2暂时故障。<br>请稍候。	\N	\N
1063	60	7	您按键不正确。\n公式的输入，应该像使用计算器一样，\n并像手写方式，从左边到右边输入。\n\n如果你不晓得该怎么做，\n请按 `ce` 键，重新输入。\n\n如果你觉得碰到 WMI2 的臭虫，\n请你重新联结此网页，\n用 http://wmi.sf.net/2/bugs 回报，\n谢谢。\n	\N	\N
806	61	7	从最近的地方求助 %s\n	\N	\N
1567	217	9	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Matematika je jednoduchá!</h2></center>Na kalkulátore na ľavej strane môžeš zapísať zadania pomocou myši alebo aj na klávesnici. Výpočty sa spúštajú s modrozelenými tlačidlami. Typ kalkullátora môžeš zmeniť pomocou ľavého tlačidla prvého riadku: teraz používaš taký typ, s ktorým sa dajú riešiť <i>úlohy na úrovni základnej školy</i>. Ak potrebuješ pomoc <a href="doc/intro_sk.html" target="_blank">klikni sem</a> !<br><br></td><td valign="top" align="right"><img src="./image/easy-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt=""></td></tr></table>	\N	\N
660	660	1	A fggvny <a href="http://en.wikipedia.org/wiki/Parci%C3%A1lis_deriv%C3%A1lt">parcilis derivltja</a>:[co]	\N	\N
693	122	7	中学	\N	\N
695	106	7	平方根	\N	\N
808	610	7	解方程式	\N	\N
809	612	7	<span style="color:blue;">没有定义</span>	\N	\N
810	614	7	<b>错误：分母为零</b>	\N	\N
811	616	7	新向量	\N	\N
812	618	7	向量完成	\N	\N
813	620	7	排列总数	\N	\N
814	622	7	矩阵的平方	\N	\N
815	624	7	矩阵的立方	\N	\N
816	626	7	Raising to the 4th power	\N	\N
817	628	7	缩小	\N	\N
818	630	7	放大	\N	\N
819	632	7	左转	\N	\N
820	634	7	右转	\N	\N
821	636	7	上移	\N	\N
823	640	7	右边缩排增加 +	\N	\N
824	642	7	右边缩排减少 -	\N	\N
825	644	7	上端缩排增加 +	\N	\N
826	646	7	下端缩排减少 -	\N	\N
822	638	7	下移	\N	\N
1570	226	9	<b>Zadaný výraz je žiaľ nezmyselný.</b>	\N	\N
1571	254	9	Vývojáry	\N	\N
842	259	8	線性代數	\N	\N
1114	568	8	<a href="http://en.wikipedia.org/wiki/Square_root" target="_blank">平方根</a> 的整數部份:[co]	\N	\N
1115	570	8	<a href="http://en.wikipedia.org/wiki/Nth_root" target="_blank"><i>n</i>次方根</a> 整數部份:[co]	\N	\N
1116	572	8	以2為底 <a href="http://en.wikipedia.org/wiki/Logarithm" target="_blank">對數</a> 的整數部份:[co]	\N	\N
829	125	8	使用英文	\N	\N
795	566	7	以和为底的对数函数整数部份	\N	\N
1055	568	7	<a href="http://en.wikipedia.org/wiki/Square_root" target="_blank">平方根</a> 的整数部份:[co]	\N	\N
1056	570	7	<a href="http://en.wikipedia.org/wiki/Nth_root" target="_blank"><i>n</i>次方根</a> 整数部份:[co]	\N	\N
1057	572	7	以2为底 <a href="http://en.wikipedia.org/wiki/Logarithm" target="_blank">对数</a> 的整数部份:[co]	\N	\N
796	574	7	以 b 为底对数的整数部份	\N	\N
1058	576	7	以 <i>b</i> 为底 <a href="http://en.wikipedia.org/wiki/Logarithm" target="_blank">对数</a> 的整数部份:[co]	\N	\N
798	34	7	<html><head></head><body>平方分解为<br /></body></html>	\N	\N
1061	36	7	<html><head></head><body><div align="center"><strong>为 CADGDM 研讨会输出试验</strong><br /></div></body></html>	\N	\N
1005	62	7	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>欢迎使用 WMI2!</h2></center>这里是 <a href="http://matek.hu/1">WMI</a> 的更新版本. 我们提供解答数学的服务. 如果你是 14-21 年龄的青少年,可以直接使用键盘或滑鼠输入题目, 并按下左边紫色按键开始计算. 如果要使用其它功能则由左上角按键切换选单. <br><br>你可以参考 <a href="doc/intro_en.html" target=_blank>手册</a> (<a href="doc/intro_en.pdf" target=_blank>PDF</a>) 或者 <a href="doc/developers_en.html">发展者 技术文件</a> (<a href="doc/developers_en.pdf" target=_blank>PDF</a>). 或者 <a href="doc/normal.avi" target=_blank>看影片</a>.<br><br></td><td valign="top" align="right"><img src="./image/normal-pres.png" style="position:relative;top:-10px;right:-10px;" alt=""></td></tr></table>	\N	\N
651	650	2	Substitution (x)	\N	\N
1606	63	7	现在可以储存工作稿件。	\N	\N
776	69	7	已经设定为 %s 语言，建议你现在重新连结网页。	\N	\N
1607	90	7	<b>matek.hu <small>BETA</small></b>	\N	\N
1007	91	7	版权 &copy; 2006-2007 Particio BT.<br> Z. Kovacs, R. Vajda, A. Fekete, G. Bakos, K. Csernai	\N	\N
1008	92	7	使用 WebMathematics Interactive %s<br> 版权 &copy; 2002-2007 University of Szeged<br>	\N	\N
1009	93	7	资料库使用 Wekker RAD Engine 加强 <br> 版权 &copy; 2005-2007 Consol Kft.<br>	\N	\N
1010	94	7	图形使用  Gnome<br> 商标版权 &copy; 2003 Zsigmond Kovacs<br>设计颜色  Zsuzsa Deak <br> <span style="font-size:smaller;">4D cube animation by Oliver Knill, Harvard University<br> Punk girl logo &copy; www.sykospark.net<br> Spiral image from Wikipedia &copy; Chris 73</span>	\N	\N
1011	95	7	使用软体： <br> GNU Linux/Apache/PostgreSQL/PHP, gnuplot/Maxima, TeX/LaTeX/ImageMagick, formconv/TeXmacs, GeoLite (http://www.maxmind.com)	\N	\N
1012	96	7	如果想联络发展者，<br> 请不要客气，寄信到下列信箱 <br> <b><a style="color: #ffffff; text-decoration: none;" href="mailto:info@matek.hu">info@matek.hu</a></b>	\N	\N
1013	97	7	请由下列连结回报臭虫 <br> <b><a style="color: #ffffff; text-decoration: none;" href="http://wmi.sf.net/2/bugs" target="_blank">http://wmi.sf.net/2/bugs</a></b>	\N	\N
1608	125	7	使用英文	\N	\N
1006	88	7	<a href="http://en.wikipedia.org/wiki/Graph_of_a_function" target="_blank"> 函数图形 </a>:	\N	\N
1609	141	7	部分和数列	\N	\N
1650	272	7	教师资料库	\N	\N
1014	139	7	<a href="http://en.wikipedia.org/wiki/Series_%28mathematics%29#Infinite_series" target="_blank">部分和数列</a>:[co]	\N	\N
1610	145	7	部分乘积数列	\N	\N
1016	147	7	<a href="http://en.wikipedia.org/wiki/Limit_of_a_sequence" target="_blank">数列的极限</a>:[co]	\N	\N
1611	149	7	数列的极限	\N	\N
1612	151	7	不定积分	\N	\N
1017	155	7	<a href="http://en.wikipedia.org/wiki/Antiderivative" target="_blank">函数的不定积分</a>:[co]	\N	\N
1018	157	7	<a href="http://en.wikipedia.org/wiki/Derivative" target="_blank">函数的导函数</a>:[co]	\N	\N
1613	159	7	函数的极限	\N	\N
1019	161	7	<a href="http://en.wikipedia.org/wiki/Limit_of_a_function" target="_blank">函数的极限</a>:[co]	\N	\N
1020	164	7	<a href="http://en.wikipedia.org/wiki/Taylor_series" target="_blank">函数的泰勒级数</a>:[co]	\N	\N
1614	166	7	泰勒级数	\N	\N
1021	169	7	<font color="black"><b>问题不正确，如有需要，可以由<a href="doc/intro_en.html" target="_blank">要求帮助</a>。</b></font>	\N	\N
1615	171	7	<b>问题太难，无法解答</b>	\N	\N
1303	628	9	Vzdialiť	\N	\N
1594	630	9	Blizšie	\N	\N
1304	632	9	Blizšie	\N	\N
1305	634	9	Otočenie doprava	\N	\N
1306	636	9	Otočenie hore	\N	\N
1308	640	9	Eltolás x+	\N	\N
1640	648	9	Určitý integrál	\N	\N
1641	652	9	<a href="http://sk.wikipedia.org/wiki/Integr%C3%A1l">určitý integrál</a> funkcie:[co]	\N	\N
1642	654	9	Substitúcia premennej x výrazu s niečím:[co]	\N	\N
1635	656	9	Parciálna derivácia	\N	\N
1636	658	9	Substitúcia	\N	\N
1637	660	9	Parciálna deriácia funkcie:[co]	\N	\N
1307	638	9	Otočenie dole	\N	\N
1353	294	10	Transponování	\N	\N
1355	298	10	Hodnost matice	\N	\N
712	188	7	Pi，圆周率，大约 .14159	\N	\N
713	189	7	次方	\N	\N
714	190	7	平方	\N	\N
715	191	7	3次方	\N	\N
716	193	7	实数	\N	\N
717	195	7	下1个参数	\N	\N
718	196	7	自然对数	\N	\N
719	197	7	对数 (以2为底)	\N	\N
720	198	7	阶乘	\N	\N
1081	217	8	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>數學變容易了！</h2></center>只要用鍵盤或者滑鼠輸入問題，按下左邊紫色的按鍵，就可以開始計算。也可以使用左上角的電腦按鍵，選擇其他的計算機功能選單。</td><td valign="top" align="right"><img src="./image/easy-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt=""></td></tr></table>	\N	\N
1082	219	8	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>微積分變簡單了!</h2></center>只要用鍵盤或者滑鼠輸入問題，按下左邊紫色的按鍵，就可以開始計算。也可以使用左上角的電腦按鍵，選擇其他的計算機功能選單。  <a href=doc/calculus.avi>示範影片</a> 提供參考，</td><td valign="top" align="right"><img src="./image/calculus-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt="Logarithmic spiral, symbol of calculus" title="Logarithmic spiral, symbol of calculus"></td></tr></table>	\N	\N
839	226	8	<b>抱歉，輸入的公式無法執行。</b>	\N	\N
1474	488	10	Pro tento výpočet byste měli zadat pouze jeden parametr. Nesmíte tedy použít čárku (",").	\N	\N
1475	491	10	<span style="color:blue;">není definován (neexistuje)</span>	\N	\N
1476	493	10	<span style="color:blue;">nepravda</span>	\N	\N
2121	460	5	Incognite	\N	\N
1093	256	8	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>歡迎來到代數園地！</h2></center>只要用鍵盤或者滑鼠輸入問題，按下左邊紫色的按鍵，就可以開始計算。也可以使用左上角的電腦按鍵，選擇其他的計算機功能選單。</td><td valign="top" align="right"><img src="./image/algebra-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt="Al Khwarizmi, author of the first algebra book (stamp from the Soviet Union, 1983)" title="Al Khwarizmi, author of the first algebra book (Russian stamp, 1983)"></td></tr></table>	\N	\N
1094	38	8	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>歡迎使用線性代數工具！</h2></center>只要用鍵盤或者滑鼠輸入問題，按下左邊紫色的按鍵，就可以開始計算。也可以使用左上角的電腦按鍵，選擇其他的計算機功能選單。如果你想弄得更清楚解題技巧， <a href=doc/linalg.avi>請看影片</a>.</td><td valign="top" align="right"><img src="./image/4dcube.gif" alt="Rotating cube in 4 dimensions" title="Rotating cube in 4 dimensions" style="position:relative;top:-10px;right:-10px;"></td></tr></table>	\N	\N
859	75	8	解題方式	\N	\N
860	78	8	更多的幫助	\N	\N
861	79	8	是否需要幫忙？	\N	\N
862	80	8	甚麼?	\N	\N
863	81	8	使用左鍵點選公式，即可使用	\N	\N
865	83	8	確定清除工作清單?	\N	\N
866	84	8	新的工作清單	\N	\N
867	85	8	儲存	\N	\N
868	86	8	列印	\N	\N
869	87	8	關於 WMI2	\N	\N
870	120	8	復原	\N	\N
931	121	8	重覆	\N	\N
872	123	8	小學	\N	\N
874	107	8	絕對值	\N	\N
875	108	8	正弦 sin	\N	\N
876	109	8	餘弦 cos	\N	\N
877	110	8	正割 tan	\N	\N
878	111	8	對數 (以10為底)	\N	\N
879	112	8	左括號	\N	\N
880	113	8	右括號	\N	\N
881	114	8	化簡	\N	\N
882	115	8	解方程式 (包含負數根)	\N	\N
883	116	8	函數圖形畫圖	\N	\N
1168	124	9	Prepnúť na maďarčinu	\N	\N
884	117	8	因式分解	\N	\N
885	118	8	求值	\N	\N
886	119	8	等號 (在方程式中)	\N	\N
887	185	8	In expanded form:[co]	\N	\N
888	186	8	展開式	\N	\N
889	187	8	餘數	\N	\N
908	173	8	In simplified form:[co]	\N	\N
909	174	8	大約	\N	\N
910	175	8	大約 :[co]	\N	\N
911	176	8	最大公因數	\N	\N
1095	177	8	<a href="http://en.wikipedia.org/wiki/Greatest_common_divisor" target="_blank">最大公因數</a>:[co]	\N	\N
912	178	8	最小公倍數	\N	\N
1096	179	8	<a href="http://en.wikipedia.org/wiki/Least_common_multiple", target="_blank">最小公倍數</a>:[co]	\N	\N
913	180	8	部份因式分解	\N	\N
1097	181	8	分解成 <a href="http://en.wikipedia.org/wiki/Partial_fraction" target="_blank">部份因式</a>:[co]	\N	\N
1098	184	8	<a href="http://en.wikipedia.org/wiki/Factorization" target="_blank">分解</a>:[co]	\N	\N
914	410	8	相異物組合	\N	\N
1099	411	8	<a href="http://en.wikipedia.org/wiki/Binomial_coefficient" target="_blank">相異物組合</a>:[co]	\N	\N
915	414	8	2x2  單位矩陣	\N	\N
916	416	8	2x2  零矩陣	\N	\N
917	418	8	2x2 矩陣	\N	\N
918	420	8	Row echelon form	\N	\N
919	422	8	In <a href="http://en.wikipedia.org/wiki/Reduced_row_echelon_form" target="_blank">row echelon form</a>:[co]	\N	\N
920	222	8	除法所得的商和餘式[:[co]	\N	\N
921	223	8	多項式分解	\N	\N
922	426	8	錯誤	\N	\N
1100	427	8	此網站特地為 Mozilla Firefox 2.0 and Internet Explorer 6/7 最佳化設計，你現在所使用的並非具有高支持的瀏覽器。請自行調整你的使用毛病後，若有所不便，敬請原諒!	\N	\N
923	430	8	<b>公式無法畫圖</b>	\N	\N
924	433	8	方程式的近似解	\N	\N
1101	435	8	所給條件區間， <a href="http://en.wikipedia.org/wiki/Equation" target="_blank">方程式</a> 的近似解l:[co]	\N	\N
926	439	8	複數函數圖形畫圖	\N	\N
929	445	8	函數的右極限:[co]	\N	\N
930	447	8	函數的左極限:[co]	\N	\N
933	451	8	在無窮遠的極限:[co]	\N	\N
934	453	8	e, Euler 常數，大約 2.71828	\N	\N
935	456	8	使用其他計算程式	\N	\N
936	458	8	選擇語系	\N	\N
937	460	8	未知變數	\N	\N
938	462	8	三角函數	\N	\N
939	464	8	對數函數	\N	\N
940	466	8	指數函數	\N	\N
941	468	8	簡單的根與次方	\N	\N
942	470	8	實數	\N	\N
943	472	8	整數變數	\N	\N
944	474	8	極限	\N	\N
945	476	8	常數	\N	\N
946	478	8	零矩陣	\N	\N
947	480	8	單位矩陣	\N	\N
948	482	8	新矩陣	\N	\N
949	484	8	函數圖形，方程式解	\N	\N
1102	486	8	計算中，必須先給兩個變數，變數之間必須用逗點 (",") 隔開。	\N	\N
1103	488	8	在計算中，只給1個變數，不需要使用逗點符號 (",")。	\N	\N
950	491	8	<span style="color:blue;">不存在</span>	\N	\N
951	493	8	<span style="color:blue;">錯誤</span>	\N	\N
952	495	8	<span style="color:blue;">正確</span>	\N	\N
953	497	8	數論	\N	\N
840	254	8	發展者	\N	\N
841	257	8	微積分	\N	\N
1083	263	8	抱歉，WMI2 尚未支援你使用的語言，所有的信息將使用英文和匈牙利文顯示。你可以考慮協助將這些信息內容翻譯成你使用的語言，非常歡迎你的協助。	\N	\N
844	286	8	反矩陣	\N	\N
1084	287	8	<a href="http://en.wikipedia.org/wiki/Invertible_matrix" target="_blank">反矩陣</a>:[co]	\N	\N
845	290	8	行列式	\N	\N
1085	291	8	<a href="http://en.wikipedia.org/wiki/Determinant" target="_blank">矩陣的行列式</a>:[co]	\N	\N
1087	299	8	矩陣秩	\N	\N
848	302	8	伴隨矩陣	\N	\N
1088	303	8	<a href="http://en.wikipedia.org/wiki/Adjugate_matrix" target="_blank">伴隨矩陣</a>:[co]	\N	\N
849	306	8	特徵多項式	\N	\N
1089	307	8	<a href="http://en.wikipedia.org/wiki/Characteristic_polynomial" target="_blank">矩陣特徵多項式</a>:[co]	\N	\N
850	310	8	固有值	\N	\N
1090	311	8	<a href="http://en.wikipedia.org/wiki/Eigenvalue%2C_eigenvector_and_eigenspace#Eigenvalues_and_eigenvectors_of_matrices" target="_blank">矩陣的固有值</a>:[co]	\N	\N
851	314	8	固有向量	\N	\N
1091	315	8	<a href="http://en.wikipedia.org/wiki/Eigenvalue%2C_eigenvector_and_eigenspace#Eigenvalues_and_eigenvectors_of_matrices" target="_blank">矩陣的固有向量</a>:[co]	\N	\N
852	318	8	矩陣乘法，數值乘法	\N	\N
853	320	8	矩陣次方	\N	\N
854	336	8	Echelon form (with unit leading coefficients)	\N	\N
1092	338	8	In echelon form (with unit leading coefficients):[co]	\N	\N
871	122	8	中學	\N	\N
873	106	8	平方根	\N	\N
890	188	8	Pi，圓周率，大約 .14159	\N	\N
891	189	8	次方	\N	\N
892	190	8	平方	\N	\N
893	191	8	3次方	\N	\N
894	193	8	實數	\N	\N
895	195	8	下1個參數	\N	\N
896	196	8	自然對數	\N	\N
897	197	8	對數 (以2為底)	\N	\N
898	198	8	階乘	\N	\N
899	199	8	指數函數	\N	\N
900	205	8	無條件進位	\N	\N
901	206	8	無條件捨去	\N	\N
902	207	8	正負號函數	\N	\N
903	208	8	3次法根	\N	\N
904	209	8	消去	\N	\N
905	210	8	小數點	\N	\N
906	211	8	Exponent of normal form	\N	\N
907	212	8	百分比	\N	\N
1104	455	8	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>歡迎來到數論的世界!</h2></center>只要用鍵盤或者滑鼠輸入問題，按下左邊紫色的按鍵，就可以開始計算。也可以使用左上角的電腦按鍵，選擇其他的計算機功能選單。</td><td valign="top" align="right"><img src="./image/lakat2.jpg" alt="Can be used for encryption" title="Can be used for encryption" style="position:relative;top:-10px;right:-10px;"></td></table>	\N	\N
1105	500	8	式子中的數為 <a href="http://en.wikipedia.org/wiki/Prime_number" target="_blank">質數</a> is:[co]	\N	\N
955	511	8	請資助 WMI2 發展！謝謝！	\N	\N
1106	513	8	乘法 (矩陣的元素相乘，而不是矩陣乘法)	\N	\N
1107	518	8	比所給的數大的最小 <a href="http://en.wikipedia.org/wiki/Prime_number" target="_blank">質數</a> :[co]	\N	\N
1108	520	8	比所給的數小的最大<a href="http://en.wikipedia.org/wiki/Prime_number" target="_blank">質數</a>:[co]	\N	\N
1109	522	8	小於所給數目的 <a href="http://en.wikipedia.org/wiki/Coprime" target="_blank">質數</a> 總數為 :[co]	\N	\N
1110	524	8	<a href="http://en.wikipedia.org/wiki/Divisor" target="_blank">因數</a>總和:[co]	\N	\N
956	526	8	小於本身的質數數目為	\N	\N
957	528	8	因數和	\N	\N
958	530	8	下1個質數	\N	\N
959	532	8	前一個質數	\N	\N
960	534	8	是否為質數？	\N	\N
961	536	8	不盡相異物直線排列	\N	\N
962	538	8	重複組合	\N	\N
963	540	8	相異物的排列	\N	\N
964	542	8	重複組合:[co]	\N	\N
965	544	8	相異物的排列:[co]	\N	\N
966	546	8	不盡相異物直線排列:[co]	\N	\N
967	548	8	階乘 ( 排列總數 ):[co]	\N	\N
968	550	8	第 n 個  Fibonacci 級數	\N	\N
1111	552	8	第 <i>n</i> 個 <a href="http://en.wikipedia.org/wiki/Fibonacci_number" target="_blank">Fibonacci 級數</a>:[co]	\N	\N
969	554	8	正著廚房	\N	\N
970	556	8	整數除法的餘數	\N	\N
1112	558	8	<a href="http://en.wikipedia.org/wiki/Quotient" target="_blank">商</a>的 <a href="http://en.wikipedia.org/wiki/Integer" target="_blank">整數</a> 部份:[co]	\N	\N
1113	560	8	<a href="http://en.wikipedia.org/wiki/Division_%28mathematics%29" target="_blank">除法</a>的<a href="http://en.wikipedia.org/wiki/Remainder" target="_blank">餘數</a>:[co]	\N	\N
971	562	8	整數平方根	\N	\N
972	564	8	整數 n 次方根	\N	\N
973	566	8	以和為底的對數函數整數部份	\N	\N
974	574	8	以 b 為底對數的整數部份	\N	\N
1117	576	8	以 <i>b</i> 為底 <a href="http://en.wikipedia.org/wiki/Logarithm" target="_blank">對數</a> 的整數部份:[co]	\N	\N
1118	581	8	計算中，變數的數目應該是 [PAR]，如果超過1個，變數之間須用逗點隔開。	\N	\N
985	601	8	<span style="color:blue;">無解</span>	\N	\N
1119	603	8	計算中，必須給三個參數，並用 (",") 隔開，第一個參數為求解的方程式，第2個和第三個參數分別為尋找區間的端點。	\N	\N
986	610	8	解方程式	\N	\N
987	612	8	<span style="color:blue;">沒有定義</span>	\N	\N
988	614	8	<b>錯誤：分母為零</b>	\N	\N
989	616	8	新向量	\N	\N
990	618	8	向量完成	\N	\N
991	620	8	排列總數	\N	\N
992	622	8	矩陣的平方	\N	\N
993	624	8	矩陣的立方	\N	\N
994	626	8	Raising to the 4th power	\N	\N
995	628	8	縮小	\N	\N
996	630	8	放大	\N	\N
997	632	8	左轉	\N	\N
998	634	8	右轉	\N	\N
999	636	8	上移	\N	\N
1001	640	8	右邊縮排增加 +	\N	\N
1624	648	8	定積分	\N	\N
1625	652	8	函數的<a href="http://en.wikipedia.org/wiki/Antiderivative" target="_blank">定積分</a>:[co]	\N	\N
1626	654	8	代入:[co]	\N	\N
1619	656	8	偏導函數	\N	\N
1620	658	8	代替	\N	\N
1621	660	8	函數的<a href="http://en.wikipedia.org/wiki/Derivative" target="_blank">偏導函數</a>:[co]	\N	\N
846	294	8	轉置矩陣	\N	\N
1086	295	8	<a href="http://en.wikipedia.org/wiki/Transpose" target="_blank">轉置矩陣</a>:[co]	\N	\N
847	298	8	矩陣秩	\N	\N
857	73	8	詳解	\N	\N
858	74	8	更多的幫助	\N	\N
864	82	8	關閉	\N	\N
1622	662	8	代換後的表示式為:[co]	\N	\N
2571	664	8	<b>錯誤：分母為零</b>	\N	\N
838	182	8	<b>抱歉，圖形過大，無法顯示</b>	\N	\N
1002	642	8	右邊縮排減少 -	\N	\N
1003	644	8	上端縮排增加 +	\N	\N
1004	646	8	下端縮排減少 -	\N	\N
1623	650	8	代值 (x)	\N	\N
1074	143	8	<a href="http://en.wikipedia.org/wiki/Infinite_product">部分乘積數列</a>:[co]	\N	\N
834	153	8	導函數	\N	\N
975	10	8	公式：[ui]	\N	\N
976	34	8	<html><head></head><body>平方分解為<br /></body></html>	\N	\N
1120	36	8	<html><head></head><body><div align="center"><strong>為 CADGDM 研討會輸出試驗</strong><br /></div></body></html>	\N	\N
977	37	8	<html><head></head><body>是...</body></html>	\N	\N
978	40	8	<html><head></head><body> test2 輸出<br /></body></html>	\N	\N
979	3	8	<html><head></head><body><p>	\N	\N
980	4	8	題目的公式：[ui]	\N	\N
981	8	8	表示式的值為:[co]	\N	\N
1121	6	8	方程式的解答為 <a href="http://en.wikipedia.org/wiki/Equation" target="_blank">解答</a> 為:[co]	\N	\N
982	54	8	清空輸入欄	\N	\N
983	59	8	WMI2暫時故障。<br>請稍候。	\N	\N
1122	60	8	您按鍵不正確。\n公式的輸入，應該像使用計算器一樣，\n並像手寫方式，從左邊到右邊輸入。\n\n如果你不曉得該怎麼做，\n請按 `ce` 鍵，重新輸入。\n\n如果你覺得碰到 WMI2 的臭蟲，\n請你重新聯結此網頁，\n用 http://wmi.sf.net/2/bugs 回報，\n謝謝。\n	\N	\N
984	61	8	從最近的地方求助 %s\n	\N	\N
1239	443	9	Limita funkcie z ľava	\N	\N
2248	120	5	Annulla	\N	\N
2249	121	5	Ripeti	\N	\N
2250	122	5	Matematica delle superiori	\N	\N
2251	123	5	Matematica delle medie	\N	\N
2245	117	5	Fattorizzazione	\N	\N
2246	118	5	Valutazione	\N	\N
2247	119	5	Simbolo di uguaglianza (in una equazione)	\N	\N
2254	153	5	Derivata	\N	\N
1815	147	5	<a href="http://it.wikipedia.org/wiki/Limite_di_una_successione" target="_blank">Limite della successione</a>:[co]	\N	\N
2253	151	5	Integrale indefinito	\N	\N
2255	155	5	<a href="http://it.wikipedia.org/wiki/Integrale#Integrale_Indefinito" target="_blank">Integrale indefinito della funzione</a>:[co]	\N	\N
1819	157	5	<a href="http://it.wikipedia.org/wiki/Derivata" target="_blank">Derivata della funzione</a>:[co]	\N	\N
2256	159	5	Limite di una funzione	\N	\N
2252	124	5	&Aacute;tv&aacute;lt&aacute;s in ungherese	\N	\N
1064	62	8	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>歡迎使用 WMI2!</h2></center>這裏是 <a href="http://matek.hu/1">WMI</a> 的更新版本. 我們提供解答數學的服務. 如果你是 14-21 年齡的青少年,可以直接使用鍵盤或滑鼠輸入題目, 並按下左邊紫色按鍵開始計算. 如果要使用其它功能則由左上角按鍵切換選單. <br><br>你可以參考 <a href="doc/intro_en.html" target=_blank>手冊</a> (<a href="doc/intro_en.pdf" target=_blank>PDF</a>) 或者 <a href="doc/developers_en.html">發展者 技術文件</a> (<a href="doc/developers_en.pdf" target=_blank>PDF</a>). 或者 <a href="doc/normal.avi" target=_blank>看影片</a>.<br><br></td><td valign="top" align="right"><img src="./image/normal-pres.png" style="position:relative;top:-10px;right:-10px;" alt=""></td></tr></table>	\N	\N
827	63	8	現在可以儲存工作稿件。	\N	\N
954	69	8	已經設定為 %s 語言，建議你現在重新連結網頁。	\N	\N
828	90	8	<b>matek.hu <small>BETA</small></b>	\N	\N
1066	91	8	版權 &copy; 2006-2007 Particio BT.<br> Z. Kovacs, R. Vajda, A. Fekete, G. Bakos, K. Csernai	\N	\N
1067	92	8	使用 WebMathematics Interactive %s<br> 版權 &copy; 2002-2007 University of Szeged<br>	\N	\N
1068	93	8	資料庫使用 Wekker RAD Engine 加強 <br> 版權 &copy; 2005-2007 Consol Kft.<br>	\N	\N
1069	94	8	圖形使用  Gnome<br> 商標版權 &copy; 2003 Zsigmond Kovacs<br>設計顏色  Zsuzsa Deak <br> <span style="font-size:smaller;">4D cube animation by Oliver Knill, Harvard University<br> Punk girl logo &copy; www.sykospark.net<br> Spiral image from Wikipedia &copy; Chris 73</span>	\N	\N
1070	95	8	使用軟體： <br> GNU Linux/Apache/PostgreSQL/PHP, gnuplot/Maxima, TeX/LaTeX/ImageMagick, formconv/TeXmacs, GeoLite (http://www.maxmind.com)	\N	\N
1071	96	8	如果想聯絡發展者，<br> 請不要客氣，寄信到下列信箱 <br> <b><a style="color: #ffffff; text-decoration: none;" href="mailto:info@matek.hu">info@matek.hu</a></b>	\N	\N
1072	97	8	請由下列連結回報臭蟲 <br> <b><a style="color: #ffffff; text-decoration: none;" href="http://wmi.sf.net/2/bugs" target="_blank">http://wmi.sf.net/2/bugs</a></b>	\N	\N
1065	88	8	<a href="http://en.wikipedia.org/wiki/Graph_of_a_function" target="_blank"> 函數圖形 </a>:	\N	\N
830	141	8	部分和數列	\N	\N
843	272	8	教師資料庫	\N	\N
1073	139	8	<a href="http://en.wikipedia.org/wiki/Series_%28mathematics%29#Infinite_series" target="_blank">部分和數列</a>:[co]	\N	\N
831	145	8	部分乘積數列	\N	\N
1075	147	8	<a href="http://en.wikipedia.org/wiki/Limit_of_a_sequence" target="_blank">數列的極限</a>:[co]	\N	\N
832	149	8	數列的極限	\N	\N
833	151	8	不定積分	\N	\N
1076	155	8	<a href="http://en.wikipedia.org/wiki/Antiderivative" target="_blank">函數的不定積分</a>:[co]	\N	\N
1077	157	8	<a href="http://en.wikipedia.org/wiki/Derivative" target="_blank">函數的導函數</a>:[co]	\N	\N
835	159	8	函數的極限	\N	\N
1078	161	8	<a href="http://en.wikipedia.org/wiki/Limit_of_a_function" target="_blank">函數的極限</a>:[co]	\N	\N
1079	164	8	<a href="http://en.wikipedia.org/wiki/Taylor_series" target="_blank">函數的泰勒級數</a>:[co]	\N	\N
836	166	8	泰勒級數	\N	\N
1080	169	8	<font color="black"><b>問題不正確，如有需要，可以由<a href="doc/intro_en.html" target="_blank">要求幫助</a>。</b></font>	\N	\N
837	171	8	<b>問題太難，無法解答</b>	\N	\N
1000	638	8	下移	\N	\N
11	11	11	Srpski	\N	\N
12	12	4	Deutsch	\N	\N
10	10	2	The formula:[ui]	\N	\N
23	23	\N	<font size="+1"><i>x<sup><small>y</small></sup></i></font>	\N	\N
24	24	\N	<big>|<i>x</i>|</big>	\N	\N
25	25	\N	<big><i>x</i></big><sup>2</sup>	\N	\N
26	26	\N	<big><i>x</i></big><sup>3</sup>	\N	\N
27	27	\N	log<sub><i><font face=Times,serif>a</font></i></sub><i>b</i>	\N	\N
28	28	\N	<big>&plusmn;</big>	\N	\N
30	30	\N	<big>&times;</big>	\N	\N
32	32	\N	<big>&#8722;</big>	\N	\N
33	33	\N	<font size=+1>&#8592;</font>	\N	\N
34	34	2	<html><head></head><body>Its square, factorized is:<br /></body></html>	\N	\N
36	36	2	<html><head></head><body><div align="center"><strong>Test layout for the CADGDM conference</strong><br /></div></body></html>	\N	\N
37	37	2	<html><head></head><body>Yes...</body></html>	\N	\N
38	38	1	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>dvzl a matek.hu lineris algebra rovata!</h2></center>A bal oldali szmolgpen tudsz feladatokat berni, akr az egrrel vagy billentyzeten is. A szmtsok a kkeszld gombokkal indthatk. A kalkultor tpust a bal fels gombbal vlthatod t. Ha segtsgre van szksged, <a href="segitseg" target="_blank">kattints ide</a> vagy <a href="doc/linalg-hu.avi">nzd meg ezt a filmet</a>!</td><td valign="top" align="right"><img src="./image/4dcube.gif" alt="Forg 4 dimenzis kocka" title="Forg 4 dimenzis kocka" style="position:relative;top:-10px;right:-10px;"></td></tr></table>	\N	\N
40	40	2	<html><head></head><body>This is the test2 layout.<br /></body></html>	\N	\N
3	3	2	<html><head></head><body><p>	\N	\N
4	4	2	The formula of the problem:[ui]	\N	\N
8	8	2	The value of the expression is:[co]	\N	\N
6	6	2	The solution of the <a href="http://en.wikipedia.org/wiki/Equation" target="_blank">equation</a> is:[co]	\N	\N
50	4	1	A feladat kplete:[ui]	\N	\N
51	8	1	A kifejezs rtke:[co]	\N	\N
52	6	1	Az <a href="http://hu.wikipedia.org/wiki/Egyenlet" target="_blank">egyenlet</a> megoldsa:[co]	\N	\N
54	54	2	Clear the input field	\N	\N
55	54	1	A szmolgp beviteli mezjnek trlse	\N	\N
57	57	\N	<font size=+1>&#8594;</font>	\N	\N
59	59	2	WMI2 is temporarily out of order.<br>Please come back later.	\N	\N
60	60	2	You have pressed an incorrect key in this context.\nA formula should be entered like in modern calculators,\nfrom left to right, similarly to hand-written formulas.\n\nIf you don't know what to do now, try to reset the\ncalculator and restart your work with the 'ce' key.\n\nIf you think you encountered a bug using WMI2, please\ntry to reload this page and visit our bug tracking site\non http://wmi.sf.net/2/bugs to report this bug, thank you.\n	\N	\N
61	61	2	Get help near %s\n	\N	\N
62	62	2	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Welcome to WMI2!</h2></center>This web site is a new version of <a href="http://matek.hu/1">WMI</a>. We are ready to serve pupils searching for solutions of mathematics. If you are at age of 14-21, just start to type the problem using the keyboard or the mouse and press a cyan button on the left to start the calculation. To select another layout of available calculator buttons please press the button on the top-left.<br><br>You can read the <a href="doc/intro_en.html" target=_blank>documentation</a> (<a href="doc/intro_en.pdf" target=_blank>PDF</a>) or the <a href="doc/developers_en.html">developers' howto</a> (<a href="doc/developers_en.pdf" target=_blank>PDF</a>). Or <a href="doc/normal.avi" target=_blank>watch this video</a>.<br><br></td><td valign="top" align="right"><img src="./image/normal-pres.png" style="position:relative;top:-10px;right:-10px;" alt=""></td></tr></table>	\N	\N
63	63	2	The worksheet can be saved now.	\N	\N
65	60	1	A lenyomott gomb ebben a pillanatban nem hasznlhat.\nA matek.hu oldal kpleteit a zsebkalkultorokban\nmegszokott mdon kell bevinni, balrl jobbra,\nmintha kzzel rnnk.\n\nHa elakadtl, nyomd le a CE gombot, vagy\ntltsd jra az oldalt.\n\nA matek.hu egyelre ksrleti stdiumban van.\nHa segteni akarsz a fejlesztsben,\nkrjk, ltogass el a http://wmi.sf.net/2/bugs oldalra.	\N	\N
66	61	1	Hogyan jn ki a megolds? Krj segtsget %s krnykn!	\N	\N
67	62	1	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Szervusz, ez itt a matek.hu!</h2></center>Igen! Megjult a matek.hu, nemcsak klalakjban, hanem mkdsben is! Termszetesen <a href="http://matek.hu/1" target="_blank">a rgi verzi is elrhet</a>. A bal oldali szmolgpen tudsz feladatokat berni, akr az egrrel vagy billentyzeten is. A szmtsok a kkeszld gombokkal indthatk. A kalkultor tpust a bal fels gombbal vlthatod: amit most hasznlsz, azzal <i>kzpiskolai feladatok</i> oldhatk meg. Ha segtsgre van szksged, <a href="segitseg" target="_blank">kattints ide</a> (<a href="doc/intro_hu.pdf">PDF</a>) vagy <a href="doc/normal-hu.avi">nzd meg ezt a filmet</a>!<br><br></td><td valign="top" align="right"><img src="./image/normal-pres.png" style="position:relative;top:-10px;right:-10px;" alt=""></td></tr></table>	\N	\N
68	68	\N	<font color="#ffe0e0"><big><b><i>x</i>=?</b></big></font>	\N	\N
69	69	2	Language is set to %s. It is suggested to the reload the page now.	\N	\N
70	69	1	Mostantl a program magyarul fog mkdni. Javasoljuk, hogy tltsd jra az oldalt.	\N	\N
71	10	1	A feladat kplete:[ui]	\N	\N
72	72	1	Krj segtsget %s krnykn!	\N	\N
73	73	1	Rszletes megolds...	\N	\N
74	74	1	Tbb segtsg...	\N	\N
75	75	1	Hogyan jn ki ez?	\N	\N
76	76	1	korrepetlst vllal.	\N	\N
77	77	1	magntanr.	\N	\N
94	94	1	Grafikai tmogats: Gnome<br> Log copyright &copy; 2003 Kovcs Zsigmond<br> Sznsszellts: Dek Zsuzsa<br> 4D kocka animci &copy; Oliver Knill, Harvard Egyetem<br> Punk lny log &copy; www.sykospark.net<br> Spirl-fot &copy; Wikipedia, Chris 73<br> Szmelmlet log &copy; Medve Zoltn	\N	\N
96	96	1	A fejlesztket az<br> <b><a style="color: #ffffff; text-decoration: none;" href="mailto:info@matek.hu">info@matek.hu</a></b><br> email-cmen lehet elrni.	\N	\N
97	97	1	Hibajelzseket a<br> <b><a style="color: #ffffff; text-decoration: none;" href="http://wmi.sf.net/2/bugs" target="_blank">http://wmi.sf.net/2/bugs</a></b><br> webcmen fogadunk, ksznjk!	\N	\N
98	90	2	<b>matek.hu <small>BETA</small></b>	\N	\N
99	91	2	Copyright &copy; 2006-2007 Particio BT.<br> Z. Kovacs, R. Vajda, A. Fekete, G. Bakos, K. Csernai	\N	\N
100	92	2	Powered by WebMathematics Interactive %s<br> Copyright &copy; 2002-2007 University of Szeged<br>	\N	\N
101	93	2	Database powered by Wekker RAD Engine<br> Copyright &copy; 2005-2007 Consol Kft.<br>	\N	\N
102	94	2	Graphics powered by Gnome<br> Logo copyright &copy; 2003 Zsigmond Kovacs<br> Color designation by Zsuzsa Deak<br> <span style="font-size:smaller;">4D cube animation by Oliver Knill, Harvard University<br> Punk girl logo &copy; www.sykospark.net<br> Spiral image from Wikipedia &copy; Chris 73<br> Number theory logo &copy; Zoltan Medve</span>	\N	\N
103	95	2	Underlying software:<br> GNU Linux/Apache/PostgreSQL/PHP, gnuplot/Maxima, TeX/LaTeX/ImageMagick, formconv/TeXmacs, GeoLite (http://www.maxmind.com)	\N	\N
104	96	2	To contact the developers,<br> feel free to write to<br> <b><a style="color: #ffffff; text-decoration: none;" href="mailto:info@matek.hu">info@matek.hu</a></b>	\N	\N
105	97	2	Please report bugs on<br> <b><a style="color: #ffffff; text-decoration: none;" href="http://wmi.sf.net/2/bugs" target="_blank">http://wmi.sf.net/2/bugs</a></b>	\N	\N
106	106	1	Ngyzetgyk	\N	\N
107	107	1	Abszoltrtk	\N	\N
108	108	1	Szinusz	\N	\N
109	109	1	Koszinusz	\N	\N
110	110	1	Tangens	\N	\N
111	111	1	Logaritmus (10-es alap)	\N	\N
112	112	1	Nyit s csuk zrjel (egytt)	\N	\N
113	113	1	Kilps a zrjeles kifejezsbl	\N	\N
114	114	1	Egyszersts	\N	\N
115	115	1	Egyenletmegolds (komplex gykk is)	\N	\N
116	116	1	Fggvnybrzols	\N	\N
117	117	1	Prmtnyezkk bonts, szorzatt alakts	\N	\N
118	118	1	Kirtkels	\N	\N
119	119	1	Egyenlsgjel (egyenletben)	\N	\N
120	120	1	Mgse	\N	\N
121	121	1	Mgis	\N	\N
122	122	1	Kzpiskols matematika	\N	\N
123	123	1	ltalnos iskolai matematika	\N	\N
124	124	1	&Aacute;tv&aacute;lt&aacute;s magyarra	\N	\N
125	125	2	Change language to English	\N	\N
126	126	\N	<font face="Times,serif" size="-1"><i>a</i><sup>2</sup>+<i>a</i></font>	\N	\N
127	127	\N	<font face="Times,serif" size="-2"><i>a</i>&#183;(<i>a</i>+1)</font>	\N	\N
128	128	\N	<font face="Times,serif" size="-1">(<i>a</i>,<i>b</i>)</font>	\N	\N
129	129	\N	<font face="Times,serif" size="-1">[<i>a</i>,<i>b</i>]</font>	\N	\N
130	130	\N	<font face="Arial,sans" size="-1">lim</font><font face="Times,serif" size="-1"><i> a<sub>n</sub></i></font>	\N	\N
131	131	\N	<span style="font-weight:normal;font-size:-1;"><i>&#402;</i>&#180;(<i>x</i>)</span>	\N	\N
132	132	\N	<center><table height="100%" cellpadding=0 cellspacing=0 border=0><tr height="100%"><td valign="middle"><font size="+1" color="white">&#8747;</font></td><td valign="middle"><font size="-1" color="white"><i>&#402;</i>(<i>x</i>)<i>dx</i></font></td></tr></table></center>	\N	\N
133	133	\N	<center><table border=0 cellspacing=0 cellpadding=0 height=100%><tr><td><table border=0 cellspacing=0 cellspacing=0><tr><td valign=bottom><center><font face="Times,serif" size="-7" color="white">1</font></center></td></tr><tr><td height=1 bgcolor=white colspan=2></td></tr><tr><td valign=top><center><font face="Times,serif" size="-7" color="white"><i>x</i></font></center></td></tr></table></td><td valign=middle><font face="Times,serif" size="-7" color="white">+</font></td><td><table border=0 cellspacing=0 cellspacing=0><tr><td valign=bottom><center><font face="Times,serif" size="-7" color="white">2</font></center></td></tr><tr><td height=1 bgcolor=white colspan=2></td></tr><tr><td valign=top><center><table border=0 cellspacing=0 cellspacing=0><tr><td><font face="Times,serif" size="-7" color="white"><i>x</i></font></td><td valign=middle><font face="Times,serif" size="-7" color="white">+</font></td><td><font face="Times,serif" size="-7" color="white">1</font></td></tr></table></center></td></tr></table></td></tr></table></center>	\N	\N
134	134	\N	<font face="Times,serif" size="+1">&#931;</font><font face="Times, serif" size="-1"><i> a<sub>n</sub></i></font>	\N	\N
146	145	2	Sequence of partial products	\N	\N
147	147	1	<a href="http://hu.wikipedia.org/wiki/Hat%C3%A1r%C3%A9rt%C3%A9k" target="_blank">A sorozat hatrrtke</a>:[co]	\N	\N
148	147	2	<a href="http://en.wikipedia.org/wiki/Limit_of_a_sequence" target="_blank">Limit of the sequence</a>:[co]	\N	\N
149	149	1	Sorozat hatrrtke	\N	\N
150	149	2	Limit of a sequence	\N	\N
151	151	1	Hatrozatlan integrl	\N	\N
152	151	2	Indefinite integral	\N	\N
153	153	1	Differencils	\N	\N
155	155	1	A fggvny hatrozatlan integrlja:[co]	\N	\N
156	155	2	<a href="http://en.wikipedia.org/wiki/Antiderivative" target="_blank">The indefinite integral of the function</a>:[co]	\N	\N
157	157	1	<a href="http://hu.wikipedia.org/wiki/Differenci%C3%A1lh%C3%A1nyados" target="_blank">A fggvny derivltja</a>:[co]	\N	\N
158	157	2	<a href="http://en.wikipedia.org/wiki/Derivative" target="_blank">The derivative of the function</a>:[co]	\N	\N
159	159	1	Fggvnyhatrrtk	\N	\N
160	159	2	Limit of a function	\N	\N
161	161	1	<a href="http://hu.wikipedia.org/wiki/Hat%C3%A1r%C3%A9rt%C3%A9k" target="_blank">A fggvny hatrrtke</a>:[co]	\N	\N
162	161	2	<a href="http://en.wikipedia.org/wiki/Limit_of_a_function" target="_blank">The limit of the function</a>:[co]	\N	\N
163	163	\N	<font face="Arial,sans" size="-2">lim</font><font face="Times,serif" size="-2">&nbsp;<i>f</i>(<i>x</i>)</font>	\N	\N
164	164	1	<a href="http://hu.wikipedia.org/wiki/Taylor-sor" target="_blank">A fggvny Taylor-sora</a>:[co]	\N	\N
165	164	2	<a href="http://en.wikipedia.org/wiki/Taylor_series" target="_blank">Taylor series of the function</a>:[co]	\N	\N
166	166	1	Taylor-sor	\N	\N
167	166	2	Taylor-series	\N	\N
169	169	1	<font color="black"><b>Hibsan megfogalmazott feladat, ha szksges, <a href="segitseg" target="_blank">krj segtsget</a>!</b></font>	\N	\N
170	169	2	<font color="black"><b>Incorrectly defined problem, please <a href="doc/intro_en.html" target="_blank">ask help</a> if needed.</b></font>	\N	\N
171	171	1	<b>Tl nehz feladat, sajnlom.</b>	\N	\N
172	171	2	<b>Too difficult problem, sorry.</b>	\N	\N
173	173	1	Egyszerstve:[co]	\N	\N
174	174	1	A kifejezs rtke hozzvetlegesen	\N	\N
175	175	1	A kifejezs rtke hozzvetlegesen:[co]	\N	\N
176	176	1	Legnagyobb kzs oszt	\N	\N
177	177	1	A kifejezsek legnagyobb kzs osztja:[co]	\N	\N
178	178	1	Legkisebb kzs tbbszrs	\N	\N
179	179	1	A kifejezsek legkisebb kzs tbbszrse:[co]	\N	\N
180	180	1	Parcilis trtek	\N	\N
181	181	1	Parcilis trtekre bontva:[co]	\N	\N
182	182	1	<b>Tl nagy lenne a kp, sajnlom.</b>	\N	\N
184	184	1	Prmtnyezkre bontva (szorzatt alaktva):[co]	\N	\N
186	186	1	sszegg alakts	\N	\N
187	187	1	Maradkos oszts maradka	\N	\N
188	188	1	Pi, matematikai konstans, rtke kb. 3,14159	\N	\N
189	189	1	Hatvnyozs	\N	\N
190	190	1	Ngyzetre emels	\N	\N
191	191	1	A szm kbe	\N	\N
193	193	1	Vals ismeretlen	\N	\N
195	195	1	Kvetkez paramter	\N	\N
196	196	1	Logaritmus (termszetes alap)	\N	\N
197	197	1	Logaritmus (2-es alap)	\N	\N
198	198	1	Faktorilis	\N	\N
199	199	1	Az exponencilis fggvny	\N	\N
200	200	\N	<big>e</big><sup><i>x</i></sup>	\N	\N
201	201	\N	<big>2</big><sup><i>x</i></sup>	\N	\N
202	202	\N	log<sub>2</sub><i>x</i>	\N	\N
203	203	\N	<big>10</big><sup><i>x</i></sup>	\N	\N
217	217	1	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>dvzl a matek.hu!</h2></center>A bal oldali szmolgpen tudsz feladatokat berni, akr az egrrel vagy billentyzeten is. A szmtsok a kkeszld gombokkal indthatk. A kalkultor tpust a bal fels gombbal vlthatod: amit most hasznlsz, azzal <i>ltalnos iskolai feladatok</i> oldhatk meg. Ha segtsgre van szksged, <a href="segitseg" target="_blank">kattints ide</a>!<br><br></td><td valign="top" align="right"><img src="./image/easy-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt=""></td></tr></table>	\N	\N
218	217	2	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Math can be easy!</h2></center>Just start to type the problem using the keyboard or the mouse and press a cyan button on the left to start the calculation. To select another layout of available calculator buttons please press the button on the top-left.</td><td valign="top" align="right"><img src="./image/easy-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt=""></td></tr></table>	\N	\N
219	219	1	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>dvzl a matek.hu analzis rovata!</h2></center>A bal oldali szmolgpen tudsz feladatokat berni, akr az egrrel vagy billentyzeten is. A szmtsok a kkeszld gombokkal indthatk. A kalkultor tpust a bal fels gombbal vlthatod: amit most hasznlsz, azzal <i>bevezet analzis feladatok</i> oldhatk meg. Ha segtsgre van szksged, <a href="segitseg" target="_blank">kattints ide</a> vagy <a href=doc/calculus-hu.avi>nzd meg ezt a filmet</a>!<br><br></td><td valign="top" align="right"><img src="./image/calculus-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt="Logaritmikus spirl, a matematikai analzist szimbolizlja" title="Logaritmikus spirl, a matematikai analzist szimbolizlja" ></td></tr></table>	\N	\N
220	219	2	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Calculus can be easy!</h2></center>Just start to type the problem using the keyboard or the mouse and press a cyan button on the left to start the calculation. To select another layout of available calculator buttons please press the button on the top-left. A <a href=doc/calculus.avi>demo video</a> is also available.</td><td valign="top" align="right"><img src="./image/calculus-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt="Logarithmic spiral, symbol of calculus" title="Logarithmic spiral, symbol of calculus"></td></tr></table>	\N	\N
224	224	1	A polinomok osztsnak maradka:[co]	\N	\N
225	225	1	Polinomok osztsa, maradk	\N	\N
226	226	1	<b>A bert kplet sajnos nem rtelmezhet.</b>	\N	\N
227	226	2	<b>The entered formula cannot be processed, sorry.</b>	\N	\N
228	228	\N	<font size="+1"><i>a</i></font>	\N	\N
229	229	\N	<font size="+1"><i>b</i></font>	\N	\N
230	230	\N	<font size="+1"><i>c</i></font>	\N	\N
231	231	\N	<font size="+1"><i>d</i></font>	\N	\N
232	232	\N	<font size="+1"><i>e</i></font>	\N	\N
233	233	\N	<font size="+1"><i>f</i></font>	\N	\N
234	234	\N	<font size="+1"><i>g</i></font>	\N	\N
235	235	\N	<font size="+1"><i>h</i></font>	\N	\N
236	236	\N	<font size="+1"><i>i</i></font>	\N	\N
237	237	\N	<font size="+1"><i>j</i></font>	\N	\N
238	238	\N	<font size="+1"><i>k</i></font>	\N	\N
239	239	\N	<font size="+1"><i>l</i></font>	\N	\N
240	240	\N	<font size="+1"><i>m</i></font>	\N	\N
241	241	\N	<font size="+1"><i>n</i></font>	\N	\N
242	242	\N	<font size="+1"><i>o</i></font>	\N	\N
243	243	\N	<font size="+1"><i>p</i></font>	\N	\N
244	244	\N	<font size="+1"><i>q</i></font>	\N	\N
245	245	\N	<font size="+1"><i>r</i></font>	\N	\N
246	246	\N	<font size="+1"><i>s</i></font>	\N	\N
247	247	\N	<font size="+1"><i>t</i></font>	\N	\N
248	248	\N	<font size="+1"><i>u</i></font>	\N	\N
249	249	\N	<font size="+1"><i>v</i></font>	\N	\N
250	250	\N	<font size="+1"><i>w</i></font>	\N	\N
251	251	\N	<font size="+1"><i>x</i></font>	\N	\N
252	252	\N	<font size="+1"><i>y</i></font>	\N	\N
253	253	\N	<font size="+1"><i>z</i></font>	\N	\N
254	254	1	Fejlesztknek	\N	\N
255	254	2	Developers	\N	\N
256	256	1	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>dvzl a matek.hu algebra rovata!</h2></center>A bal oldali szmolgpen tudsz feladatokat berni, akr az egrrel vagy billentyzeten is. A szmtsok a kkeszld gombokkal indthatk. A kalkultor tpust a bal fels gombbal vlthatod t. Ha segtsgre van szksged, <a href="segitseg" target="_blank">kattints ide</a>!<br><br></td><td valign="top" align="right"><img src="./image/algebra-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt="Al-Hvrizmi, az els algebra knyv szerzje (szovjet blyeg, 1983)" title="Al-Hvrizmi, az els algebra knyv szerzje (szovjet blyeg, 1983)"></td></tr></table>	\N	\N
261	259	2	Linear algebra	\N	\N
262	262	\N	<big><i>n</i>!</big>	\N	\N
263	263	2	Sorry, the selected language is not supported yet in WMI2. All messages will be shown in Hungarian or English. If you are a native speaker of the selected language, please consider contributing translations of the original texts. Your help is welcome!	\N	\N
266	266	\N	<big><i>x</i></big><sup>4</sup>	\N	\N
267	267	\N	<span style="letter-spacing:-0.15em;"><sup><var>3</var></sup>&#8730;</span><span style="text-decoration:overline;"><var><i>x</i></var></span>	\N	\N
268	268	\N	<table align="center" valign="middle" cellpadding="0" cellspacing="0" border="0"><tr valign="middle"><td style="color:white;font-size:x-large;">(</td><td><table cellpadding="0" cellspacing="0" border="0"><tr valign="middle"><td style="font-size:x-small;color:white;"><b><i>n</i><b></td></tr><tr valign="middle"><td style="color:white;font-size:x-small;"><b><i>k</i></b></td></tr></table></td><td style="font-size:x-large;color:white;">)</td></table>	\N	\N
269	269	\N	<table cellpadding="0" cellspacing="0" align="center"><tr valign="baseline"><td align="center" style="color:white;font-face:Times,serif;font-size:x-small;"><b><font face="Arial,sans">lim</font><br><span style="font-size:xx-small;"><i>x</i>&#8594;<i>x<sub>0</sub><sup>-</sup></i></span></b></td><td style="color:white;font-size:x-small;font-face:Times,serif;">&nbsp;<b><i><font face="Times,serif">f</font></i>(<i>x</i>)</b></td></tr></table>	\N	\N
270	270	\N	<table cellpadding="0" cellspacing="0" align="center"><tr valign="baseline"><td align="center" style="color:white;font-face:Times,serif;font-size:x-small;"><b><font face="Arial,sans">lim</font><br><span style="font-size:xx-small;"><i>x</i>&#8594;<i>x<sub>0</sub><sup>+</sup></i></span></b></td><td style="color:white;font-size:x-small;font-face:Times,serif;"><b><i><font face="Times,serif">f</font></i>(<i>x</i>)</b></td></tr></table>	\N	\N
271	271	\N	<span style="text-align:center;font-face:Times,serif;font-size:x-small;"><b><font face="Arial,sans">lim</font><big><font face="Times,serif">&#8721;</font></big><i><font face="Times,serif">a<sub>n</sub></font></i></b></span>	\N	\N
274	274	\N	<span style="font-weight:normal;font-size:larger;">|<span style="font-size:normal;font-style:italic;font-weight:bold;"><font face="Verdana, Arial, sans-serif">A</font></span>|</span>	\N	\N
275	275	\N	<span style="font-weight:bold;font-size:larger;font-style:italic;"><font face="Verdana, Arial, sans-serif">A</font></span><sup>-1</sup>	\N	\N
276	276	\N	<span style="font-size:normal;font-weight:normal;">adj(</span><span style="font-style:italic;font-weight:normal;font-size:larger;"><font face="Verdana, Arial, sans-serif">A</font></span><span style="font-size:normal;font-weight:normal;">)</span>	\N	\N
277	277	\N	<font face="Verdana, Arial, sans-serif">|<i>x</i>&#183;<i>I</i>-<i>A</i>|</font>	\N	\N
278	278	\N	<span style="font-size:larger;font-style:italic;font-weight:bold;"><font face="Verdana, Arial, sans-serif">I</font></span><sub>2</sub>	\N	\N
279	279	\N	<span style="font-size:larger;font-style:italic;font-weight:bold;"><font face="Verdana, Arial, sans-serif">I</font></span><sub>3</sub>	\N	\N
280	280	\N	<span style="font-weight:bold;font-style:italic;color:#c0c0c0;"><font face="Verdana, Arial, sans-serif">Av=<span style="color:white;">&#955;</span>v</font></span>	\N	\N
281	281	\N	<span style="font-size:larger;font-style:italic;font-weight:bold;"><font face="Verdana, Arial, sans-serif">A</font></span><sup>T</sup>	\N	\N
282	282	\N	<span style="font-size:normal;font-weight:bold;font-style:italic;"><font face="Verdana, Arial, sans-serif">A&#183;B</font></span>	\N	\N
283	283	\N	<span style="font-size:larger;font-weight:bold;font-style:italic;"><font face="Verdana, Arial, sans-serif">A</font></span><sup>n</sup>	\N	\N
284	284	\N	<span style="font-size:larger;font-style:italic;font-weight:bold;"><font face="Verdana, Arial, sans-serif">M</font></span><sub>2x2</sub>	\N	\N
285	285	\N	<span style="font-size:larger;font-style:italic;font-weight:bold;"><font face="Verdana, Arial, sans-serif">M</font></span><sub>3x3</sub>	\N	\N
286	286	1	Mtrixinvertls	\N	\N
287	287	1	<a href="http://hu.wikipedia.org/wiki/Invert%C3%A1lhat%C3%B3_m%C3%A1trix" target="_blank">A mtrix inverze</a>:[co]	\N	\N
288	286	2	Matrix inverse	\N	\N
289	287	2	<a href="http://en.wikipedia.org/wiki/Invertible_matrix" target="_blank">The inverse of the matrix</a>:[co]	\N	\N
290	290	1	Determinns	\N	\N
291	291	1	<a href="http://hu.wikipedia.org/wiki/Determin%C3%A1ns" target="_blank">A mtrix determinnsa</a>:[co]	\N	\N
292	290	2	Determinant	\N	\N
293	291	2	<a href="http://en.wikipedia.org/wiki/Determinant" target="_blank">The determinant of the matrix</a>:[co]	\N	\N
294	294	1	Transzponls	\N	\N
295	295	1	<a href="http://hu.wikipedia.org/wiki/Adjung%C3%A1lt_(m%C3%A1trixinvert%C3%A1l%C3%A1s)#Transzpon.C3.A1lt" target="_blank">A mtrix transzponltja</a>:[co]	\N	\N
301	299	2	<a href="http://en.wikipedia.org/wiki/Rank_(linear_algebra)" target="_blank">The rank of the matrix</a>:[co]	\N	\N
302	302	1	Adjunglt mtrix	\N	\N
303	303	1	<a href="http://hu.wikipedia.org/wiki/Adjung%C3%A1lt_(m%C3%A1trixinvert%C3%A1l%C3%A1s)" target="_blank">A mtrix adjungltja</a>:[co]	\N	\N
304	302	2	Adjugate matrix	\N	\N
305	303	2	<a href="http://en.wikipedia.org/wiki/Adjugate_matrix" target="_blank">The adjugate of the matrix</a>:[co]	\N	\N
306	306	1	Karakterisztikus polinom	\N	\N
338	338	1	Lpcss alakban (a ftlban 1-esekkel):[co]	\N	\N
339	338	2	In echelon form (with unit leading coefficients):[co]	\N	\N
340	335	2	RREF	\N	\N
341	341	\N	<span style="font-size:larger;font-face:Times,serif;font-style:italic;">A</span><sup>H</sup>	\N	\N
342	342	\N	<span style="font-size:larger;font-face:Times,serif;font-style:italic;text-decoration:overline;">A</span>	\N	\N
343	256	2	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Welcome to the Department of Algebra!</h2></center>Just start to type the problem using the keyboard or the mouse and press a cyan button on the left to start the calculation. To select another layout of available calculator buttons please press the button on the top-left.</td><td valign="top" align="right"><img src="./image/algebra-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt="Al Khwarizmi, author of the first algebra book (stamp from the Soviet Union, 1983)" title="Al Khwarizmi, author of the first algebra book (Russian stamp, 1983)"></td></tr></table>	\N	\N
344	38	2	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Welcome to the Linear Algebra tools!</h2></center>Just start to type the problem using the keyboard or the mouse and press a cyan button on the left to start the calculation. To select another layout of available calculator buttons please press the button on the top-left. To get a closer look how you can enter a problem, <a href=doc/linalg.avi>watch this video</a>.</td><td valign="top" align="right"><img src="./image/4dcube.gif" alt="Rotating cube in 4 dimensions" title="Rotating cube in 4 dimensions" style="position:relative;top:-10px;right:-10px;"></td></tr></table>	\N	\N
348	75	2	The way to the solution...	\N	\N
349	78	2	Even more help...	\N	\N
350	79	2	Need help?	\N	\N
351	80	2	What's this?	\N	\N
352	81	2	On left-click this formula will be placed into the input field	\N	\N
354	83	2	Are you sure you want to clear the worksheet?	\N	\N
355	84	2	New worksheet	\N	\N
356	85	2	Save	\N	\N
357	86	2	Print	\N	\N
358	87	2	About WMI2	\N	\N
359	120	2	Undo	\N	\N
360	121	2	Redo	\N	\N
361	122	2	Secondary school mathematics	\N	\N
362	123	2	Elementary school mathematics	\N	\N
363	106	2	Square root	\N	\N
364	107	2	Absolute value	\N	\N
365	108	2	Sine	\N	\N
366	109	2	Cosine	\N	\N
367	110	2	Tangent	\N	\N
368	111	2	Logarithm (base 10)	\N	\N
369	112	2	Parentheses (both opening and closing, 1 level in)	\N	\N
370	113	2	Quitting parentheses (1 level out)	\N	\N
371	114	2	Simplification	\N	\N
372	115	2	Equation solving (including complex roots)	\N	\N
373	116	2	Plotting a function	\N	\N
374	117	2	Factorization	\N	\N
375	118	2	Evaluation	\N	\N
376	119	2	Equal sign (in an equation)	\N	\N
377	185	2	In expanded form:[co]	\N	\N
378	186	2	Expansion	\N	\N
379	187	2	Remainder of division	\N	\N
380	188	2	Pi, mathematical constant, cca. 3,14159	\N	\N
418	418	1	2x2-es mtrix (sablon)	\N	\N
419	418	2	Matrix of size 2x2 (template)	\N	\N
420	420	1	Lpcss alak	\N	\N
421	420	2	Row echelon form	\N	\N
422	422	1	Lpcss alakban:[co]	\N	\N
423	422	2	In <a href=http://en.wikipedia.org/wiki/Row_echelon_form>row echelon form</a>:[co]	\N	\N
424	222	2	Quotient and remainder after division:[co]	\N	\N
425	223	2	Division of polynomials	\N	\N
426	426	1	Hiba	\N	\N
427	426	2	Error	\N	\N
428	427	1	Ezt az oldalt Mozilla Firefox 2.0-ra s Internet Explorer 6/7-re optimalizltuk. gy tnik, egy, a matek.hu ltal nem tmogatott bngszt hasznlsz. Elfordulhat, hogy nhny funcki nem fog megfelelen mkdni, amirt elre is elnzsedet krjk.	\N	\N
429	427	2	This web site is highly optimized for Mozilla Firefox 2.0 and Internet Explorer 6/7. You currently seem to be using a not fully supported browser. Please be prepared to experience problems on using. Sorry for your inconvenience!	\N	\N
430	430	1	<b>Ezt a kpletet nem sikerlt brzolni.</b>	\N	\N
431	430	2	<b>This formula wasn't succeeded to plot.</b>	\N	\N
432	432	\N	<big><i>x</i>&#8776;?</big>	\N	\N
433	433	1	Egyenlet kzelt megoldsa	\N	\N
434	433	2	Approximate solution of equation	\N	\N
435	435	1	Az <a href="http://hu.wikipedia.org/wiki/Egyenlet" target="_blank">egyenlet</a> egy kzelt megoldsa az adott intervallumon:[co]	\N	\N
436	435	2	One approximate solution of the <a href="http://en.wikipedia.org/wiki/Equation" target="_blank">equation</a> on the given interval:[co]	\N	\N
437	437	1	3D fggvnybrzols	\N	\N
438	437	2	Plotting a function in 3D	\N	\N
439	439	1	Komplex fggvnybrzols	\N	\N
440	439	2	Plotting a complex function	\N	\N
441	441	1	Jobboldali fggvnyhatrrtk	\N	\N
442	441	2	Limit of function from the right	\N	\N
443	443	1	Baloldali fggvnyhatrrtk	\N	\N
444	443	2	Limit of function from the left	\N	\N
445	445	1	A fggvny jobboldali hatrrtke:[co]	\N	\N
446	445	2	The limit of function from the right:[co]	\N	\N
447	447	1	A fggvny baloldali hatrrtke:[co]	\N	\N
448	447	2	The limit of function from the left:[co]	\N	\N
449	449	1	sszeg hatrrtke	\N	\N
450	449	2	Limit of summa	\N	\N
451	451	1	sszeg hatrrtke a vgtelenben:[co]	\N	\N
452	451	2	The limit of sum at infinity:[co]	\N	\N
453	453	1	e, matematikai konstans, rtke kb. 2.71828	\N	\N
454	453	2	e, mathematical constant, cca. 2.71828	\N	\N
455	455	1	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>dvzl a matek.hu szmelmlet rovata!</h2></center>A bal oldali szmolgpen tudsz feladatokat berni, akr az egrrel vagy billentyzeten is. A szmtsok a kkeszld gombokkal indthatk. A kalkultor tpust a bal fels gombbal vlthatod t. Ha segtsgre van szksged, <a href="segitseg" target="_blank">kattints ide</a>!</td><td valign="top" align="right"><img src="./image/lakat2.jpg" alt="Kdolsra is hasznlhat" title="Kdolsra is hasznlhat" style="position:relative;top:-10px;right:-10px;"></td></table>	\N	\N
456	456	1	Msik szmolgp betltse	\N	\N
457	456	2	Load another calculator	\N	\N
458	458	1	Nyelvvlaszts	\N	\N
459	458	2	Language selector	\N	\N
460	460	1	Ismeretlenek	\N	\N
461	460	2	Unknown variables	\N	\N
462	462	1	Trigonometriai fggvnyek	\N	\N
513	513	1	Szorzs (mtrixok elemeinek pozcinknti sszeszorzsa, nem mtrixszorzs)	\N	\N
514	513	2	Multiplication (of elements of matrices one by one, not matrix multiplication)	\N	\N
515	515	\N	<font face="Verdana, Arial, sans-serif" size="+1"><i>n</i>!</font>	\N	\N
516	516	\N	<font size="+1">/</font>	\N	\N
517	517	\N	<b>mod</b>	\N	\N
518	518	1	A megadott szm utn kvetkez <a href="http://hu.wikipedia.org/wiki/Pr%C3%ADmsz%C3%A1mok" target="_blank">prmszm</a>:[co]	\N	\N
542	542	1	Ismtlses kombincii szma:[co]	\N	\N
543	542	2	Their multiset coefficient:[co]	\N	\N
545	544	2	Number of variations (permutations):[co]	\N	\N
546	546	1	Az ismtlses permutcik szma:[co]	\N	\N
547	546	2	Number of permutations with repetition:[co]	\N	\N
548	548	1	Faktorilis (permutcik szma):[co]	\N	\N
549	548	2	Factorial (number of permutations):[co]	\N	\N
550	550	1	Fibonacci sorozat n-edik eleme	\N	\N
551	550	2	The nth element of the Fibonacci series	\N	\N
552	552	1	A <a href="http://hu.wikipedia.org/wiki/Fibonacci-sz%C3%A1mok" target="_blank">Fibonacci sorozat</a> <i>n</i>-edik eleme:[co]	\N	\N
553	552	2	The <i>n</i>th element of the <a href="http://en.wikipedia.org/wiki/Fibonacci_number" target="_blank">Fibonacci series</a>:[co]	\N	\N
554	554	1	Egsz oszts	\N	\N
555	554	2	Integer division	\N	\N
556	556	1	Egsz oszts maradka	\N	\N
557	556	2	Remainder of integer division	\N	\N
558	558	1	A hnyados egsz rsze:[co]	\N	\N
559	558	2	The <a href="http://en.wikipedia.org/wiki/Integer" target="_blank">integer</a> part of the <a href="http://en.wikipedia.org/wiki/Quotient" target="_blank">quotient</a>:[co]	\N	\N
560	560	1	Az oszts maradka:[co]	\N	\N
561	560	2	The <a href="http://en.wikipedia.org/wiki/Remainder" target="_blank">remainder</a> of the <a href="http://en.wikipedia.org/wiki/Division_%28mathematics%29" target="_blank">division</a>:[co]	\N	\N
562	562	1	Egsz ngyzetgykvons	\N	\N
563	562	2	Integer square root	\N	\N
564	564	1	Egsz n-edik gykvons	\N	\N
565	564	2	Integer nth root	\N	\N
566	566	1	2-es alap logaritmus egsz rsze	\N	\N
567	566	2	Integer part of base 2 logarithm	\N	\N
568	568	1	A <a href="http://hu.wikipedia.org/wiki/Gy%C3%B6kvon%C3%A1s" target="_blank">ngyzetgyk</a> egsz rsze:[co]	\N	\N
569	568	2	Integer part of <a href="http://en.wikipedia.org/wiki/Square_root" target="_blank">square root</a>:[co]	\N	\N
570	570	1	Az <a href="http://hu.wikipedia.org/wiki/Gy%C3%B6kvon%C3%A1s" target="_blank"><i>n</i>-edik gyk</a> egsz rsze:[co]	\N	\N
571	570	2	Integer part of <a href="http://en.wikipedia.org/wiki/Nth_root" target="_blank"><i>n</i>th root</a>:[co]	\N	\N
572	572	1	A szm 2-es alap <a href="http://hu.wikipedia.org/wiki/Logaritmus" target="_blank">logaritmus</a>nak egsz rsze:[co]	\N	\N
573	572	2	Integer part of base 2 <a href="http://en.wikipedia.org/wiki/Logarithm" target="_blank">logarithm</a> of the number:[co]	\N	\N
575	574	2	Integer part of logarithm of base b	\N	\N
576	576	1	A szm <i>b</i> alap <a href="http://hu.wikipedia.org/wiki/Logaritmus" target="_blank">logaritmus</a>nak egsz rsze:[co]	\N	\N
577	576	2	Integer part of base <i>b</i> <a href="http://en.wikipedia.org/wiki/Logarithm" target="_blank">logarithm</a> of the number:[co]	\N	\N
578	578	\N	<span style="font-weight:normal;">&#8970;log<sub><small><i>b</i></small></sub><font face="Times, serif"><i>a</i></font>&#8971;</span>	\N	\N
579	579	\N	<span style="font-size:larger;font-weight:bold;font-style:italic;"><font face="Verdana, Arial, sans-serif">A</font></span><sup>2</sup>	\N	\N
580	580	\N	<span style="font-size:larger;font-weight:bold;font-style:italic;"><font face="Verdana, Arial, sans-serif">A</font></span><sup>3</sup>	\N	\N
581	581	1	Ehhez a szmtshoz [PAR] paramtert kell megadni, vesszvel elvlasztva.	\N	\N
582	581	2	For this calculation, the number of given parameters should be [PAR], and if it is more than one, the params should be separated by commas.	\N	\N
584	584	\N	<big>[</big>	\N	\N
585	585	\N	<big>]</big>	\N	\N
586	586	\N	<big>(</big>	\N	\N
587	587	\N	<big>)</big>	\N	\N
588	588	\N	<big>.</big>	\N	\N
589	589	\N	<big>=</big>	\N	\N
590	590	\N	<big>,</big>	\N	\N
591	591	\N	<big>1</big>	\N	\N
592	592	\N	<big>2</big>	\N	\N
593	593	\N	<big>3</big>	\N	\N
594	594	\N	<big>4</big>	\N	\N
676	336	7	Echelon form (with unit leading coefficients)	\N	\N
1033	338	7	In echelon form (with unit leading coefficients):[co]	\N	\N
677	335	7	RREF	\N	\N
681	75	7	解题方式	\N	\N
682	78	7	更多的帮助	\N	\N
139	139	1	A rszletsszeg sorozat:[co]	\N	\N
143	143	1	A rszletszorzat sorozat:[co]	\N	\N
144	143	2	<a href="http://en.wikipedia.org/wiki/Infinite_product">Sequence of partial products</a>:[co]	\N	\N
145	145	1	Rszletszorzat sorozat	\N	\N
154	153	2	Derivative	\N	\N
595	595	\N	<big>5</big>	\N	\N
596	596	\N	<big>6</big>	\N	\N
597	597	\N	<big>7</big>	\N	\N
598	598	\N	<big>8</big>	\N	\N
599	599	\N	<big>9</big>	\N	\N
600	600	\N	<big>0</big>	\N	\N
601	601	1	<span style="color:blue;">nincs megolds</span>	\N	\N
602	601	2	<span style="color:blue;">there are no solutions</span>	\N	\N
603	603	1	Ehhez a szmtshoz 3 paramtert kell megadni. A paramtereket egy vessz (",") vlasztja el egymstl. Az els paramter a megoldand egyenletet tartalmazza, a msodik s a harmadik pedig kt rtk, amik annak az intervallumnak a vgpontjait hatrozzk meg, ahol a megoldst kell keresni.	\N	\N
604	603	2	You should give 3 parameters for this calculation. The parameters must be separated by a comma (","). The first parameter contains the equation to solve, the second and the third contain two values which determine the endpoints of the interval where the solution is to be sought.	\N	\N
605	605	\N	<span style="font-size:bigger;">&#8970;</span><span style="letter-spacing:-0.15em;">&#8730;</span><span style="text-decoration:overline;"><var><i>x</i></var></span><span style="font-size:bigger;">&#8971</span>	\N	\N
606	606	\N	<span style="font-size:bigger;">&#8970;</span><span style="letter-spacing:-0.15em;"><sup><var>n</var></sup>&#8730;</span><span style="text-decoration:overline;"><var><i>x</i></var></span><span style="font-size:bigger;">&#8971</span>	\N	\N
607	607	\N	<big><b><i>x</i>=?</b></big>	\N	\N
608	608	\N	<big>lg</big>	\N	\N
609	609	\N	<big>ln</big>	\N	\N
610	610	1	Egyenletmegolds	\N	\N
611	610	2	Equation solving	\N	\N
612	612	1	<span style="color:blue;">nincs definilva</span>	\N	\N
613	612	2	<span style="color:blue;">undefined</span>	\N	\N
614	614	1	<b>Hiba: nullval val oszts</b>	\N	\N
615	614	2	<b>Error: division by zero</b>	\N	\N
616	616	1	j vektor	\N	\N
617	616	2	New vector	\N	\N
618	618	1	Kilps a vektorbl	\N	\N
619	618	2	Quitting vector (1 level out)	\N	\N
620	620	1	Permutcik szma	\N	\N
621	620	2	Number of permutations	\N	\N
622	622	1	Mtrix ngyzetreemelse	\N	\N
623	622	2	Square of a matrix	\N	\N
624	624	1	Mtrix kbre emelse	\N	\N
625	624	2	Cube of a matrix	\N	\N
626	626	1	Negyedik hatvnyra emels	\N	\N
627	626	2	Raising to the 4th power	\N	\N
628	628	1	Tvolabbrl	\N	\N
629	628	2	Zoom out	\N	\N
630	630	1	Kzelebbrl	\N	\N
631	630	2	Zoom in	\N	\N
632	632	1	Forgats balra	\N	\N
633	632	2	Rotate to the left	\N	\N
684	80	7	甚么?	\N	\N
634	634	1	Forgats jobbra	\N	\N
635	634	2	Rotate to the right	\N	\N
636	636	1	Forgats fellre	\N	\N
637	636	2	Rotate to the top	\N	\N
638	638	1	Forgats alulra	\N	\N
639	638	2	Rotate to the bottom	\N	\N
640	640	1	Eltols x+	\N	\N
641	640	2	Offset x+	\N	\N
648	648	1	Hatrozott integrl	\N	\N
649	648	2	Definite integral	\N	\N
650	650	1	Behelyettests (x)	\N	\N
652	652	1	A fggvny hatrozott integrlja:[co]	\N	\N
653	652	2	The <a href="http://en.wikipedia.org/wiki/Definite_integral">definite integral</a> of the function:[co]	\N	\N
654	654	1	A kifejezs x vltozjba helyettestve:[co]	\N	\N
655	654	2	Substituting the variable x of the expression with something:[co]	\N	\N
656	656	1	Parcilis derivlt	\N	\N
657	656	2	Partial derivative	\N	\N
658	658	1	Behelyettests	\N	\N
659	658	2	Substitution	\N	\N
661	660	2	The <a href="http://en.wikipedia.org/wiki/Partial_derivative">partial derivative</a> of the function:[co]	\N	\N
666	666	1	<b>Hiba: hiba a kplet talaktsakor</b>	\N	\N
667	666	2	<b>Error: error while converting formula</b>	\N	\N
927	441	8	函數的右極限	\N	\N
928	443	8	函數的左極限	\N	\N
1568	219	9	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Víta ťa podsystém matematickej analízy portálu!</h2></center>Na kalkulárore na ľavej strane môžeš zapísať zadania pomocou myši alebo aj na klávesnici. Výpočty sa spúštajú s modrozelenými tlačidlami. Typ kalkulátora môžeš zmeniť pomocou ľavého tlačidla prvého riadku: teraz používaš modul, s ktorým sa dajú riešiť <i>základné úlohy matematickej analýzy</i>. Ak potrebuješ pomoc <a href="doc/intro_sk.html" target="_blank">klikni sem</a> alebo <a href=doc/calculus-sk.avi>pozri tento videozáznam</a>!<br><br></td><td valign="top" align="right"><img src="./image/calculus-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt="Logaritmická špirála, symbolizuje matematickú analýzu" title="Logaritmická špirála, symbolizuje matematickú analýzu" ></td></tr></table>	\N	\N
1573	257	9	Matemaická analýza	\N	\N
1211	259	9	Lineárna algebra	\N	\N
1649	263	9	Prepáč, vybratý jazyk momentálne nie je podporovaný v WMI2. Všetky oznamy budú zobrazené v jazyku anglickom alebo maďarskom. Ak ovládate týchto jazykov, prosím navrhnite preklad pôvodných textov. Vás pomoc ďakujeme!	\N	\N
1213	286	9	Invertovanie matíc	\N	\N
1214	287	9	Inverzná matica:[co]	\N	\N
1215	290	9	Determinant	\N	\N
1216	291	9	Determinant matice:[co]	\N	\N
1220	299	9	Hodnosť matice:[co]	\N	\N
1221	302	9	Adjungovaná matica	\N	\N
1222	303	9	Adjungovaná matica:[co]	\N	\N
1131	306	9	Charakteristický polynóml	\N	\N
1223	307	9	Charakteristický polymóm matice (v <i>x</i>):[co]	\N	\N
1224	310	9	Vlastné hodnoty	\N	\N
1225	311	9	Vlastné hodnoty matice v tvare [[<i>vlastné hodnoty</i>], [<i>k nim priradené multiplicity</i>]:[co]	\N	\N
1226	314	9	Vlastné vektory	\N	\N
1227	315	9	Vlastné vektory matice v tvare [[[<i>vlastné hodnoty</i>],[<i>k nim priradené multiplicity</i>]], <i>1. vlastný vektor</i>, <i>2. vlastný vektor</i>, ...]:[co]	\N	\N
1228	318	9	Násobenie matíc, skalárný násobok	\N	\N
1229	320	9	Umocnenie matíc	\N	\N
1574	336	9	Redukovaný schodový tvar (s jednotkovými hlavnými koeficientmi)	\N	\N
1575	338	9	Redukovaný schodový tvar (s jednotkovými hlavnými koeficientmi):[co]	\N	\N
1132	335	9	RST	\N	\N
1572	256	9	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Víta ťa podsystém algebry portálu!</h2></center>Na kalkulátore na ľavej strane môžeš zapísať zadania pomocou myši alebo aj na klávesnici. Výpočty sa spúštajú s modrozelenými tlačidlami. Typ kalkulátora môžeš zmeniť pomocou ľavého tlačidla prvého riadku: teraz používaš modul, s ktorým sa dajú riešiť <i>základné úlohy matematickej analýzy</i>. Ak potrebuješ pomoc <a href="doc/intro_sk.html" target="_blank">klikni sem</a>!<br><br></td><td valign="top" align="right"><img src="./image/algebra-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt="Al-Hvárizmi, autor prvej knihy o algebre (sovjetský poštový známok, 1983)" title="Al-Hvárizmi, autor prvej knihy o algebre (sovjetský poštový známok, 1983)"></td></tr></table>	\N	\N
1591	38	9	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Víta ťa podsystém lineárnej algebry portálu!</h2></center>Na kalkulátore na ľavej strane môžeš zapísať zadania pomocou myši alebo aj na klávesnici. Výpočty sa spúštajú s modrozelenými tlačidlami. Typ kalkulátora môžeš zmeniť pomocou ľavého tlačidla prvého riadku. Ak potrebuješ pomoc <a href="doc/intro_sk.html" target="_blank">klikni sem</a> alebo <a href="doc/linalg-sk.avi">pozri tento videozáznam</a>!</td><td valign="top" align="right"><img src="./image/4dcube.gif" alt="Rotujúca štvorrozmerná kocka" title="Rotujúca štvorrozmerná kocka" style="position:relative;top:-10px;right:-10px;"></td></tr></table>	\N	\N
1142	75	9	Postup riešenia...	\N	\N
1144	78	9	Ešte viac pomoci...	\N	\N
1145	79	9	Potrebujes pomoc?	\N	\N
1140	80	9	Čo je to?	\N	\N
1551	81	9	S ľavým klikom tátu formulu umiestnite do príkazového riadu	\N	\N
1147	83	9	Naozaj chceš vymazať pracovný hárok?	\N	\N
1148	84	9	Nový pracovný hárok	\N	\N
1149	85	9	Uložiť	\N	\N
1150	86	9	Tlačiť	\N	\N
1151	87	9	O WMI2	\N	\N
1164	120	9	Späť	\N	\N
1165	121	9	Znovu	\N	\N
1166	122	9	Matematika strednej školy	\N	\N
1167	123	9	Matematika základnej školy	\N	\N
1157	106	9	Druhá odmocnina	\N	\N
1158	107	9	Absolútna hodnota	\N	\N
1124	108	9	Sínus	\N	\N
1125	109	9	Kosínus	\N	\N
1126	110	9	Tangens	\N	\N
1159	111	9	Logaritmus (so základom 10)	\N	\N
1160	112	9	Zátvorky (spolu začiatok a koniec)	\N	\N
1555	113	9	Výstup z výrazu so zátvorkou	\N	\N
1556	114	9	Zjednodušenie	\N	\N
1161	115	9	Riešenie rovnice (aj komplexné korene)	\N	\N
1162	116	9	Zobrazenie funkcie	\N	\N
1557	117	9	Prvočíselná faktorizácia, rozklad na súčin	\N	\N
1163	118	9	Vyhodnotenie	\N	\N
1558	119	9	Znamienko rovnosti (v rovnici)	\N	\N
1191	185	9	V rozkladanom tvare	\N	\N
1192	186	9	Rozklad na súčet	\N	\N
1193	187	9	Zvyšok zvyškového delenia	\N	\N
1198	193	9	Reálna nezmáma	\N	\N
1563	195	9	Ďalší parameter	\N	\N
1199	196	9	Logaritmus (prírodzený)	\N	\N
1200	197	9	Logaritmus (so základom 2)	\N	\N
1201	198	9	Faktoriál	\N	\N
1202	199	9	Exponenciálna funkcia	\N	\N
1564	205	9	Horná celá časť	\N	\N
1203	206	9	Dolná celá časť	\N	\N
1565	207	9	Znamienková (signum) funkcia	\N	\N
1204	208	9	Tretia odmocnina	\N	\N
1205	209	9	Negácia	\N	\N
1128	210	9	Desiatková bodka	\N	\N
1566	211	9	Exponent normálneho tvaru	\N	\N
1206	212	9	Percento	\N	\N
1559	173	9	V zjednošenom tvare:[co]	\N	\N
1560	174	9	Približná hodnota	\N	\N
1561	175	9	Približne:[co]	\N	\N
1184	176	9	Najväčší spoločný deliteľ	\N	\N
1185	177	9	Najväčší spoločný deliteľ:[co]	\N	\N
1186	178	9	Najmenší spločný násobok	\N	\N
1187	179	9	Najmenší spločný násobok výrazov:[co]	\N	\N
1188	180	9	Rozdelenie na parciálne zlomky	\N	\N
1189	181	9	Rozklad na parciálne zlomky:[co]	\N	\N
1562	184	9	Rozdelenie na súčin (faktorizácia):[co]	\N	\N
1230	410	9	Binomiálny koeficient	\N	\N
1231	411	9	Hľadaný binomiálny koeficient:[co]	\N	\N
1232	414	9	Jednotková matica typu 2x2	\N	\N
1233	416	9	Nulová matica typu 2x2	\N	\N
1234	418	9	Matica (šablóna) typu 2x2	\N	\N
1576	420	9	Radový schodový tvar	\N	\N
1577	422	9	V radovom schodovom tvare:[co]	\N	\N
1207	222	9	Podiel a zvyšok delenia:[co]	\N	\N
1208	223	9	Delenie polyn´émov	\N	\N
1133	426	9	Chyba	\N	\N
1578	427	9	Túto stránku sme optimalizovali na Mozilla Firefox 2.0 a Internet Explorer 6/7. Pravdepodobne používaš priehľadač nepodporovaný portálom. Vopred Ti ospravedlňujeme, lebo možno niektoré funkcie nebudú správne fungovať!	\N	\N
1235	430	9	<b>Tento výraz sa nepodarilo zobraziť.</b>	\N	\N
1579	433	9	Priblížne riešenie rovnice	\N	\N
1580	435	9	Priblížne riešenie <a href="http://sk.wikipedia.org/wiki/Rovnica_%28matematika%29" target="_blank">rovnice</a> na danom intervale :[co]	\N	\N
1236	437	9	3D (trojrozmerné) zobrazenie funkcie	\N	\N
1237	439	9	Komplexné zobrazenie funkcie	\N	\N
1238	441	9	Limita funkcie z prava	\N	\N
1240	445	9	Limta funkcie z prava:[co]	\N	\N
1241	447	9	Limita funkcie z ľava:[co]	\N	\N
1242	449	9	Limita z súčtu	\N	\N
1243	451	9	Limita nekonečného súčtu:[co]	\N	\N
1244	453	9	e, matematická konštanta, cca. 2.71828	\N	\N
1292	456	9	Načítanie druhého kalkulátora	\N	\N
1245	458	9	Výber jazyka	\N	\N
1134	460	9	Neznáme premenné	\N	\N
1287	462	9	Trigonometrické funkcie	\N	\N
1246	464	9	Logaritmická funkcie	\N	\N
1247	466	9	Funkcie exponenciálnej veľkosti	\N	\N
1582	468	9	Jednoduché odmocniny a mocniny	\N	\N
1248	470	9	Reálne premenné	\N	\N
1249	472	9	Celé premenné	\N	\N
2589	124	4	&Aacute;tv&aacute;lt&aacute;s ins Ungarische	\N	\N
1250	474	9	Limity	\N	\N
1135	476	9	Konštanty	\N	\N
1251	478	9	Nulová matica	\N	\N
1252	480	9	Jednotková matica	\N	\N
1253	482	9	Nová matica	\N	\N
1254	484	9	Zobrazenie funkcie, riešenie rovníc	\N	\N
1583	486	9	K tomuto výpočtu treba zadať dvoch parametrov. Parametre oddeluje čiarka  (",").	\N	\N
1584	488	9	K tomuto výpočtu treba zadať iba jeden parameter. Teda nesmie sa používať  čiarku  (",").	\N	\N
1255	491	9	<span style="color:blue;">nie je definované (nemá zmysel, neexistuje)</span>	\N	\N
1136	493	9	<span style="color:blue;">nepravda</span>	\N	\N
1137	495	9	<span style="color:blue;">pravda</span>	\N	\N
1256	497	9	Teória čísel	\N	\N
1581	455	9	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Víta ťa podsystém teórie čísel portálu!</h2></center>Na kalkulátore na ľavej strane môžeš zapísať zadania pomocou myši alebo aj na klávesnici. Výpočty sa spúštajú s modrozelenými tlačidlami. Typ kalkulátora môžeš zmeniť pomocou ľavého tlačidla prvého riadku. Ak potrebuješ pomoc <a href="doc/intro_sk.html" target="_blank">klikni sem</a>!</td><td valign="top" align="right"><img src="./image/lakat2.jpg" alt="Používa sa aj na kódovanie" title="Používa sa aj na kódovanie" style="position:relative;top:-10px;right:-10px;"></td></table>	\N	\N
1257	500	9	To, že číslo je <a href="http://sk.wikipedia.org/wiki/Prvo%C4%8D%C3%ADslo" target="_blank">prvočíslo</a>:[co]	\N	\N
1263	511	9	Prosím podporte WMI2! Ďakujeme!	\N	\N
1264	513	9	Násobenie (násobenie prvkov matice s tou istou polohou v matici, nie je to násobenie matíc)	\N	\N
1586	518	9	Najmenšie <a href="http://sk.wikipedia.org/wiki/Prvo%C4%8D%C3%ADslo" target="_blank">prvočíslo</a> väčšie ako dané číslo:[co]	\N	\N
1587	520	9	Najväčšie <a href="http://sk.wikipedia.org/wiki/Prvo%C4%8D%C3%ADslo" target="_blank">prvočíslo</a> menšie ako dané číslo:[co]	\N	\N
1265	522	9	Počet nesúdelných čísel, ktoré sú menšie ako dané číslo. 	\N	\N
1266	524	9	Súčet <a href="http://sk.wikipedia.org/wiki/Delite%C4%BE" target="_blank">deliteľov</a> daného čísla:[co]	\N	\N
1288	526	9	Počet menších nesúdeliteľných čísel	\N	\N
1289	528	9	Súčet deliteľov	\N	\N
1588	530	9	Nasledujúce prvočíslo	\N	\N
1589	532	9	Prechádzajúce prvočíslo	\N	\N
1267	534	9	Je toto číslo prvočíslo?	\N	\N
1268	536	9	Počet opakovaných pernutácií	\N	\N
1269	538	9	Multiset koeficient (počet opakovaných kombinácií)	\N	\N
1270	540	9	Počet variancií (permutácií)	\N	\N
1271	542	9	Multiset koeficient (počet opakovaných kombinácií):[co]	\N	\N
1272	544	9	Počet variancií (permutácií):[co]	\N	\N
1273	546	9	Počet opakovaných pernutácií:[co]	\N	\N
1274	548	9	Faktoriál (počet permutácií):[co]	\N	\N
1138	550	9	n-tý člen Fibonacciho postupnosti	\N	\N
1139	552	9	<i>n</i>-tý člen <a href="http://sk.wikipedia.org/wiki/Fibonacciho_postupnos%C5%A5" target="_blank">Fibonacciho postupnosti</a> :[co]	\N	\N
1275	554	9	Celočíselné delenie	\N	\N
1276	556	9	Zvyšok celočíselného delenia	\N	\N
1277	558	9	<a href="http://sk.wikipedia.org/wiki/Cel%C3%A9_%C4%8D%C3%ADslo" target="_blank">Celá</a> časť podielu:[co]	\N	\N
1278	560	9	Zvyšok delenia:[co]	\N	\N
1279	562	9	Celá druhá odmocnina	\N	\N
1280	564	9	Celá n-tá odmocnina	\N	\N
1281	566	9	Celá časť logaritmu so základom 2	\N	\N
1282	568	9	Celá časť <a href="http://sk.wikipedia.org/wiki/Odmocnina" target="_blank">druhej odmocniny</a>:[co]	\N	\N
1283	570	9	Celá časť <a href="http://sk.wikipedia.org/wiki/Odmocnina" target="_blank"><i>n</i>-tej odmocniny</a>:[co]	\N	\N
1284	572	9	Celá časť <a href="http://sk.wikipedia.org/wiki/Logaritmus" target="_blank">logaritmu</a> so základom 2 daného čísla:[co]	\N	\N
1285	574	9	Celá časť logaritmu so základom b	\N	\N
1286	576	9	Celá časť <a href="http://sk.wikipedia.org/wiki/Logaritmus" target="_blank">logaritmu</a> so základom <i>b</i> daného čísla:[co]	\N	\N
1590	581	9	K tomuto výpočtu [PAR] treba zadať parameter, oddelene s čiarkou.	\N	\N
1293	601	9	<span style="color:blue;">nemá riešenie</span>	\N	\N
1593	603	9	K tomuto výpočtu treba zadať 3 parametre. Parametov oddeluje čiarka  (","). Prvý parameter je rovnica, ktorú chceme vypočítať, druhý a tretí sú také hodnoty, ktoré určujú začiatok a koniec intervalu, kde hľadáme riešenie.	\N	\N
1294	610	9	Riešenie rovnice	\N	\N
1295	612	9	<span style="color:blue;">nie je definované</span>	\N	\N
1296	614	9	<b>Chyba: delenie s nulou</b>	\N	\N
1297	616	9	Nový vektor	\N	\N
1298	618	9	Výstup z vektoru	\N	\N
1299	620	9	Počet permutácií	\N	\N
1300	622	9	Umocnenie matice na druhú	\N	\N
1301	624	9	Umocnenie matice na tretiu	\N	\N
1302	626	9	Umocnenie na štvrtú	\N	\N
1219	298	9	Hodnosť matice	\N	\N
1259	72	9	Požiadať pomoc v blízkosti %s...	\N	\N
1260	73	9	Detailné riešenie...	\N	\N
1261	74	9	Viac pomoci...	\N	\N
1146	82	9	Zavrieť	\N	\N
1638	662	9	Substitúcia do výrazu:[co]	\N	\N
2573	664	9	<b>Chyba: delenie s nulou</b>	\N	\N
1190	182	9	<b>Prepáč, obrázok by bol príliš veľký.</b>	\N	\N
1309	642	9	Eltolás x-	\N	\N
1310	644	9	Eltolás y+	\N	\N
1311	646	9	Eltolás y-	\N	\N
1639	650	9	Substitúcia (x)	\N	\N
1171	143	9	Postupnosť čiastkových súčinov:[co]	\N	\N
1176	153	9	Derivácia	\N	\N
1595	10	9	Výraz:[ui]	\N	\N
1643	34	9	<html><head></head><body>Je to stvorec, jeho faktorizácia je:<br /></body></html>	\N	\N
1644	36	9	<html><head></head><body><div align="center"><strong>Test layout for the CADGDM conference</strong><br /></div></body></html>	\N	\N
1645	37	9	<html><head></head><body>Áno...</body></html>	\N	\N
1646	40	9	<html><head></head><body>To je 2. testová vrstva.<br /></body></html>	\N	\N
1647	3	9	<html><head></head><body><p>	\N	\N
1258	4	9	Výraz zadania:[ui]	\N	\N
1290	8	9	Hodnota výrazu je:[co]	\N	\N
1291	6	9	Riešenie <a href="http://sk.wikipedia.org/wiki/Rovnica_%28matematika%29" target="_blank">rovnice</a> je :[co]	\N	\N
1592	54	9	Vymazanie vstupného poľa kalkulátora	\N	\N
1569	59	9	WMI2 je dočasne nedostupný.<br>Prosím navštívte nás neskoršie!	\N	\N
1549	60	9	Momentálne stlačené tlačidlo nie je možné použiť.\nVýrazy na stránke treba zadávať so zvyčajným\nspôsobom z ľava do prava ako v kalkulačkách,\nalebo pri rukopise.\nAk si zasekol, tak stlač tlačidlo CE alebo načítaj znovu stránku.\n\nStránka matek.hu je ešte v štádiu vývoja.\nAk chceš pomôcť vo vývoji, tak prosíme\nnavštívte stránku http://wmi.sf.net/2/bugs.\n	\N	\N
1141	61	9	Ako vyšiel tento výsledok? Pýtaj pomoc v okolí mesta %s \n	\N	\N
1550	62	9	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Ahoj, vítame ťa!</h2></center>Stránka matek.hu je nová a nie len vo zvhľade ale aj v vo svojích pricípoch. Samozrejme aj <a href="http://matek.hu/1" target="_blank">stará verzia</a> je dostupná. Na kalkulátore na ľavej strane môžeš zapísať zadania pomocou myši alebo aj na klávesnici. Výpočty sa spúštajú s modrozelenými tlačidlami. Typ kalkulátora môžeš zmeniť pomocou ľavého tlačidla prvého riadku: teraz používaš taký typ, s ktorým sa dajú riešiť <i>stredoškolské úlohy</i>. Ak potrebuješ pomoc <a href="doc/intro_sk.html" target="_blank">klikni sem</a> (<a href="doc/intro_sk.pdf">PDF</a>) alebo <a href="doc/normal-sk.avi">pozri tento záznam</a>!<br><br></td><td valign="top" align="right"><img src="./image/normal-pres.png" style="position:relative;top:-10px;right:-10px;" alt=""></td></tr></table>	\N	\N
1129	63	9	Pracovný hárok je možné uložiť	\N	\N
1585	69	9	Jazyk je nastavený na %s. Je potrebné znovunačítanie stránky.	\N	\N
1123	90	9	<b>matek.hu <small>BETA</small></b>	\N	\N
1153	91	9	Copyright &copy; 2006-2007 Partíció BT.<br> Kovács Z., Vajda R., Fekete Á., Bakos G., Csernai K.	\N	\N
1552	92	9	Portál podporovaný s WebMathematics Interactive %s .<br> Copyright &copy; 2002-2007 Segedínska Univerzita<br>	\N	\N
1553	93	9	Databáza podporovaná s Wekker RAD Engine<br> Copyright &copy; 2005-2007 Consol Kft.<br>	\N	\N
1154	94	9	Grafická podpora: Gnome<br> Logó copyright &copy; 2003 Kovács Zsigmond<br> Farebná zostava: Deák Zsuzsa<br> <span style="font-size:smaller;">4D animácia kocky &copy; Oliver Knill, Harvardská Univerzita<br> Punk dievča logo &copy; www.sykospark.net<br> Foto špirály &copy; Wikipedia, Chris 73<br> Logo teórie čísel &copy; Medve Zoltán</span>	\N	\N
1155	95	9	Ďalšie podsystémy:<br> GNU Linux/Apache/PostgreSQL/PHP, gnuplot/Maxima, TeX/LaTeX/ImageMagick, formconv/TeXmacs, GeoLite (http://www.maxmind.com)	\N	\N
1554	96	9	Team vývojárov je dostupný na <b><a style="color: #ffffff; text-decoration: none;" href="mailto:info@matek.hu">info@matek.hu</a></b> emailovej adrese.	\N	\N
1156	97	9	Nahlásenie porúch prijímame na <br> <b><a style="color: #ffffff; text-decoration: none;" href="http://wmi.sf.net/2/bugs" target="_blank">http://wmi.sf.net/2/bugs</a></b><br> webovej adrese, ďakujeme!	\N	\N
1648	125	9	Zmena jazyka na slovenčinu	\N	\N
1152	88	9	Graf funkcie:	\N	\N
1170	141	9	Postupnosť čiastočného súčtu radu	\N	\N
1212	272	9	Databáza učitelov	\N	\N
1169	139	9	<a href="http://sk.wikipedia.org/wiki/Rad_%28matematika%29" target="_blank">Postupnosť čiastočného súčtu radu</a>:[co]	\N	\N
1172	145	9	Postupnosť čiastočného súčinu radu	\N	\N
1173	147	9	<a href="http://sk.wikipedia.org/wiki/Limita" target="_blank">Limita postupnosti</a>:[co]	\N	\N
1174	149	9	Limita postupnosti	\N	\N
1175	151	9	Neurčitý integrál	\N	\N
1177	155	9	<a href="http://sk.wikipedia.org/wiki/Integr%C3%A1l#Neur.C4.8Dit.C3.BD_integr.C3.A1l" target="_blank">Neurčený integrál funkcie</a>:[co]	\N	\N
1178	157	9	<a href="http://sk.wikipedia.org/wiki/Deriv%C3%A1cia" target="_blank">Derivácia funkcie</a>:[co]	\N	\N
1179	159	9	Limita funkcie	\N	\N
1180	161	9	<a href="http://sk.wikipedia.org/wiki/Limita#Limita_funkcie" target="_blank">Limita funkcie</a>:[co]	\N	\N
1181	164	9	Taylorov rad funkcie:[co]	\N	\N
1127	166	9	Taylorov rad	\N	\N
1182	169	9	<font color="black"><b>Nesprávne definovaná úloha, prosíme <a href="doc/intro_sk.html" target="_blank">pýtaj pomoc</a> ak je potrebné.</b></font>	\N	\N
1183	171	9	<b>Prepáč, príliš ťažká úloha.</b>	\N	\N
1341	217	10	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Matematika může být snadná!</h2></center>Začněte zapisovat zadání pomocí klávesnice nebo myši na kalkulátoru na levé straně. Výpočty se spouštějí modrozelenými tlačítky. Typ kalkulátoru můžete změnit pomocí levého tlačítka v prvním řádku.</td><td valign="top" align="right"><img src="./image/easy-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt=""></td></tr></table>	\N	\N
1342	219	10	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Analýza může být snadná!</h2></center>Začněte zapisovat zadání pomocí klávesnice nebo myši na kalkulátoru na levé straně. Výpočty se spouštějí modrozelenými tlačítky.Typ kalkulátoru můžete změnit pomocí levého tlačítka v prvním řádku. <a href=doc/calculus.avi>Demonstrační videozáznam</a> je rovněž k dispozici.</td><td valign="top" align="right"><img src="./image/calculus-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt="Logarithmic spiral, symbol of calculus" title="Logarithmic spiral, symbol of calculus"></td></tr></table>	\N	\N
1343	226	10	<b>Zadaný vzorec nemůže být zpracován, promiňte.</b>	\N	\N
1344	254	10	Vývojáři	\N	\N
1345	257	10	Analýza	\N	\N
1346	259	10	Lineární algebra	\N	\N
1347	263	10	Promiňte, vybraný jazyk není dosud ve WMI2 podporován. Všechna hlášení budou zobrazena v maďarštině nebo v angličtině. Jste-li rodilým mluvčím zvoleného jazyka, zvažte prosím možnost ohledně přispění k překladu originálních textů. Vaše pomoc je vítána!	\N	\N
1349	286	10	Inverzní matice	\N	\N
1350	287	10	<a href="http://en.wikipedia.org/wiki/Invertible_matrix" target="_blank">Inverzní matice</a>:[co]	\N	\N
1351	290	10	Determinant	\N	\N
1352	291	10	<a href="http://en.wikipedia.org/wiki/Determinant" target="_blank">Determinant matice</a>:[co]	\N	\N
1356	299	10	<a href="http://en.wikipedia.org/wiki/Rank_(linear_algebra)" target="_blank">Hodnost matice</a>:[co]	\N	\N
1357	302	10	Adjungovaná matice	\N	\N
1358	303	10	<a href="http://en.wikipedia.org/wiki/Adjugate_matrix" target="_blank">Adjungovaná matice</a>:[co]	\N	\N
1359	306	10	Charakteristický polynom	\N	\N
1360	307	10	<a href="http://en.wikipedia.org/wiki/Characteristic_polynomial" target="_blank">Charakteristický polynom matice (vzhledem k <i>x</i>)</a>:[co]	\N	\N
1361	310	10	Vlastní čísla	\N	\N
1362	311	10	<a href="http://en.wikipedia.org/wiki/Eigenvalue%2C_eigenvector_and_eigenspace#Eigenvalues_and_eigenvectors_of_matrices" target="_blank">Vlastní čísla matice</a> ve tvaru [[<i>vlastní čísla</i>], [<i>jejich násobnosti</i>]]:[co]	\N	\N
1363	314	10	Vlastní vektory	\N	\N
1364	315	10	<a href="http://en.wikipedia.org/wiki/Eigenvalue%2C_eigenvector_and_eigenspace#Eigenvalues_and_eigenvectors_of_matrices" target="_blank">Vlastní vektory matice</a> ve tvaru [[[<i>vlastní čísla</i>], [<i>jejich násobnosti</i>]], <i>1.  vlastní vektor</i>, <i>2. vlastní vektor</i>, ...]:[co]	\N	\N
1365	318	10	Násobení matic, skalární násobek	\N	\N
1366	320	10	Mocnina matice	\N	\N
1367	336	10	Schodovitý tvar (s jednotkovými vedoucími koeficienty)	\N	\N
1368	338	10	Ve schodovitém tvaru (s jednotkovými vedoucími koeficienty):[co]	\N	\N
1369	335	10	RREF	\N	\N
1370	256	10	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Vítejte v oddílu Algebry!</h2></center>Začněte zapisovat zadání pomocí klávesnice nebo myši na kalkulátoru na levé straně. Výpočty se spouštějí modrozelenými tlačítky. Typ kalkulátoru můžete změnit pomocí levého tlačítka v prvním řádku.</td><td valign="top" align="right"><img src="./image/algebra-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt="Al Khwarizmi, author of the first algebra book (stamp from the Soviet Union, 1983)" title="Al Khwarizmi, author of the first algebra book (Russian stamp, 1983)"></td></tr></table>	\N	\N
1371	38	10	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Vitejte v podsystému Lineární algebry!</h2></center>Začněte zapisovat zadání pomocí klávesnice nebo myši na kalkulátoru na levé straně. Výpočty se spouštějí modrozelenými tlačítky. Typ kalkulátoru můžete změnit pomocí levého tlačítka v prvním řádku. Pro získání bližší představy, jak zadávat úlohu, <a href=doc/linalg.avi>zhlédněte tento videozáznam</a>.</td><td valign="top" align="right"><img src="./image/4dcube.gif" alt="Rotating cube in 4 dimensions" title="Rotating cube in 4 dimensions" style="position:relative;top:-10px;right:-10px;"></td></tr></table>	\N	\N
1375	75	10	Postup řešení...	\N	\N
1376	78	10	Ještě další pomoc...	\N	\N
1377	79	10	Potřeba pomoci?	\N	\N
1378	80	10	Co je to?	\N	\N
1379	81	10	Kliknutím levého tlačítka  bude tento vzorec vložen do vstupního pole	\N	\N
1381	83	10	Jste si jisti, že chcete vymazat pracovní stránku?	\N	\N
1382	84	10	Nová pracovní stránka	\N	\N
1383	85	10	Uložit	\N	\N
1384	86	10	Tisk	\N	\N
1385	87	10	O WMI2	\N	\N
1386	120	10	Zpět	\N	\N
1454	121	10	Znovu	\N	\N
1387	122	10	Středoškolská matematika	\N	\N
1388	123	10	Matematika základní školy	\N	\N
1389	106	10	Druhá odmocnina	\N	\N
1390	107	10	Absolutní hodnota	\N	\N
1391	108	10	Sinus	\N	\N
1392	109	10	Kosinus	\N	\N
1393	110	10	Tangens	\N	\N
1394	111	10	Dekadický logaritmus 	\N	\N
1395	112	10	Závorky (jak začátek tak konec, 1 úroveň dovnitř)	\N	\N
1396	113	10	Výstup z výrazu se závorkou (1 úroveň ven)	\N	\N
1397	114	10	Zjednodušení	\N	\N
1398	115	10	Řesení rovnice v komplexním oboru	\N	\N
1399	116	10	Zobrazení funkce	\N	\N
1400	117	10	Faktorizace, rozklad v součin	\N	\N
1401	118	10	Vyčíslení	\N	\N
1402	119	10	Znaménko rovnosti (v rovnici)	\N	\N
1403	185	10	V rozšířeném tvaru:[co]	\N	\N
1404	186	10	Roznásobení	\N	\N
1405	187	10	Zbytek dělení	\N	\N
1406	188	10	Pi, matematická konstanta, přibližně 3,14159	\N	\N
1407	189	10	Mocnina	\N	\N
1408	190	10	Druhá mocnina	\N	\N
1409	191	10	Třetí mocnina	\N	\N
1410	193	10	Reálná proměnná	\N	\N
1411	195	10	Další parametr	\N	\N
1412	196	10	Přirozený logaritmus 	\N	\N
1413	197	10	Logaritmus (se základem 2)	\N	\N
1414	198	10	Faktoriál	\N	\N
1415	199	10	Exponenciální funkce	\N	\N
1416	205	10	Horní celá část	\N	\N
1417	206	10	Dolní celá část	\N	\N
1418	207	10	Znaménková (signum) funkce	\N	\N
1419	208	10	Třetí odmocnina 	\N	\N
1420	209	10	Negace	\N	\N
1421	210	10	Desetinná tečka	\N	\N
1422	211	10	Exponent normálního tvaru	\N	\N
1423	212	10	Procento	\N	\N
1424	173	10	Ve zjednodušeném tvaru:[co]	\N	\N
1425	174	10	Přibližně	\N	\N
1426	175	10	Přibližně:[co]	\N	\N
1427	176	10	Největší společný dělitel	\N	\N
1428	177	10	<a href="http://en.wikipedia.org/wiki/Greatest_common_divisor" target="_blank">Největší společný dělitel výrazů</a>:[co]	\N	\N
1429	178	10	Nejmenší společný násobek	\N	\N
1430	179	10	<a href="http://en.wikipedia.org/wiki/Least_common_multiple", target="_blank">Nejmenší společný násobek výrazů</a>:[co]	\N	\N
1431	180	10	Rozklad na parciální zlomky	\N	\N
1432	181	10	Rozklad na <a href="http://en.wikipedia.org/wiki/Partial_fraction" target="_blank">parciální zlomky</a>:[co]	\N	\N
1433	184	10	<a href="http://en.wikipedia.org/wiki/Factorization" target="_blank">Faktorizace (rozklad v součin)</a>:[co]	\N	\N
1434	410	10	Binomický koeficient	\N	\N
1435	411	10	<a href="http://en.wikipedia.org/wiki/Binomial_coefficient" target="_blank">Binomický koeficient</a>:[co]	\N	\N
1436	414	10	Jednotková matice typu 2x2	\N	\N
1437	416	10	Nulová matice typu 2x2	\N	\N
1438	418	10	Matice typu 2x2 (vzor)	\N	\N
1439	420	10	Schodovitý tvar	\N	\N
1440	422	10	Ve <a href=http://en.wikipedia.org/wiki/Row_echelon_form>schodovitém tvaru</a>:[co]	\N	\N
1441	222	10	Podíl a zbytek při dělení:[co]	\N	\N
1442	223	10	Dělení polynomů	\N	\N
1443	426	10	Chyba	\N	\N
1444	427	10	Tato webová stránka je optimalizována pro Mozilla Firefox 2.0 a Internet Explorer 6/7. Pravděpodobně používáte prohlížeč ne plně podporovaný portálem matek.hu. Buďte prosím připraveni, že se setkáte s problémy. Za Vaše potíže se omlouváme!	\N	\N
1445	430	10	<b>Tento výraz se nepodařilo zobrazit.</b>	\N	\N
1446	433	10	Přibližné řešení rovnice	\N	\N
1447	435	10	Přibližné řešení <a href="http://en.wikipedia.org/wiki/Equation" target="_blank">rovnice</a> na daném intervalu:[co]	\N	\N
1448	437	10	3D (trojrozměrné) zobrazení funkce	\N	\N
1449	439	10	Zobrazení komplexní funkce	\N	\N
1450	441	10	Limita funkce zprava	\N	\N
1451	443	10	Limita funkce zleva	\N	\N
1452	445	10	Limita funkce zprava:[co]	\N	\N
1453	447	10	Limita funkce zleva:[co]	\N	\N
1455	449	10	Součet řady	\N	\N
1456	451	10	Součet nekonečné řady:[co]	\N	\N
1457	453	10	e, matematická konstanta, přibližně 2.71828	\N	\N
1458	456	10	Načtení dalšího kalkulátoru	\N	\N
1459	458	10	Výběr jazyka	\N	\N
1460	460	10	Neznámé proměnné	\N	\N
1461	462	10	Trigonometrické funkce	\N	\N
1462	464	10	Logaritmické funkce	\N	\N
1463	466	10	Exponenciální funkce	\N	\N
1464	468	10	Jednoduché odmocniny a mocniny	\N	\N
1465	470	10	Reálné proměnné	\N	\N
1466	472	10	Celočíselné proměnné	\N	\N
1467	474	10	Limity	\N	\N
1468	476	10	Konstanty	\N	\N
1469	478	10	Nulová matice	\N	\N
1470	480	10	Jednotková matice	\N	\N
1471	482	10	Nová matice	\N	\N
1472	484	10	Zobrazení funkce, řešení rovnic	\N	\N
1473	486	10	Pro tento výpočet byste měli zadat 2 parametry. Parametry musí být odděleny čárkou (",").	\N	\N
1477	495	10	<span style="color:blue;"> pravda</span>	\N	\N
1478	497	10	Teorie čísel	\N	\N
1479	455	10	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Vítejte v oddílu Teorie čísel!</h2></center>Začněte zapisovat zadání pomocí klávesnice nebo myši na kalkulátoru na levé straně. Výpočty se spouštějí modrozelenými tlačítky. Typ kalkulátoru můžete změnit pomocí levého tlačítka v prvním řádku.</td><td valign="top" align="right"><img src="./image/lakat2.jpg" alt="Can be used for encryption" title="Can be used for encryption" style="position:relative;top:-10px;right:-10px;"></td></table>	\N	\N
1480	500	10	Výrok, že dané číslo je <a href="http://en.wikipedia.org/wiki/Prime_number" target="_blank">prvočíslo</a> je:[co]	\N	\N
1482	511	10	Podpořte prosím WMI2! Děkujeme!	\N	\N
1483	513	10	Násobení (prvků matice stejnou polohou v matici, není násobení matic)	\N	\N
1484	518	10	Nejmenší <a href="http://en.wikipedia.org/wiki/Prime_number" target="_blank">prvočíslo</a> které je větší než dané číslo:[co]	\N	\N
1485	520	10	Největší <a href="http://en.wikipedia.org/wiki/Prime_number" target="_blank">prvočíslo</a> které je menší než dané číslo:[co]	\N	\N
1486	522	10	Počet <a href="http://en.wikipedia.org/wiki/Coprime" target="_blank">nesoudělných čísel</a> menších než dané číslo:[co]	\N	\N
1487	524	10	Součet <a href="http://en.wikipedia.org/wiki/Divisor" target="_blank">dělitelů</a> daného čísla:[co]	\N	\N
1488	526	10	Počet menších nesoudělných čísel  	\N	\N
1489	528	10	Součet dělitelů	\N	\N
1490	530	10	Následující prvočíslo	\N	\N
1491	532	10	Předchozí prvočíslo	\N	\N
1492	534	10	Je číslo prvočíslo?	\N	\N
1493	536	10	Počet permutací s opakováním	\N	\N
1494	538	10	Počet kombinací s opakováním	\N	\N
1495	540	10	Počet variací (permutací)	\N	\N
1496	542	10	Počet kombinací s opakováním:[co]	\N	\N
1497	544	10	Počet variací (permutací):[co]	\N	\N
1498	546	10	Počet permutací s opakováním:[co]	\N	\N
1499	548	10	Faktoriál (počet permutací):[co]	\N	\N
1500	550	10	N-tý člen Fibonacciho posloupnosti	\N	\N
1501	552	10	<i>n</i>-tý člen <a href="http://en.wikipedia.org/wiki/Fibonacci_number" target="_blank">Fibonacciho posloupnosti</a>:[co]	\N	\N
1502	554	10	Celočíselné dělení	\N	\N
1503	556	10	Zbytek celočíselného dělení	\N	\N
1504	558	10	 <a href="http://en.wikipedia.org/wiki/Integer" target="_blank">celá</a> část <a href="http://en.wikipedia.org/wiki/Quotient" target="_blank">podílu</a>:[co]	\N	\N
1505	560	10	 <a href="http://en.wikipedia.org/wiki/Remainder" target="_blank">zbytek</a> při <a href="http://en.wikipedia.org/wiki/Division_%28mathematics%29" target="_blank">dělení</a>:[co]	\N	\N
1506	562	10	Celá druhá odmocnina	\N	\N
1507	564	10	Celá n-tá odmocnina	\N	\N
1508	566	10	Celá část logaritmu se základem 2	\N	\N
1509	568	10	Celá část <a href="http://en.wikipedia.org/wiki/Square_root" target="_blank">druhé odmocniny</a>:[co]	\N	\N
1510	570	10	Celá část <a href="http://en.wikipedia.org/wiki/Nth_root" target="_blank"><i>n</i>-té odmocniny</a>:[co]	\N	\N
1511	572	10	Celá část <a href="http://en.wikipedia.org/wiki/Logarithm" target="_blank">logaritmu se základem 2</a> daného čísla:[co]	\N	\N
1512	574	10	Celá část logaritmu se základem b	\N	\N
1513	576	10	Celá část <a href="http://en.wikipedia.org/wiki/Logarithm" target="_blank">logaritmu</a> se základem <i>b</i> daného čísla:[co]	\N	\N
1514	581	10	Pro tento výpočet by měl být počet daných parametrů [PAR] a pokud je jich více než jeden, měly by být parametry odděleny čárkami.	\N	\N
1529	601	10	<span style="color:blue;">neexistuje řešení</span>	\N	\N
1515	603	10	Pro tento výpočet byste měli zadat 3 parametry. Parametry musí být odděleny čárkou (","). První parametr obsahuje rovnici, kterou chceme řešit; druhý a třetí obsahují dvě hodnoty, které určují začátek a konec intervalu, v němž hledáme řešení.	\N	\N
1530	610	10	Řešení rovnice	\N	\N
1531	612	10	<span style="color:blue;">není definován</span>	\N	\N
1532	614	10	<b>Chyba: dělení nulou</b>	\N	\N
1533	616	10	Nový vektor	\N	\N
1534	618	10	Ukončení vektoru (1 úroveň ven)	\N	\N
1535	620	10	Počet permutací	\N	\N
1536	622	10	Druhá mocnina matice	\N	\N
1537	624	10	Třetí mocnina matice	\N	\N
1538	626	10	Umocnění na čtvrtou	\N	\N
1539	628	10	Vzdálit, zoom out	\N	\N
1540	630	10	Přiblížit, zoom in	\N	\N
1541	632	10	Otočení doleva	\N	\N
1542	634	10	Otočení doprava	\N	\N
1543	636	10	Otočení nahoru	\N	\N
1545	640	10	Posunutí x+	\N	\N
1632	648	10	Určitý integrál	\N	\N
1633	652	10	<a href="http://en.wikipedia.org/wiki/Definite_integral"> Určitý integrál</a> funkce:[co]	\N	\N
1634	654	10	Nahrazením proměnné x ve výrazu:[co]	\N	\N
1627	656	10	Parciální derivace	\N	\N
1628	658	10	Substituce	\N	\N
1629	660	10	<a href="http://en.wikipedia.org/wiki/Partial_derivative"> Parciální derivace</a> funkce:[co]	\N	\N
1354	295	10	<a href="http://en.wikipedia.org/wiki/Transpose" target="_blank">Transponovaná matice</a>:[co]	\N	\N
1372	72	10	O pomoc požádejte blízko %s...	\N	\N
1373	73	10	Podrobné řešení...	\N	\N
1374	74	10	Další pomoc... 	\N	\N
1630	662	10	Nahrazením do výrazu:[co]	\N	\N
2575	664	10	<b>Chyba: dělení nulou</b>	\N	\N
1340	182	10	<b>Obrázek by byl příliš veliký, promiňte.</b>	\N	\N
1546	642	10	Posunutí x-	\N	\N
1547	644	10	Posunutí y+	\N	\N
1548	646	10	Posunutí y-	\N	\N
1631	650	10	Substituce (x)	\N	\N
1326	143	10	<a href="http://en.wikipedia.org/wiki/Infinite_product">Posloupnost  částečných součinů</a>:[co]	\N	\N
1331	153	10	Derivace	\N	\N
1516	10	10	Vzorec:[ui]	\N	\N
1517	34	10	<html><head></head><body>Jeho druhá mocnina, rozložená v součin je:<br /></body></html>	\N	\N
1518	36	10	<html><head></head><body><div align="center"><strong>Testovací dispozice na konferenci CADGDM</strong><br /></div></body></html>	\N	\N
1519	37	10	<html><head></head><body>Ano...</body></html>	\N	\N
1520	40	10	<html><head></head><body>Toto je test2 dispozice.<br /></body></html>	\N	\N
1521	3	10	<html><head></head><body><p>	\N	\N
1522	4	10	Vzorec zadání:[ui]	\N	\N
1523	8	10	Hodnota výrazu je:[co]	\N	\N
1524	6	10	Řešení <a href="http://en.wikipedia.org/wiki/Equation" target="_blank">rovnice</a> je:[co]	\N	\N
1525	54	10	Vymazání vstupního pole	\N	\N
1526	59	10	WMI2 je dočasně mimo provoz.<br>Navštivte nás prosím později.	\N	\N
1527	60	10	Právě jste zmáčknuli nesprávnou klávesu.\nVzorec by měl být zadán jako na kalkulačkách,\nzleva doprava, stejně jako při ručním psaní výrazů.\n\nNevíte-li, co nyní dělat, zkuste resetovat \nkalkulátor a restartovat svou práci tlačítkem 'ce'.\n\nJestliže si myslíte, že jste při práci s WMI2 narazili na programovou chybu,\nzkuste prosím tuto stránku znovu natáhnout a navštivte naše místo pro sledování chyb\nna http://wmi.sf.net/2/bugs abyste tuto chybu nahlásili, děkujeme.\n	\N	\N
1528	61	10	Pomoc získáte blízko %s \n	\N	\N
1312	62	10	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Vítejte ve WMI2!</h2></center>Tato webová stránka je novou verzí <a href="http://matek.hu/1">WMI</a>. Slouží studentům, kteří hledají matematická řešení. Máte-li 14-21 let, začněte zapisovat zadání pomocí klávesnice nebo myši na kalkulátoru na levé straně. Výpočty se spouštějí modrozelenými tlačítky. Typ kalkulátoru můžete změnit pomocí levého tlačítka v prvním řádku.<br><br>Můžete si přečíst <a href="doc/intro_en.html" target=_blank>dokumentaci</a> (<a href="doc/intro_en.pdf" target=_blank>PDF</a>) nebo <a href="doc/developers_en.html"> vývojářské jak na to</a> (<a href="doc/developers_en.pdf" target=_blank>PDF</a>). Nebo <a href="doc/normal.avi" target=_blank>si prohlédněte tento videozáznam</a>.<br><br></td><td valign="top" align="right"><img src="./image/normal-pres.png" style="position:relative;top:-10px;right:-10px;" alt=""></td></tr></table>	\N	\N
1313	63	10	Pracovní stránka může být nyní uložena.	\N	\N
1481	69	10	Jazyk je nastaven na  %s. Doporučujeme nyní znovu načíst stránku.	\N	\N
1315	90	10	<b>matek.hu <small>BETA</small></b>	\N	\N
1316	91	10	Copyright &copy; 2006-2007 Particio BT.<br> Z. Kovacs, R. Vajda, A. Fekete, G. Bakos, K. Csernai	\N	\N
1317	92	10	Portál podporovaný WebMathematics Interactive %s<br> Copyright &copy; 2002-2007 Univerzita Szeged<br>	\N	\N
1318	93	10	Databáze podporovaná Wekker RAD Engine<br> Copyright &copy; 2005-2007 Consol Kft.<br>	\N	\N
1319	94	10	Grafická podpora Gnome<br> Logo copyright &copy; 2003 Zsigmond Kovacs<br> Barevná sestava Zsuzsa Deak<br> <span style="font-size:smaller;">4D animace krychle Oliver Knill, Univerzita Harvard <br> Logo punkové dívky &copy; www.sykospark.net<br> Zobrazení spirály Wikipedia &copy; Chris 73<br> Logo teorie čísel &copy; Zoltan Medve</span>	\N	\N
1320	95	10	Další podsystémy:<br> GNU Linux/Apache/PostgreSQL/PHP, gnuplot/Maxima, TeX/LaTeX/ImageMagick, formconv/TeXmacs, GeoLite (http://www.maxmind.com)	\N	\N
1321	96	10	Chcete-li kontaktovat vývojáře,<br> můžete bez obav psát na<br> <b><a style="color: #ffffff; text-decoration: none;" href="mailto:info@matek.hu">info@matek.hu</a></b>	\N	\N
1322	97	10	Programové chyby prosím oznamte na<br> <b><a style="color: #ffffff; text-decoration: none;" href="http://wmi.sf.net/2/bugs" target="_blank">http://wmi.sf.net/2/bugs</a></b>	\N	\N
1323	125	10	Změnit jazyk na angličtinu	\N	\N
1314	88	10	<a href="http://en.wikipedia.org/wiki/Graph_of_a_function" target="_blank">Graf funkce</a>:	\N	\N
1325	141	10	Posloupnost částečných součtů	\N	\N
1348	272	10	Databáze vyučujících	\N	\N
1324	139	10	<a href="http://en.wikipedia.org/wiki/Series_%28mathematics%29#Infinite_series" target="_blank">Posloupnost částečných součtů</a>:[co]	\N	\N
1327	145	10	Posloupnost částečných součinů	\N	\N
1328	147	10	<a href="http://en.wikipedia.org/wiki/Limit_of_a_sequence" target="_blank">Limita posloupnosti</a>:[co]	\N	\N
1329	149	10	Limita posloupnosti	\N	\N
1330	151	10	Neurčitý integrál	\N	\N
1332	155	10	<a href="http://en.wikipedia.org/wiki/Antiderivative" target="_blank">Neurčitý integrál funkce</a>:[co]	\N	\N
1333	157	10	<a href="http://en.wikipedia.org/wiki/Derivative" target="_blank">Derivace funkce</a>:[co]	\N	\N
1334	159	10	Limita funkce	\N	\N
1335	161	10	<a href="http://en.wikipedia.org/wiki/Limit_of_a_function" target="_blank">Limita funkce</a>:[co]	\N	\N
1336	164	10	<a href="http://en.wikipedia.org/wiki/Taylor_series" target="_blank">Taylorova řada funkce</a>:[co]	\N	\N
1337	166	10	Taylorova řada	\N	\N
1338	169	10	<font color="black"><b>Nesprávně zadaná úloha <a href="doc/intro_en.html" target="_blank">požádejte o pomoc</a> pokud je potřeba.</b></font>	\N	\N
1339	171	10	<b>Příliš obtížná úloha, promiňte.</b>	\N	\N
1544	638	10	Otočení dolů	\N	\N
1194	188	9	Pi, matematická konštanta, jeho pribl. hodnota 3,14159	\N	\N
1195	189	9	Mocnina	\N	\N
1196	190	9	Štvorec	\N	\N
1197	191	9	Tretia mocnina	\N	\N
2794	294	4	Transponierung	\N	\N
2795	295	4	<a href="http://de.wikipedia.org/wiki/Matrix_%28Mathematik%29#Die_transponierte_Matrix" target="_blank">Die transponierte Matrix</a>:[co]	\N	\N
2796	298	4	Rang einer Martix	\N	\N
2797	299	4	<a href="http://de.wikipedia.org/wiki/Rang_(Mathematik)" target="_blank">A mátrix rangja</a>:[co]	\N	\N
2798	302	4	Adjungierte Martix	\N	\N
2799	303	4	<a href="http://de.wikipedia.org/wiki/Adjungierte_Matrix" target="_blank">Adjungierte Matrix</a>:[co]	\N	\N
2800	307	4	Das charakteristische Polinom der Matrix:[co]	\N	\N
2801	310	4	Eigenwerte	\N	\N
1143	76	9	dooučovanie ponúka.	\N	\N
1	1	7	&#20013;&#22269;	\N	\N
2	2	8	&#33274;&#28771;	\N	\N
5	5	9	Slovak	\N	\N
7	7	10	&#268;esky	\N	\N
78	78	1	Mg tbb segtsg...	\N	\N
79	79	1	Krj segtsget!	\N	\N
80	80	1	Mi ez?	\N	\N
81	81	1	Bal-kattintsra a kplet bekerl a beviteli mezbe.	\N	\N
82	82	1	Bezr	\N	\N
83	83	1	Valban trljk a munkalapot?	\N	\N
84	84	1	j munkalap	\N	\N
85	85	1	Ments	\N	\N
86	86	1	Nyomtats	\N	\N
87	87	1	Informcik a honlaprl	\N	\N
88	88	1	A fggvny brzolva:	\N	\N
95	95	1	Tovbbi alrendszerek:<br> GNU Linux/Apache/PostgreSQL/PHP, gnuplot/Maxima, TeX/LaTeX/ImageMagick, formconv/TeXmacs, GeoLite (http://www.maxmind.com)	\N	\N
89	88	2	<a href="http://en.wikipedia.org/wiki/Graph_of_a_function" target="_blank">The graph of the function</a>:	\N	\N
90	90	1	<b>matek.hu <font color=#d0d0d0><small>BETA</small></font></b>	\N	\N
91	91	1	Copyright &copy; 2006-2007 Partci BT.<br> Kovcs Z., Vajda R., Fekete ., Bakos G., Csernai K.	\N	\N
92	92	1	A portl a WMI %s kezelfelleten alapul.<br> Copyright &copy; 2002-2007 SZTE	\N	\N
93	93	1	Adatbzis-motor: Wekker alkalmazsfejleszt<br> Copyright &copy; 2005-2007 Consol Rendszerhz Kft.<br>	\N	\N
141	141	1	Rszletsszeg sorozat	\N	\N
142	141	2	Sequence of partial sums	\N	\N
272	272	1	Tanrok adatbzisa	\N	\N
273	272	2	Database of teachers	\N	\N
2787	257	4	Einführende Analysis	\N	\N
2788	259	4	Lineare Algebra	\N	\N
2789	272	4	Datenbasis von Lehrern	\N	\N
2790	286	4	Matrixinventierung	\N	\N
2791	287	4	<a href="http://de.wikipedia.org/wiki/Inverse_Matrix" target="_blank">Die inverse Matrix</a>:[co]	\N	\N
2792	290	4	Determinante	\N	\N
2793	291	4	<a href="http://de.wikipedia.org/wiki/Determinante_%28Mathematik%29"target="_blank">Die Determinante einer Matrix</a>:[co]	\N	\N
2814	427	4	Diese Seite wurde auf Mozilla Firefox 2.0 und Internet Explorer 6/7 optimalisiert. Du benutzt wahrscheinlich einen von matek.hu nicht unterstützten Browser. Es kann vorkommen, dass einige Funktionen nicht optimal benutzt werden können, wir bitten dich deswegen um Entschuldigung.	\N	\N
2815	430	4	<b>Es konnte kein Graf zu dieser Formel gezeichnet werden.</b>	\N	\N
2816	433	4	Annähernde Lösung einer Gleichung	\N	\N
2817	435	4	Eine annähernde Lösung der <a href="http://de.wikipedia.org/wiki/Gleichung" target="_blank">Gleichung</a> im angegebenen Intervall:[co]	\N	\N
2818	437	4	Funktionsgrafen in 3D	\N	\N
2819	439	4	Grafen komplexer Funktionen	\N	\N
2881	335	3	RLA	\N	\N
2919	75	3	D’ou vient cela?	\N	\N
2920	76	3	se charge de donner des cours particuliers	\N	\N
2921	77	3	privat-docent.	\N	\N
2950	124	3		\N	\N
2987	224	3	Reste de la division des polinomes:[co]	\N	\N
2988	225	3	Division des polynomes, reste	\N	\N
2989	258	3	Algèbre	\N	\N
3036	520	3	La somme des diviseurs du nombre accordé:[co]	\N	\N
3032	435	3	La somme des diviseurs du nombre accordé:[co]	\N	\N
3033	437	3	Représentation des fonctions	\N	\N
3034	439	3	Représentation des fonctions	\N	\N
2821	441	3	La limite de la fonction à droite	\N	\N
135	135	\N	<font face="Times,serif" size="+1">&#928;</font><font face="Times, serif" size="-1"><i> a<sub>n</sub></i></font>	\N	\N
136	136	\N	<font face="Times,serif" size="-2"><i>x</i><sup>4</sup>:<i>x</i><sup>2</sup>&#8722;1</i></font>	\N	\N
137	137	\N	<big>&#8776;</big>	\N	\N
138	138	\N	<center><table cellspacing=0 cellpadding=0 border=0 height=100%> <tr> <td height=100%> <table border=0 cellspacing=0 cellpadding=0 height=100%> <tr> <td valign=bottom height=100%> <center><font color=white size=-2> 2 </font></center> </td> </tr> <tr> <td height=1 bgcolor=white colspan=2> </td> </tr> <tr> <td valign=top height=100%> <center><font color=white size=-2> 4 </font></center> </td> </tr></table></td> <td height=100%> <font color=white size=-2>=</font></td> <td height=100%> <table border=0 cellspacing=0 cellpadding=0 height=100%> <tr> <td valign=bottom height=100%> <center><font color=white size=-2> 1 </font></center> </td> </tr> <tr> <td height=1 bgcolor=white colspan=2> </td> </tr> <tr> <td valign=top height=100%> <center> <font color=white size=-2>2</font> </center> </td> </tr></table></td> </tr> </table></center>	\N	\N
140	139	2	<a href="http://en.wikipedia.org/wiki/Series_%28mathematics%29#Infinite_series" target="_blank">Sequence of partial sums</a>:[co]	\N	\N
2596	441	4	rechtsseitiger Funktionsgrenzwert  	\N	\N
2597	443	4	linksseitiger Funktionsgrenzwert 	\N	\N
2827	453	3	e, constante mathématique, sa valeur approchée: 2.71828	\N	\N
2735	121	4	doch	\N	\N
2933	91	3	Copyright &copy; 2006-2007 Partíció BT.<br> Kovács Z., Vajda R., Fekete Á., Bakos G., Csernai K.	\N	\N
2935	95	3	Logiciel fondamental:<br> GNU Linux/Apache/PostgreSQL/PHP, gnuplot/Maxima, TeX/LaTeX/ImageMagick, formconv/TeXmacs, GeoLite (http://www.maxmind.com)	\N	\N
2931	88	3	La fonction représentée:	\N	\N
2991	272	3	Base de données des professeurs	\N	\N
2951	147	3	<a href="http://hu.wikipedia.org/wiki/Hat%C3%A1r%C3%A9rt%C3%A9k" target="_blank">La limite de la suite</a>:[co]	\N	\N
2872	149	3	Limite de suite	\N	\N
2952	151	3	Intégrale indéfinie	\N	\N
2954	155	3	Intégrale indéfinie de la fonction:[co]	\N	\N
2955	157	3	<a href="http://hu.wikipedia.org/wiki/Differenci%C3%A1lh%C3%A1nyados" target="_blank">La dérivée de la fonction</a>:[co]	\N	\N
2956	159	3	Limite de la fonction	\N	\N
2957	161	3	<a href="http://hu.wikipedia.org/wiki/Hat%C3%A1r%C3%A9rt%C3%A9k" target="_blank">La limite de la fonction</a>:[co]	\N	\N
2958	164	3	<a href="http://hu.wikipedia.org/wiki/Série de Taylor" target="_blank">Série de Taylor de la fonction</a>:[co]	\N	\N
2959	166	3	Série de Taylor	\N	\N
2960	171	3	</b>Problème trop difficile, désolé.</b>	\N	\N
2875	638	3	Rotation en dessous	\N	\N
2598	445	4	Der rechtsseitige Grenzwert der Funktion:[co]	\N	\N
2599	447	4	Der linksseitige Grenzwert der Funktion:[co]	\N	\N
2600	449	4	Grenzwert einer Summe	\N	\N
2601	451	4	Grenzwert der Summe der unendlichen Reihe:[co]	\N	\N
3025	226	3	</b>La formule donnée est malheureusement dénuée de sens.</b>	\N	\N
3045	257	3	Introduction dans l’analyse	\N	\N
2990	259	3	Algèbre linéaire	\N	\N
2992	286	3	Inversion d'une matrice	\N	\N
2993	287	3	<a href="http://hu.wikipedia.org/wiki/Invert%C3%A1lhat%C3%B3_m%C3%A1trix" target="_blank">Inverse de la matrice</a>:[co]	\N	\N
2994	290	3	Déterminant	\N	\N
2995	291	3	<a href="http://hu.wikipedia.org/wiki/Determin%C3%A1ns" target="_blank">Déterminant de la matrice</a>:[co]	\N	\N
2999	299	3	<a href="http://hu.wikipedia.org/wiki/M%C3%A1trix_(matematika)#M.C3.A1trix_rangja" target="_blank">Rang de la matrice</a>:[co]	\N	\N
3000	302	3	Matrice adjointe	\N	\N
3001	303	3	<a href="http://hu.wikipedia.org/wiki/Adjung%C3%A1lt_(m%C3%A1trixinvert%C3%A1l%C3%A1s)" target="_blank">Matrice adjointe</a>:[co]	\N	\N
3002	306	3	Polynôme caractéristique	\N	\N
3003	307	3	Polynôme caractéristique de la matrice (<i>x</i>):[co]	\N	\N
3004	310	3	Valeurs propres	\N	\N
3006	314	3	Vecteurs propres	\N	\N
3008	318	3	Multiplication des matrices, multiplication par un scalaire	\N	\N
3009	320	3	Puissance d'une matrice	\N	\N
3040	38	3	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Bienvenue à la page d'algèbre linéaire!</h2></center>Commencez juste à dactylographier le problème utilisant le clavier ou la souris et à appuyer sur un bouton bleu-vert du côté gauche pour commencer le calcul. Pour choisir une autre disposition des boutons disponibles de calculatrice veuillez appuyer sur le bouton sur le dessus-gauche.Pour obtenir une aide plus attentive comment vous pouvez écrire un problème, <a href="doc/linalg-hu.avi"?vip=5f81caecde3af5633d00214aa5a41ef0>observez cette vidéo</a>!</td><td valign="top" align="right"><img src="./image/4dcube.gif" alt="Forgó 4 dimenziós kocka" title="Forgó 4 dimenziós kocka" style="position:relative;top:-10px;right:-10px;"></td></tr></table>	\N	\N
2922	78	3	Plus d’aide…	\N	\N
2923	79	3	Demande du renseignement.	\N	\N
2924	80	3	Qu'est-ce que c'est?	\N	\N
2926	83	3	Êtes-vous sûr de supprimer la feuille de travail ?	\N	\N
2927	84	3	Nouvelle feuille.	\N	\N
2928	85	3	Enregistrer	\N	\N
2929	86	3	Imprimer	\N	\N
2946	120	3	Pourtant pas	\N	\N
2947	121	3	Pourtant	\N	\N
2948	122	3	Mathématique secondaire	\N	\N
2949	123	3	Mathématique primaire	\N	\N
2895	106	3	Racine carrée	\N	\N
2937	107	3	Valeur absolue	\N	\N
2938	108	3	Sinus	\N	\N
2939	109	3	Cosinus	\N	\N
2940	110	3	Tangente	\N	\N
2941	111	3	Logarithme (logarithme décimal)	\N	\N
2942	112	3	Parenthèse ouvrante et fermante	\N	\N
3026	113	3	Sortie de l’expression entre parenthèse	\N	\N
3046	114	3	Simplification	\N	\N
2943	115	3	Résolution de l’équation (racines complexes aussi)	\N	\N
2944	116	3	Représentation des fonctions	\N	\N
3027	117	3	Factorisation première, factorisation	\N	\N
2945	118	3	Évaluation	\N	\N
3047	119	3	Signe d'égalité (dans l’équation)	\N	\N
2890	185	3	Sous forme de somme	\N	\N
2968	186	3	Développement	\N	\N
2969	187	3	Le reste par une division	\N	\N
2970	188	3	Pi, constante mathématique, sa valeur approchée est environ 3,14159	\N	\N
2971	189	3	Élévation à une puissance	\N	\N
2972	190	3	Élévation au carré	\N	\N
2973	191	3	Le cube du nombre	\N	\N
2974	193	3	Inconnue réelle	\N	\N
3048	195	3	Le paramètre suivant	\N	\N
2975	196	3	Logarithme (népérien)	\N	\N
2976	197	3	Logarithme (de base 2)	\N	\N
2977	198	3	Factorielle	\N	\N
2978	199	3	La fonction exponentielle	\N	\N
3049	205	3	Partie entière inférieure	\N	\N
2979	206	3	Partie entière inférieure	\N	\N
3050	207	3	Fonction signe	\N	\N
2980	208	3	Racine cubique	\N	\N
2981	209	3	Négation	\N	\N
2982	210	3	Point décimal	\N	\N
3028	211	3	Exposant de la forme scientifique	\N	\N
2983	212	3	Pour-cent	\N	\N
3029	173	3	En simplifiant:[co]	\N	\N
3051	174	3	La valeur approximative de l’expression	\N	\N
3052	175	3	La valeur approximative de l’expression:[co]	\N	\N
2961	176	3	Plus grand commun diviseur	\N	\N
2962	177	3	Le plus grand commun diviseurs des expressions	\N	\N
2963	178	3	Plus petit commun multiple	\N	\N
2964	179	3	Le plus petit commun multiple des expressions	\N	\N
2965	180	3	Fractions simples	\N	\N
2966	181	3	Ayant décomposé en fractions simples	\N	\N
3030	184	3	Sous forme de multiplicatioon des facteurs premiers:[co]	\N	\N
2899	410	3	Coefficient binomial	\N	\N
3010	411	3	Le coefficient binomial en question:[co]	\N	\N
3011	414	3	matrice unité d’ordre 2	\N	\N
3012	416	3	matrice nulle d’ordre 2	\N	\N
3013	418	3	matrice d’ordre 2 (modèle)	\N	\N
2985	222	3	Quotient de deux polinomes et le reste:[co]	\N	\N
2986	223	3	Division des polinomes	\N	\N
3014	426	3	Crash	\N	\N
2822	443	3	La limite de la fonction à gauche	\N	\N
2823	445	3	La limite de la fonction à droite:[co]	\N	\N
2824	447	3	La limite de la fonction à gauche:[co]	\N	\N
2825	449	3	La limite de la somme	\N	\N
2826	451	3	La limite de la somme dans l’infinie	\N	\N
2828	456	3	Chargez un autre calculateur	\N	\N
2829	458	3	Sélecteur de langue	\N	\N
2830	460	3	Inconnues	\N	\N
2831	462	3	Fonctions trigonométriques	\N	\N
2832	464	3	Fonctions logarithmes	\N	\N
2833	466	3	Fonction de grandeur exponentielle	\N	\N
3053	468	3	Des racines et des puissances	\N	\N
2834	470	3	Variables réelles	\N	\N
2835	472	3	Variables entieres	\N	\N
2836	474	3	Limites	\N	\N
2837	476	3	Constantes	\N	\N
2838	478	3	Matrice nulle	\N	\N
2839	480	3	Matrice unité	\N	\N
2840	482	3	Matrice nouvelle	\N	\N
2841	484	3	Représentation des fonctions et résolution des équations	\N	\N
3041	486	3	Vous devriez donner 2 paramètres pour ce calcul. Les paramètres doivent être séparés par une virgule (",").	\N	\N
3042	488	3	Ce calcul n’a besoin que d’un parametre, donc il est interdit d’utiliser de virgule.	\N	\N
2842	491	3	elle n’est pas définie (elle n’existe pas)	\N	\N
2843	493	3	<span style="color:blue;">faux</span>	\N	\N
2671	646	4	Verschiebung y-	\N	\N
2673	106	4	Quadratwurzel	\N	\N
2844	495	3	<span style="color:blue;">vrai</span>	\N	\N
2882	497	3	Théorie des nombres	\N	\N
3043	455	3	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Bienvenue à la section de théorie des nombres!</h2></center>Commencez juste à taper le problème utilisant le clavier ou la souris et à appuyer sur un bouton bleu-vert du côté gauche pour commencer le calcul. Pour choisir une autre disposition des boutons disponibles de calculatrice veuillez appuyer sur le bouton sur le dessus-gauche.	\N	\N
2845	500	3	Est-ce que le nombre est-il un <a href="http://hu.wikipedia.org/wiki/Pr%C3%ADmsz%C3%A1mok" target="_blank">nombre premier</a>:[co]	\N	\N
2846	511	3	Prier de soutenir le matek.hu. Merci.	\N	\N
2847	513	3	Multiplication (produit par position des éléments des matrices, pas de produit des matrices	\N	\N
3035	518	3	Le nombre premier après le nombre accordé:[co]	\N	\N
2849	524	3	La somme des diviseurs du nombre accordé:[co]	\N	\N
2850	526	3	Le nombres des nombres premiers entre eux	\N	\N
2851	528	3	Somme des diviseurs	\N	\N
3037	530	3	Nombre premier suivant	\N	\N
3054	532	3	Le nombre premier précédent	\N	\N
2852	534	3	Est-ce que le nombre est-il un nombre premier?	\N	\N
2853	536	3	Nombre de la permutation avec répétitions	\N	\N
2854	538	3	Nombre de la combinaison avec répétitions	\N	\N
2855	540	3	Nombre des arrangements	\N	\N
2856	542	3	Nombre de la combinaison avec répétitions:[co]	\N	\N
2857	544	3	Nombre des arrangements:[co]	\N	\N
2858	546	3	Nombre de la permutation avec répétitions:[co]	\N	\N
2859	548	3	Factorielle (nombre de la permutation):[co]	\N	\N
2860	550	3	n-ème éléments de la suite de Fibonacci	\N	\N
2883	552	3	n-ème nombre de la <a href="http://hu.wikipedia.org/wiki/Fibonacci-sz%C3%A1mok" target="_blank">suite de Fibonacci</a>:[co]	\N	\N
3055	556	3	Le reste	\N	\N
2886	558	3	La partie entiere du quotient:[co]	\N	\N
2887	560	3	Le reste	\N	\N
2888	562	3	Extraction de la racine carrée	\N	\N
2861	564	3	Extraction de la racine n-ieme	\N	\N
2889	566	3	La partie entiere du logarithme en base de 2	\N	\N
3056	572	3	La partie entiere du logarithme en base de 2:[co]	\N	\N
2865	574	3	La partie entiere du logarithme de base b	\N	\N
2900	601	3	<span style="color:blue;">pas de solution</span>	\N	\N
2901	610	3	Résolution de l’équation	\N	\N
2902	612	3	<span style="color:blue;">il n'est pas défini</span>	\N	\N
2903	614	3	</b>Crash: division par zéro</b>	\N	\N
2904	616	3	Nouveau vecteur	\N	\N
2905	618	3	Sortie du vecteur	\N	\N
2906	620	3	Nombre des permutations	\N	\N
2907	622	3	Carré d'une matrice	\N	\N
2867	624	3	Matrice au cube	\N	\N
2868	626	3	Puissance quatrieme	\N	\N
2869	628	3	De loin	\N	\N
3038	630	3	De plus proche	\N	\N
2870	632	3	Rotation à gauche	\N	\N
2873	634	3	Rotation à droite	\N	\N
2874	636	3	Rotation au-dessus	\N	\N
2876	640	3	Translation x+	\N	\N
2908	648	3	Intégrale définie	\N	\N
2877	652	3	L'intégrale définie de la fonction:[co] 	\N	\N
2878	656	3	Dérivée partielle	\N	\N
2879	658	3	Substitution	\N	\N
2894	660	3	<a href="http://en.wikipedia.org/wiki/Parci%C3%A1lis_deriv%C3%A1lt">Dérivée partielle</a> de la fonction:[co]	\N	\N
2996	294	3	Transposition	\N	\N
2998	298	3	Rang de la matrice	\N	\N
3057	72	3	D’ou vient cette solution?	\N	\N
2917	73	3	Résolution détaillée...	\N	\N
2918	74	3	Plus d’aide	\N	\N
2925	82	3	Fermer	\N	\N
2967	182	3	<b>Ce serait une image trop grande, désolé.</b>	\N	\N
2891	642	3	Translation x-	\N	\N
2892	644	3	Translation y+	\N	\N
2893	646	3	Translation y-	\N	\N
2909	650	3	Substitution (x)	\N	\N
2953	153	3	Différentiation	\N	\N
3058	4	3	Formule du problème:[ui]	\N	\N
3059	8	3	Valeur de la expression:[co]	\N	\N
2914	6	3	Résolution de la quation:[co]	\N	\N
3060	54	3	L’effacement de la case d’entrée de la calculatrice	\N	\N
3061	59	3	<a href="http://matek.hu">Matek.hu</a> ne fontionne pas temporairement.<br>Essayez, s.v.p. plus tard!	\N	\N
3062	61	3	D’ou vient cette solution?	\N	\N
3063	63	3	La feuille de travail peut être sauvegardé maintenant.	\N	\N
3044	69	3	Dès maintenant, la langue du programme sera le %s. Vous êtes invités à recharger la page.	\N	\N
2932	90	3	<b>matek.hu <font color=#d0d0d0><small>BETA</small></font></b>	\N	\N
2586	108	4	Sinus	\N	\N
2802	311	4	<a href="http://de.wikipedia.org/wiki/Eigenwert#Berechnung_der_Eigenwerte_einer_Matrix" target="_blank">Eigenwerte der Matrix</a> [[<i>Eigenwerte</i>], in der Form [<i>ihre Vielfachheiten</i>]:[co]	\N	\N
2803	314	4	Eigenvektoren	\N	\N
2804	315	4	<a href="http://de.wikipedia.org/wiki/Eigenwert#Berechnung_der_Eigenwerte_einer_Matrix" target="_blank">Eigenwerte der Matrix in der Form</a>  [[[<i>Eigenwerte</i>],[<i>ihre Vielfachheiten</i>]], <i>1. Eigenvektor</i>, <i>2. Eigenvektor</i>, ...]:[co]	\N	\N
2805	318	4	Matrizenmultiplikation, Skalarmultiplikation/Skalarprodukt	\N	\N
2806	320	4	Potenzieren von Matrizen	\N	\N
2807	338	4	In Stufenform (mit Einsen in der Hauptdiagonale):[co]	\N	\N
2808	411	4	der gesuchte Binomialkoeffizient:[co]	\N	\N
2809	414	4	2x2 Einheitsmatrix	\N	\N
2810	416	4	2x2 Nullmatrix	\N	\N
2811	418	4	2x2 Matrix (Vorlage)	\N	\N
2812	420	4	Stufenform	\N	\N
2813	422	4	in Stufenform:[co]	\N	\N
2595	426	4	Fehler	\N	\N
2463	107	11	Апсолутна вредност	\N	\N
2464	108	11	Синус	\N	\N
2538	287	11	<a href="http://hu.wikipedia.org/wiki/Invert%C3%A1lhat%C3%B3_m%C3%A1trix" target="_blank">У ма́триксинверзе</a>:[co]	\N	\N
2540	291	11	<a href="http://hu.wikipedia.org/wiki/Determin%C3%A1ns" target="_blank">У детерминанта од матрице</a>:[co]	\N	\N
2541	294	11	Транспосинг	\N	\N
2542	295	11	<a href="http://hu.wikipedia.org/wiki/Adjung%C3%A1lt_(m%C3%A1trixinvert%C3%A1l%C3%A1s)#Transzpon.C3.A1lt" target="_blank">	\N	\N
2543	298	11	Чин, а матрица	\N	\N
2544	299	11	<a href="http://hu.wikipedia.org/wiki/M%C3%A1trix_(matematika)#M.C3.A1trix_rangja" target="_blank">У чин је матрица</a>:[co]	\N	\N
2546	303	11	<a href="http://hu.wikipedia.org/wiki/Adjung%C3%A1lt_(m%C3%A1trixinvert%C3%A1l%C3%A1s)" target="_blank">A mátrix adjungáltja</a>:[co]	\N	\N
2547	306	11	Карактеристични полином	\N	\N
2548	307	11	У карактеристичним полином од матрице (<и> кс </ и> бен):[co]	\N	\N
2549	310	11	Својствене вриједности	\N	\N
2550	311	11	<a href="http://hu.wikipedia.org/wiki/Saj%C3%A1tvektor_%C3%A9s_saj%C3%A1t%C3%A9rt%C3%A9k" target="_blank">У властите вредности од матрице [[<i>sajátértékek</i>], [<i>hozzájuk tartozó multiplicitások</i>] у облику:[co]	\N	\N
2356	513	11	Умножавање (за елементе матрице позицију множењем, а не множење матрица)	\N	\N
2357	518	11	Након што је одобрена број наследник<a href="http://hu.wikipedia.org/wiki/Pr%C3%ADmsz%C3%A1mok" target="_blank">прим број</a>:[co]	\N	\N
2358	520	11	У једном пред одобрава број <a href="http://hu.wikipedia.org/wiki/Pr%C3%ADmsz%C3%A1mok" target="_blank">прим број</a>:[co]	\N	\N
2359	522	11	Наведени број мањих <a href="http://hu.wikipedia.org/wiki/Relat%C3%ADv_pr%C3%ADmek" target="_blank"> релативна примес</a> száma:[co]	\N	\N
2360	524	11	Збир од дивисорс од уписаног броја	\N	\N
2361	526	11	Мањи број у односу примес	\N	\N
2362	528	11	Збир дивисорс	\N	\N
2363	530	11	Следећи број премијера	\N	\N
2364	532	11	Је број претходног премијера	\N	\N
2365	534	11	Је ли моја уста премијера?	\N	\N
2366	536	11	Број понављања пермутације	\N	\N
2367	538	11	Број понављања комбинације	\N	\N
2368	540	11	Број варијација	\N	\N
2369	542	11	Број његова понављања комбинације	\N	\N
2370	544	11	Број варијација	\N	\N
2371	546	11	Број понавкауе пермутације	\N	\N
2372	548	11	Факторијел (број пермутације)	\N	\N
2373	550	11	Фибонацци сериес н-едик свом елементу	\N	\N
2376	570	11	Az <a href="http://hu.wikipedia.org/wiki/Gy%C3%B6kvon%C3%A1s" target="_blank"><i>n</i>корен</a>његов цијели дио:[co]	\N	\N
2377	572	11	Број са 2 основу<a href="http://hu.wikipedia.org/wiki/Logaritmus" target="_blank">логаритам</a>његов цијели дио:[co]	\N	\N
2378	574	11	б основи све је део логаритма	\N	\N
2379	576	11	Број<i>b</i> основa <a href="http://hu.wikipedia.org/wiki/Logaritmus" target="_blank">логаритaм</a>његов цијели дио:[co]	\N	\N
2380	581	11	За овај израчунавање [PAR]потребно је доделити параметар, одвојен зарезима.	\N	\N
2381	624	11	Подизање једна матрица на Кубе	\N	\N
2382	626	11	Четврти на власт повећати	\N	\N
2383	628	11	Више удаљене	\N	\N
2385	632	11	Окренувши лефтуардс	\N	\N
2386	141	11	Детаљ збир серија	\N	\N
2387	149	11	Ограничење вредност низа	\N	\N
2388	634	11	Скретање десно	\N	\N
2389	636	11	Кад одозго	\N	\N
2390	638	11	Обарања	\N	\N
2391	640	11	Оффсетx+	\N	\N
2392	652	11	У интегрални недвосмислен у функцији:[co]	\N	\N
2393	656	11	Само делови дериват	\N	\N
2394	658	11	Замена	\N	\N
2395	662	11	У супституирани изражавање:[co]	\N	\N
2396	335	11	РЛА	\N	\N
2397	497	11	Број теорија	\N	\N
2398	552	11	A <a href="http://hu.wikipedia.org/wiki/Fibonacci-sz%C3%A1mok" target="_blank">Фибонацци сериес</a> <i>n</i>свом елементу:[co]\t	\N	\N
2399	554	11	Цела Дивизија	\N	\N
2400	556	11	Цела подјеле преосталог	\N	\N
2401	558	11	Све је у склопу квоцијент:[co]	\N	\N
2402	560	11	Све је у склопу квоцијент:[co]	\N	\N
2403	562	11	Цела квадратни корен функција	\N	\N
2404	566	11	Све је део логаритма с 2 основу	\N	\N
2405	185	11	Сум у облику:[co]	\N	\N
2406	642	11	Оффсетx-	\N	\N
2407	644	11	Оффсетy+	\N	\N
2408	646	11	Оффсетy-	\N	\N
2409	660	11	Функција<a href="http://en.wikipedia.org/wiki/Parci%C3%A1lis_deriv%C3%A1lt">његова парцијалне деривација</a>:[co]	\N	\N
2410	106	11	Квадратни корен	\N	\N
2411	139	11	У детаљ збир серија:[co]	\N	\N
2412	143	11	У детаљ серије производа:[co]	\N	\N
2413	145	11	Детаљ производа серија	\N	\N
2414	59	11	A <a href="http://matek.hu">matek.hu</a> привремено осим фирма ван. <b> Молимо га, нека га посетите касније!	\N	\N
2415	336	11	Згази облик (у главном дијагонале с једне 1)	\N	\N
2416	410	11	Биномни коефицијент	\N	\N
2417	601	11	<span style="color:blue;">не постоји решење</span>	\N	\N
2418	603	11	Потребно је обезбедити 3 параметара за овај израчунавање. Параметри једног вессзо̃ ( ", ") дијели га од других. То елсо̋ параметар подразумева се једначина бити ријешено, друга и трећа иако је имао два што идентификовати ендпоинтс од интервала јер где је потребно тражити решења.	\N	\N
2419	610	11	Формула решење	\N	\N
2420	612	11	<span style="color:blue;">Није дефинисано</span>	\N	\N
2421	614	11	<b>Грешку: баве нула</b>	\N	\N
2422	616	11	Нови Вектор	\N	\N
2423	618	11	Сецесије из Вектор	\N	\N
2424	620	11	Број пермутације	\N	\N
2425	622	11	Квадрирање једна матрица	\N	\N
2426	648	11	Дефинисан интегрални	\N	\N
2427	650	11	Замена (x)	\N	\N
2428	654	11	Израз x његову променљиву заменитиe:[co]	\N	\N
2429	38	11	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Поздравља матек.ху заглавља и линеарна алгебра!</h2></center>Можете писати задаће лево калкулатор, ви сте са мишем на тастатури чак. У прорачунима су стартабле с плаво-зелене тастере. Ви мај претворити врсту калкулатора с леве горњи дугме. Ако требате помоћ<a href="segitseg" target="_blank">клик</a> vagy <a href="doc/linalg-hu.avi">гледати овај филм</a>!</td><td valign="top" align="right"><img src="./image/4dcube.gif" alt="Forgó 4 dimenziós kocka" title= кружи простран коцке" style="position:relative;top:-10px;right:-10px;"></td></tr></table>	\N	\N
2432	8	11	Вредност израза:[co]	\N	\N
2433	6	11	Az <a href="http://hu.wikipedia.org/wiki/Egyenlet" target="_blank">егыенлет </а> његово решење:[co]	\N	\N
2434	54	11	Брисања од улазних поља калкулатора	\N	\N
2435	60	11	У притискање дугмета у овом тренутку не хасзна́лхато́.  НУ матек.ху формуле се од стране зсебкалкула́торокбан  нпотребно је узети у то на уобичајени начин, с леве јоббра,  нкао да са стране ірна́нк.  н НОвецоме га ако дође до зауставити ЦЕ дугме, вагы  ноптерећење на ново га олдалт.  н НА матек.ху егыело̃ре кісэрлети ста́диумбан ван.  НАко желите помоћи фејлесзтэсбен,  нмолимо да посетите далеко хттп://уми.сф.нет/2/бугс је на страну.	\N	\N
2436	61	11	Како је решење израчунава? Питајте помоћи% с његове околице!	\N	\N
2437	62	11	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>ово овде је матек.ху!</h2></center>Да! Је обновио матек.ху, не само његов изглед, али у њему радимо! Наравно<a href="http://matek.hu/1" target="_blank">старе верзије доступне</a>Можете писати задаће лево калкулатор, ви сте са мишем на тастатури чак. У прорачунима су стартабле с плаво-зелене тастере. Ви мај промијенити врсту калкулатора с леве горњи дугме: оно што сада користите, то <и> кӧзэписколаи феладаток </ и> могу решити. Ако вам треба помоћ,<a href="segitseg" target="_blank">kattints ide</a> (<a href="doc/intro_hu.pdf">PDF</a>) vagy <a href="doc/normal-hu.avi">гледати овај филм</a>!<br><br></td><td valign="top" align="right"><img src="./image/normal-pres.png" style="position:relative;top:-10px;right:-10px;" alt=""></td></tr></table>	\N	\N
2438	69	11	Програм ће радити на мађарском сада. Ми предлажемо да би за вас оптерећење на страни на нови.	\N	\N
2430	4	11	Формула за задатак:[ui]	\N	\N
2431	10	11	Формула за задатак:[ui]	\N	\N
2439	72	11	Питајте помоћи% с његове околице!	\N	\N
2440	73	11	Детаљно решење ...	\N	\N
2441	74	11	Више помоћи ...	\N	\N
2442	75	11	Како је то израчунава?	\N	\N
2443	76	11	он обавезује тренирању.	\N	\N
2444	77	11	приватна старатељ.	\N	\N
2445	78	11	Чак и више помоћи ...	\N	\N
2446	79	11	Питајте помоћи.	\N	\N
2447	80	11	Шта је ово?	\N	\N
2448	81	11	Формула добија у лево миша кликните у поље уноса.	\N	\N
2449	82	11	Затвори	\N	\N
2450	83	11	Нека нас избришете радни стварно?	\N	\N
2451	84	11	Нова радни	\N	\N
2452	85	11	Ресцуе	\N	\N
2453	86	11	Штампа	\N	\N
2454	87	11	Информације на уеб страници	\N	\N
2455	88	11	Функција приказан:	\N	\N
2456	90	11	<b>матек.ху <font color=#d0d0d0><small>BETA</small></font></b>	\N	\N
2457	91	11	Copyright &copy; 2006-2007 Partíció BT.<br>З. Смитх, Р. Вајда, Фекете а., Бакос Г., К. Цсернаи	\N	\N
2458	93	11	База мотора: Уеккер програмер апликација<br> Цопыригхт © 2005-2007 Цонсол систем кућа доо.<br>	\N	\N
2459	94	11	Графичка подршка:Gnome<br> Logó copyright &copy; 2003 Kovács Zsigmond<br>Схема Боја: Deák Zsuzsa<br> 4D kocka animáció &copy; Oliver Knill, Harvard Egyetem<br> Punk lány logó &copy; www.sykospark.net<br> Spirál-fotó &copy; Wikipedia, Chris 73<br> Број теорија лого&copy; Medve Zoltán	\N	\N
2460	95	11	додатни подсистема:<br> GNU Linux/Apache/PostgreSQL/PHP, gnuplot/Maxima, TeX/LaTeX/ImageMagick, formconv/TeXmacs, GeoLite (http://www.maxmind.com)	\N	\N
2461	96	11	Програмери га<br> <b><a style="color: #ffffff; text-decoration: none;" href="mailto:info@matek.hu">info@matek.hu</a></b><br>могуће је добити на е-маил наслов.	\N	\N
2462	97	11	Грешке у<br> <b><a style="color: #ffffff; text-decoration: none;" href="http://wmi.sf.net/2/bugs" target="_blank">http://wmi.sf.net/2/bugs</a></b><br> смо примили на уеб адресу, ми рећи хвала за то!	\N	\N
2465	109	11	Косинус	\N	\N
2466	110	11	Тангенс	\N	\N
2467	111	11	Логаритам (са 10 подлога)	\N	\N
2468	112	11	Отварач и затварање заграда (заједно)	\N	\N
2469	113	11	Сецесије у загради израза	\N	\N
2470	114	11	Поједностављење	\N	\N
2471	115	11	Формула решење (комплексна корена)	\N	\N
2472	116	11	Функција приказа	\N	\N
2473	117	11	Премијер фактори дисмолитион, обликовање производа	\N	\N
2474	118	11	Евалуација	\N	\N
2296	254	5	Sviluppatori	\N	\N
2475	119	11	Једнаке знак (у једначине)	\N	\N
2476	120	11	Након свих	\N	\N
2477	121	11	Након свих	\N	\N
2478	122	11	Средњошколци студент математике	\N	\N
2479	123	11	Основна школа математике	\N	\N
2480	124	11	&Aacute;tv&aacute;lt&aacute;s на мађарском	\N	\N
2481	147	11	<a href="http://hu.wikipedia.org/wiki/Hat%C3%A1r%C3%A9rt%C3%A9k" target="_blank">Границу од вредности серије</a>:[co]	\N	\N
2482	151	11	Недефинисани интегрални	\N	\N
2483	153	11	Диференцијација	\N	\N
2484	155	11	На неодређено интеграл од функције:[co]	\N	\N
2485	157	11	<a href="http://hu.wikipedia.org/wiki/Differenci%C3%A1lh%C3%A1nyados" target="_blank">Функција деривација</a>:[co]	\N	\N
2486	159	11	Функција ограничење вредности	\N	\N
2487	161	11	<a href="http://hu.wikipedia.org/wiki/Hat%C3%A1r%C3%A9rt%C3%A9k" target="_blank">Функција ограничење вредности</a>:[co]	\N	\N
2488	164	11	<a href="http://hu.wikipedia.org/wiki/Taylor-sor" target="_blank">Таylor је низ функција</a>:[co]	\N	\N
2489	166	11	Taylor ред	\N	\N
2490	169	11	<font color="black"><b>Задатак криво формулисао, ако је потребно,<a href="segitseg" target="_blank">затражити помоћ</a>!</b></font>	\N	\N
2491	171	11	<b>Премало тешки задатак, Опростите за то.</b>	\N	\N
2492	173	11	Поједностављени:[co]	\N	\N
2493	174	11	Вредност израза грубо	\N	\N
2494	175	11	Вредност израза грубо:[co]	\N	\N
2495	176	11	Највећи заједнички дјелилац	\N	\N
2496	177	11	Највећи заједнички дјелилац од израза:[co]	\N	\N
2497	178	11	Минимална заједнички више	\N	\N
2498	179	11	Најмањи заједницки више од израза:[co]	\N	\N
2499	180	11	Само делови разбијен један	\N	\N
2500	181	11	У Сплиту делимично СЛОМЉЕНА оне:[co]	\N	\N
2501	182	11	<b>Слика би била превелика, Опростите за то<b>	\N	\N
2502	184	11	У Сплиту премијера фактора (претворена у производ):[co]	\N	\N
2503	186	11	Сум обликовање	\N	\N
2504	187	11	Резидуална подјеле преосталог	\N	\N
2505	188	11	Пи, Математичка константа једном, његова вредност је цца. 3,14159	\N	\N
2506	189	11	Потенцирауу	\N	\N
2507	190	11	На тргу повећање	\N	\N
2508	191	11	На Кубе мојих уста	\N	\N
2509	193	11	Реал непозната	\N	\N
2510	195	11	Следећи параметар	\N	\N
2511	196	11	Логаритам (с природним основи)	\N	\N
2512	197	11	Логаритам (с 2 основи)	\N	\N
2513	198	11	Факторијел	\N	\N
2514	199	11	У експоненцијална функција	\N	\N
2515	205	11	Горњи део целе	\N	\N
2516	206	11	Мањи део целе	\N	\N
2517	207	11	Пријава (сзигнум) функција	\N	\N
2518	208	11	Коцка корен	\N	\N
2519	209	11	Негатинг	\N	\N
2520	210	11	Децимални сепаратор	\N	\N
2521	211	11	У степен нормални облик	\N	\N
2522	212	11	Проценат	\N	\N
2523	63	11	Могуће је сачувати радни сада.	\N	\N
2524	217	11	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Поздравља матек.ху!</h2></center>Можете писати задаће лево калкулатор, ви сте га с мишем биллентыюзетен чак и превише. У прорачунима су стартабле с плаво-зелене тастере. Врста калкулатора лево фелсо̃ вам мај релеј с дугме: оно што сада користите, то <и> а́лтала́нос школа феладаток </ и> могу решити. Ако вам треба помоћ,<a href="segitseg" target="_blank">kattints ide</a>!<br><br></td><td valign="top" align="right"><img src="./image/easy-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt=""></td></tr></table>	\N	\N
2525	219	11	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Поздравља матек.ху заглавља за анализу!</h2></center>Можете писати задаће лево калкулатор, ви сте га с мишем биллентыюзетен чак и превише. У прорачунима су стартабле с плаво-зелене тастере. Врста калкулатора лево фелсо̃ вам мај релеј с дугме: оно што сада користите, то <и> бевезето̃ анализа феладаток </ и> могу решити. Ако вам треба помоћ,<a href="segitseg" target="_blank">kattints ide</a> vagy <a href=doc/calculus-hu.avi>nézd meg ezt a filmet</a>!<br><br></td><td valign="top" align="right"><img src="./image/calculus-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt=А логаритамску спирала, математичке анализе сликовито је" title="А логаритамску спирала, математичке анализе сликовито је" ></td></tr></table>	\N	\N
2526	222	11	У квоцијент од две полиноми, а преостали један:[co]	\N	\N
2528	224	11	За подјеле се преостали полиноми:[co]	\N	\N
2529	225	11	Полиноми подела, преостали	\N	\N
2530	226	11	<b>Формула записано у нажалост не може се тумачити.<b>	\N	\N
2531	254	11	За програмере	\N	\N
2532	256	11	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>Поздравља матек.ху заглавља и алгебра!</h2></center>Можете писати задаће лево калкулатор, ви сте га с мишем биллентыюзетен чак и превише. У прорачунима су стартабле с плаво-зелене тастере. Врста калкулатора лево фелсо̃ вам мај претворити га с дугме. Ако вам треба помоћ,<a href="segitseg" target="_blank">kattints ide</a>!<br><br></td><td valign="top" align="right"><img src="./image/algebra-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt="Al-Hvárizmi,први алгебра аутор књиге (совјетска печат, 1983)" title="Al-Hvárizmi први алгебра аутор књиге (совјетска печат, 1983) "></td></tr></table>	\N	\N
2533	257	11	Уводна анализа	\N	\N
2534	258	11	Алгебра	\N	\N
2535	259	11	Линеарна алгебра	\N	\N
2536	272	11	А учитеља базе података	\N	\N
2537	286	11	Ма́триксинвертинг	\N	\N
2539	290	11	Детерминанта	\N	\N
2555	338	11	У згази облик (у главном дијагонале с једне 1):[co]	\N	\N
2556	411	11	У упитним биномни коефицијент:[co]	\N	\N
2557	414	11	2кс2-тих јединица матрица	\N	\N
2558	416	11	2кс2-ес нула матрица	\N	\N
2559	418	11	2кс2-ес матрица (шема)	\N	\N
2561	422	11	У згази облик:[co]	\N	\N
2562	426	11	Грешка	\N	\N
2563	427	11	Ова страна на Мозилла Фирефокс 2.0 и Интернет Експлорер на 6 / 7 ми је оптимизиран. Је нестају на начин да је, у матек.ху не подржава користите прегледач. Он мај десити да неке фунцкио́ не мрља адекватно радити јер ми молити за своје задовољење унапред.	\N	\N
2564	430	11	<b>Он није успео сликати ову формулу<b>	\N	\N
2565	433	11	Приближава се решење једначине	\N	\N
2566	435	11	Az <a href="http://hu.wikipedia.org/wiki/Egyenlet" target="_blank">Приближава се решење једначине:[co]	\N	\N
2567	437	11	3Д приказ функције	\N	\N
2568	439	11	Комплексних функција приказом	\N	\N
1855	217	5	<table cellpadding="0" cellspacing="0" border="0"><tr><td><center><h2>La matematica può essere facile!</h2></center>Inizia a inserire il problema utilizzando la tastiera o il mouse e premi il pulsante azzurro sulla sinistra per eseguire il calcolo. Per selezionare un altro tipo di calcolatrice disponibile premi il pulsante in alto a sinistra.</td><td valign="top" align="right"><img src="./image/easy-pres.jpg" style="position:relative;top:-10px;right:-10px;" alt=""></td></tr></table>	\N	\N
2198	616	5	Nuovo vettore	\N	\N
2199	618	5	Chiusura del vettore (1 livello esterno)	\N	\N
2200	620	5	Numero di permutazioni	\N	\N
2201	622	5	Quadrato di una matrice	\N	\N
2158	624	5	Cubo di una matrice	\N	\N
2159	626	5	Elevamento alla quarta potenza	\N	\N
2161	630	5	Da vicino	\N	\N
3015	263	5		\N	\N
3016	666	5		\N	\N
3018	34	5		\N	\N
3019	36	5		\N	\N
3020	37	5		\N	\N
3021	40	5		\N	\N
3022	3	5		\N	\N
2208	54	5		\N	\N
2190	59	5		\N	\N
2187	139	5	<a href="http://it.wikipedia.org/wiki/Serie" target="_blank">Successione di somme parziali</a>:[co]	\N	\N
2189	145	5	Successione di prodotti parziali	\N	\N
2164	149	5	Limite di una successione	\N	\N
1821	161	5	<a href="http://it.wikipedia.org/wiki/Limite_di_una_funzione" target="_blank">Limite della funzione</a>:[co]	\N	\N
1822	164	5	<a href="http://it.wikipedia.org/wiki/Serie_di_Taylor" target="_blank">Serie di Taylor della funzione</a>:[co]	\N	\N
2257	166	5	Serie di Taylor	\N	\N
1823	169	5	<font color="black"><b>Il problema non è definito correttamente, <a href="doc/intro_en.html" target="_blank">chiedi aiuto</a> se necessario.</b></font>	\N	\N
2258	171	5	<b>Problema troppo complesso, spiacente.</b>	\N	\N
2167	638	5	Ruota in basso	\N	\N
\.


--
-- Data for Name: kep; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY langbutton (id, lang, button) FROM stdin;
1	1	215
2	2	210
3	3	212
4	4	211
5	5	214
6	6	213
7	7	209
8	8	216
9	9	208
10	10	207
11	11	319
\.


--
-- Data for Name: latogatas; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY mathtext (id, mtext, os, sorrend) FROM stdin;
1	<b>Quadratic equation solving.</b><br>Equation:<br><center><!--ci1--></center><br>Roots:<br><center><!--uo1--> <!--uo2--></center><br>	\N	\N
2	<b>Division with remainder.</b><br>Divide <!--ci1--> by <!--ci2-->!<br>The quotient is:<br><!--uo1-->,<br>the remainder is:<br><!--uo2-->.<br>	\N	\N
\.


--
-- Data for Name: menu; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY messages (id, handle, textid) FROM stdin;
1	php_error	59
2	calc_wrongbutton	60
3	ws_gethelp	61
4	ws_intro	62
5	ws_save	63
6	calc_lang	69
7	ws_helpdiv	72
8	ws_gethelp1	73
9	ws_gethelp2	74
10	ws_gethelp3	75
11	ws_teacher1	76
12	ws_teacher2	77
13	ws_morehelp	78
14	ws_gethelp4	79
15	ws_whatisit	80
16	ws_formula	81
17	ws_close	82
18	ws_reallynew	83
19	ws_newhint	84
20	ws_savehint	85
21	ws_printhint	86
22	ws_helphint	87
23	ws_plot	88
24	info_title	90
25	info_copyright	91
26	info_poweredby	92
27	info_datapower	93
28	info_graphpower	94
29	info_underlying	95
30	info_contact	96
31	info_bugs	97
32	ws_caserror	169
33	ws_timeout	171
34	ws_bigimage	182
35	ws_badinput	226
36	ws_devhint	254
37	nolanguage	263
38	teacherdata	272
39	errortitle	426
40	errorbrowser	427
41	ws_gnuplot_err	430
42	mess_undefined	491
43	mess_false	493
44	mess_true	495
45	ws_paypal	511
46	calc_params	581
47	mess_nosolution	601
48	mess_ind	612
49	mess_div0	614
50	plot_zin	630
51	plot_zout	628
52	plot_rleft	632
53	plot_rright	634
54	plot_rtop	636
55	plot_rbottom	638
56	plot_oxp	640
57	plot_oxm	642
58	plot_oyp	644
59	plot_oym	646
60	mess_log0	664
61	mess_formconv_error	666
\.


--
-- Data for Name: mezo; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY request (id, application, parameter, formula, filename, sent, received, os, sorrend) FROM stdin;
\.


--
-- Data for Name: showed_ad; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY showed_ad (id, felhasznalo, category, showed, visitor_ip, visitor_hostname, visitor_geoip_city, visitor_geoip_latitude, visitor_geoip_longitude, clicked, visitor_distance, os, sorrend) FROM stdin;
1	10	8	2008-01-31 15:10:43	160.114.144.116	\N	Szeged	\N	\N	f	\N	\N	\N
2	5	8	2008-01-31 15:10:43	160.114.144.116	\N	Szeged	\N	\N	f	\N	\N	\N
3	7	8	2008-01-31 15:10:43	160.114.144.116	\N	Szeged	\N	\N	f	\N	\N	\N
4	10	2	2008-02-02 14:40:20	160.114.145.115	\N	Szeged	\N	\N	f	\N	\N	\N
5	8	2	2008-02-02 14:40:20	160.114.145.115	\N	Szeged	\N	\N	f	\N	\N	\N
6	7	2	2008-02-02 14:40:20	160.114.145.115	\N	Szeged	\N	\N	f	\N	\N	\N
7	10	7	2008-02-02 22:23:45	160.114.145.115	\N	Szeged	\N	\N	f	\N	\N	\N
8	5	7	2008-02-02 22:23:45	160.114.145.115	\N	Szeged	\N	\N	f	\N	\N	\N
9	7	7	2008-02-02 22:23:45	160.114.145.115	\N	Szeged	\N	\N	f	\N	\N	\N
10	10	2	2008-02-03 16:04:49	160.114.136.178	\N	Szeged	\N	\N	t	\N	\N	\N
11	8	2	2008-02-03 16:04:49	160.114.136.178	\N	Szeged	\N	\N	t	\N	\N	\N
12	7	2	2008-02-03 16:04:49	160.114.136.178	\N	Szeged	\N	\N	t	\N	\N	\N
13	9	9	2008-02-04 11:40:30	195.178.75.191	\N	Brno	\N	\N	f	\N	\N	\N
14	10	9	2008-02-04 11:40:30	195.178.75.191	\N	Brno	\N	\N	f	\N	\N	\N
15	10	2	2008-11-14 10:17:01	195.199.144.230	\N	Szeged	\N	\N	f	\N	\N	\N
16	8	2	2008-11-14 10:17:01	195.199.144.230	\N	Szeged	\N	\N	f	\N	\N	\N
17	7	2	2008-11-14 10:17:01	195.199.144.230	\N	Szeged	\N	\N	f	\N	\N	\N
18	9	7	2008-11-20 11:16:10	195.178.75.191	\N	Brno	\N	\N	f	\N	\N	\N
19	10	7	2008-11-20 11:16:10	195.178.75.191	\N	Brno	\N	\N	f	\N	\N	\N
20	11	7	2008-11-20 11:16:10	195.178.75.191	\N	Brno	\N	\N	f	\N	\N	\N
21	10	7	2008-12-01 22:48:58	160.114.145.218	\N	Szeged	\N	\N	f	\N	\N	\N
22	11	7	2008-12-01 22:48:58	160.114.145.218	\N	Szeged	\N	\N	f	\N	\N	\N
23	7	7	2008-12-01 22:48:58	160.114.145.218	\N	Szeged	\N	\N	f	\N	\N	\N
24	9	2	2008-12-04 12:25:40	195.199.75.198	\N	Budars	\N	\N	f	\N	\N	\N
25	10	2	2008-12-04 12:25:40	195.199.75.198	\N	Budars	\N	\N	f	\N	\N	\N
26	11	2	2008-12-04 12:25:40	195.199.75.198	\N	Budars	\N	\N	t	\N	\N	\N
27	9	2	2008-12-21 04:11:03	67.186.142.224	\N	Hartford	\N	\N	f	\N	\N	\N
28	10	2	2008-12-21 04:11:03	67.186.142.224	\N	Hartford	\N	\N	f	\N	\N	\N
29	11	2	2008-12-21 04:11:03	67.186.142.224	\N	Hartford	\N	\N	f	\N	\N	\N
30	9	2	2009-02-03 18:42:37	195.199.203.150	\N	Budars	\N	\N	f	\N	\N	\N
31	10	2	2009-02-03 18:42:37	195.199.203.150	\N	Budars	\N	\N	f	\N	\N	\N
32	11	2	2009-02-03 18:42:37	195.199.203.150	\N	Budars	\N	\N	f	\N	\N	\N
33	6	2	2009-02-04 12:09:47	193.6.2.37	\N	Miskolc	\N	\N	f	\N	\N	\N
34	9	2	2009-02-04 12:09:47	193.6.2.37	\N	Miskolc	\N	\N	f	\N	\N	\N
35	10	2	2009-02-04 12:09:47	193.6.2.37	\N	Miskolc	\N	\N	f	\N	\N	\N
36	11	2	2009-02-04 14:50:27	87.97.104.77	\N	Szeged	\N	\N	f	\N	\N	\N
37	10	2	2009-02-04 14:50:27	87.97.104.77	\N	Szeged	\N	\N	f	\N	\N	\N
38	5	2	2009-02-04 14:50:27	87.97.104.77	\N	Szeged	\N	\N	f	\N	\N	\N
39	5	2	2009-02-04 19:52:28	78.92.152.111	\N		\N	\N	f	\N	\N	\N
40	6	2	2009-02-04 19:52:28	78.92.152.111	\N		\N	\N	f	\N	\N	\N
41	7	2	2009-02-04 19:52:28	78.92.152.111	\N		\N	\N	f	\N	\N	\N
42	9	2	2009-02-15 12:07:49	89.134.162.249	\N	Budapest	\N	\N	f	\N	\N	\N
43	10	2	2009-02-15 12:07:49	89.134.162.249	\N	Budapest	\N	\N	f	\N	\N	\N
44	11	2	2009-02-15 12:07:49	89.134.162.249	\N	Budapest	\N	\N	f	\N	\N	\N
45	10	6	2009-02-15 12:14:42	160.114.145.126	\N	Szeged	\N	\N	f	\N	\N	\N
46	11	6	2009-02-15 12:14:42	160.114.145.126	\N	Szeged	\N	\N	f	\N	\N	\N
47	7	6	2009-02-15 12:14:42	160.114.145.126	\N	Szeged	\N	\N	f	\N	\N	\N
48	5	2	2009-03-04 20:44:11	94.160.69.24	\N		\N	\N	f	\N	\N	\N
49	6	2	2009-03-04 20:44:11	94.160.69.24	\N		\N	\N	f	\N	\N	\N
50	7	2	2009-03-04 20:44:11	94.160.69.24	\N		\N	\N	f	\N	\N	\N
51	10	2	2009-07-03 17:46:04	160.114.145.30	\N	Szeged	\N	\N	f	\N	\N	\N
52	11	2	2009-07-03 17:46:04	160.114.145.30	\N	Szeged	\N	\N	f	\N	\N	\N
53	5	2	2009-07-03 17:46:04	160.114.145.30	\N	Szeged	\N	\N	f	\N	\N	\N
54	10	2	2009-07-03 18:13:11	160.114.145.30	\N	Szeged	\N	\N	f	\N	\N	\N
55	11	2	2009-07-03 18:13:11	160.114.145.30	\N	Szeged	\N	\N	f	\N	\N	\N
56	5	2	2009-07-03 18:13:11	160.114.145.30	\N	Szeged	\N	\N	f	\N	\N	\N
57	11	9	2009-07-04 15:32:48	160.114.145.30	\N	Szeged	\N	\N	f	\N	\N	\N
58	10	9	2009-07-04 15:32:48	160.114.145.30	\N	Szeged	\N	\N	f	\N	\N	\N
59	9	9	2009-07-04 15:32:48	160.114.145.30	\N	Szeged	\N	\N	f	\N	\N	\N
\.


--
-- Data for Name: solvecode; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY solvecode (id, mcode, os, sorrend) FROM stdin;
1	print("solve code 1");	\N	\N
2	print("solve code 2");	\N	\N
\.


--
-- Data for Name: szakag; Type: TABLE DATA; Schema: public; Owner: postgres
--

